
DROP TABLE IF EXISTS `#__assets`;
CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=MyISAM ;

INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES
(1, 0, 1, 640, 0, 'root.1', 'Root Asset', '{"core.login.site":{"6":1,"2":1},"core.login.admin":{"6":1},"core.login.offline":[],"core.admin":{"8":1},"core.manage":{"7":1},"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(2, 1, 2, 3, 1, 'com_admin', 'com_admin', '{}'),
(3, 1, 4, 11, 1, 'com_banners', 'com_banners', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(4, 1, 12, 13, 1, 'com_cache', 'com_cache', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(5, 1, 14, 15, 1, 'com_checkin', 'com_checkin', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(6, 1, 16, 17, 1, 'com_config', 'com_config', '{}'),
(7, 1, 18, 87, 1, 'com_contact', 'com_contact', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(8, 1, 88, 501, 1, 'com_content', 'com_content', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1},"core.edit.own":[]}'),
(9, 1, 502, 503, 1, 'com_cpanel', 'com_cpanel', '{}'),
(10, 1, 504, 505, 1, 'com_installer', 'com_installer', '{"core.admin":{"7":1},"core.manage":{"7":1},"core.create":[],"core.delete":[],"core.edit.state":[]}'),
(11, 1, 506, 507, 1, 'com_languages', 'com_languages', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(12, 1, 508, 509, 1, 'com_login', 'com_login', '{}'),
(13, 1, 510, 511, 1, 'com_mailto', 'com_mailto', '{}'),
(14, 1, 512, 513, 1, 'com_massmail', 'com_massmail', '{}'),
(15, 1, 514, 515, 1, 'com_media', 'com_media', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":{"5":1},"core.edit":[],"core.edit.state":[]}'),
(16, 1, 516, 517, 1, 'com_menus', 'com_menus', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(17, 1, 37, 38, 1, 'com_messages', 'com_messages', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(18, 1, 520, 521, 1, 'com_modules', 'com_modules', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(19, 1, 522, 529, 1, 'com_newsfeeds', 'com_newsfeeds', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(20, 1, 530, 531, 1, 'com_plugins', 'com_plugins', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(21, 1, 532, 533, 1, 'com_redirect', 'com_redirect', '{"core.admin":{"7":1},"core.manage":[]}'),
(22, 1, 534, 535, 1, 'com_search', 'com_search', '{"core.admin":{"7":1},"core.manage":{"6":1}}'),
(23, 1, 536, 537, 1, 'com_templates', 'com_templates', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(24, 1, 538, 539, 1, 'com_users', 'com_users', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.own":{"6":1},"core.edit.state":[]}'),
(25, 1, 540, 557, 1, 'com_weblinks', 'com_weblinks', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1,"10":0,"12":0},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1}}'),
(26, 1, 558, 559, 1, 'com_wrapper', 'com_wrapper', '{}'),
(39, 8, 115, 304, 2, 'com_content.category.14', 'Sample Data-Articles', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(38, 25, 547, 548, 2, 'com_weblinks.category.13', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(37, 19, 525, 526, 2, 'com_newsfeeds.category.12', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(36, 7, 23, 24, 2, 'com_contact.category.11', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(35, 3, 7, 8, 2, 'com_banners.category.10', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(34, 8, 105, 114, 2, 'com_content.category.9', 'Uncategorised', '{"core.create":{"10":0,"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(40, 3, 9, 10, 2, 'com_banners.category.15', 'Sample Data-Banners', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(41, 7, 25, 86, 2, 'com_contact.category.16', 'Sample Data-Contact', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(42, 19, 527, 528, 2, 'com_newsfeeds.category.17', 'Sample Data-Newsfeeds', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(43, 25, 549, 556, 2, 'com_weblinks.category.18', 'Sample Data-Weblinks', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(44, 39, 116, 247, 3, 'com_content.category.19', 'Joomla!', '{"core.create":{"10":0,"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(45, 44, 117, 224, 4, 'com_content.category.20', 'Extensions', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(46, 45, 118, 133, 5, 'com_content.category.21', 'Components', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(47, 45, 134, 193, 5, 'com_content.category.22', 'Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(48, 45, 194, 205, 5, 'com_content.category.23', 'Templates', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(49, 45, 206, 207, 5, 'com_content.category.24', 'Languages', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(50, 45, 208, 223, 5, 'com_content.category.25', 'Plugins', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(51, 39, 248, 279, 3, 'com_content.category.26', 'Park Site', '{"core.create":{"10":0,"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(52, 51, 249, 254, 4, 'com_content.category.27', 'Park Blog', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(53, 51, 255, 276, 4, 'com_content.category.28', 'Photo Gallery', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(54, 39, 280, 293, 3, 'com_content.category.29', 'Fruit Shop Site', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(55, 54, 281, 286, 4, 'com_content.category.30', 'Growers', '{"core.create":{"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":{"10":1}}'),
(56, 43, 550, 551, 3, 'com_weblinks.category.31', 'Park Links', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(57, 43, 552, 555, 3, 'com_weblinks.category.32', 'Joomla! Specific Links', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(58, 57, 553, 554, 4, 'com_weblinks.category.33', 'Other Resources', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(59, 41, 26, 27, 3, 'com_contact.category.34', 'Park Site', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(60, 41, 28, 85, 3, 'com_contact.category.35', 'Shop Site', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(61, 60, 29, 30, 4, 'com_contact.category.36', 'Staff', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(62, 60, 31, 84, 4, 'com_contact.category.37', 'Fruit Encyclopedia', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(63, 62, 32, 33, 5, 'com_contact.category.38', 'A', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(64, 62, 34, 35, 5, 'com_contact.category.39', 'B', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(65, 62, 36, 37, 5, 'com_contact.category.40', 'C', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(66, 62, 38, 39, 5, 'com_contact.category.41', 'D', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(67, 62, 40, 41, 5, 'com_contact.category.42', 'E', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(68, 62, 42, 43, 5, 'com_contact.category.43', 'F', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(69, 62, 44, 45, 5, 'com_contact.category.44', 'G', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(70, 62, 46, 47, 5, 'com_contact.category.45', 'H', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(71, 62, 48, 49, 5, 'com_contact.category.46', 'I', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(72, 62, 50, 51, 5, 'com_contact.category.47', 'J', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(73, 62, 52, 53, 5, 'com_contact.category.48', 'K', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(74, 62, 54, 55, 5, 'com_contact.category.49', 'L', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(75, 62, 56, 57, 5, 'com_contact.category.50', 'M', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(76, 62, 58, 59, 5, 'com_contact.category.51', 'N', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(77, 62, 60, 61, 5, 'com_contact.category.52', 'O', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(78, 62, 62, 63, 5, 'com_contact.category.53', 'P', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(79, 62, 64, 65, 5, 'com_contact.category.54', 'Q', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(80, 62, 66, 67, 5, 'com_contact.category.55', 'R', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(81, 62, 68, 69, 5, 'com_contact.category.56', 'S', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(82, 62, 70, 71, 5, 'com_contact.category.57', 'T', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(83, 62, 72, 73, 5, 'com_contact.category.58', 'U', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(84, 62, 74, 75, 5, 'com_contact.category.59', 'V', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(85, 62, 76, 77, 5, 'com_contact.category.60', 'W', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(86, 62, 78, 79, 5, 'com_contact.category.61', 'X', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(87, 62, 80, 81, 5, 'com_contact.category.62', 'Y', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(88, 62, 82, 83, 5, 'com_contact.category.63', 'Z', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(89, 46, 119, 120, 6, 'com_content.article.1', 'Administrator Components', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(90, 93, 136, 137, 7, 'com_content.article.2', 'Archive Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(91, 93, 138, 139, 7, 'com_content.article.3', 'Article Categories Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(92, 93, 140, 141, 7, 'com_content.article.4', 'Articles Category Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(93, 47, 135, 150, 6, 'com_content.category.64', 'Content Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(94, 47, 151, 158, 6, 'com_content.category.65', 'User Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(95, 47, 159, 172, 6, 'com_content.category.66', 'Display Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(96, 47, 173, 184, 6, 'com_content.category.67', 'Utility Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(97, 48, 195, 196, 6, 'com_content.category.68', 'Atomic', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(98, 48, 197, 198, 6, 'com_content.category.69', 'Beez 20', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(99, 48, 199, 200, 6, 'com_content.category.70', 'Beez5', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(100, 48, 201, 202, 6, 'com_content.category.71', 'Milky Way', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(101, 50, 209, 210, 6, 'com_content.article.5', 'Authentication', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(102, 51, 277, 278, 4, 'com_content.article.6', 'Australian Parks ', '{"core.delete":[],"core.edit":{"2":1},"core.edit.state":[]}'),
(103, 95, 160, 161, 7, 'com_content.article.7', 'Banner Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(104, 44, 225, 226, 4, 'com_content.article.8', 'Beginners', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(105, 46, 121, 122, 6, 'com_content.article.9', 'Contact', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(106, 46, 123, 124, 6, 'com_content.article.10', 'Content', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(107, 109, 267, 268, 6, 'com_content.article.11', 'Cradle Mountain', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(108, 53, 256, 265, 5, 'com_content.category.72', 'Animals', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(109, 53, 266, 275, 5, 'com_content.category.73', 'Scenery', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(110, 95, 162, 163, 7, 'com_content.article.12', 'Custom HTML Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(111, 54, 287, 288, 4, 'com_content.article.13', 'Directions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(112, 50, 211, 212, 6, 'com_content.article.14', 'Editors', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(113, 50, 213, 214, 6, 'com_content.article.15', 'Editors-xtd', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(114, 95, 164, 165, 7, 'com_content.article.16', 'Feed Display', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(115, 52, 250, 251, 5, 'com_content.article.17', 'First Blog Post', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(116, 52, 252, 253, 5, 'com_content.article.18', 'Second Blog Post', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(117, 95, 166, 167, 7, 'com_content.article.19', 'Footer Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(118, 54, 289, 290, 4, 'com_content.article.20', 'Fruit Shop', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(119, 44, 227, 228, 4, 'com_content.article.21', 'Getting Help', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(120, 44, 229, 230, 4, 'com_content.article.22', 'Getting Started', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(121, 55, 282, 283, 5, 'com_content.article.23', 'Happy Orange Orchard', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(122, 44, 231, 232, 4, 'com_content.article.24', 'Joomla!', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(123, 108, 257, 258, 6, 'com_content.article.25', 'Koala', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(124, 96, 174, 175, 7, 'com_content.article.26', 'Language Switcher', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(125, 93, 142, 143, 7, 'com_content.article.27', 'Latest Articles Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(126, 94, 152, 153, 7, 'com_content.article.28', 'Login Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(127, 166, 188, 189, 7, 'com_content.article.29', 'Menu Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(128, 93, 144, 145, 7, 'com_content.article.30', 'Most Read Content', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(129, 93, 146, 147, 7, 'com_content.article.31', 'News Flash', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(130, 44, 233, 234, 4, 'com_content.article.32', 'Parameters', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(131, 108, 259, 260, 6, 'com_content.article.33', 'Phyllopteryx', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(132, 109, 269, 270, 6, 'com_content.article.34', 'Pinnacles', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(133, 44, 235, 236, 4, 'com_content.article.35', 'Professionals', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(134, 95, 168, 169, 7, 'com_content.article.36', 'Random Image Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(135, 93, 148, 149, 7, 'com_content.article.37', 'Related Items Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(136, 44, 237, 238, 4, 'com_content.article.38', 'Sample Sites', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(137, 46, 125, 126, 6, 'com_content.article.39', 'Search', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(138, 96, 176, 177, 7, 'com_content.article.40', 'Search Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(139, 50, 215, 216, 6, 'com_content.article.41', 'Search ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(140, 39, 294, 295, 3, 'com_content.article.42', 'Site Map', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(141, 108, 261, 262, 6, 'com_content.article.43', 'Spotted Quoll', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(142, 96, 178, 179, 7, 'com_content.article.44', 'Statistics Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(143, 96, 180, 181, 7, 'com_content.article.45', 'Syndicate Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(144, 50, 217, 218, 6, 'com_content.article.46', 'System', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(145, 44, 239, 240, 4, 'com_content.article.47', 'The Joomla! Community', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(146, 44, 241, 242, 4, 'com_content.article.48', 'The Joomla! Project', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(147, 48, 203, 204, 6, 'com_content.article.49', 'Typography', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(148, 44, 243, 244, 4, 'com_content.article.50', 'Upgraders', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(149, 50, 219, 220, 6, 'com_content.article.51', 'User', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(150, 46, 127, 128, 6, 'com_content.article.52', 'Users', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(151, 44, 245, 246, 4, 'com_content.article.53', 'Using Joomla!', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(152, 46, 129, 130, 6, 'com_content.article.54', 'Weblinks', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(153, 95, 170, 171, 7, 'com_content.article.55', 'Weblinks Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(154, 94, 154, 155, 7, 'com_content.article.56', 'Who\'s Online', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(155, 108, 263, 264, 6, 'com_content.article.57', 'Wobbegone', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(156, 55, 284, 285, 5, 'com_content.article.58', 'Wonderful Watermelon', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(157, 96, 182, 183, 7, 'com_content.article.59', 'Wrapper Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(158, 46, 131, 132, 6, 'com_content.article.60', 'News Feeds', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(159, 166, 190, 191, 7, 'com_content.article.61', 'Breadcrumbs Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(160, 50, 221, 222, 6, 'com_content.article.62', 'Content', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(162, 109, 271, 272, 6, 'com_content.article.64', 'Blue Mountain Rain Forest', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(163, 109, 273, 274, 6, 'com_content.article.65', 'Ormiston Pound', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(165, 94, 156, 157, 7, 'com_content.article.66', 'Latest Users Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(166, 47, 187, 192, 6, 'com_content.category.75', 'Navigation Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(167, 54, 291, 292, 4, 'com_content.category.76', 'Recipes', '{"core.create":{"12":1,"10":1},"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":{"12":1,"10":1}}'),
(168, 34, 106, 107, 3, 'com_content.article.67', 'What\'s New in 1.5?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(169, 1, 622, 623, 1, 'com_jaextmanager', 'com_jaextmanager', '{}'),
(170, 34, 108, 109, 3, 'com_content.article.68', 'Typography', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(183, 1, 632, 633, 1, 'com_k2', 'k2', '{"core.admin":[],"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(173, 8, 305, 318, 2, 'com_content.category.77', 'Slideshow', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(174, 173, 306, 307, 3, 'com_content.article.69', 'Curabitur mollis ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(175, 173, 308, 309, 3, 'com_content.article.70', 'Etiam interdum faucibus lacus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(176, 173, 310, 311, 3, 'com_content.article.71', 'Maecenas vitae orci dignissim', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(177, 173, 312, 313, 3, 'com_content.article.72', 'Say hello to Joomlart business', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(178, 173, 314, 315, 3, 'com_content.article.73', 'Sed tempus justo it', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(179, 173, 316, 317, 3, 'com_content.article.74', 'Welcome to my website', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(182, 8, 319, 328, 2, 'com_content.category.78', 'NEX News', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(184, 182, 320, 321, 3, 'com_content.article.75', 'Lorem ipsum dolor sit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(185, 34, 110, 111, 3, 'com_content.article.76', 'About K2 ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(187, 8, 329, 330, 2, 'com_content.category.79', 'World', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(188, 8, 331, 332, 2, 'com_content.category.80', 'U.S', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(189, 272, 482, 499, 3, 'com_content.category.81', 'Africa', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(190, 272, 464, 481, 3, 'com_content.category.82', 'Asia', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(191, 272, 446, 463, 3, 'com_content.category.83', 'Europe', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(192, 272, 428, 445, 3, 'com_content.category.84', 'Latin America', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(193, 272, 410, 427, 3, 'com_content.category.85', 'Middle East', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(194, 272, 392, 409, 3, 'com_content.category.86', 'Business', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(195, 272, 372, 391, 3, 'com_content.category.87', 'World Sport', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(196, 272, 354, 371, 3, 'com_content.category.88', 'Entertaiment', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(197, 8, 333, 334, 2, 'com_content.category.89', 'Tech', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(198, 191, 447, 448, 4, 'com_content.article.77', 'On Eve of Key Meeting, New Rifts on Euro Emerge', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(199, 191, 449, 450, 4, 'com_content.article.78', 'Germany Set to Offer Banks Help on Reserves', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(200, 191, 451, 452, 4, 'com_content.article.79', 'Gorbachev Calls for New Vote', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(201, 191, 453, 454, 4, 'com_content.article.80', 'British Police Arrest Man In Scandal ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(202, 191, 455, 456, 4, 'com_content.article.81', 'Gangster in Italy arrested', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(203, 191, 457, 458, 4, 'com_content.article.82', 'Plan for Online Freedoms Stalls at European Meeting', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(204, 191, 459, 460, 4, 'com_content.article.83', 'J! 2.5 template: Brinkmanship for Debt Crisis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(205, 191, 461, 462, 4, 'com_content.article.84', 'Biden Treads Softly in Greece', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(206, 190, 475, 476, 4, 'com_content.article.85', 'At Climate Talks, a Familiar Standoff Between U.S. and China', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(207, 190, 471, 472, 4, 'com_content.article.86', 'South Korea to Send $5.7 Million in Aid to North Korea', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(208, 190, 467, 468, 4, 'com_content.article.87', 'TimesCast  Attacks On Afghan Shiites', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(209, 190, 469, 470, 4, 'com_content.article.88', 'Thailand: American Sentenced for Defaming King', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(210, 190, 473, 474, 4, 'com_content.article.89', 'Beijing\'s Smoggy Skies', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(211, 190, 477, 478, 4, 'com_content.article.90', 'Newswallah: Censorship', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(212, 190, 479, 480, 4, 'com_content.article.91', 'Mine Attack Kills 19 Civilians in Afghanistan', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(213, 190, 465, 466, 4, 'com_content.article.92', 'Karzai Says He Will Talk to Pakistan Over Attacks', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(214, 193, 411, 412, 4, 'com_content.article.93', 'Al Qaeda blamed for Iraq violence wave', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(215, 193, 413, 414, 4, 'com_content.article.94', 'Attacks kill at least 42 in Iraq on Shiite religious holiday', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(216, 193, 415, 416, 4, 'com_content.article.95', 'Elit risus In justo', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(217, 193, 417, 418, 4, 'com_content.article.96', 'Tincidunt cursus quam', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(218, 193, 419, 420, 4, 'com_content.article.97', 'Et Nunc mus sem Nunc Cras', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(219, 193, 421, 422, 4, 'com_content.article.98', 'Ex-homeless woman leaves $150,000 to Hebrew University', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(220, 193, 423, 424, 4, 'com_content.article.99', 'Hac Morbi ac leo at felis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(221, 193, 425, 426, 4, 'com_content.article.100', 'Sed et elit condimentum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(222, 189, 483, 484, 4, 'com_content.article.101', 'Joomla 2.5 day Africa', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(223, 189, 485, 486, 4, 'com_content.article.102', 'JA Nex Joomla 2.5 Template', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(224, 189, 487, 488, 4, 'com_content.article.103', 'Hillary Clinton: We\'re committed to Africa\'s future', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(225, 189, 489, 490, 4, 'com_content.article.104', 'Joomla 2.5 city conference', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(226, 189, 491, 492, 4, 'com_content.article.105', 'Nunc egestas ut tempus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(227, 189, 493, 494, 4, 'com_content.article.106', 'Protests as Sudan \'tight pants\' trial delayed', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(228, 189, 495, 496, 4, 'com_content.article.107', 'Somalia', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(229, 189, 497, 498, 4, 'com_content.article.108', 'Zimbabwe\'s writers connected to their country', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(230, 195, 373, 374, 4, 'com_content.article.109', 'Millions? Private Jet? Columbia Offers New York', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(231, 195, 375, 376, 4, 'com_content.article.110', 'England stars offer summer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(232, 195, 377, 378, 4, 'com_content.article.111', 'Habitant lobortis vitae pretium vitae', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(233, 195, 379, 380, 4, 'com_content.article.112', 'Fringilla Maecenas libero ut faucibus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(234, 195, 381, 382, 4, 'com_content.article.113', 'Murray eases through in Montreal ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(235, 195, 383, 384, 4, 'com_content.article.114', 'Matt Roberts\' MotoGP column ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(236, 195, 385, 386, 4, 'com_content.article.115', 'In nec suscipit metus eros mauris eu ipsum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(237, 195, 387, 388, 4, 'com_content.article.116', 'India Closes Torch Relay to Spectators', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(238, 195, 389, 390, 4, 'com_content.article.117', ' Morbi faucibus Sed Vivamus odio semper', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(239, 196, 355, 356, 4, 'com_content.article.118', 'Vestibulum nec Phasellus facilisi', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(240, 196, 357, 358, 4, 'com_content.article.119', 'Scarlett Johansson to Play Sexy Alien', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(241, 196, 359, 360, 4, 'com_content.article.120', 'Harry Potter and the Deathly Hallows, Part 1', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(242, 196, 361, 362, 4, 'com_content.article.121', 'Congue Cum tincidunt nunc wisi turpis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(243, 196, 363, 364, 4, 'com_content.article.122', 'Exclusive: A Day To Remember', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(244, 196, 365, 366, 4, 'com_content.article.123', 'Tempor magnis tincidunt euismod', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(245, 196, 367, 368, 4, 'com_content.article.124', 'Vestibulum ac pede id Cum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(246, 196, 369, 370, 4, 'com_content.article.125', 'Justo quam orci ipsum enim', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(247, 194, 393, 394, 4, 'com_content.article.126', 'Sony, Stung by Losses, Delays Thin TV', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(248, 194, 395, 396, 4, 'com_content.article.127', 'Semper accumsan Integer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(249, 194, 397, 398, 4, 'com_content.article.128', 'Nunc lacus quis dui adipiscing', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(250, 194, 399, 400, 4, 'com_content.article.129', 'Nullam et nascetur vel', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(251, 194, 401, 402, 4, 'com_content.article.130', 'Taking the ethical high road', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(252, 194, 403, 404, 4, 'com_content.article.131', 'From Vacant to Vibrant', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(253, 194, 405, 406, 4, 'com_content.article.132', 'Phones Get Game Power in the Cloud', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(254, 194, 407, 408, 4, 'com_content.article.133', 'White House Pushes Vote on Consumer Agency Chief', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(255, 192, 429, 430, 4, 'com_content.article.134', 'First Latino White Sox Star Gets Another Shot', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(256, 192, 431, 432, 4, 'com_content.article.135', 'Democrats See a Two-Horse G.O.P', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(257, 192, 433, 434, 4, 'com_content.article.136', '2 Character Models for a Single ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(258, 192, 435, 436, 4, 'com_content.article.137', 'Plan to Widen Availability of Morning', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(259, 192, 437, 438, 4, 'com_content.article.138', 'Blagojevich Sentenced to 14 Years in Prison', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(260, 192, 439, 440, 4, 'com_content.article.139', 'Florida Budget Adds to School Spending', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(261, 192, 441, 442, 4, 'com_content.article.140', 'â€˜Occupyâ€™ Groups Face Setbacks ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(262, 192, 443, 444, 4, 'com_content.article.141', 'Eyeing 2012, White House Presses Europe ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(263, 272, 336, 353, 3, 'com_content.category.90', 'Fashion', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(264, 263, 337, 338, 4, 'com_content.article.142', 'Enim sollicitudin habitasse', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(265, 263, 339, 340, 4, 'com_content.article.143', 'Ipsum sagittis venenatis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(266, 263, 341, 342, 4, 'com_content.article.144', 'Karcher K2900M pressure washer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(267, 263, 343, 344, 4, 'com_content.article.145', 'Morbi congue ac sapien sit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(268, 263, 345, 346, 4, 'com_content.article.146', 'Multi-purpose oval roaster', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(269, 263, 347, 348, 4, 'com_content.article.147', 'Ut Mauris elit ipsum Pellentesque nec', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(270, 263, 349, 350, 4, 'com_content.article.148', 'Rhoncus tellus eros enim netus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(271, 263, 351, 352, 4, 'com_content.article.149', 'Vestibulum sem wisi', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(272, 8, 335, 500, 2, 'com_content.category.91', 'All Category', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(273, 34, 112, 113, 3, 'com_content.article.150', 'All positions layout', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(274, 182, 322, 323, 3, 'com_content.article.151', 'Lorem ipsum dolor sit (2)', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(275, 182, 324, 325, 3, 'com_content.article.152', 'Lorem ipsum dolor sit (3)', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(276, 182, 326, 327, 3, 'com_content.article.153', 'Lorem ipsum dolor sit (4)', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(277, 39, 298, 299, 3, 'com_content.article.154', 'Full width', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(278, 39, 300, 301, 3, 'com_content.article.155', '3 Columns', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(279, 39, 302, 303, 3, 'com_content.article.156', 'Content + Right', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(281, 1, 638, 639, 1, 'com_kunena', 'com_kunena', '{}');

DROP TABLE IF EXISTS `#__associations`;
CREATE TABLE `#__associations` (
  `id` varchar(50) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__banner_clients`;
CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=MyISAM ;

INSERT INTO `#__banner_clients` (`id`, `name`, `contact`, `email`, `extrainfo`, `state`, `checked_out`, `checked_out_time`, `metakey`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`) VALUES
(1, 'Joomla!', 'Administrator', 'email@email.com', '', 1, 0, '0000-00-00 00:00:00', '', 0, '', -1, -1, -1),
(2, 'Shop', 'Example', 'example@example.com', '', 1, 0, '0000-00-00 00:00:00', '', 0, '', -1, 0, 0),
(3, 'Bookstore', 'Bookstore Example', 'example@example.com', '', 1, 0, '0000-00-00 00:00:00', '', 0, '', -1, 0, 0);

DROP TABLE IF EXISTS `#__banner_tracks`;
CREATE TABLE `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__banners`;
CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__banners` (`id`, `cid`, `type`, `name`, `alias`, `imptotal`, `impmade`, `clicks`, `clickurl`, `state`, `catid`, `description`, `custombannercode`, `sticky`, `ordering`, `metakey`, `params`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `reset`, `created`, `language`) VALUES
(2, 3, 0, 'Shop 1', 'shop-1', 0, 74, 2, 'http://shop.joomla.org/amazoncom-bookstores.html', 1, 15, 'Get books about Joomla! at the Joomla! book shop.', '', 0, 1, '', '{"imageurl":"images\\/banners\\/white.png","width":"","height":"","alt":"Joomla! Books"}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2011-01-01 00:00:01', 'en-GB'),
(3, 2, 0, 'Shop 2', 'shop-2', 0, 120, 2, 'http://shop.joomla.org', 1, 15, 'T Shirts, caps and more from the Joomla! Shop.', '', 0, 2, '', '{"imageurl":"images\\/banners\\/white.png","width":"","height":"","alt":"Joomla! Shop"}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2011-01-01 00:00:01', 'en-GB'),
(4, 1, 0, 'Support Joomla!', 'support-joomla', 0, 39, 1, 'http://contribute.joomla.org', 1, 15, 'Your contributions of time, talent and money make Joomla! possible.', '', 0, 3, '', '{"imageurl":"images\\/banners\\/white.png","width":"","height":"","alt":""}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'en-GB');

DROP TABLE IF EXISTS `#__categories`;
CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the j40f79_assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`) VALUES
(1, 0, 0, 0, 163, 0, '', 'system', 'ROOT', 'root', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{}', '', '', '', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(9, 34, 1, 131, 132, 1, 'uncategorised', 'com_content', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, '*'),
(10, 35, 1, 129, 130, 1, 'uncategorised', 'com_banners', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":"","foobar":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(11, 36, 1, 125, 126, 1, 'uncategorised', 'com_contact', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(12, 37, 1, 61, 62, 1, 'uncategorised', 'com_newsfeeds', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(13, 38, 1, 57, 58, 1, 'uncategorised', 'com_weblinks', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(14, 39, 1, 9, 56, 1, 'sample-data-articles', 'com_content', 'Sample Data-Articles', 'sample-data-articles', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(15, 40, 1, 127, 128, 1, 'sample-data-banners', 'com_banners', 'Sample Data-Banners', 'sample-data-banners', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":"","foobar":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(16, 41, 1, 63, 124, 1, 'sample-data-contact', 'com_contact', 'Sample Data-Contact', 'sample-data-contact', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(17, 42, 1, 59, 60, 1, 'sample-data-newsfeeds', 'com_newsfeeds', 'Sample Data-Newsfeeds', 'sample-data-newsfeeds', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(18, 43, 1, 1, 8, 1, 'sample-data-weblinks', 'com_weblinks', 'Sample Data-Weblinks', 'sample-data-weblinks', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(19, 44, 14, 10, 39, 2, 'sample-data-articles/joomla', 'com_content', 'Joomla!', 'joomla', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, '*'),
(20, 45, 19, 11, 38, 3, 'sample-data-articles/joomla/extensions', 'com_content', 'Extensions', 'extensions', '', '<p>The Joomla! content management system lets you create webpages of various types using extensions. There are 5 basic types of extensions: components, modules, templates, languages, and plugins. Your website includes the extensions you need to create a basic website in English, but thousands of additional extensions of all types are available. TheÂ <a href="http://extensions.joomla.org" style="color: #1b57b1; text-decoration: none; font-weight: normal;">Joomla! Extensions Directory</a> is the largest directory of Joomla! extensions.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, '*'),
(21, 46, 20, 12, 13, 4, 'sample-data-articles/joomla/extensions/components', 'com_content', 'Components', 'components', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-component.png" class="image-left" alt="Component Image" />Components are larger extensions that produce the major content for your site. Each component has one or more "views" that control how content is displayed.In the Joomla! administrator there are additional extensions such as Menus, Redirection, and the extension managers.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, '*'),
(22, 47, 20, 14, 25, 4, 'sample-data-articles/joomla/extensions/modules', 'com_content', 'Modules', 'modules', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-module.png" alt="Media Image" class="image-left" />Modules are small blocks of content that can be displayed in positions on a web page. The menus on this site are displayed in modules. The core of Joomla! includes 17 separate modules ranging from login to search to random images. Each module has a name that starts mod_ but when it displays it has a title. In the descriptions in this section, the titles are the same as the names.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, '*'),
(23, 48, 20, 26, 33, 4, 'sample-data-articles/joomla/extensions/templates', 'com_content', 'Templates', 'templates', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-themes.png" border="0" alt="Media Image" align="left" />Templates give your site its look and feel. They determine layout, colors, type faces, graphics and other aspects of design that make your site unique. Your installation of Joomla comes prepackaged with three front end templates and two backend templates. <a href="http://help.joomla.org/proxy/index.php?option=com_help&keyref=Help16:Extensions_Template_Manager_Templates">Help</a></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-09-17 18:21:49', 0, '*'),
(75, 166, 22, 23, 24, 5, 'sample-data-articles/joomla/extensions/modules/navigation-modules', 'com_content', 'Navigation Modules', 'navigation-modules', '', '<p>Navigation modules help your visitors move through your site and find what they need.</p>\r\n<p>Menus provide your site with structure and help your visitors navigate your site. Â Although they are all based on the same menu module, the variety of ways menus are used in the sample data show how flexible this module is.</p>\r\n<p>A menu can range from extremely simple (for example the top menu or the menu for the Australian Parks sample site) to extremely complex (for example the About Joomla! menu with its many levels). They can also be used for other types of presentation such as the site map linked from the "This Site" menu.</p>\r\n<p>Breadcrumbs provide users with information about where they are in a site.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, '*'),
(24, 49, 20, 34, 35, 4, 'sample-data-articles/joomla/extensions/languages', 'com_content', 'Languages', 'languages', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-language.png" border="0" alt="Languages Image" align="left" />Joomla! installs in English, but translations of the interfaces, sample data and help screens are available in dozens of languages. <a href="http://help.joomla.org/proxy/index.php?option=com_help&keyref=Help16:Extensions_Language_Manager_Installed">Help</a></p>\r\n<p><a href="http://community.joomla.org/translations.html">Translation information</a></p>\r\n<p>If there is no language pack available for your language, instructions are available for creating your own translation, which you can also contribute to the community by starting a translation team to create an accredited translation.</p>\r\n<p>Translations of the interfaces are installed using the extensions manager in the site administrator and then managed using the language manager.</p>\r\n<p>If you have two or more languages installed you may enable the language switcher plugin and module. They should always be used together. If you create multilingual content and mark your content, menu items or modules as in specific languages and follow <a href="http://docs.joomla.org/Language_Switcher_Tutorial_for_Joomla_1.6">the complete instructions</a> your users will be able to select a specific content language using the module. By default both the plugin and module are disabled.</p>\r\n<p>There are a number of extensions that can help you manage translations of content available in the<a href="http://extensions.joomla.org"> Joomla! Extensions Directory</a>.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-10 04:07:45', 0, '*'),
(25, 50, 20, 36, 37, 4, 'sample-data-articles/joomla/extensions/plugins', 'com_content', 'Plugins', 'plugins', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-plugin.png" border="0" alt="Plugin Image" align="left" />Plugins are small task oriented extensions that enhance the Joomla! framework. Some are associated with particular extensions and others, such as editors, are used across all of Joomla!. Most beginning users do not need to change any of the plugins that install with Joomla!. <a href="http://help.joomla.org/proxy/index.php?option=com_help&keyref=Help16:Extensions_Plugin_Manager_Edit">Help</a></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-10 04:05:05', 0, '*'),
(26, 51, 14, 40, 49, 2, 'sample-data-articles/park-site', 'com_content', 'Park Site', 'park-site', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, 'en-GB'),
(27, 52, 26, 41, 42, 3, 'sample-data-articles/park-site/park-blog', 'com_content', 'Park Blog', 'park-blog', '', '<p><span style="font-size: 12px;">Here is where I will blog all about the parks of Australia.</span></p>\r\n<p><em>You can make a blog on your website by creating a category to write you blog posts in (this one is called Park Blog). Each blog post will be an article in that category. If you make a category blog menu link with 1 column it will look like this page, if you display the category description (this part) displayed. </em></p>\r\n<p><em>To enhance your blog you may want to add Â extensions forÂ <a href="http://extensions.joomla.org/extensions/contacts-and-feedback/articles-comments" style="color: #1b57b1; text-decoration: none; font-weight: normal;">comments</a>,<a href="http://extensions.joomla.org/extensions/social-web" style="color: #1b57b1; text-decoration: none; font-weight: normal;"> interacting with social network sites</a>,Â <a href="http://extensions.joomla.org/extensions/content-sharing" style="color: #1b57b1; text-decoration: none; font-weight: normal;">tagging</a>, andÂ <a href="http://extensions.joomla.org/extensions/content-sharing" style="color: #1b57b1; text-decoration: none; font-weight: normal;">keeping in contact with your readers</a>.Â Â Â You will also enable the syndication that is included in Joomla! (in the Integration Options set Show Feed Link to Show an make sure to display the syndication module on the page).</em></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":"images\\/sampledata\\/parks\\/banner_cradle.jpg"}', '', '', '{"author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, 'en-GB'),
(28, 53, 26, 43, 48, 3, 'sample-data-articles/park-site/photo-gallery', 'com_content', 'Photo Gallery', 'photo-gallery', '', '<p><img src="images/sampledata/parks/banner_cradle.jpg" border="0" /></p>\r\n<p>These are my photos from parks I have visited (I didn\'t take them, they are all from <a href="http://commons.wikimedia.org/wiki/Main_Page">Wikimedia Commons</a>).</p>\r\n<p><em>This shows you how to make a simple image gallery using articles in com_content. </em></p>\r\n<p><em>In each article put a thumbnail image before a "readmore" and the full size image after it. Set the article to Show Intro Text: Hide. </em></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, 'en-GB'),
(29, 54, 14, 50, 55, 2, 'sample-data-articles/fruit-shop-site', 'com_content', 'Fruit Shop Site', 'fruit-shop-site', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, '*'),
(30, 55, 29, 51, 52, 3, 'sample-data-articles/fruit-shop-site/growers', 'com_content', 'Growers', 'growers', '', '<p>We search the whole countryside for the best fruit growers.</p>\r\n<p><em>You can let each supplier have a page that he or she can edit. To see this in action you will need to create a users who is in the suppliers group. Â <br />Create one page in the growers category for that user and make that supplier the author of the page. Â That user will be able to edit his or her page. </em></p>\r\n<p><em>This illustrates the use of the Edit Own permission. </em></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, '*'),
(31, 56, 18, 2, 3, 2, 'sample-data-weblinks/park-links', 'com_weblinks', 'Park Links', 'park-links', '', '<p>Here are links to some of my favorite parks.</p>\r\n<p><em>The weblinks component provides an easy way to make links to external sites that are consistently formatted and categorised. You can create weblinks from the front end of your site.</em></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":"images\\/sampledata\\/parks\\/banner_cradle.jpg"}', '', '', '{"author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, 'en-GB'),
(32, 57, 18, 4, 7, 2, 'sample-data-weblinks/joomla-specific-links', 'com_weblinks', 'Joomla! Specific Links', 'joomla-specific-links', '', '<p><div style="font-family: Tahoma, Helvetica, Arial, sans-serif; font-size: 76%; background-color: #ffffff; background-image: initial; background-attachment: initial; background-origin: initial; background-clip: initial; line-height: 1.3em; color: #333333;"><p>A selection of links that are all related to the Joomla! Project.</p></div></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(33, 58, 32, 5, 6, 3, 'sample-data-weblinks/joomla-specific-links/other-resources', 'com_weblinks', 'Other Resources', 'other-resources', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(34, 59, 16, 64, 65, 2, 'sample-data-contact/park-site', 'com_contact', 'Park Site', 'park-site', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, 'en-GB'),
(35, 60, 16, 66, 123, 2, 'sample-data-contact/shop-site', 'com_contact', 'Shop Site', 'shop-site', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(36, 61, 35, 67, 68, 3, 'sample-data-contact/shop-site/staff', 'com_contact', 'Staff', 'staff', '', '<p>Please feel free to contact our staff at any time should you need assistance.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(37, 62, 35, 69, 122, 3, 'sample-data-contact/shop-site/fruit-encyclopedia', 'com_contact', 'Fruit Encyclopedia', 'fruit-encyclopedia', '', '<p>Â </p><p>Our directory of information about different kinds of fruit.</p><p>We love fruit and want the world to know more about all of its many varieties.</p><p>Although it is small now, we work on it whenever we have a chance.</p><p>All of the images can be found in <a href="http://commons.wikimedia.org/wiki/Main_Page">Wikimedia Commons</a>.</p><p><img src="images/sampledata/fruitshop/apple.jpg" border="0" alt="Apples" title="Apples" /></p><p><em>This encyclopedia is implemented using the contact component, each fruit a separate contact and a category for each letter. A CSS style is used to create the horizontal layout of the alphabet headings. </em></p><p><em>If you wanted to, you could allow some users (such as your growers) to have access to just this category in the contact component and let them help you to create new content for the encyclopedia.</em></p><p>Â </p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(38, 63, 37, 70, 71, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/a', 'com_contact', 'A', 'a', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(39, 64, 37, 72, 73, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/b', 'com_contact', 'B', 'b', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(40, 65, 37, 74, 75, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/c', 'com_contact', 'C', 'c', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(41, 66, 37, 76, 77, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/d', 'com_contact', 'D', 'd', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(42, 67, 37, 78, 79, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/e', 'com_contact', 'E', 'e', '', '', 0, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(43, 68, 37, 80, 81, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/f', 'com_contact', 'F', 'f', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(44, 69, 37, 82, 83, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/g', 'com_contact', 'G', 'g', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(45, 70, 37, 84, 85, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/h', 'com_contact', 'H', 'h', '', '', 0, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(46, 71, 37, 86, 87, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/i', 'com_contact', 'I', 'i', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(47, 72, 37, 88, 89, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/j', 'com_contact', 'J', 'j', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(48, 73, 37, 90, 91, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/k', 'com_contact', 'K', 'k', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(49, 74, 37, 92, 93, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/l', 'com_contact', 'L', 'l', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(50, 75, 37, 94, 95, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/m', 'com_contact', 'M', 'm', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(51, 76, 37, 96, 97, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/n', 'com_contact', 'N', 'n', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(52, 77, 37, 98, 99, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/o', 'com_contact', 'O', 'o', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(53, 78, 37, 100, 101, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/p', 'com_contact', 'P', 'p', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(54, 79, 37, 102, 103, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/q', 'com_contact', 'Q', 'q', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(55, 80, 37, 104, 105, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/r', 'com_contact', 'R', 'r', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(56, 81, 37, 106, 107, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/s', 'com_contact', 'S', 's', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(57, 82, 37, 108, 109, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/t', 'com_contact', 'T', 't', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(58, 83, 37, 110, 111, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/u', 'com_contact', 'U', 'u', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(59, 84, 37, 112, 113, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/v', 'com_contact', 'V', 'v', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(60, 85, 37, 114, 115, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/w', 'com_contact', 'W', 'w', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(61, 86, 37, 116, 117, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/x', 'com_contact', 'X', 'x', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(62, 87, 37, 118, 119, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/y', 'com_contact', 'Y', 'y', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(63, 88, 37, 120, 121, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/z', 'com_contact', 'Z', 'z', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(64, 93, 22, 15, 16, 5, 'sample-data-articles/joomla/extensions/modules/articles-modules', 'com_content', 'Content Modules', 'articles-modules', '', '<p>Content modules display article and other information from the content component.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, '*'),
(65, 94, 22, 17, 18, 5, 'sample-data-articles/joomla/extensions/modules/user-modules', 'com_content', 'User Modules', 'user-modules', '', '<p>User modules interact with the user system, allowing users to login, showing who is logged in, and showing the most recently registered users.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(66, 95, 22, 19, 20, 5, 'sample-data-articles/joomla/extensions/modules/display-modules', 'com_content', 'Display Modules', 'display-modules', '', '<p>These modules display information from components other than content and user. These include weblinks, news feeds and the media manager.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(67, 96, 22, 21, 22, 5, 'sample-data-articles/joomla/extensions/modules/utility-modules', 'com_content', 'Utility Modules', 'utility-modules', '', '<p>Utility modules provide useful functionality such as search, syndication, and statistics.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*'),
(68, 97, 23, 31, 32, 5, 'sample-data-articles/joomla/extensions/templates/atomic', 'com_content', 'Atomic', 'atomic', '', '<p>Atomic is a minimal template designed to be a skeleton for making your own template and to learn about Joomla! templating.</p>\r\n<p><img src="templates/atomic/template_thumbnail.png" border="0" alt="The Atomic Template" style="border: 0; float: right;" /></p>\r\n<p>Â </p>\r\n<ul>\r\n<li><a href="index.php?Itemid=285">Home Page</a></li>\r\n<li><a href="index.php?Itemid=316">Typography</a></li>\r\n</ul>\r\n<p>Â </p>\r\n<p>Â </p>\r\n<p><br /><br /></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, '*'),
(69, 98, 23, 27, 28, 5, 'sample-data-articles/joomla/extensions/templates/beez-20', 'com_content', 'Beez 20', 'beez-20', '', '<p><img src="templates/beez_20/template_thumbnail.png" border="0" alt="Beez_20 thumbnail" align="right" style="float: right;" /></p>\r\n<p>Beez 2.0 is a versatile, easy to customize template that works for a variety of sites. It meets major accessibilityÂ standards and demonstrates a range of css and javascript techniques. It is the default template that installs with Joomla!</p>\r\n<ul>\r\n<li><a href="index.php?Itemid=424">Home Page</a></li>\r\n<li><a href="index.php?Itemid=423">Typography</a></li>\r\n</ul>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, '*'),
(70, 99, 23, 29, 30, 5, 'sample-data-articles/joomla/extensions/templates/beez5', 'com_content', 'Beez5', 'beez5', '', '<p><img src="templates/beez5/template_thumbnail.png" border="0" alt="Beez5 Thumbnail" align="right" style="float: right;" /></p>\r\n<p>Â </p>\r\n<p>Beez 5 is an html5 implementation of a Joomla! template. It uses a number of html5 techniques to enhance the presentation of a site. It is used as the template for the Fruit Shop sample site.</p>\r\n<ul>\r\n<li><a href="index.php?Itemid=458">Home Page</a></li>\r\n<li><a href="index.php?Itemid=457">Typography</a></li>\r\n</ul>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, '*'),
(72, 108, 28, 44, 45, 4, 'sample-data-articles/park-site/photo-gallery/animals', 'com_content', 'Animals', 'animals', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, 'en-GB'),
(73, 109, 28, 46, 47, 4, 'sample-data-articles/park-site/photo-gallery/scenery', 'com_content', 'Scenery', 'scenery', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, 'en-GB'),
(76, 167, 29, 53, 54, 3, 'sample-data-articles/fruit-shop-site/recipes', 'com_content', 'Recipes', 'recipes', '', '<p>Customers and suppliers can post their favorite recipes for fruit here.</p>\r\n<p>A good idea is to promote the use of metadata keywords to make finding other recipes for the same fruit easier.</p>\r\n<p><em>To see this in action, create a user assigned to the customer group and a user assigned to the suppliers group. These users will be able to create their own recipe pages and edit those pages. The will not be able to edit other users\' pages.</em><br /><br /></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-01-01 00:00:01', 42, '2011-01-01 00:00:01', 0, '*'),
(77, 173, 1, 133, 134, 1, 'slideshow', 'com_content', 'Slideshow', 'slideshow', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-05 06:42:55', 0, '0000-00-00 00:00:00', 0, '*'),
(78, 182, 1, 135, 136, 1, 'nex-news', 'com_content', 'NEX News', 'nex-news', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-05 07:33:25', 42, '2011-12-15 06:47:40', 0, '*'),
(79, 187, 1, 137, 138, 1, 'world', 'com_content', 'World', 'world', '', '', -2, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-08 01:40:02', 0, '0000-00-00 00:00:00', 0, '*'),
(80, 188, 1, 139, 140, 1, 'us', 'com_content', 'U.S', 'us', '', '', -2, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-08 01:41:10', 0, '0000-00-00 00:00:00', 0, '*'),
(81, 189, 91, 160, 161, 2, 'all-category/africa', 'com_content', 'Africa', 'africa', '', '<p><img src="images/stories/demo/category-9.jpg" border="0" alt="Sample Image" />Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-08 01:41:54', 42, '2011-12-16 04:24:14', 0, '*'),
(82, 190, 91, 158, 159, 2, 'all-category/asia', 'com_content', 'Asia', 'asia', '', '<p><img src="images/stories/demo/category-8.jpg" border="0" alt="Sample Image" />Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-08 01:42:36', 42, '2011-12-16 04:23:21', 0, '*'),
(83, 191, 91, 156, 157, 2, 'all-category/europe', 'com_content', 'Europe', 'europe', '', '<p><img src="images/stories/demo/category-7.jpg" border="0" alt="Sample Image" />Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-08 01:43:23', 42, '2011-12-16 04:21:20', 0, '*'),
(84, 192, 91, 154, 155, 2, 'all-category/latin-america', 'com_content', 'Latin America', 'latin-america', '', '<p><img src="images/stories/demo/category-6.jpg" border="0" alt="Sample Image" />Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-08 01:44:15', 42, '2011-12-16 04:17:29', 0, '*'),
(85, 193, 91, 152, 153, 2, 'all-category/middle-east', 'com_content', 'Middle East', 'middle-east', '', '<p><img src="images/stories/demo/category-5.jpg" border="0" alt="Sample Image" />Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-08 01:45:29', 42, '2011-12-16 04:13:49', 0, '*'),
(86, 194, 91, 150, 151, 2, 'all-category/business', 'com_content', 'Business', 'business', '', '<p><img src="images/stories/demo/category-4.jpg" border="0" alt="Sample Image" />Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-08 03:05:44', 42, '2011-12-16 04:12:27', 0, '*'),
(87, 195, 91, 148, 149, 2, 'all-category/world-sport', 'com_content', 'World Sport', 'world-sport', '', '<p><img src="images/stories/demo/category-3.jpg" border="0" alt="Sample Image" />Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-08 03:06:52', 42, '2011-12-16 04:10:08', 0, '*'),
(88, 196, 91, 146, 147, 2, 'all-category/entertaiment', 'com_content', 'Entertaiment', 'entertaiment', '', '<p><img src="images/stories/demo/category-2.jpg" border="0" alt="Sample Image" />Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-08 03:07:42', 42, '2011-12-16 04:08:44', 0, '*'),
(89, 197, 1, 141, 142, 1, 'tech', 'com_content', 'Tech', 'tech', '', '', -2, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-08 03:08:36', 0, '0000-00-00 00:00:00', 0, '*'),
(90, 263, 91, 144, 145, 2, 'all-category/fashion', 'com_content', 'Fashion', 'fashion', '', '<p><img src="images/stories/demo/category-1.jpg" border="0" alt="Sample Image" />Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-12 10:58:45', 42, '2011-12-16 04:05:31', 0, '*'),
(91, 272, 1, 143, 162, 1, 'all-category', 'com_content', 'All Category', 'all-category', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-13 08:53:03', 0, '0000-00-00 00:00:00', 0, '*');

DROP TABLE IF EXISTS `#__contact_details`;
CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `imagepos`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES
(1, 'Contact Name Here', 'name', 'Position', 'Street Address', 'Suburb', 'State', 'Country', 'Zip Code', 'Telephone', 'Fax', '<p>Information about or by the contact.</p>', 'images/map.jpg', 'top', 'email@email.com', 1, 1, 42, '2011-12-16 10:10:01', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"sliders","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"1","linka_name":"Twitter","linka":"http:\\/\\/twitter.com\\/joomla","linkb_name":"YouTube","linkb":"http:\\/\\/www.youtube.com\\/user\\/joomla","linkc_name":"Facebook","linkc":"http:\\/\\/www.facebook.com\\/joomla","linkd_name":"FriendFeed","linkd":"http:\\/\\/friendfeed.com\\/joomla","linke_name":"Scribed","linke":"http:\\/\\/www.scribd.com\\/people\\/view\\/504592-joomla","contact_layout":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 16, 1, '', '', 'last', 'first', 'middle', 'en-GB', '2011-01-01 00:00:01', 42, '', '2011-12-16 10:10:01', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(2, 'Webmaster', 'webmaster', '', '', '', '', '', '', '', '', '', '', NULL, 'webmaster@example.com', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","show_email_form":"1","show_email_copy":"1","banned_email":"","banned_subject":"","banned_text":"","validate_session":"1","custom_reply":"","redirect":""}', 0, 34, 1, '', '', '', '', '', 'en-GB', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(3, 'Owner', 'owner', '', '', '', '', '', '', '', '', '<p>I\'m the owner of this store.</p>', '', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 2, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 36, 1, '', '', '', '', '', '*', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(4, 'Buyer', 'buyer', '', '', '', '', '', '', '', '', '<p>I am in charge of buying fruit. If you sell good fruit, contact me.</p>', '', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"0","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 36, 1, '', '', '', '', '', '*', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(5, 'Bananas', 'bananas', 'Scientific Name: Musa', 'Image Credit: Enzik\r\nRights: Creative Commons Share Alike Unported 3.0\r\nSource: http://commons.wikimedia.org/wiki/File:Bananas_-_Morocco.jpg', '', 'Type: Herbaceous', 'Large Producers: India, China, Brasil', '', '', '', '<p>Bananas are a great source of potassium.</p>\r\n<p>Â </p>', 'images/sampledata/fruitshop/bananas_2.jpg', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"show_with_link","show_contact_list":"","presentation_style":"plain","show_name":"","show_position":"1","show_email":"","show_street_address":"","show_suburb":"","show_state":"1","show_postcode":"","show_country":"1","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"1","linka_name":"Wikipedia: Banana English","linka":"http:\\/\\/en.wikipedia.org\\/wiki\\/Banana","linkb_name":"Wikipedia:  \\u0939\\u093f\\u0928\\u094d\\u0926\\u0940 \\u0915\\u0947\\u0932\\u093e","linkb":"http:\\/\\/hi.wikipedia.org\\/wiki\\/%E0%A4%95%E0%A5%87%E0%A4%B2%E0%A4%BE","linkc_name":"Wikipedia:Banana Portugu\\u00eas","linkc":"http:\\/\\/pt.wikipedia.org\\/wiki\\/Banana","linkd_name":"Wikipedia: \\u0411\\u0430\\u043d\\u0430\\u043d  \\u0420\\u0443\\u0441\\u0441\\u043a\\u0438\\u0439","linkd":"http:\\/\\/ru.wikipedia.org\\/\\u0411\\u0430\\u043d\\u0430\\u043d","linke_name":"","linke":"","contact_layout":"beez5:encyclopedia"}', 0, 39, 1, '', '', '', '', '', '*', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(6, 'Apples', 'apples', 'Scientific Name: Malus domestica', 'Image Credit: Fievet\r\nRights: Public Domain\r\nSource: http://commons.wikimedia.org/wiki/File:Pommes_vertes.JPG', '', 'Family: Rosaceae', 'Large: Producers: China, United States', '', '', '', '<p>Apples are a versatile fruit, used for eating, cooking, and preserving.</p>\r\n<p>There are more that 7500 different kinds of apples grown around the world.</p>', 'images/sampledata/fruitshop/apple.jpg', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"plain","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"1","linka_name":"Wikipedia: Apples English","linka":"http:\\/\\/en.wikipedia.org\\/wiki\\/Apple","linkb_name":"Wikipedia: Manzana Espa\\u00f1ol ","linkb":"http:\\/\\/es.wikipedia.org\\/wiki\\/Manzana","linkc_name":"Wikipedia: \\u82f9\\u679c \\u4e2d\\u6587","linkc":"http:\\/\\/zh.wikipedia.org\\/zh\\/\\u82f9\\u679c","linkd_name":"Wikipedia: Tofaa Kiswahili","linkd":"http:\\/\\/sw.wikipedia.org\\/wiki\\/Tofaa","linke_name":"","linke":"","contact_layout":"beez5:encyclopedia"}', 0, 38, 1, '', '', '', '', '', '*', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(7, 'Tamarind', 'tamarind', 'Scientific Name: Tamarindus indica', 'Image Credit: Franz Eugen KÃ¶hler, KÃ¶hler\'s Medizinal-Pflanzen \r\nRights: Public Domain\r\nSource:http://commons.wikimedia.org/wiki/File:Koeh-134.jpg', '', 'Family: Fabaceae', 'Large Producers: India, United States', '', '', '', '<p>Tamarinds are a versatile fruit used around the world. In its young form it is used in hot sauces; ripened it is the basis for many refreshing drinks.</p>\r\n<p>Â </p>', 'images/sampledata/fruitshop/tamarind.jpg', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"plain","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"1","linka_name":"Wikipedia: Tamarind English","linka":"http:\\/\\/en.wikipedia.org\\/wiki\\/Tamarind","linkb_name":"Wikipedia: \\u09a4\\u09c7\\u0981\\u09a4\\u09c1\\u09b2  \\u09ac\\u09be\\u0982\\u09b2\\u09be  ","linkb":"http:\\/\\/bn.wikipedia.org\\/wiki\\/\\u09a4\\u09c7\\u0981\\u09a4\\u09c1\\u09b2 ","linkc_name":"Wikipedia: Tamarinier Fran\\u00e7ais","linkc":"http:\\/\\/fr.wikipedia.org\\/wiki\\/Tamarinier","linkd_name":"Wikipedia:Tamaline lea faka-Tonga","linkd":"http:\\/\\/to.wikipedia.org\\/wiki\\/Tamaline","linke_name":"","linke":"","contact_layout":"beez5:encyclopedia"}', 0, 57, 1, '', '', '', '', '', '*', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(8, 'Shop Address', 'shop-address', '', '', 'Our City', 'Our Province', 'Our Country', '', '555-555-5555', '', '<p>Here are directions for how to get to our shop.</p>', '', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 35, 1, '', '', '', '', '', '*', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');

DROP TABLE IF EXISTS `#__content`;
CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the j40f79_assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `title_alias` varchar(255) binary NOT NULL DEFAULT '' COMMENT 'Deprecated in Joomla! 3.0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `sectionid` int(10) unsigned NOT NULL DEFAULT '0',
  `mask` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `parentid` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(1, 89, 'Administrator Components', 'administrator-components', '', '<p>AllÂ components also are used in the administrator area of your website. In addition to the ones listed here, there are components in the administrator that do not have direct front end displays, but do help shape your site. The most important ones for most users are</p>\r\n<ul>\r\n<li>Media Manager</li>\r\n<li>Extensions Manager</li>\r\n<li>Menu Manager</li>\r\n<li>Global Configuration</li>\r\n<li>Banners</li>\r\n<li>Redirect</li>\r\n</ul>\r\n<hr title="Media Manager" alt="Media Manager" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" />\r\n<h3>Media Manager</h3>\r\n<p>The media manager component lets you upload and insert images into content throughout your site. Optionally, you can enable the flash uploader which will allow you to to upload multiple images. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Content_Media_Manager">Help</a></p>\r\n<hr title="Extensions Manager" alt="Extensions Manager" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" />\r\n<h3>Extensions Manager</h3>\r\n<p>The extensions manager lets you install, update, uninstall and manage all of your extensions. The extensions manager has been extensively redesigned for Joomla! 1.6, although the core install and uninstall functionality remains the same as in Joomla 1.5. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Extension_Manager_Install">Help</a></p>\r\n<hr title="Menu Manager" alt="Menu Manager" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" />\r\n<h3>Menu Manager</h3>\r\n<p>The menu manager lets you create the menus you see displayed on your site. It also allows you to assign modules and template styles to specific menu links. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Menus_Menu_Manager">Help</a></p>\r\n<hr title="Global Configuration" alt="Global Configuration" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" />\r\n<h3>Global Configuration</h3>\r\n<p>The global configuration is where the site administrator configures things such as whether search engine friendly urls are enabled, the site meta data (descriptive text used by search engines and indexers) and other functions. For many beginning users simply leaving the settings on default is a good way to begin, although when your site is ready for the public you will want to change the meta data to match its content. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Site_Global_Configuration">Help</a></p>\r\n<hr title="Banners" alt="Banners" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" />\r\n<h3>Banners</h3>\r\n<p>The banners component provides a simple way to display a rotating image in a module and, if you wish to have advertising, a way to track the number of times an image is viewed and clicked. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Banners_Banners_Edit">Help</a></p>\r\n<h3>\r\n<hr title="Redirect" class="system-pagebreak" />\r\n</h3>\r\n<h3><br />Redirect</h3>\r\n<p>The redirect component is used to manage broken links that produce Page Not Found (404) errors. If enabled it will allow you to redirect broken links to specific pages. It can also be used to manage migration related URL changes.Â <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Redirect_Manager">Help</a></p>', '', 1, 0, 0, 21, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-12-21 03:48:32', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 8, 0, 7, '', '', 1, 11, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(8, 104, 'Beginners', 'beginners', '', '<p>If this is your first Joomla site or your first web site, you have come to the right place. Joomla will help you get your website up and running quickly and easily.</p>\r\n<p>Start off using your site by logging in using the administrator account you created when you installed Joomla!.</p>\r\n', '\r\n<p>Explore the articles and other resources right here on your site data to learn more about how Joomla works.(When you\'re done reading, you can delete or archive all of this.) You will also probably want to visit the beginners\' areas of the <a href="http://docs.joomla.org/Beginners">Joomla documentation</a> and <a href="http://forum.joomla.org">support forums</a>.</p>\r\n<p>You\'ll also want to sign up for the Joomla Security Mailing list and the Announcements mailing list. For inspiration visit the Joomla Site Showcase to see an amazing array of ways people use Joomla to tell their stories on the web.</p>\r\n<p>The basic Joomla! installation will let you get a great site up and running, but when you are ready for more features the power of Joomla! is in the creative ways that developers have extended it to do all kinds of things. Visit the Joomla! Extensions Directory to see thousands of extensions that can do almost anything you could want on a website. Can\'t find what you need? You may want to find a Joomla professional on the Joomla! Resources Directory.</p>\r\n<p>Want to learn more? Consider attending a Joomla! Day or other event or joining a local Joomla! Users Group. Can\'t find one near you? Start one yourself.</p>', 1, 0, 0, 19, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-12-26 04:36:44', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 4, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(2, 90, 'Archive Module', 'archive-module', '', '<p>This module shows a list of the calendar months containing archived articles. After you have changed the status of an article to archived, this list will be automatically generated.Â <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Archive" title="Archive Module">Help</a></p>\r\n<div class="sample-module">{loadmodule articles_archive,Archived Articles}</div>', '', 1, 0, 0, 64, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:18:05', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 5, 0, 5, 'modules, content', '', 1, 32, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(7, 103, 'Banner Module', 'banner-module', '', '<p>The banner module is used to display the banners that are managed by the banners component in the site administrator. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Banners">Help</a>.</p>\r\n<div class="sample-module">{loadmodule banners,Banners}</div>', '', 1, 0, 0, 66, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:32:58', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 6, '', '', 1, 8, '', 0, '*', ''),
(3, 91, 'Article Categories Module', 'article-categories-module', '', '<p>This module displays a list of categories from one parent category.Â <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Categories" title="Categories Module">Help</a></p>\r\n<div class="sample-module">{loadmodule articles_categories,Articles Categories}</div>', '', 1, 0, 0, 64, '2011-01-01 00:00:01', 42, '', '2011-12-22 03:16:52', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 6, 0, 6, 'modules, content', '', 1, 6, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(4, 92, 'Articles Category Module', 'articles-category-module', '', '<p>This module allows you to display the articles in a specific category. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Category">Help</a></p>\r\n<div class="sample-module">{loadmodule articles_category,Articles Category}</div>', '', 1, 0, 0, 64, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:18:26', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 8, 0, 7, '', 'articles,content', 1, 10, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(5, 101, 'Authentication', 'authentication', '', '<p>The authentication plugins operate when users login to your site or administrator. The Joomla! authentication is in operation by default but you can enable Gmail or LDAP or install a plugin for a different system. An example is included that may be used to create a new authentication plugin.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>Joomla <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Authentication_-_GMail">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>Gmail <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Authentication_-_GMail">Help</a></li>\r\n<li>LDAP <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Authentication_-_LDAP">Help</a></li>\r\n</ul>', '', 1, 0, 0, 25, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-06 06:15:21', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 3, '', '', 1, 1, '', 0, '*', ''),
(6, 102, 'Australian Parks ', 'australian-parks', '', '<p><img src="images/sampledata/parks/banner_cradle.jpg" border="0" alt="Cradle Park Banner" /></p>\r\n<p>Welcome!</p>\r\n<p>This is a basic site about the beautiful and fascinating parks of Australia.</p>\r\n<p>On this site you can read all about my travels to different parks, see photos, and find links to park websites.</p>\r\n<p><em>This sample site is an example of using the core of Joomla! to create a basic website, whether a "brochure site," Â a personal blog, or as a way to present information on a topic you are interested in.</em></p>\r\n<p><em> Read more about the site in the About Parks module.</em></p>\r\n<p>Â </p>', '', 1, 0, 0, 26, '2011-01-01 00:00:01', 42, 'Parks Webmaster', '2011-09-06 06:20:19', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 1, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(9, 105, 'Contacts', 'contact', '', '<p>The contact component provides a way to provide contact forms and information for your site or to create a complex directory that can be used for many different purposes. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Contacts_Contacts">Help</a></p>', '', 1, 0, 0, 21, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-01-10 04:15:37', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 2, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(10, 106, 'Content', 'content', '', '<p>The content component (com_content) is what you use to write articles. It is extremely flexible and has the largest number of built in views. Articles can be created and edited from the front end, making content the easiest component to use to create your site content. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Content_Article_Manager">Help</a></p>', '', 1, 0, 0, 21, '2011-01-01 00:00:01', 42, '', '2011-01-10 04:28:12', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 1, '', '', 1, 6, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(11, 107, 'Cradle Mountain', 'cradle-mountain', '', '<p><img src="images/sampledata/parks/landscape/250px_cradle_mountain_seen_from_barn_bluff.jpg" border="0" alt="Cradle Mountain" style="vertical-align: middle;" /></p>', '<p><img src="images/sampledata/parks/landscape/800px_cradle_mountain_seen_from_barn_bluff.jpg" border="0" alt="Cradle Mountain" style="vertical-align: middle;" /></p><p>Â </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Rainforest,bluemountainsNSW.jpg</p><p class="caption">Author: Alan J.W.C.</p><p class="caption">License: GNU Free Documentation License v . 1.2 or later</p>', 1, 0, 0, 73, '2011-01-01 00:00:01', 42, 'Parks Webmaster', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 1, '', '', 1, 0, '', 0, '*', ''),
(12, 110, 'Custom HTML Module', 'custom-html-module', '', '<p>This Module allows you to create your own HTML Module using a WYSIWYG editor.Â <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Custom_HTML" title="Custom HTML Module">Help</a></p>\r\n<div class="sample-module">{loadmodule custom,Custom HTML}</div>', '', 1, 0, 0, 66, '2011-01-01 00:00:01', 42, '', '2011-09-17 22:21:39', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 12, 0, 1, '', '', 1, 13, '', 0, '*', ''),
(13, 111, 'Directions', 'directions', '', '<p>Here\'s how to find our shop.</p><p>By car</p><p>Drive along Main Street to the intersection with First Avenue. Â Look for our sign.</p><p>By foot</p><p>From the center of town, walk north on Main Street until you see our sign.</p><p>By bus</p><p>Take the #73 Bus to the last stop. We are on the north east corner.</p>', '', 1, 0, 0, 29, '2011-01-01 00:00:01', 42, 'Fruit Shop Webmaster', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 2, '', '', 1, 0, '', 0, '*', ''),
(14, 112, 'Editors', 'editors', '', '<p>Editors are used thoughout Joomla! where content is created. TinyMCE is the default choice in most locations although CodeMirror is used in the template manager. No Editor provides a text box for html content.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>CodeMirror <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Editor_-_CodeMirror">Help</a></li>\r\n<li>TinyMCE<a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Editor_-_TinyMCE"> Help</a></li>\r\n<li>No Editor <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Editor_-_None">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>None</li>\r\n</ul>', '', 1, 0, 0, 25, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-06 05:45:40', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 5, '', '', 1, 0, '', 0, '*', ''),
(15, 113, 'Editors-xtd', 'editors-xtd', '', '<p>These plugins are behind the buttons found beneath your editor. They only run when an editor plugin runs.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>Editor Button: Image<a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Button_-_Image">Â Help</a></li>\r\n<li>Editor Button: ReadmoreÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Button_-_Readmore">Help</a></li>\r\n<li>Editor Button: Page BreakÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Button_-_Pagebreak">Help</a></li>\r\n<li>Editor Button: ArticleÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Button_-_Article">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>None</li>\r\n</ul>', '', 1, 0, 0, 25, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-06 06:17:38', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 6, '', '', 1, 1, '', 0, '*', ''),
(16, 114, 'Feed Display', 'feed-display', '', '<p>This module allows the displaying of a syndicated feed. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Feed_Display" title="Feed Display Module">Help</a></p>\r\n<div class="sample-module">{loadmodule feed,Feed Display}</div>', '', 1, 0, 0, 66, '2011-01-01 00:00:01', 42, '', '2011-09-17 22:22:08', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 2, '', '', 1, 3, '', 0, '*', ''),
(17, 115, 'First Blog Post', 'first-blog-post', '', '<p><em>Lorem Ipsum is filler text that is commonly used by designers before the content for a new site is ready.</em></p><p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed faucibus purus vitae diam posuere nec eleifend elit dictum. Aenean sit amet erat purus, id fermentum lorem. Integer elementum tristique lectus, non posuere quam pretium sed. Quisque scelerisque erat at urna condimentum euismod. Fusce vestibulum facilisis est, a accumsan massa aliquam in. In auctor interdum mauris a luctus. Morbi euismod tempor dapibus. Duis dapibus posuere quam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. In eu est nec erat sollicitudin hendrerit. Pellentesque sed turpis nunc, sit amet laoreet velit. Praesent vulputate semper nulla nec varius. Aenean aliquam, justo at blandit sodales, mauris leo viverra orci, sed sodales mauris orci vitae magna.</p>', '<p>Quisque a massa sed libero tristique suscipit. Morbi tristique molestie metus, vel vehicula nisl ultrices pretium. Sed sit amet est et sapien condimentum viverra. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Phasellus viverra tortor porta orci convallis ac cursus erat sagittis. Vivamus aliquam, purus non luctus adipiscing, orci urna imperdiet eros, sed tincidunt neque sapien et leo. Cras fermentum, dolor id tempor vestibulum, neque lectus luctus mauris, nec congue tellus arcu nec augue. Nulla quis mi arcu, in bibendum quam. Sed placerat laoreet fermentum. In varius lobortis consequat. Proin vulputate felis ac arcu lacinia adipiscing. Morbi molestie, massa id sagittis luctus, sem sapien sollicitudin quam, in vehicula quam lectus quis augue. Integer orci lectus, bibendum in fringilla sit amet, rutrum eget enim. Curabitur at libero vitae lectus gravida luctus. Nam mattis, ligula sit amet vestibulum feugiat, eros sem sodales mi, nec dignissim ante elit quis nisi. Nulla nec magna ut leo convallis sagittis ac non erat. Etiam in augue nulla, sed tristique orci. Vestibulum quis eleifend sapien.</p><p>Nam ut orci vel felis feugiat posuere ut eu lorem. In risus tellus, sodales eu eleifend sed, imperdiet id nulla. Nunc at enim lacus. Etiam dignissim, arcu quis accumsan varius, dui dui faucibus erat, in molestie mauris diam ac lacus. Sed sit amet egestas nunc. Nam sollicitudin lacinia sapien, non gravida eros convallis vitae. Integer vehicula dui a elit placerat venenatis. Nullam tincidunt ligula aliquet dui interdum feugiat. Maecenas ultricies, lacus quis facilisis vehicula, lectus diam consequat nunc, euismod eleifend metus felis eu mauris. Aliquam dapibus, ipsum a dapibus commodo, dolor arcu accumsan neque, et tempor metus arcu ut massa. Curabitur non risus vitae nisl ornare pellentesque. Pellentesque nec ipsum eu dolor sodales aliquet. Vestibulum egestas scelerisque tincidunt. Integer adipiscing ultrices erat vel rhoncus.</p><p>Integer ac lectus ligula. Nam ornare nisl id magna tincidunt ultrices. Phasellus est nisi, condimentum at sollicitudin vel, consequat eu ipsum. In venenatis ipsum in ligula tincidunt bibendum id et leo. Vivamus quis purus massa. Ut enim magna, pharetra ut condimentum malesuada, auctor ut ligula. Proin mollis, urna a aliquam rutrum, risus erat cursus odio, a convallis enim lectus ut lorem. Nullam semper egestas quam non mattis. Vestibulum venenatis aliquet arcu, consectetur pretium erat pulvinar vel. Vestibulum in aliquet arcu. Ut dolor sem, pellentesque sit amet vestibulum nec, tristique in orci. Sed lacinia metus vel purus pretium sit amet commodo neque condimentum.</p><p>Aenean laoreet aliquet ullamcorper. Nunc tincidunt luctus tellus, eu lobortis sapien tincidunt sed. Donec luctus accumsan sem, at porttitor arcu vestibulum in. Sed suscipit malesuada arcu, ac porttitor orci volutpat in. Vestibulum consectetur vulputate eros ut porttitor. Aenean dictum urna quis erat rutrum nec malesuada tellus elementum. Quisque faucibus, turpis nec consectetur vulputate, mi enim semper mi, nec porttitor libero magna ut lacus. Quisque sodales, leo ut fermentum ullamcorper, tellus augue gravida magna, eget ultricies felis dolor vitae justo. Vestibulum blandit placerat neque, imperdiet ornare ipsum malesuada sed. Quisque bibendum quam porta diam molestie luctus. Sed metus lectus, ornare eu vulputate vel, eleifend facilisis augue. Maecenas eget urna velit, ac volutpat velit. Nam id bibendum ligula. Donec pellentesque, velit eu convallis sodales, nisi dui egestas nunc, et scelerisque lectus quam ut ipsum.</p>', 1, 0, 0, 27, '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 0, '', '', 1, 0, '', 0, '*', ''),
(18, 116, 'Second Blog Post', 'second-blog-post', '', '<p><em>Lorem Ipsum is text that is traditionally used by designers when working on a site before the content is ready.</em></p><p>Pellentesque bibendum metus ut dolor fermentum ut pulvinar tortor hendrerit. Nam vel odio vel diam tempus iaculis in non urna. Curabitur scelerisque, nunc id interdum vestibulum, felis elit luctus dui, ac dapibus tellus mauris tempus augue. Duis congue facilisis lobortis. Phasellus neque erat, tincidunt non lacinia sit amet, rutrum vitae nunc. Sed placerat lacinia fermentum. Integer justo sem, cursus id tristique eget, accumsan vel sapien. Curabitur ipsum neque, elementum vel vestibulum ut, lobortis a nisl. Fusce malesuada mollis purus consectetur auctor. Morbi tellus nunc, dapibus sit amet rutrum vel, laoreet quis mauris. Aenean nec sem nec purus bibendum venenatis. Mauris auctor commodo libero, in adipiscing dui adipiscing eu. Praesent eget orci ac nunc sodales varius.</p>', '<p>Nam eget venenatis lorem. Vestibulum a interdum sapien. Suspendisse potenti. Quisque auctor purus nec sapien venenatis vehicula malesuada velit vehicula. Fusce vel diam dolor, quis facilisis tortor. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Pellentesque libero nisi, pellentesque quis cursus sit amet, vehicula vitae nisl. Curabitur nec nunc ac sem tincidunt auctor. Phasellus in mattis magna. Donec consequat orci eget tortor ultricies rutrum. Mauris luctus vulputate molestie. Proin tincidunt vehicula euismod. Nam congue leo non erat cursus a adipiscing ipsum congue. Nulla iaculis purus sit amet turpis aliquam sit amet dapibus odio tincidunt. Ut augue diam, congue ut commodo pellentesque, fermentum mattis leo. Sed iaculis urna id enim dignissim sodales at a ipsum. Quisque varius lobortis mollis. Nunc purus magna, pellentesque pellentesque convallis sed, varius id ipsum. Etiam commodo mi mollis erat scelerisque fringilla. Nullam bibendum massa sagittis diam ornare rutrum.</p><p>Praesent convallis metus ut elit faucibus tempus in quis dui. Donec fringilla imperdiet nibh, sit amet fringilla velit congue et. Quisque commodo luctus ligula, vitae porttitor eros venenatis in. Praesent aliquet commodo orci id varius. Nulla nulla nibh, varius id volutpat nec, sagittis nec eros. Cras et dui justo. Curabitur malesuada facilisis neque, sed tempus massa tincidunt ut. Sed suscipit odio in lacus auctor vehicula non ut lacus. In hac habitasse platea dictumst. Sed nulla nisi, lacinia in viverra at, blandit vel tellus. Nulla metus erat, ultrices non pretium vel, varius nec sem. Morbi sollicitudin mattis lacus quis pharetra. Donec tincidunt mollis pretium. Proin non libero justo, vitae mattis diam. Integer vel elit in enim varius posuere sed vitae magna. Duis blandit tempor elementum. Vestibulum molestie dui nisi.</p><p>Curabitur volutpat interdum lorem sed tempus. Sed placerat quam non ligula lacinia sodales. Cras ultrices justo at nisi luctus hendrerit. Quisque sit amet placerat justo. In id sapien eu neque varius pharetra sed in sapien. Etiam nisl nunc, suscipit sed gravida sed, scelerisque ut nisl. Mauris quis massa nisl, aliquet posuere ligula. Etiam eget tortor mauris. Sed pellentesque vestibulum commodo. Mauris vitae est a libero dapibus dictum fringilla vitae magna.</p><p>Nulla facilisi. Praesent eget elit et mauris gravida lobortis ac nec risus. Ut vulputate ullamcorper est, volutpat feugiat lacus convallis non. Maecenas quis sem odio, et aliquam libero. Integer vel tortor eget orci tincidunt pulvinar interdum at erat. Integer ullamcorper consequat eros a pellentesque. Cras sagittis interdum enim in malesuada. Etiam non nunc neque. Fusce non ligula at tellus porta venenatis. Praesent tortor orci, fermentum sed tincidunt vel, varius vel dui. Duis pulvinar luctus odio, eget porta justo vulputate ac. Nulla varius feugiat lorem sed tempor. Phasellus pulvinar dapibus magna eget egestas. In malesuada lectus at justo pellentesque vitae rhoncus nulla ultrices. Proin ut sem sem. Donec eu suscipit ipsum. Cras eu arcu porttitor massa feugiat aliquet at quis nisl.</p>', 1, 0, 0, 27, '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 0, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 0, '', '', 1, 0, '', 0, '*', ''),
(19, 117, 'Footer Module', 'footer-module', '', '<p>This module shows the Joomla! copyright information. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Footer" title="Footer Module">Help</a></p>\r\n<div class="sample-module">{loadmodule footer,Footer}</div>', '', 1, 0, 0, 66, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:22:47', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 3, '', '', 1, 4, '', 0, '*', ''),
(20, 118, 'Fruit Shop', 'fruit-shop', '', '<h2>Welcome to the Fruit Shop</h2><p>We sell fruits from around the world. Please use our website to learn more about our business. We hope you will come to our shop and buy some fruit.</p><p ><em>This mini site will show you how you might want to set up a site for a business, in this case one selling fruit. It shows how to use access controls to manage your site content. If you were building a real site, you would might want to extend it with e-commerce, a catalog, mailing lists or other enhancements, many of which are available through the</em><a href="http://extensions.joomla.org"><em> Joomla! Extensions Directory</em></a>.</p><p><em>To understand this site you will probably want to make one user with groups set to customer and one with group set to grower. By logging in with different privileges  you can see how access control works.</em></p>', '', 1, 0, 0, 29, '2011-01-01 00:00:01', 42, 'Fruit Shop Webmaster', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 1, '', '', 1, 0, '', 0, '*', ''),
(21, 119, 'Getting Help', 'getting-help', '', '<p><img class="image-left" src="administrator/templates/hathor/images/header/icon-48-help_header.png" border="0" /> There are lots of places you can get help with Joomla!. In many places in your site administrator you will see the help icon. Click on this for more information about the options and functions of items on your screen. Other places to get help are:</p>\r\n<ul>\r\n<li><a href="http://forum.joomla.org">Support Forums</a></li>\r\n<li><a href="http://docs.joomla.org">Documentation</a></li>\r\n<li><a href="http://resources.joomla.org">Professionals</a></li>\r\n<li><a href="http://shop.joomla.org/amazoncom-bookstores.html">Books</a></li>\r\n</ul>', '', 1, 0, 0, 19, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-01-10 15:32:54', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 10, 0, 8, '', '', 1, 17, '', 0, '*', ''),
(22, 120, 'Getting Started', 'getting-started', '', '<p>It\'s easy to get started creating your website. Knowing some of the basics will help.</p><h3>What is a Content Management System?</h3><p>A content management system is software that allows you to create and manage webpages easily by separating the creation of your content from the mechanics required to present it on the web.</p><p>In this site, the content is stored in a <em>database</em>. The look and feel are created by a <em>template</em>. The Joomla! software brings together the template and the content to create web pages.</p><h3>Site and Administrator</h3><p>Your site actually has two separate sites. The site (also called the front end) is what visitors to your site will see.  The administrator (also called the back end) is only used by people managing your site. You can access the administrator by clicking the "Site Administrator" link on the "This Site" menu or by adding /administrator to the end of you domain name.</p><p>Log in to the administrator using the username and password created during the installation of Joomla!.</p><h3>Logging in</h3><p>To login to the front end of your site use the login form or the login menu link on the "This Site" menu. Use the user name an password that were created as part of the installation process. Once logged in you will be able to create and edit articles.</p><p>In managing your site, you will be able to create content that only logged in users are able to see.</p><h3>Creating an article</h3><p>Once you are logged in, a new menu will be visible.  To create a new article, click on the "submit article" link on that menu.</p><p>The new article interface gives you a lot of options, but all you need to do is add a title an put something in the content area. To make it easy to find, set the state to published an put it in the Joomla! category.</p><div>You can edit an existing article by  clicking on the edit icon (this only displays to users who have the right to edit).</div><h3>Learn more</h3><p>There is much more to learn about how to use Joomla! to create the web site you envision. You can learn much more at the <a href="http://docs.joomla.org">Joomla! documentation site</a> and on the<a href="http://forum.joomla.org"> Joomla! forums</a>.</p>', '', 1, 0, 0, 19, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 9, '', '', 1, 2, '', 0, '*', ''),
(23, 121, 'Happy Orange Orchard', 'happy-orange-orchard', '', '<p>At our orchard we grow the world\'s best oranges as well as other citrus fruit such as lemons and grapefruit. Our family has been tending this orchard for generations.</p>', '', 1, 0, 0, 30, '2011-01-01 00:00:01', 42, 'Fruit Shop Webmaster', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 2, '', '', 1, 0, '', 0, '*', ''),
(24, 122, 'Joomla!', 'joomla', '', '<p>Congratulations! You have a Joomla! site! Joomla! makes it easy to build a website just the way you want it and keep it simple to update and maintain.</p>\r\n<p>Joomla! is a flexible and powerful platform, whether you are building a small site for yourself or a huge site with hundreds of thousands of visitors. Joomla is open source, which means you can make it work just the way you want it to.</p>', '', 1, 0, 0, 19, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-12-26 04:36:29', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 2, '', '', 1, 44, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(25, 123, 'Koala', 'koala', '', '<p><img src="images/sampledata/parks/animals/180px_koala_ag1.jpg" border="0" alt="Koala  Thumbnail" width="180" height="123" style="vertical-align: middle; border: 0;" /></p>', '<p><img src="images/sampledata/parks/animals/800px_koala_ag1.jpg" border="0" alt="Koala Climbing Tree" width="500" height="341" style="vertical-align: middle; border: 0;" /></p><p>Â </p><p>Â </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Koala-ag1.jpg</p><p class="caption">Author: Arnaud Gaillard</p><p><span class="caption">License: Creative Commons Share Alike Attribution Generic 1.0</span></p>', 1, 0, 0, 72, '2011-01-01 00:00:01', 42, 'Parks Webmaster', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 2, '', '', 1, 0, '', 0, '*', ''),
(26, 124, 'Language Switcher', 'language-switcher', '', '<p>The language switcher module allows you to take advantage of the language tags that are available when content, modules and menu links are created.</p>\r\n<p>This module displays a list of available Content Languages for switching between them.</p>\r\n<p>When switching languages, it redirects to the Home page defined for the chosen language. Thereafter, the navigation will be the one defined for that language.</p>\r\n<p><strong>The language filter plugin must be enabled for this module to work properly.</strong></p>\r\n<p><strong></strong> <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Language_Switcher" title="Language Switcher Module">Help</a></p>\r\n<p>To view an example of the language switch moduler module, go to the site administrator and enable the language filter plugin and the language switcher module labellled "language switcher" and visit the fruit shop or park sample sites. Then follow<a href="http://docs.joomla.org/Language_Switcher_Tutorial_for_Joomla_1.6"> the instructions in this tutorial</a>.</p>', '', 1, 0, 0, 67, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-01-10 03:57:35', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 3, '', '', 1, 3, '', 0, '*', ''),
(27, 125, 'Latest Articles Module', 'latest-articles-module', '', '<p>This Module shows a list of the most recently published and current Articles. Some that are shown may have expired even though they are the most recent. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Latest_News" title="Latest Articles">Help</a></p>\r\n<div class="sample-module">{loadmodule articles_latest,Latest News}</div>', '', 1, 0, 0, 64, '2011-01-01 00:00:01', 42, '', '2011-09-17 22:14:56', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 8, 0, 1, 'modules, content', '', 1, 15, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(28, 126, 'Login Module', 'login-module', '', '<p>This module displays a username and password login form. It also displays a link to retrieve a forgotten password. If user registration is enabled (in the Global Configuration settings), another link will be shown to enable self-registration for users. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Login" title="Login">Help</a></p>\r\n<div class="sample-module">{loadmodule login,login}</div>', '', 1, 0, 0, 65, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:20:35', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 2, '', '', 1, 5, '', 0, '*', ''),
(29, 127, 'Menu Module', 'menu-module', '', '<p>This module displays a menu on the site (frontend). Â Menus can be displayed in a wide variety of ways by using the menu options and css menu styles. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Menu">Help</a></p>\r\n<div class="sample-module">{loadmodule mod_menu,Menu Example}</div>', '', 1, 0, 0, 75, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:18:45', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 8, 0, 1, '', '', 1, 11, '', 0, '*', ''),
(30, 128, 'Most Read Content', 'most-read-content', '', '<p>This Module shows a list of the currently published Articles which have the highest number of page views. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Most_Read" title="Most Read Content">Help</a></p>\r\n<div class="sample-module">{loadmodule articles_popular,Articles Most Read}</div>', '', 1, 0, 0, 64, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:15:37', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 5, 0, 2, 'modules, content', '', 1, 10, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(31, 129, 'News Flash', 'news-flash', '', '<p>Displays a set number of articles from a category based on date or random selection. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Newsflash" title="News Flash Module">Help</a></p>\r\n<div class="sample-module">{loadmodule articles_news,News Flash}</div>', '', 1, 0, 0, 64, '2011-01-01 00:00:01', 42, '', '2011-09-17 22:16:46', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 3, 'modules, content', '', 1, 10, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(32, 130, 'Parameters', 'parameters', '', '<p>As you make your Joomla! site using the extension you will control the details of the display using <em>parameter</em><strong>s</strong>. Parameters control everything from whether the author\'s name is displayed to who can view what to the number of items shown on a list.</p>\r\n<p>Default parameters for each component are changed using the Options button on the component toolbar.</p>\r\n<p>Parameters can also be set on an individual item, such as an article or contact and in menu links.</p>\r\n<p>If you are happy with how your site looks, it is fine to leave all of the parameters set to the defaults that were created when your site was installed. As you become more experienced with Joomla! you will use parameters more.</p>\r\n<p>Â </p>', '', 1, 0, 0, 19, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-05 19:55:56', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 10, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(33, 131, 'Phyllopteryx', 'phyllopteryx', '', '<p><img src="images/sampledata/parks/animals/200px_phyllopteryx_taeniolatus1.jpg" border="0" style="vertical-align: middle;" /></p><p>Â </p>', '<p><img src="images/sampledata/parks/animals/800px_phyllopteryx_taeniolatus1.jpg" border="0" style="vertical-align: middle;" /></p><p>Â </p><p>Source: http://en.wikipedia.org/wiki/File:Phyllopteryx_taeniolatus1.jpg</p><p>Author: Richard Ling</p><p>License: GNU Free Documentation License v 1.2 or later</p>', 1, 0, 0, 72, '2011-01-01 00:00:01', 42, 'Parks Webmaster', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 3, '', '', 1, 0, '', 0, '*', ''),
(34, 132, 'Pinnacles', 'pinnacles', '', '<p><img src="images/sampledata/parks/landscape/120px_pinnacles_western_australia.jpg" border="0" alt="Kings Canyon" width="120" height="90" style="vertical-align: middle; border: 0;" /></p>', '<p><img src="images/sampledata/parks/landscape/800px_pinnacles_western_australia.jpg" border="0" alt="King\'s Canyon" width="500" height="374" style="vertical-align: middle; border: 0;" /></p><p>Â </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Pinnacles_Western_Australia.jpg</p><p class="caption">Author: <a class="new" href="http://commons.wikimedia.org/w/index.php?title=User:Markdoe&action=edit&redlink=1" title="User:Markdoe (page does not exist)"></a>Martin Gloss</p><p class="caption">License: GNU Free Documentation license v 1.2 or later.</p>', 1, 0, 0, 73, '2011-01-01 00:00:01', 42, 'Parks Webmaster', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 4, '', '', 1, 0, '', 0, '*', ''),
(35, 133, 'Professionals', 'professionals', '', '<p>Joomla! 1.7Â continues development of the Joomla Framework and CMS as a powerful and flexible way to bring your vision of the web to reality. With the administrator now fully MVC, the ability to control its look and the management of extensions is now complete.</p>\r\n', '\r\n<p>Working with multiple template styles and overrides for the same views, creating the design you want is easier than it has ever been. Limiting support to PHP 5.2.4 and above and ending legacy support for Joomla 1.0 extensions makes Joomla! lighter and faster than ever.Â Languages files can now be overridden without having your changes lost during an upgrade. Â With the proper xml your users update extensions with a single click.</p>\r\n<p>Access control lists are now incorporated using a new system developed for Joomla!. The ACL system is designed with developers in mind, so it is easy to incorporate into your extensions. The new nested sets libraries allow you to incorporate infinitely deep categories but also to use nested sets in a variety of other ways.</p>\r\n<p>A new forms library makes creating all kinds of user interaction simple. MooTools 1.3 provides a highly flexible javascript framework that is a major advance over MooTools 1.0.</p>\r\n<p>New events throughout the core make integration of your plugins where you want them a snap.</p>\r\n<p>The separation of the Joomla! Platform project from the Joomla! CMS project makes continuous development of new, powerful APIs Â and continuous improvement of existing APIs possible while maintaining the stability of the CMS that millions of webmasters and professionals rely upon.</p>\r\n<p>Learn about:</p>\r\n<ul>\r\n<li><a href="http://docs.joomla.org/What\'s_new_in_Joomla_1.6">Changes since 1.5</a></li>\r\n<li><a href="http://docs.joomla.org/ACL_Tutorial_for_Joomla_1.6">Working with ACL</a></li>\r\n<li><a href="http://docs.joomla.org/API16:JCategories">Working with nested categories</a></li>\r\n<li><a href="http://docs.joomla.org/API16:JForm">Forms library</a></li>\r\n<li><a href="http://docs.joomla.org/Working_with_Mootools_1.3">Working with Mootools 1.3</a></li>\r\n<li><a href="http://docs.joomla.org/Layout_Overrides_in_Joomla_1.6">Using new features of the override system</a></li>\r\n<li><a href="http://api.joomla.org">Joomla! API</a></li>\r\n<li><a href="http://docs.joomla.org/API16:JDatabaseQuery">Using JDatabaseQuery</a></li>\r\n<li><a href="http://docs.joomla.org/What\'s_new_in_Joomla_1.6#Events">New and updated events</a></li>\r\n<li><a href="http://docs.joomla.org/Xml-rpc_changes_in_Joomla!_1.6">Xmlrpc</a></li>\r\n<li><a href="http://docs.joomla.org/What\'s_new_in_Joomla_1.6#Extension_management">Installing and updating extensions</a></li>\r\n<li><a href="http://docs.joomla.org/Setting_up_your_workstation_for_Joomla!_development">Setting up your development environment</a></li>\r\n<li><a href="github.com/joomla">The Joomla! Platform Repository</a>Â </li>\r\n</ul>', 1, 0, 0, 19, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-05 19:52:39', 42, 0, '0000-00-00 00:00:00', '2011-01-09 16:41:13', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 15, 0, 5, '', '', 1, 10, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(36, 134, 'Random Image Module', 'random-image-module', '', '<p>This Module displays a random image from your chosen image directory. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Random_Image" title="Random Image Module">Help</a></p>\r\n<div class="sample-module">{loadmodule random_image,Random Image}</div>', '', 1, 0, 0, 66, '2011-01-01 00:00:01', 42, '', '2011-09-17 22:23:31', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 5, 0, 4, '', '', 1, 6, '', 0, '*', ''),
(37, 135, 'Related Items Module', 'related-items-module', '', '<p>This Module displays other Articles that are related to the one currently being viewed. These relations are established by the Meta Keywords.Â Â All the keywords of the current Article are searched against all the keywords of all other published articles. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Related" title="Related Items Module">Help</a></p>\r\n<div class="sample-module">{loadmodule related_items,Articles Related Items}</div>', '', 1, 0, 0, 64, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:17:41', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 4, 'modules, content', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(38, 136, 'Sample Sites', 'sample-sites', '', '<p>Your installation includes sample data, designed to show you some of the options you have for building your website. In addition to information about Joomla! there are two sample "sites within a site" designed to help you get started with builidng your own site.</p><p>The first site is a simple site about <a href="index.php?Itemid=243">Australian Parks</a>. It shows how you can quickly and easily build a personal site with just the building blocks that are part of Joomla!. It includes a personal blog, weblinks, and a very simple image gallery.</p><p>The second site is slightly more complex and represents what you might do if you are building a site for a small business, in this case a <a href="index.php/welcome.html"></a><a href="index.php?Itemid=429">Fruit Shop</a>.</p><p>In building either style site, or something completely different, you will probably want to add <a href="http://extensions.joomla.org">extensions</a> and either create or purchase your own template. Many Joomla! users start off by modifying the <a href="http://docs.joomla.org/How_do_you_modify_a_template%3F">templates</a> that come with the core distribution so that they include special images and other design elements that relate to their site\'s focus.</p>', '', 1, 0, 0, 19, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 11, '', '', 1, 2, '', 0, '*', ''),
(39, 137, 'Search', 'search-component', '', '<p>The search component provides basic search functionality for the information contained in your core components. Many third party extensions also can be searched by the search component. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Search">Help</a></p>', '', 1, 0, 0, 21, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-01-10 04:19:31', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 3, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(40, 138, 'Search Module', 'search-module', '', '<p>This module will display a search box. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Search" title="Search">Help</a></p>\r\n<div class="sample-module">{loadmodule search,Search}</div>', '', 1, 0, 0, 67, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:35:56', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 4, '', '', 1, 5, '', 0, '*', ''),
(41, 139, 'Search ', 'search-plugin', '', '<p>The search component uses plugins to control which parts of your Joomla! site are searched. You may choose to turn off some areas to improve performance or for other reasons. Many third party Joomla! extensions have search plugins that extend where search takes place.</p>\r\n<p>Default On:</p>\r\n<ul>\r\n<li>Content <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Content">Help</a></li>\r\n<li>Contacts <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Contacts">Help</a></li>\r\n<li>WeblinksÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Weblinks">Help</a></li>\r\n<li>News FeedsÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Newsfeeds">Help</a></li>\r\n<li>CategoriesÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Categories">Help</a></li>\r\n</ul>', '', 1, 0, 0, 25, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-06 06:13:18', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 0, 1, '', '', 1, 0, '', 0, '*', ''),
(42, 140, 'Site Map', 'site-map', '', '<p>{loadposition sitemapload}</p><p><em>By putting all of your content into nested categories you can give users and search engines access to everything using a menu.</em></p>', '', 1, 0, 0, 14, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 3, '', '', 1, 0, '', 0, '*', ''),
(43, 141, 'Spotted Quoll', 'spotted-quoll', '', '<p><img src="images/sampledata/parks/animals/220px_spottedquoll_2005_seanmcclean.jpg" border="0" alt="Spotted Quoll" style="vertical-align: middle; border: 0;" /></p>', '<p><img src="images/sampledata/parks/animals/789px_spottedquoll_2005_seanmcclean.jpg" border="0" alt="Spotted Quoll" style="vertical-align: middle;" /></p><p>Â </p><p>Source: http://en.wikipedia.org/wiki/File:SpottedQuoll_2005_SeanMcClean.jpg</p><p>Author: Sean McClean</p><p>License: GNU Free Documentation License v 1.2 or later</p>', 1, 0, 0, 72, '2011-01-01 00:00:01', 42, 'Parks Webmaster', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 4, '', '', 1, 0, '', 0, '*', ''),
(44, 142, 'Statistics Module', 'statistics', '', '<p>The Statistics Module shows information about your server installation together with statistics on the Web site users, number of Articles in your database and the number of Web links you provide.</p>\r\n<div class="sample-module">{loadmodule mod_stats,Statistics}</div>', '', 1, 0, 0, 67, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:36:28', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 5, 0, 5, '', '', 1, 5, '', 0, '*', ''),
(45, 143, 'Syndicate Module', 'syndicate-module', '', '<p>The syndicate module allows you to display a link that allows users to take a feed from your site. It will only display on pages for which feeds are possible. That means it will not display on single article, contact or weblinks pages, such as this one. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Syndicate" title="Synicate Module">Help</a></p>\r\n<div class="sample-module">{loadposition syndicate,Syndicate}</div>', '', 1, 0, 0, 67, '2011-01-01 00:00:01', 42, '', '2011-09-17 22:37:24', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 6, '', '', 1, 2, '', 0, '*', ''),
(46, 144, 'System', 'system', '', '<p>System plugins operate every time a page on your site loads. They control such things as your URLS, whether users can check a "remember me" box on the login module, and whether caching is enabled. Â New in 1.6 is the redirect plugin that with the redirect component assist you in managing changes in URLs.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>Remember meÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Remember_Me">Help</a></li>\r\n<li>SEFÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_SEF">Help</a></li>\r\n<li>DebugÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Debug">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>CacheÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Cache">Help</a></li>\r\n<li>LogÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Log">Help</a></li>\r\n<li>RedirectÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Redirect">Help</a></li>\r\n</ul>', '', 1, 0, 0, 25, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-06 06:12:56', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 2, '', '', 1, 1, '', 0, '*', ''),
(47, 145, 'The Joomla! Community', 'the-joomla-community', '', '<p>Joomla! means All Together, and it is a community of people all working and having fun together that makes Joomla! possible. Thousands of people each year participate in the Joomla! community, and we hope you will be one of them.</p><p>People with all kinds of skills, of all skill levels and from around the world are welcome to join in. Participate in the <a href="http://joomla.org">Joomla.org</a> family of websites (the<a href="http://forum.joomla.org"> forum </a>is a great place to start). Come to a <a href="http://community.joomla.org/events.html">Joomla! event</a>. Join or start a <a href="http://community.joomla.org/user-groups.html">Joomla! Users Group</a>. Whether you are a developer, site administrator, designer, end user or fan, there are ways for you to participate and contribute.</p>', '', 1, 0, 0, 19, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 4, '', '', 1, 1, '', 0, '*', ''),
(48, 146, 'The Joomla! Project', 'the-joomla-project', '', '<p>The Joomla! Project consists of all of the people who make and support the Joomla! Web Platform and Content Management System.</p><p>Our mission is to provide a flexible platform for digital publishing and collaboration.</p><p>The core values are:</p><ul><li>Freedom</li><li>Equality</li><li>Trust</li><li>Community</li><li>Collaboration</li><li>Usability</li></ul><p>In our vision, we see:</p><ul><li>People publishing and collaborating in their communities and around the world</li><li>Software that is free, secure, and high-quality</li><li>A community that is enjoyable and rewarding to participate in</li><li>People around the world using their preferred languages</li><li>A project that acts autonomously</li><li>A project that is socially responsible</li><li>A project dedicated to maintaining the trust of its users</li></ul><p>There are millions of users around the world and thousands of people who contribute to the Joomla! Project. They work in three main groups: the Production Working Group, responsible for everything that goes into software and documentation; the Community Working Group, responsible for creating a nurturing the community; and Open Source Matters, the non profit organization responsible for managing legal, financial and organizational issues.</p><p>Joomla! is a free and open source project, which uses the GNU General Public LicenseÂ version 2 or later.</p>', '', 1, 0, 0, 19, '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 1, '', '', 1, 1, '', 0, '*', ''),
(49, 147, 'Typography', 'typography', '', '<h1>H1 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h1><h2>H2 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h2><h3>H3 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h3><h4>H4 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h4><h5>H5 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h5><h6>H6 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h6><p>P The quick brown fox ran over the lazy dog. THE QUICK BROWN FOX RAN OVER THE LAZY DOG.</p><ul><li>Item</li><li>Item</li><li>Item<br /> <ul><li>Item</li><li>Item</li><li>Item<br /> <ul><li>Item</li><li>Item</li><li>Item</li></ul></li></ul></li></ul><ol><li>tem</li><li>Item</li><li>Item<br /> <ol><li>Item</li><li>Item</li><li>Item<br /><ol><li>Item</li><li>Item</li><li>Item</li></ol></li></ol> </li></ol>', '', -2, 0, 0, 23, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 1, '', '', 1, 0, '', 0, '*', ''),
(50, 148, 'Upgraders', 'upgraders', '', '<p>If you are an experienced Joomla! 1.5 user, this Joomla! site will seem very familiar. There are new templates and improved user interfaces, but most functionality is the same. The biggest changes are improved access control (ACL) and nested categories. This release of Joomla! has strong continuity with Joomla! 1.6 while adding enhancements.</p>\r\n', '\r\n<p>The new user manager which will let you manage who has access to what in your site. You can leave access groups exactly the way you had them in Joomla 1.5 or make them as complicated as you want. You can learn more about<a href="http://docs.joomla.org/ACL_Tutorial_for_Joomla_1.6"> how access control works</a> in on the <a href="http://docs.joomla.org">Joomla! Documentation site</a></p>\r\n<p>In Joomla 1.5 and 1.0 content was organized into sections and categories. From 1.6 forward sections are gone, and you can create categories within categories, going as deep as you want. The sample data provides many examples of the use of nested categories.</p>\r\n<p>All layouts have been redesigned to improve accessibility and flexibility.Â </p>\r\n<p>Updating your site and extensions when needed is easier than ever thanks to installer improvements.</p>\r\n<p>Â </p>', 1, 0, 0, 19, '2011-01-01 00:00:01', 42, '', '2011-12-26 04:36:14', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 5, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(51, 149, 'User', 'user-plugins', '', '<p>Default on:</p>\r\n<ul>\r\n<li>Joomla <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#User_-_Joomla.21">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<p>Two new plugins are available in 1.6 but are disabled by default.</p>\r\n<ul>\r\n<li>Contact CreatorÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#User_-_Contact_Creator">Help</a><br />Creates a new linked contact record for each new user created.</li>\r\n<li>ProfileÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#User_-_Profile">Help</a><br />This example profile plugin allows you to insert additional fields into user registration and profile display. This is intended as an example of the types of extensions to the profile you might want to create.</li>\r\n</ul>', '', 1, 0, 0, 25, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-06 05:43:26', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 4, '', '', 1, 0, '', 0, '*', ''),
(52, 150, 'Users', 'users-component', '', '<p>The users extension lets your site visitors register, login and logout, change their passwords and other information, and recover lost passwords. In the administrator it allows you to create, block and manage users and create user groups and access levels. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Users_User_Manager">Help</a></p>\r\n<p>Please note that some of the user views will not display if you are not logged in to the site.</p>', '', 1, 0, 0, 21, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-01-10 04:52:55', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 5, '', '', 1, 21, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(53, 151, 'Using Joomla!', 'using-joomla', '', '<p>With Joomla! You can create anything from a simple personal website to a complex ecommerce or social site with millions of visitors.</p><p>This section of the sample data provides you with a brief introduction to Joomla! concepts and reference material to help you understand how Joomla! works.</p><p><em>When you no longer need the sample data, you can can simply unpublish the sample data category found within each extension in the site administrator or you may completely delete each item and all of the categories. </em></p>', '', 1, 0, 0, 19, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 7, '', '', 1, 143, '', 0, '*', ''),
(54, 152, 'Weblinks', 'weblinks', '', '<p>Weblinks (com_weblinks) is a component that provides a structured way to organize external links and present them in a visually attractive, consistent and informative way. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Weblinks_Links">Help</a></p>', '', 1, 0, 0, 21, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-01-10 04:20:10', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 6, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(55, 153, 'Weblinks Module', 'weblinks-module', '', '<p>This module displays the list of weblinks in a category. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Weblinks" title="Weblinks Module">Help</a></p>\r\n<div class="sample-module">{loadmodule weblinks,Weblinks}</div>', '', 1, 0, 0, 66, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:32:10', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 7, 0, 5, '', '', 1, 23, '', 0, '*', ''),
(56, 154, 'Who\'s Online', 'whos-online', '', '<p>The Who\'s Online Module displays the number of Anonymous Users (e.g. Guests) and Registered Users (ones logged in) that are currently accessing the Web site. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Who_Online" title="Who\'s Online">Help</a></p>\r\n<div class="sample-module">{loadmodule whosonline,Who\'s Online}</div>', '', 1, 0, 0, 65, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:19:45', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 1, '', '', 1, 5, '', 0, '*', ''),
(57, 155, 'Wobbegone', 'wobbegone', '', '<p><img src="images/sampledata/parks/animals/180px_wobbegong.jpg" border="0" alt="Wobbegone" style="vertical-align: middle; border: 0;" /></p>', '<p><img src="images/sampledata/parks/animals/800px_wobbegong.jpg" border="0" style="vertical-align: middle; border: 0;" /></p><p>Source: http://en.wikipedia.org/wiki/File:Wobbegong.jpg</p><p>Author: Richard Ling</p><p>Rights: GNU Free Documentation License v 1.2 or later</p>', 1, 0, 0, 72, '2011-01-01 00:00:01', 42, 'Parks Webmaster', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 1, '', '', 1, 0, '', 0, '*', ''),
(58, 156, 'Wonderful Watermelon', 'wonderful-watermelon', '', '<p>Watermelon is a wonderful and healthy treat. We grow the world\'s sweetest watermelon. We have the largest watermelon patch in our country.</p>', '', 1, 0, 0, 30, '2011-01-01 00:00:01', 42, 'Fruit Shop Webmaster', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 1, '', '', 1, 0, '', 0, '*', ''),
(59, 157, 'Wrapper Module', 'wrapper-module', '', '<p>This module shows an iFrame window to specified location. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Wrapper" title="Wrapper Module">Help</a></p>\r\n<div class="sample-module">{loadmodule wrapper,Wrapper}</div>', '', 1, 0, 0, 67, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:35:00', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 8, 0, 1, '', '', 1, 15, '', 0, '*', ''),
(60, 158, 'News Feeds', 'news-feeds', '', '<p>News Feeds (com_newsfeeds) provides a way to organize and present news feeds. News feeds are a way that you present information from another site on your site. For example, the joomla.org website has numerous feeds that you can incorporate on your site. You an use menus to present a single feed, a list of feeds in a category, or or a list of all feed categories. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Newsfeeds_Feeds">Help</a></p>', '', 1, 0, 0, 21, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-01-10 04:17:08', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 4, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(61, 159, 'Breadcrumbs Module', 'breadcrumbs-module', '', '<p>Breadcrumbs provide a pathway for users to navigate through the site. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Breadcrumbs" title="Breacrumbs Module">Help</a></p>\r\n<div class="sample-module">{loadmodule breadcrumbs,breadcrumbs}</div>', '', 1, 0, 0, 75, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:10:19', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 5, 0, 2, '', '', 1, 8, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(62, 160, 'Content', 'content-plugins', '', '<p>Content plugins run when specific kinds of pages are loaded. They do things ranging from protecting email addresses from harvesters to creating page breaks.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>Email Cloaking <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Content_-_Email_Cloaking">Help</a></li>\r\n<li>Load Module <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Content_-_Load_Modules">Help</a></li>\r\n<li>Page Break <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Content_-_Pagebreak">Help</a></li>\r\n<li>Page Navigation<a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Content_-_Page_Navigation"> Help</a></li>\r\n<li>VoteÂ <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Content_-_Vote">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>Code Highlighter (GeSHi) <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Content_-_Code_Highlighter_.28GeSHi.29">Help</a></li>\r\n</ul>', '', 1, 0, 0, 25, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-06 06:11:50', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, 7, '', '', 1, 1, '', 0, '*', ''),
(64, 162, 'Blue Mountain Rain Forest', 'blue-mountain-rain-forest', '', '<p><img src="images/sampledata/parks/landscape/120px_rainforest_bluemountainsnsw.jpg" border="0" alt="Rain Forest Blue Mountrains" /></p>', '<p><img src="images/sampledata/parks/landscape/727px_rainforest_bluemountainsnsw.jpg" border="0" alt="Rain Forest Blue Mountrains" style="vertical-align: middle;" /></p><p>Â </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Rainforest,bluemountainsNSW.jpg</p><p class="caption">Author: Adam J.W.C.</p><p class="caption">License: GNU Free Documentation License</p>', 1, 0, 0, 73, '2011-01-01 00:00:01', 42, 'Parks Webmaster', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 2, '', '', 1, 0, '', 0, '*', ''),
(65, 163, 'Ormiston Pound', 'ormiston-pound', '', '<p><img src="images/sampledata/parks/landscape/180px_ormiston_pound.jpg" border="0" alt="Ormiston Pound" style="border: 0;" /></p>', '<p><img src="images/sampledata/parks/landscape/800px_ormiston_pound.jpg" border="0" alt="Ormiston Pound" height="375" style="vertical-align: middle; border: 0;" /></p><p>Â </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Ormiston_Pound.JPG</p><p class="caption">Author:</p><p class="caption">License: GNU Free Public Documentation License</p>', 1, 0, 0, 73, '2011-01-01 00:00:01', 42, 'Parks Webmaster', '2011-01-01 00:00:01', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 3, '', '', 1, 0, '', 0, '*', ''),
(66, 165, 'Latest Users Module', 'latest-users-module', '', '<p>This module displays the latest registered users. <a href="http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Latest_Users">Help</a></p>\r\n<div class="sample-module">{loadmodule users_latest,Users Latest}</div>', '', 1, 0, 0, 65, '2011-01-01 00:00:01', 42, 'Joomla!', '2011-09-17 22:21:05', 42, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"1","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 0, 3, '', '', 1, 6, '', 0, '*', ''),
(67, 168, 'What\'s New in 1.5?', 'whats-new-in-15', '', '<p>This article deliberately archived as an example.</p><p>As with previous releases, Joomla! provides a unified and easy-to-use framework for delivering content for Web sites of all kinds. To support the changing nature of the Internet and emerging Web technologies, Joomla! required substantial restructuring of its core functionality and we also used this effort to simplify many challenges within the current user interface. Joomla! 1.5 has many new features.</p>\r\n<p style="margin-bottom: 0in;">In Joomla! 1.5, you\'\'ll notice:</p>\r\n<ul>\r\n<li>Substantially improved usability, manageability, and scalability far beyond the original Mambo foundations</li>\r\n<li>Expanded accessibility to support internationalisation, double-byte characters and right-to-left support for Arabic, Farsi, and Hebrew languages among others</li>\r\n<li>Extended integration of external applications through Web services</li>\r\n<li>Enhanced content delivery, template and presentation capabilities to support accessibility standards and content delivery to any destination</li>\r\n<li>A more sustainable and flexible framework for Component and Extension developers</li>\r\n<li>Backward compatibility with previous releases of Components, Templates, Modules, and other Extensions</li>\r\n</ul>', '', 2, 0, 0, 9, '2011-01-01 00:00:01', 42, 'Joomla! 1.5', '2011-01-01 00:00:01', 0, 0, '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(68, 170, 'Typography', 'typography', '', '<div id="ja-typo">\r\n<p>This page presents most of typographical aspects of JA T3v2 Framework. <span class="highlight">Make your readers happy</span> with great Typography and User Experience!</p>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Preformatted text</span></h1>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Headings</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<h1>This is a sample Heading 1. Lorem ipsum.</h1>\r\n<h2>This is a sample Heading 2. Lorem ipsum.</h2>\r\n<h3>This is a sample Heading 3. Lorem ipsum.</h3>\r\n<h4>This is a sample Heading 4. Lorem ipsum.</h4>\r\n<h5>This is a sample Heading 5. Lorem ipsum.</h5>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Special Content</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p>Below is a sample of <strong>pre</strong> tag or <strong>code</strong> class:</p>\r\n<pre>#ja-rightcol {\r\n  width: 180px;\r\n  float: right;\r\n  color: #EEEEEE;\r\n}\r\n</pre>\r\n<p>This is a <span class="highlight">highlight phrase</span>. Use <strong>class="highlight"</strong>.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Blockquote</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<blockquote><span class="open">T</span>his is a sample <strong>Blockquote</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</blockquote>\r\n<blockquote><span class="open">T</span>his is a sample Blockquote. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.<span class="close">!</span></blockquote>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Dropcaps</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p><span class="dropcap">T</span>his is a Magazine Style Drop Cap. The first letter in this paragraph is big. JA Templates bring into your Jooomla template the magazine drop cap technique and CSS2 includes the first-letter pseudo class.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Lists Style</span></h1>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block first clearfix">\r\n<h2 class="ja-typo-title"><span>Ordered List</span></h2>\r\n<div class="ja-typo-blockct clearfix"><ol>\r\n<li>This is a sample <strong>Ordered List</strong>.</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n</ol></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Un-Ordered List</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<ul>\r\n<li>This is a sample <strong>Unordered List</strong>.</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block last clearfix">\r\n<h2 class="ja-typo-title"><span>Definition List</span></h2>\r\n<div class="ja-typo-blockct clearfix"><dl><dt>This is a sample <strong>Definition List</strong>.</dt><dd>Condimentum quis.</dd><dd>Congue Quisque augue elit dolor.</dd><dd>Congue Quisque augue elit dolor.</dd></dl></div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<h2 class="ja-typo-title"><span>Special Unordered Lists</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<ul class="ja-typo-list list-arrow">\r\n<li><span class="icon">&nbsp;  </span>This is a sample <strong>Arrow list</strong>.</li>\r\n<li><span class="icon">&nbsp; </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</li>\r\n<li><span class="icon">&nbsp; </span>This is a sample Arrowlist.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<ul class="ja-typo-list list-star">\r\n<li><span class="icon">&nbsp;  </span>This is a sample <strong>Star list</strong>.</li>\r\n<li><span class="icon">&nbsp;  </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</li>\r\n<li><span class="icon">&nbsp;  </span>This is a sample Starlist.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<ul class="ja-typo-list list-check">\r\n<li><span class="icon">&nbsp;  </span>This is a sample <strong>Check list</strong>.</li>\r\n<li><span class="icon">&nbsp;  </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</li>\r\n<li><span class="icon">&nbsp;  </span>This is a sample Checklist.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<h2 class="ja-typo-title"><span>Block Number</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="blocknumber blocknumber-1"><span class="bignumber">01</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="blocknumber blocknumber-1"><span class="bignumber">02</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="blocknumber blocknumber-1"><span class="bignumber">03</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="blocknumber blocknumber-2"><span class="bignumber">A</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="blocknumber blocknumber-2"><span class="bignumber">B</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="blocknumber blocknumber-2"><span class="bignumber">C</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="blocknumber blocknumber-3"><span class="bignumber">a</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="blocknumber blocknumber-3"><span class="bignumber">b</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="blocknumber blocknumber-3"><span class="bignumber">c</span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Icons Style</span></h1>\r\n<div class="ja-typo-blockrow cols-2 clearfix">\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-icon icon-error"><span class="icon">&nbsp;  </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-message"><span class="icon">&nbsp;  </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-tips"><span class="icon">&nbsp;  </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-key"><span class="icon">&nbsp;  </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-tag"><span class="icon">&nbsp;  </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-icon icon-cart"><span class="icon">&nbsp;  </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-doc"><span class="icon">&nbsp;  </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-note"><span class="icon">&nbsp;  </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-photo"><span class="icon">&nbsp;  </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-icon icon-mobi"><span class="icon">&nbsp;  </span>Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Bubbles</span></h1>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Grey Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-1">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-2">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Blue Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-3">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-4">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Black Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-5">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-6">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Grey Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-rounded bubble-1">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-rounded bubble-2">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Blue Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-rounded bubble-3">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-rounded bubble-4">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Black Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-rounded bubble-5">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-rounded bubble-6">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Message Boxes &amp; Legend Styles</span></h1>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Message Boxes with Icons</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-sticky"><strong>This is a sticky</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-box box-download"><strong>This is a download box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Message Boxes - Style 1</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-grey-1"><strong>This is a grey box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-box box-hilite-1"><strong>This is a hilite box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Message Boxes - Style 2</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-grey-2"><strong>This is a grey box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-box box-hilite-2"><strong>This is a hilite box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Message Boxes with Icons</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-rounded box-sticky"><strong>This is a sticky</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-box box-rounded box-download"><strong>This is a download box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Message Boxes - Style 1</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-rounded box-grey-1"><strong>This is a grey box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-box box-rounded box-hilite-1"><strong>This is a hilite box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Message Boxes - Style 2</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-rounded box-grey-2"><strong>This is a grey box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n<p class="ja-typo-box box-rounded box-hilite-2"><strong>This is a hilite box</strong>. Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id. Interdum pharetra in a metus congue In Sed Pellentesque tincidunt pharetra.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-2 clearfix">\r\n<h2 class="ja-typo-title"><span>Legends</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-legend legend-1">\r\n<h3 class="legend-title">Legend - Style 1</h3>\r\nLorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae.</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-legend legend-2">\r\n<h3 class="legend-title">Legend - Style 2</h3>\r\nLorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae.</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-2 clearfix">\r\n<h2 class="ja-typo-title"><span>Rounded Legends</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-legend legend-rounded legend-1">\r\n<h3 class="legend-title">Rounded Legend - Style 1</h3>\r\nLorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae.</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-legend legend-rounded legend-2">\r\n<h3 class="legend-title">Rounded Legend - Style 2</h3>\r\nLorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae.</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Buttons &amp; Tags</span></h1>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Big Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-blue ja-typo-btn-big btn-big-blue" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-green ja-typo-btn-big btn-big-green" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-red ja-typo-btn-big btn-big-red" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-orange ja-typo-btn-big btn-big-orange" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-black ja-typo-btn-big btn-big-black" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-grey ja-typo-btn-big btn-big-grey" href="#"><span>Button Text</span></a></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Icon Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn ja-typo-btn-icn btn-icn-save" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn ja-typo-btn-icn btn-icn-tip" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn ja-typo-btn-icn btn-icn-warning" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn ja-typo-btn-icn btn-icn-info" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn ja-typo-btn-icn btn-icn-ok" href="#"><span><span>Button Text</span></span></a></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Small Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-blue ja-typo-btn-sm btn-sm-blue" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-green ja-typo-btn-sm btn-sm-green" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-red ja-typo-btn-sm btn-sm-red" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-orange ja-typo-btn-sm btn-sm-orange" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-black ja-typo-btn-sm btn-sm-black" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-grey ja-typo-btn-sm btn-sm-grey" href="#"><span>Button Text</span></a></div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Big Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-rounded-big btn-blue ja-typo-btn-big btn-big-blue" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-green ja-typo-btn-big btn-big-green" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-red ja-typo-btn-big btn-big-red" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-orange ja-typo-btn-big btn-big-orange" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-black ja-typo-btn-big btn-big-black" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-grey ja-typo-btn-big btn-big-grey" href="#"><span>Button Text</span></a></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Icon Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-save" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-tip" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-warning" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-info" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-ok" href="#"><span><span>Button Text</span></span></a></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Small Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-rounded-sm btn-blue ja-typo-btn-sm btn-sm-blue" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-green ja-typo-btn-sm btn-sm-green" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-red ja-typo-btn-sm btn-sm-red" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-orange ja-typo-btn-sm btn-sm-orange" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-black ja-typo-btn-sm btn-sm-black" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-grey ja-typo-btn-sm btn-sm-grey" href="#"><span>Button Text</span></a></div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-2 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Squared Tags</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p>This is a sample <span class="ja-typo-tag tag-grey">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-blue">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-green">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-red">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-orange">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-black">Inline Tag</span>. Use this to provide useful information.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Tags</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-grey">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-blue">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-green">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-red">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-orange">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-black">Inline Tag</span>. Use this to provide useful information.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Special Module Style</span></h1>\r\n<div class="ja-typo-blockrow cols-4 clearfix">\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="moduletable moduletable_badge badge-top"><span class="badge">&nbsp;  </span>\r\n<div class="ja-box-ct">Use module suffix: <strong>_badge badge-top</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="moduletable moduletable_badge badge-new"><span class="badge">&nbsp;  </span>\r\n<div class="ja-box-ct">Use module suffix: <strong>_badge badge-new</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="moduletable moduletable_badge badge-vote"><span class="badge">&nbsp;</span>\r\n<div class="ja-box-ct">Use module suffix: <strong>_badge badge-vote</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="moduletable moduletable_badge badge-hot" style="margin-right: 0;"><span class="badge">&nbsp;  </span>\r\n<div class="ja-box-ct">Use module suffix: <strong>_badge badge-hot</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Forms</span></h1>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<h2 class="ja-typo-title"><span>Form Fieldset</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix"><fieldset><legend>Templates Fieldset</legend> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien suscipit ac.</fieldset></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix"><fieldset class="ja-typo-fieldset fieldset-1"><legend>Special Fieldset - Style 1</legend> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est.</fieldset></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix"><fieldset class="ja-typo-fieldset fieldset-2"><legend>Special Fieldset - Style 2</legend> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est.</fieldset></div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<h2 class="ja-typo-title"><span>Form Elements</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix"><form id="formelements" action="#" method="post">\r\n<p><label for="input">Sample Input 1</label> <br /> <input id="input" class="inputbox" type="text" name="input" /></p>\r\n<p><label for="input2">Sample Input 2</label> <br /> <input id="input2" class="inputbox" type="text" name="input2" /></p>\r\n<p><input id="radio" type="radio" name="radio" /><label for="radio">Sample Radio Input</label> <input id="checkbox" type="checkbox" name="checkbox" /><label for="checkbox">Sample CheckBox Input</label></p>\r\n<p><label for="select">Sample Select Field:</label><br /> <select id="select"><option>Option One</option><option>Option Two</option></select></p>\r\n<p><label for="textfield">Sample Textarea Field:</label><br /> <textarea id="textfield" name="textfield" rows="5" cols="45"></textarea></p>\r\n<p><input id="button" class="button" type="submit" name="button" value="Submit" /> <input id="button2" class="button" type="reset" name="button2" value="Reset" /></p>\r\n</form></div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>', '', 1, 0, 0, 9, '2011-12-05 03:17:24', 42, '', '2012-07-11 02:25:23', 42, 42, '2012-07-11 02:25:23', '2011-12-05 03:17:24', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 8, 0, 2, '', '', 1, 98, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(69, 174, 'Curabitur mollis ', 'curabitur-mollis', '', '<!-- {jaimage main="images/stories/demo/slideshow/sl-1.jpg" thumb="images/stories/demo/slideshow/sl-1.jpg"} -->\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?</p>', '', 1, 0, 0, 77, '2011-12-05 06:45:09', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-12-05 06:45:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(70, 175, 'Etiam interdum faucibus lacus', 'etiam-interdum-faucibus-lacus', '', '<!-- {jaimage main="images/stories/demo/slideshow/sl-2.jpg"} thumb="images/stories/demo/slideshow/sl-2.jpg"} -->\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?</p>', '', 1, 0, 0, 77, '2011-12-05 06:47:54', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-12-05 06:47:54', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(71, 176, 'Maecenas vitae orci dignissim', 'maecenas-vitae-orci-dignissim', '', '<!-- {jaimage main="images/stories/demo/slideshow/sl-3.jpg"} thumb="images/stories/demo/slideshow/sl-3.jpg"} -->\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?</p>', '', 1, 0, 0, 77, '2011-12-05 06:49:38', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-12-05 06:49:38', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(72, 177, 'Say hello to Joomlart business', 'say-hello-to-joomlart-business', '', '<!-- {jaimage main="images/stories/demo/slideshow/sl-4.jpg"} thumb="images/stories/demo/slideshow/sl-4.jpg"} -->\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?</p>', '', 1, 0, 0, 77, '2011-12-05 06:50:47', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-12-05 06:50:47', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 2, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(73, 178, 'Sed tempus justo it', 'sed-tempus-justo-it', '', '<!-- {jaimage main="images/stories/demo/slideshow/sl-5.jpg"} thumb="images/stories/demo/slideshow/sl-5.jpg"} -->\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?</p>', '', 1, 0, 0, 77, '2011-12-05 06:51:53', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-12-05 06:51:53', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(74, 179, 'Welcome to my website', 'welcome-to-my-website', '', '<!-- {jaimage main="images/stories/demo/slideshow/sl-6.jpg"} thumb="images/stories/demo/slideshow/sl-6.jpg"} -->\r\n<p>Public education is crying out for leaders. This may seem strange when there is no shortage of people in leadership positions. They have attained degrees, certification, experience, and titles that qualify them to direct and supervise other educators. Nulla id risus purus, nec porttitor metus. Nunc accumsan, enim vitae rhoncus pellentesque, libero enim dapibus nisl, sollicitudin aliquet diam magna quis mi. Nam id nisi sapien, at blandit tortor. Ut lorem tortor, euismod nec tincidunt quis, fringilla et neque. Sed gravida feugiat diam ac sagittis. Ut lorem tortor, euismod nec tincidunt quis, fringilla et neque.</p>', '', 1, 0, 0, 77, '2011-12-05 06:53:54', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-12-05 06:53:54', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(75, 184, 'Lorem ipsum dolor sit', 'lorem-ipsum-dolor-sit', '', '<div><img src="images/stories/demo/world/af-6.jpg" border="0" alt="Aenean Donec gravida hendrerit" title="Sample image" align="left" /></div>\r\n<p>Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel.</p>\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 0, 0, 78, '2011-12-06 04:30:00', 42, '', '2011-12-15 06:52:20', 42, 0, '0000-00-00 00:00:00', '2011-12-06 04:30:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(76, 185, 'About K2 ', 'about-k2', '', '<img src="images/stories/demo/sample-09.jpg" border="0" align="right" alt="GetK2" class="img-border" />\r\n\r\n{jathumbnail off images="images/stories/demo/sample-09.jpg"}\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer vel nunc eros tempus magnis. Lorem ante eros pulvinar laoreet interdum Phasellus vitae id risus Nulla. Convallis Proin at lobortis leo Quisque eros habitasse ornare sed Suspendisse. Orci ligula Sed urna libero pellentesque Integer risus sed gravida semper. Dui justo Nam nec mauris Curabitur Curabitur lobortis eros felis eros. Lacinia egestas Quisque est fermentum In ac lobortis fermentum tincidunt eu. Cursus accumsan.</p>\r\n\r\n<p>Nam orci montes sem iaculis risus adipiscing Nam nunc id id. Cursus tempor turpis mauris leo Pellentesque at eget senectus lacus vitae. Porta adipiscing felis Donec ligula sapien dui eget enim quis sapien. Phasellus tincidunt ipsum vel id ultrices laoreet ac interdum Nam quis. Mauris Lorem ut Phasellus Nam adipiscing velit ac egestas feugiat ac. Lacus suscipit Lorem Nullam in Nam vel semper Vivamus lacinia lacinia. Vestibulum a sollicitudin.</p>\r\n\r\n<p>Nibh eros lorem Nunc tincidunt libero adipiscing tempor nulla tincidunt convallis. Turpis est rhoncus lacinia adipiscing vitae et Pellentesque Nam leo ornare. Tincidunt non nibh interdum id nec et est nulla leo justo. Urna id sed quis vel Nullam urna non laoreet et Aenean. Pharetra adipiscing Integer interdum nibh id justo ac Donec fermentum auctor. Ac orci Phasellus fringilla ornare Vestibulum sit dapibus Nam arcu Phasellus. Condimentum nibh.</p>\r\n\r\n<p>Faucibus elit morbi dignissim auctor In id ultrices quis Nunc ipsum. Interdum platea nibh id massa penatibus nunc tristique montes Nullam habitasse. Tellus sit faucibus sagittis pretium cursus Pellentesque porttitor sed ligula eros. Curabitur adipiscing elit Pellentesque eget ipsum Pellentesque tincidunt volutpat ante velit. At risus lacinia molestie ridiculus non enim Nulla iaculis pellentesque interdum. Id velit lacus sapien magnis sapien.</p>\r\n', '', 1, 0, 0, 9, '2011-12-06 04:45:47', 42, '', '2011-12-29 09:12:07', 42, 0, '0000-00-00 00:00:00', '2011-12-06 04:45:47', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 11, 0, 1, '', '', 1, 56, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(77, 198, 'On Eve of Key Meeting, New Rifts on Euro Emerge', 'on-eve-of-key-meeting-new-rifts-on-euro-emerge', '', '<p><img class="caption" src="images/stories/demo/world/eu-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris.</p>\r\n', '\r\n<p><img class="caption" src="images/stories/demo/world/eu-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy. Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus.</p>\r\n<p>Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n<div id="html_content" style="display: none;">Laoreet ac Nullam pretium nibh ac Ut pellentesque nunc turpis rhoncus. Neque felis enim eget pellentesque ullamcorper Morbi nunc interdum eget Integer. Tristique vitae mauris scelerisque lacinia.</div>\r\n<p>Adipiscing {highslide event=\'drop-shadow\' outlineType=\'drop-shadow\' type=\'html\' contentid=\'html_content\' width=300 height=150} leo quis wisi justo{/highslide} dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<blockquote><span class="open">L</span>orem ipsum dolor sit amet consectetuer ut mauris at Nam id. <span class="highlight">Nam nec semper quis congue Donec</span> netus odio eu id consequat. Massa enim semper pellentesque Cras Sed neque congue dolor habitasse dui. Tempus In cursus Vestibulum Quisque at at ut dolor ut a. Tincidunt elit Integer venenatis Vestibulum libero at id orci dolor justo. Ornare dictum non orci ligula odio tempor orci neque urna Nam. Ornare vitae vita<span class="close">e.</span></blockquote>\r\n<p>Vestibulum libero habitant sapien aliquet tortor Aenean lacinia laoreet justo sapien. Enim Pellentesque augue leo et montes consequat enim justo elit Nam. Feugiat cursus malesuada dui mollis fermentum justo congue nec nibh feugiat. Gravida justo nec risus ligula pede metus senectus tempor Maecenas massa. Laoreet nulla eros id congue ante purus scelerisque mauris semper elit. Duis Vestibulum cursus.</p>\r\n<p>Semper augue dolor tellus at vel magna vitae et Aliquam Vestibulum. Ut Sed eu orci auctor tellus interdum ac tincidunt id est. In rhoncus nibh Curabitur Curabitur quis massa mattis eget tincidunt cursus. Tortor ipsum nec cursus laoreet vitae feugiat id pellentesque Aenean Sed. Natoque Nulla risus magna justo Sed Phasellus leo.</p>\r\n<p>Scelerisque velit semper Suspendisse sociis consectetuer consequat Vestibulum semper vel interdum. Sed faucibus adipiscing augue justo nec cursus eget commodo semper lacinia. Donec tellus Sed porttitor Nullam natoque urna ac ut odio ut. Pellentesque enim Suspendisse natoque tellus risus Nam convallis dui ac massa. Urna id Nulla Nullam Sed mauris et ac sagittis Cum nunc. Vitae.</p>', 1, 0, 0, 83, '2011-12-08 03:11:57', 42, '', '0000-00-00 00:00:00', 0, 42, '2011-12-13 09:42:31', '2011-12-08 03:11:57', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(78, 199, 'Germany Set to Offer Banks Help on Reserves', 'germany-set-to-offer-banks-help-on-reserves', '', '<div><img src="images/stories/demo/world/eu-3.jpg" border="0" alt="Augue et montes montes ut" title="Sample image" align="left" /></div>\r\n<p>Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean.</p>\r\n', '\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet. Vel et et fames pellentesque semper eu arcu laoreet mauris Sed. Lobortis Donec neque sapien elit nibh egestas neque vel lorem id. Consequat Nulla at egestas et risus dis Sed semper id fringilla. Hendrerit tincidunt pretium lobortis at Curabitur id auctor semper pede hac. At gravida eu.</p>\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>\r\n<p>Et consequat et magnis fringilla urna massa dui mi eget vel. Rhoncus vestibulum leo ac eget et venenatis Curabitur eu at tortor. Nam Nulla consectetuer velit Nam in vel scelerisque ac dictum molestie. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>', 1, 0, 0, 83, '2011-12-08 03:13:03', 42, '', '2011-12-13 09:41:00', 42, 0, '0000-00-00 00:00:00', '2011-12-08 03:13:03', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 6, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(79, 200, 'Gorbachev Calls for New Vote', 'gorbachev-calls-for-new-vote-in-disputed-russian-elections', '', '<div><img src="images/stories/demo/world/eu-5.jpg" border="0" alt="Ornare nisl nibh leo a nulla" title="Sample image" align="left" /></div>\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede.</p>\r\n', '\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet. Vel et et fames pellentesque semper eu arcu laoreet mauris Sed. Lobortis Donec neque sapien elit nibh egestas neque vel lorem id. Consequat Nulla at egestas et risus dis Sed semper id fringilla. Hendrerit tincidunt pretium lobortis at Curabitur id auctor semper pede hac. At gravida eu.</p>\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>\r\n<p>Et consequat et magnis fringilla urna massa dui mi eget vel. Rhoncus vestibulum leo ac eget et venenatis Curabitur eu at tortor. Nam Nulla consectetuer velit Nam in vel scelerisque ac dictum molestie. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>', 1, 0, 0, 83, '2011-12-08 03:13:56', 42, '', '2011-12-13 09:42:13', 42, 0, '0000-00-00 00:00:00', '2011-12-08 03:13:56', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(85, 206, 'At Climate Talks, a Familiar Standoff Between U.S. and China', 'at-climate-talks-a-familiar-standoff-between-us-and-china', '', '<img src="images/stories/demo/world/us-7.jpg" border="0" alt="Ante semper sapien lorem" title="Sample image" align="left" />\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum.</p>\r\n', '\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 0, 0, 82, '2011-12-08 03:29:59', 42, '', '2011-12-13 09:55:28', 42, 0, '0000-00-00 00:00:00', '2011-12-08 03:29:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 7, 0, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(80, 201, 'British Police Arrest Man In Scandal ', 'british-police-arrest-man-in-scandal-over-hacking', '', '<div><img src="images/stories/demo/world/eu-1.jpg" border="0" alt="Augue et montes montes ut" title="Sample image" align="left" /></div>\r\n<p>Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean.</p>\r\n', '\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet. Vel et et fames pellentesque semper eu arcu laoreet mauris Sed. Lobortis Donec neque sapien elit nibh egestas neque vel lorem id. Consequat Nulla at egestas et risus dis Sed semper id fringilla. Hendrerit tincidunt pretium lobortis at Curabitur id auctor semper pede hac. At gravida eu.</p>\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>\r\n<p>Et consequat et magnis fringilla urna massa dui mi eget vel. Rhoncus vestibulum leo ac eget et venenatis Curabitur eu at tortor. Nam Nulla consectetuer velit Nam in vel scelerisque ac dictum molestie. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>', 1, 0, 0, 83, '2011-12-08 03:16:26', 42, '', '2011-12-13 09:40:02', 42, 0, '0000-00-00 00:00:00', '2011-12-08 03:16:26', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(81, 202, 'Gangster in Italy arrested', 'gangster-in-italy-arrested-after-16-year-manhunt', '', '<div><img src="images/stories/demo/world/eu-2.jpg" border="0" alt="Augue et montes montes ut" title="Sample image" align="left" /></div>\r\n<p>Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean.</p>\r\n', '\r\n<div><img src="images/stories/demo/world/eu-5.jpg" border="0" alt="Friends Agrees to Resolution Takeover " title="Sample image" align="left" /></div>\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet. Vel et et fames pellentesque semper eu arcu laoreet mauris Sed. Lobortis Donec neque sapien elit nibh egestas neque vel lorem id. Consequat Nulla at egestas et risus dis Sed semper id fringilla. Hendrerit tincidunt pretium lobortis at Curabitur id auctor semper pede hac. At gravida eu.</p>\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>\r\n<p>Et consequat et magnis fringilla urna massa dui mi eget vel. Rhoncus vestibulum leo ac eget et venenatis Curabitur eu at tortor. Nam Nulla consectetuer velit Nam in vel scelerisque ac dictum molestie. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>', 1, 0, 0, 83, '2011-12-08 03:17:21', 42, '', '2011-12-26 04:37:32', 42, 42, '2011-12-26 04:37:32', '2011-12-08 03:17:21', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(82, 203, 'Plan for Online Freedoms Stalls at European Meeting', 'plan-for-online-freedoms-stalls-at-european-meeting', '', '<div><img src="images/stories/demo/world/eu-3.jpg" border="0" alt="Augue et montes montes ut" title="Sample image" align="left" /></div>\r\n<p>Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean.</p>\r\n', '\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet. Vel et et fames pellentesque semper eu arcu laoreet mauris Sed. Lobortis Donec neque sapien elit nibh egestas neque vel lorem id. Consequat Nulla at egestas et risus dis Sed semper id fringilla. Hendrerit tincidunt pretium lobortis at Curabitur id auctor semper pede hac. At gravida eu.</p>\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>\r\n<p>Et consequat et magnis fringilla urna massa dui mi eget vel. Rhoncus vestibulum leo ac eget et venenatis Curabitur eu at tortor. Nam Nulla consectetuer velit Nam in vel scelerisque ac dictum molestie. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>', 1, 0, 0, 83, '2011-12-08 03:18:24', 42, '', '2011-12-13 09:47:06', 42, 0, '0000-00-00 00:00:00', '2011-12-08 03:18:24', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(83, 204, 'J! 2.5 template: Brinkmanship for Debt Crisis', 'j-2-5-template-brinkmanship-for-debt-crisis', '', '<div><img src="images/stories/demo/world/eu-5.jpg" border="0" alt="Augue et montes montes ut" title="Sample image" align="left" /></div>\r\n<p>Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean.</p>\r\n', '\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet. Vel et et fames pellentesque semper eu arcu laoreet mauris Sed. Lobortis Donec neque sapien elit nibh egestas neque vel lorem id. Consequat Nulla at egestas et risus dis Sed semper id fringilla. Hendrerit tincidunt pretium lobortis at Curabitur id auctor semper pede hac. At gravida eu.</p>\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>\r\n<p>Et consequat et magnis fringilla urna massa dui mi eget vel. Rhoncus vestibulum leo ac eget et venenatis Curabitur eu at tortor. Nam Nulla consectetuer velit Nam in vel scelerisque ac dictum molestie. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>', 1, 0, 0, 83, '2011-12-08 03:19:23', 42, '', '2012-02-18 10:25:51', 42, 42, '2012-06-20 03:24:19', '2011-12-08 03:19:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 4, 0, 1, 'Joomla news site 2.5 template, Joomla 2.5 template site news, Joomla 2.5 site news template', 'Joomla 2.5 template for world and local news. ', 1, 10, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(84, 205, 'Biden Treads Softly in Greece', 'biden-treads-softly-in-greece', '', '<div><img src="images/stories/demo/world/eu-1.jpg" border="0" alt="Augue et montes montes ut" title="Sample image" align="left" /></div>\r\n<p>Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean.</p>\r\n', '\r\n<div><img src="images/stories/demo/world/eu-3.jpg" border="0" alt="Friends Agrees to Resolution Takeover " title="Sample image" align="left" /></div>\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet. Vel et et fames pellentesque semper eu arcu laoreet mauris Sed. Lobortis Donec neque sapien elit nibh egestas neque vel lorem id. Consequat Nulla at egestas et risus dis Sed semper id fringilla. Hendrerit tincidunt pretium lobortis at Curabitur id auctor semper pede hac. At gravida eu.</p>\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>\r\n<p>Et consequat et magnis fringilla urna massa dui mi eget vel. Rhoncus vestibulum leo ac eget et venenatis Curabitur eu at tortor. Nam Nulla consectetuer velit Nam in vel scelerisque ac dictum molestie. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>', 1, 0, 0, 83, '2011-12-08 03:20:28', 42, '', '2011-12-13 09:39:40', 42, 0, '0000-00-00 00:00:00', '2011-12-08 03:20:28', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 0, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(86, 207, 'South Korea to Send $5.7 Million in Aid to North Korea', 'south-korea-to-send-57-million-in-aid-to-north-korea', '', '<p><img src="images/stories/demo/world/us-3.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n', '\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 0, 0, 82, '2011-12-08 03:30:57', 42, '', '2011-12-13 09:04:01', 42, 0, '0000-00-00 00:00:00', '2011-12-08 03:30:57', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 6, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(87, 208, 'TimesCast  Attacks On Afghan Shiites', 'timescast-attacks-on-afghan-shiites', '', '<img src="images/stories/demo/world/us-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" />\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis.</p>\r\n', '\r\n<p>Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut. Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>', 1, 0, 0, 82, '2011-12-08 03:31:53', 42, '', '2011-12-13 09:55:53', 42, 0, '0000-00-00 00:00:00', '2011-12-08 03:31:53', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 6, 0, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(88, 209, 'Thailand: American Sentenced for Defaming King', 'thailand-american-sentenced-for-defaming-king', '', '<div><img src="images/stories/demo/world/us-6.jpg" border="0" alt="Pellentesque odio dapibus" title="Sample image" align="left" /></div>\r\n<p>Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec.</p>\r\n', '\r\n<div><img src="images/stories/demo/world/us-2.jpg" border="0" alt="Obama and the Practice of Medicine" title="Sample image" align="left" /></div>\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 0, 0, 82, '2011-12-08 03:32:42', 42, '', '2011-12-13 09:05:20', 42, 0, '0000-00-00 00:00:00', '2011-12-08 03:32:42', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(89, 210, 'Beijing\'s Smoggy Skies', 'beijings-smoggy-skies', '', '<div><img src="images/stories/demo/world/us-3.jpg" border="0" alt="U.S., Mexico, Canada Vow Cooperation " title="Sample image" align="left" /></div>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel.</p>\r\n', '\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. ibh nibh consectetuer semper pretium Cum mauris justo eros. acinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Quam ligula Mauris ac a et morbi eu Vestibulum congue Aenean. Elit diam ut egestas ut et fames Integer pretium interdum molestie. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 0, 0, 82, '2011-12-08 03:34:25', 42, '', '2011-12-13 09:02:00', 42, 0, '0000-00-00 00:00:00', '2011-12-08 03:34:25', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 5, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(90, 211, 'Newswallah: Censorship', 'newswallah-censorship', '', '<p><img src="images/stories/demo/world/us-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis.</p>\r\n', '\r\n<p>Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut. Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<hr title="Tellus et Mauris wisi eu Curabitur" alt="page-2" class="system-pagebreak" />\r\n<p>Tellus et Mauris wisi eu Curabitur hac et Sed adipiscing augue. At ac Morbi sit cursus libero facilisis eget auctor mi semper. Tincidunt ante eu et diam faucibus Aenean pellentesque congue mauris ac. Et pretium augue odio eget orci dolor ipsum Nam senectus consequat. Sed Vivamus condimentum in Vestibulum auctor neque egestas Suspendisse congue ac. Vel quis Aenean hendrerit tortor.</p>\r\n<p>Et velit eu Vestibulum augue volutpat pede tincidunt feugiat tellus ac. Natoque Curabitur semper dictum Vestibulum urna quam et Proin tincidunt et. Phasellus Nam ridiculus et hac Donec platea et vitae convallis wisi. Tellus adipiscing neque et neque sapien augue id nisl Aliquam leo. Accumsan Lorem ipsum semper ligula ac lacinia Nam eget Nam sodales. Quis mauris eu sed et vitae lorem elit dui ipsum montes.</p>\r\n<p>Vitae turpis sit Phasellus ut hendrerit id et Nam Vivamus nulla. Curabitur vitae justo a id ipsum leo et turpis augue Aliquam. Fermentum tempus dui massa sed at Vivamus malesuada neque interdum vitae. Pellentesque Vestibulum quis orci magna eget magna a elit nisl sed. Commodo mollis nunc pretium Nam quis felis Ut Sed justo vel. Risus massa nisl mauris.</p>\r\n<p>Donec Nam commodo at et Vestibulum sed condimentum Donec a at. Morbi tempor Sed cursus Vivamus quis id Praesent pharetra turpis sed. Semper elit lobortis vitae nibh molestie adipiscing enim metus at Sed. Enim ultrices eget ipsum tincidunt ac est arcu lorem pede metus. Faucibus nibh convallis at laoreet tempus ornare commodo tincidunt platea velit. Tellus nibh platea laoreet Quisque Nulla Integer ut congue.</p>\r\n<p>In hendrerit adipiscing amet adipiscing Curabitur ut metus ipsum vel eleifend. Donec est tristique Aliquam nonummy pede augue eu turpis Vivamus felis. Vitae In Integer sagittis sit Quisque senectus dolor a pellentesque consectetuer. Hendrerit Sed elit congue ipsum Sed et ipsum congue ac Phasellus. Semper volutpat sit vel ut enim.</p>\r\n<hr title="What\'s new?" alt="page-3" class="system-pagebreak" />\r\n<p>Et velit eu Vestibulum augue volutpat pede tincidunt feugiat tellus ac. Natoque Curabitur semper dictum Vestibulum urna quam et Proin tincidunt et. Phasellus Nam ridiculus et hac Donec platea et vitae convallis wisi. Tellus adipiscing neque et neque sapien augue id nisl Aliquam leo. Accumsan Lorem ipsum semper ligula ac lacinia Nam eget Nam sodales. Quis mauris eu sed et vitae lorem elit dui ipsum montes.</p>\r\n<p>Vitae turpis sit Phasellus ut hendrerit id et Nam Vivamus nulla. Curabitur vitae justo a id ipsum leo et turpis augue Aliquam. Fermentum tempus dui massa sed at Vivamus malesuada neque interdum vitae. Pellentesque Vestibulum quis orci magna eget magna a elit nisl sed. Commodo mollis nunc pretium Nam quis felis Ut Sed justo vel. Risus massa nisl mauris.</p>\r\n<p>Donec Nam commodo at et Vestibulum sed condimentum Donec a at. Morbi tempor Sed cursus Vivamus quis id Praesent pharetra turpis sed. Semper elit lobortis vitae nibh molestie adipiscing enim metus at Sed. Enim ultrices eget ipsum tincidunt ac est arcu lorem pede metus. Faucibus nibh convallis at laoreet tempus ornare commodo tincidunt platea velit. Tellus nibh platea laoreet Quisque Nulla Integer ut congue.</p>\r\n<h3>This is an heading 3</h3>\r\n<ul>\r\n<li>Et velit eu Vestibulum augue volutpat pede tincidunt</li>\r\n<li>In hendrerit adipiscing amet adipiscing Curabitur</li>\r\n<li>Donec est tristique Aliquam nonummy pede augue eu turpis Vivamus felis</li>\r\n<li>Ac gravida mauris Aenean massa Pellentesque eget pellentesque</li>\r\n</ul>\r\n<p>In hendrerit adipiscing amet adipiscing Curabitur ut metus ipsum vel eleifend. Donec est tristique Aliquam nonummy pede augue eu turpis Vivamus felis. Vitae In Integer sagittis sit Quisque senectus dolor a pellentesque consectetuer. Hendrerit Sed elit congue ipsum Sed et ipsum congue ac Phasellus. Semper volutpat sit vel ut enim.</p>\r\n<p>Id risus convallis Nam magna at Quisque ligula turpis accumsan vitae. Ac gravida mauris Aenean massa Pellentesque eget pellentesque nisl convallis mauris. Magna suscipit wisi congue quis sed feugiat Nam a eget Sed. Nascetur quis malesuada diam gravida Pellentesque id leo turpis sapien nibh. Leo condimentum id pede gravida Nullam.</p>\r\n<p>Tincidunt eros In sed eros magna congue Suspendisse eleifend quis dui. Dis Sed turpis Cum Nulla congue dolor felis In porttitor eget. Risus Sed consectetuer Ut Sed et dui neque velit habitasse cursus. Dui Quisque eget suscipit scelerisque elit nec dignissim penatibus Vivamus mus. Condimentum ac consectetuer congue Nullam ac tristique venenatis sit Vestibulum nec.</p>\r\n<p>Sem consequat ipsum nisl vel Nam feugiat wisi porta tincidunt habitasse. Pellentesque vitae elit vitae accumsan sapien eu sem laoreet tellus ut. Lacus sed et ligula Sed nascetur Aliquam adipiscing sit Nam nulla. Urna iaculis augue neque enim In sed Pellentesque metus ridiculus amet. Nulla massa ut lacus vitae Fusce Lorem Aenean risus at at.</p>\r\n<p><a class="comment" href="#" title="Comment">Your comment</a><a class="video" href="#" title="View video">View video</a></p>', 1, 0, 0, 82, '2011-12-08 04:10:12', 42, '', '2011-12-13 09:04:11', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:10:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 5, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(91, 212, 'Mine Attack Kills 19 Civilians in Afghanistan', 'mine-attack-kills-19-civilians-in-afghanistan', '', '<img src="images/stories/demo/world/us-8.jpg" border="0" alt="Obama and the Practice of Medicine" title="Sample image" align="left" />\r\n<p>Vestibulum et Curabitur Curabitur dapibus nibh pharetra tellus porttitor Lorem nibh. In et Sed amet semper sagittis vestibulum consectetuer sed wisi Proin.</p>\r\n', '\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 0, 0, 82, '2011-12-08 04:12:01', 42, '', '2011-12-13 09:55:41', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:12:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 7, 0, 1, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(92, 213, 'Karzai Says He Will Talk to Pakistan Over Attacks', 'scientific-panel-finds-few-clear-environmental-links-to-breast-cancer', '', '<div><img src="images/stories/demo/world/us-7.jpg" border="0" alt="Pellentesque odio dapibus" title="Sample image" align="left" /></div>\r\n<p>Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec.</p>\r\n', '\r\n<div><img class="caption" src="images/stories/demo/world/us-7.jpg" border="0" alt="Obama and the Practice of Medicine" title="Sample image" align="left" /></div>\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 0, 0, 82, '2011-12-08 04:13:44', 42, '', '2011-12-13 09:02:43', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:13:44', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 0, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(93, 214, 'Al Qaeda blamed for Iraq violence wave', 'al-qaeda-blamed-for-iraq-violence-wave', '', '<div><img src="images/stories/demo/middle/mi-1.jpg" border="0" alt="Al Qaeda blamed for Iraq violence wave" title="Sample image" align="left" /></div>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel n justo ac ridiculus sed urna elit diam pretium.</p>\r\n', '\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 0, 0, 85, '2011-12-08 04:18:48', 42, '', '2011-12-13 09:28:17', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:18:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(94, 215, 'Attacks kill at least 42 in Iraq on Shiite religious holiday', 'attacks-kill-at-least-42-in-iraq-on-shiite-religious-holiday', '', '<div><img src="images/stories/demo/middle/mi-3.jpg" border="0" alt="Attacks kill at least 42 in Iraq on Shiite religious holiday" title="Sample image" align="left" /></div>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. S</p>\r\n', '\r\n<p>ed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 0, 0, 85, '2011-12-08 04:21:34', 42, '', '2011-12-13 09:28:30', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:21:34', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 8, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(95, 216, 'Elit risus In justo', 'elit-risus-in-justo', '', '<div><img src="images/stories/demo/middle/mi-5.jpg" border="0" alt="Elit risus In justo" title="Sample image" align="left" /></div>\r\n<p>In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst.</p>\r\n', '\r\n<div><img src="images/stories/demo/middle/mi-2.jpg" border="0" alt="Al Qaeda blamed for Iraq violence wave" title="Sample image" align="left" /></div>\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 0, 0, 85, '2011-12-08 04:22:48', 42, '', '2011-12-13 09:30:21', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:22:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(96, 217, 'Tincidunt cursus quam', 'tincidunt-cursus-quam', '', '<div><img src="images/stories/demo/middle/mi-6.jpg" border="0" alt="Tincidunt cursus quam" title="Sample image" align="left" /></div>\r\n<p>Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n', '\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 0, 0, 85, '2011-12-08 04:24:08', 42, '', '2011-12-13 09:33:22', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:24:08', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 6, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(97, 218, 'Et Nunc mus sem Nunc Cras', 'et-nunc-mus-sem-nunc-cras', '', '<div><img src="images/stories/demo/middle/mi-7.jpg" border="0" alt=" Et Nunc mus sem Nunc Cras" title="Sample image" align="left" /></div>\r\n<p>In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst.</p>\r\n', '\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 0, 0, 85, '2011-12-08 04:25:01', 42, '', '2011-12-13 09:29:46', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:25:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(98, 219, 'Ex-homeless woman leaves $150,000 to Hebrew University', 'ex-homeless-woman-leaves-150000-to-hebrew-university', '', '<div><img src="images/stories/demo/middle/mi-2.jpg" border="0" alt="Ex-homeless woman leaves $150,000 to Hebrew University" title="Sample image" align="left" /></div>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n', '\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 0, 0, 85, '2011-12-08 04:27:16', 42, '', '2011-12-13 09:31:35', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:27:16', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(99, 220, 'Hac Morbi ac leo at felis', 'hac-morbi-ac-leo-at-felis', '', '<div><img src="images/stories/demo/middle/mi-4.jpg" border="0" alt="Hac Morbi ac leo at felis" title="Sample image" align="left" /></div>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n', '\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 0, 0, 85, '2011-12-08 04:28:22', 42, '', '2011-12-13 09:31:24', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:28:21', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(100, 221, 'Sed et elit condimentum', 'sed-et-elit-condimentum', '', '<div><img src="images/stories/demo/middle/mi-8.jpg" border="0" alt="Sed et elit condimentum" title="Sample image" align="left" /></div>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n', '\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 0, 0, 85, '2011-12-08 04:29:58', 42, '', '2011-12-13 09:32:37', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:29:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(101, 222, 'Joomla 2.5 day Africa', 'joomla-2-5-day-africa', '', '<div><img src="images/stories/demo/world/af-5.jpg" border="0" alt="Aenean at vel interdum" title="Sample image" align="left" /></div>\r\n<p>Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<div><img src="images/stories/demo/world/af-2.jpg" border="0" alt="Voices from afar: Zimbabwe\'s writers connected to their country" title="Sample image" align="left" /></div>\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 0, 0, 81, '2011-12-08 04:33:03', 42, '', '2012-02-18 10:20:49', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:33:03', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 8, 0, 7, 'fashion, business, entertainment, sport, news, Joomla 2.5 template', 'Joomla 2.5 template for news site update.', 1, 17, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(102, 223, 'JA Nex Joomla 2.5 Template', 'ja-nex-joomla-2-5-template', '', '<div><img src="images/stories/demo/world/af-6.jpg" border="0" alt="Aenean Donec gravida hendrerit" title="Sample image" align="left" /></div>\r\n<p>Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel.</p>\r\n', '\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 0, 0, 81, '2011-12-08 04:34:00', 42, '', '2012-06-20 03:26:22', 42, 42, '2012-06-20 03:26:22', '2011-12-08 04:34:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 5, 0, 6, 'Joomla 2.5 news template, news Joomla 2.5 template, Joomla news 2.5 template', 'Joomla 2.5 template for newspaper and maganize', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(103, 224, 'Hillary Clinton: We\'re committed to Africa\'s future', 'hillary-clinton-were-committed-to-africas-future', '', '<div><img src="images/stories/demo/world/af-2.jpg" border="0" alt="Al Qaeda blamed for Iraq violence wave" title="Sample image" align="left" /></div>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n', '\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 0, 0, 81, '2011-12-08 04:35:05', 42, '', '2011-12-13 08:04:17', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:35:05', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 5, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(104, 225, 'Joomla 2.5 city conference', 'joomla-2-5-city-conference', '', '<div><img src="images/stories/demo/world/af-7.jpg" border="0" alt="Nam cursus odio et quis convallis" title="Sample image" align="left" /></div>\r\n<p>Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n', '\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 0, 0, 81, '2011-12-08 04:36:52', 42, '', '2012-06-20 03:25:27', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:36:52', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 7, 0, 4, 'Joomla 2.5 template news site, Joomla 2.5 conference template, Joomla 2.5 template world news', 'Joomla 2.5 template for updated news.', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(105, 226, 'Nunc egestas ut tempus', 'nunc-egestas-ut-tempus', '', '<div><img src="images/stories/demo/world/af-4.jpg" border="0" alt="Nunc egestas ut tempus" title="Sample image" align="left" /></div>\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<div><img class="caption" src="images/stories/demo/world/af-2.jpg" border="0" alt="Voices from afar: Zimbabwe\'s writers connected to their country" title="Sample image" align="left" /></div>\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 0, 0, 81, '2011-12-08 04:37:50', 42, '', '2011-12-13 08:05:15', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:37:50', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 3, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(106, 227, 'Protests as Sudan \'tight pants\' trial delayed', 'protests-as-sudan-tight-pants-trial-delayed', '', '<div><img src="images/stories/demo/world/af-3.jpg" border="0" alt="Protests as Sudan tight pants trial delayed" title="Sample image" align="left" /></div>\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam.</p>\r\n', '\r\n<p>Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac. Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>', 1, 0, 0, 81, '2011-12-08 04:38:59', 42, '', '2011-12-13 08:05:20', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:38:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 2, '', '', 1, 26, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(107, 228, 'Somalia', 'somalia', '', '<div><img src="images/stories/demo/world/af-8.jpg" border="0" alt="Felis tempor felis" title="Getty Images" align="left" /></div>\r\n<p>In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum.</p>\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<div><img class="caption" src="images/stories/demo/world/af-2.jpg" border="0" alt="Voices from afar: Zimbabwe\'s writers connected to their country" title="Sample image" align="left" /></div>\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 0, 0, 81, '2011-12-08 04:40:11', 42, '', '2011-12-13 08:04:36', 42, 42, '2011-12-24 02:01:48', '2011-12-08 04:40:11', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 1, '', '', 1, 6, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(108, 229, 'Zimbabwe\'s writers connected to their country', 'zimbabwes-writers-connected-to-their-country', '', '<div><img src="images/stories/demo/world/af-2.jpg" border="0" alt="Felis tempor felis" title="Getty Images" align="left" /></div>\r\n<p>In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum.</p>\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<div><img class="caption" src="images/stories/demo/world/af-6.jpg" border="0" alt="Voices from afar: Zimbabwe\'s writers connected to their country" title="Sample image" align="left" /></div>\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 0, 0, 81, '2011-12-08 04:41:31', 42, '', '2011-12-24 02:02:22', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:41:30', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 10, 0, 0, '', '', 1, 16, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(109, 230, 'Millions? Private Jet? Columbia Offers New York', 'millions-private-jet-columbia-offers-new-york', '', '<div><img src="images/stories/demo/sport/football-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Lorem ipsum dolor sit amet consectetuer nibh nisl ante faucibus eget. Pellentesque Phasellus arcu tristique Vestibulum laoreet eu Quisque libero libero id.</p>\r\n<p>Pede Cum Duis nec mauris semper id nec Lorem enim ullamcorper. Augue Vestibulum tellus Suspendisse tortor Vestibulum laoreet Nam tellus cursus interdum. Dolor Morbi nec quis est commodo sollicitudin.</p>\r\n', '\r\n<p>Pretium nisl id eu Suspendisse in quis pellentesque Nulla hendrerit Vivamus. Vitae eget pellentesque sed velit tempus Vestibulum eu libero diam semper. Dolor Morbi nec quis est commodo sollicitudin a sem sed wisi. Lorem orci leo vel enim Sed.</p>\r\n<p>Sit laoreet sagittis pellentesque dui fringilla vestibulum Nunc sed consectetuer Nullam. Sapien pede interdum auctor pellentesque Aenean et lobortis et Pellentesque justo. Pede Cum Duis nec mauris semper id nec Lorem enim ullamcorper. Augue Vestibulum tellus Suspendisse tortor Vestibulum laoreet Nam tellus cursus interdum. Feugiat eu porttitor justo congue Integer dolor Curabitur nulla Vestibulum amet. Nibh cursus turpis fringilla hendrerit adipiscing Maecenas sit ipsum.</p>\r\n<p>Cursus et ipsum molestie In vel wisi purus dui quis ut. Nam Cras Duis et orci tincidunt feugiat non pede Vestibulum Sed. Mauris pellentesque enim Nam ut et semper elit nibh tortor orci. Tellus congue Curabitur sem diam dignissim pretium sed Aenean fringilla habitasse. Sed sem felis sagittis sodales ac congue Maecenas Vivamus a sem. Mauris ut Vestibulum dictum porttitor at morbi turpis Sed.</p>\r\n<p>Tortor ullamcorper tellus adipiscing nulla lacinia semper augue ut Vivamus felis. Nonummy amet Vestibulum ut laoreet lorem habitant tellus ac tincidunt et. Morbi senectus nascetur pede dictumst tincidunt dignissim et id tellus Nam. Nam quis nisl et pede wisi ut ipsum lorem Vivamus morbi. Tincidunt malesuada urna aliquet Donec vel consequat tristique mauris enim Sed. Elit non.</p>', 1, 0, 0, 87, '2011-12-08 04:59:22', 42, '', '2011-12-13 09:20:53', 42, 0, '0000-00-00 00:00:00', '2011-12-08 04:59:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 8, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(110, 231, 'England stars offer summer', 'england-stars-offer-summer', '', '<div><img src="images/stories/demo/sport/cricket-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Et libero pretium accumsan convallis sapien elit orci tempus sed In. Nibh Praesent et eleifend Vivamus laoreet tortor metus habitant fames gravida.</p>\r\n', '\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus. Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo.</p>\r\n<p>Tortor pretium ipsum Maecenas justo ut lacus nec a sem Ut. Urna wisi wisi mauris pretium laoreet sit risus Nulla elit consequat. Auctor id enim leo condimentum lorem ipsum leo Quisque Vivamus fames. Condimentum nibh venenatis vitae felis mus adipiscing ridiculus eget lacus eros. Nulla semper quis sapien ut molestie pretium tempus interdum Sed orci. Ac tincidunt Suspendisse ligula feugiat sapien hendrerit feugiat egestas massa.</p>\r\n<p>Neque egestas Cras eget et neque neque Praesent condimentum orci ligula. Aenean dictumst metus vitae Aenean et Integer nibh mus cursus consectetuer. Id Vestibulum Donec Pellentesque dui Cum eleifend amet orci vitae sollicitudin. Dui egestas Donec tincidunt lorem a Cum ut et libero justo. Ante justo ac Sed ligula in convallis est pede hendrerit wisi. Dui Sed platea tempus odio fames Phasellus vitae id senectus nulla.</p>\r\n<p>Et accumsan Quisque platea dictum enim nec id Vestibulum libero vel. Ac volutpat eu nibh Quisque risus faucibus laoreet nec dolor at. In consectetuer pretium Curabitur Sed at elit ut Curabitur porta et. Nisl libero eros pellentesque vitae feugiat porttitor quis In semper sapien. Quisque sociis tempor wisi ante mollis Aenean.</p>\r\n<p>Quis eu laoreet porttitor nibh tellus justo ante a vitae adipiscing. Velit egestas euismod Nulla wisi In augue est nibh consequat Pellentesque. Aenean massa nibh malesuada laoreet vitae senectus Aenean ut pede cursus. Justo augue aliquet fringilla senectus dis sociis tellus ut Quisque tempus. Adipiscing turpis Pellentesque lacus eget magna dis leo lacinia metus et. Nam habitasse enim vel pellentesque nunc Nam dolor pede lorem.</p>\r\n<p>Est Nam felis est euismod pretium mauris tellus libero sem cursus. Condimentum vel Aenean pellentesque volutpat turpis euismod fames nec quis enim. Ac non eu In urna Lorem Lorem ac Nam mattis hendrerit. Consectetuer Donec neque justo felis platea porttitor eu pede morbi in. Consequat laoreet elit mattis nec lacus dolor Vestibulum lacus sit.</p>', 1, 0, 0, 87, '2011-12-08 06:33:22', 42, '', '2011-12-13 09:17:24', 42, 0, '0000-00-00 00:00:00', '2011-12-08 06:33:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(111, 232, 'Habitant lobortis vitae pretium vitae', 'habitant-lobortis-vitae-pretium-vitae', '', '<div><img src="images/stories/demo/sport/cricket-7.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Vel dolor ligula tristique magnis sit nunc neque commodo eros convallis. Sed sapien orci ut interdum dolor vel tempus id ipsum consectetuer. Ut eros egestas massa In porttitor sagittis Donec cursus Curabitur sed. Mauris Vivamus sociis et mauris ullamcorper Vestibulum ac lacus nibh metus. Iaculis sem turpis Curabitur Vestibulum Phasellus Pellentesque nec pede quis Fusce.</p>\r\n', '\r\n<p>Congue lacus Vivamus est at sed facilisis eu tincidunt Sed vitae. Porttitor nec nisl convallis auctor convallis amet facilisis Phasellus pharetra ut. Penatibus pretium tincidunt ridiculus molestie eros id pellentesque elit ridiculus ac. Tincidunt nisl lacinia metus Nam adipiscing nibh Curabitur Aliquam eu eu. Malesuada mi turpis eget accumsan eleifend Sed augue habitasse Quisque ornare. Eget Sed Nullam Curabitur lorem.</p>\r\n<p>Elit a nunc auctor vitae Maecenas tortor scelerisque dignissim semper eleifend. Nibh non Aenean ut velit eleifend id Phasellus netus laoreet morbi. Id condimentum eu habitant vel amet gravida porttitor Vestibulum consectetuer nibh. In elit Mauris ut id nonummy orci fringilla molestie sit fringilla. Malesuada interdum Nam nisl leo sem elit vel pretium mauris tincidunt.</p>\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros.</p>\r\n<p>Et quis mauris pretium interdum felis velit sed et a et. Aenean tempus pede Pellentesque pulvinar Sed congue eget hac Aenean laoreet. Penatibus laoreet consectetuer tempus Ut penatibus in ante ac ac consectetuer. Netus elit Morbi et ac Nam parturient risus Cras nulla dolor. Pretium gravida Morbi consectetuer elit Quisque sodales est congue interdum Curabitur. Tellus nisl auctor Morbi fringilla id at consectetuer.</p>', 1, 0, 0, 87, '2011-12-08 06:34:33', 42, '', '2011-12-13 09:18:46', 42, 0, '0000-00-00 00:00:00', '2011-12-08 06:34:33', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 6, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(112, 233, 'Fringilla Maecenas libero ut faucibus', 'fringilla-maecenas-libero-ut-faucibus', '', '<div><img src="images/stories/demo/sport/tennis-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Consectetuer venenatis nulla Nunc Morbi pretium penatibus Aenean velit malesuada pharetra. Curabitur interdum senectus semper cursus adipiscing eros et ac porttitor tincidunt.</p>\r\n', '\r\n<p>Dictumst et orci Nulla faucibus egestas risus mauris interdum Phasellus Nunc. Morbi urna Vestibulum Suspendisse risus orci metus accumsan id wisi est. Metus purus Vestibulum ac ut vitae Donec ullamcorper mus penatibus In. Pede Donec amet. Risus tempus lacinia pharetra justo magna nibh commodo ac vitae Lorem. Congue mattis justo Fusce sed rutrum mattis iaculis nisl nibh Nunc. At ut Nulla at Curabitur nisl Morbi lorem id congue neque. Platea fringilla volutpat malesuada laoreet Integer euismod et tempus in elit. Justo netus non consequat at Curabitur dictum mauris mauris.</p>\r\n<p>Tincidunt vestibulum justo pulvinar Vivamus eleifend mus Phasellus mi pretium est. Pretium pellentesque vitae nibh In adipiscing egestas lacus tempus molestie quis. Volutpat euismod tincidunt odio Aenean cursus ornare lorem consequat dolor pharetra. Vestibulum Duis pellentesque et laoreet vitae dapibus dui feugiat Aliquam natoque. Lacinia justo porttitor nibh nec pede dolor magnis turpis nunc mauris. Amet elit.</p>\r\n<p>Justo ligula nonummy ante nibh Duis sem egestas volutpat sagittis at. Est habitasse tempor quis Curabitur wisi dictumst orci laoreet Curabitur ut. Sapien scelerisque orci sit id tempor ac nibh mollis pretium justo. Gravida mauris turpis lacus sit pretium iaculis feugiat semper dui Sed. Mollis orci in nec gravida aliquam felis condimentum platea et ultrices. Arcu tincidunt venenatis ac.</p>\r\n<p>Facilisis tristique at wisi Donec fermentum Integer Nulla Vestibulum nulla nec. In Morbi dis elit mauris felis pede Lorem habitasse platea porttitor. Sapien metus orci penatibus Sed nulla semper Curabitur tellus odio nulla. Sed Morbi dolor Quisque ut velit In massa sit sed id. Platea et metus mus Curabitur Sed et turpis amet.</p>\r\n<p>Sociis sit urna et quis enim wisi nisl magna tellus vel. Tincidunt at eros ut dictum sed Curabitur Curabitur In lacus porta. Natoque ut enim nec convallis platea egestas enim Curabitur tempus Proin. Semper tempus gravida nulla laoreet Donec Suspendisse semper velit Proin Nunc. Nam tristique quis sed ut Nulla nibh Morbi malesuada Curabitur risus. Tincidunt quis orci a id Sed auctor Aenean augue sociis justo. Tempor.</p>\r\n<p>Fringilla Maecenas libero ut faucibus interdum volutpat eros elit Nunc et. Montes non nunc sollicitudin pellentesque Curabitur leo lobortis dolor eu penatibus. Curabitur Nulla consectetuer Phasellus mus Nulla nunc venenatis in elit Nam. Vivamus mi vitae laoreet et at ipsum a odio dis Aliquam. Ipsum massa tellus eu ut pede eget porttitor Morbi sit vitae. In tincidunt justo metus.</p>', 1, 0, 0, 87, '2011-12-08 06:35:12', 42, '', '2011-12-13 09:18:05', 42, 0, '0000-00-00 00:00:00', '2011-12-08 06:35:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(113, 234, 'Murray eases through in Montreal ', 'murray-eases-through-in-montreal', '', '<div><img src="images/stories/demo/sport/tennis-3.jpg" border="0" alt="Murray eases through in Montreal " title="Murray eases through in Montreal " align="left" /></div>\r\n<p>Fusce fringilla ut ante interdum velit et leo elit ligula pede. Mus malesuada pellentesque adipiscing Lorem est elit Lorem odio risus interdum.</p>\r\n', '\r\n<p>Nam tincidunt at cursus Curabitur Ut feugiat velit auctor eu Curabitur. Lobortis ac semper condimentum Vestibulum eget adipiscing Morbi parturient dignissim pretium. Sapien pede nunc neque Phasellus neque tempus auctor Sed at.Ut pellentesque quis turpis dui tincidunt tempus pellentesque ridiculus pretium vel. Orci Curabitur ligula pellentesque Curabitur nec fames vitae Curabitur odio laoreet. Fringilla Aenean Curabitur vel neque malesuada augue.</p>\r\n<p>Sit Vestibulum Nullam pellentesque ac Aenean ac urna pellentesque nunc orci. Vitae Curabitur interdum platea pede Quisque dui semper mauris non elit. Rutrum Lorem Suspendisse auctor arcu interdum odio est et nulla sodales. Vestibulum ante senectus adipiscing quam neque amet tortor id ipsum quis. Pellentesque Vivamus tempus laoreet Phasellus tincidunt Curabitur felis elit convallis tellus. Platea dui platea dui id Ut.</p>\r\n<p>Et et nec Nulla semper elit sed morbi felis mauris nascetur. Sed ipsum cursus ut nibh magna condimentum ut nibh Pellentesque tortor. Nullam Phasellus cursus ullamcorper Vestibulum eros urna Curabitur ut libero turpis. Integer vel urna cursus Curabitur ac netus Nullam Duis nulla Vestibulum. Ut et at tincidunt interdum ipsum Lorem fringilla nunc urna dignissim. Curabitur hac nascetur In wisi purus Nulla urna dapibus risus convallis. Consectetuer Phasellus.</p>\r\n<p>Dignissim Nam Nam ligula amet Donec convallis urna pede tortor laoreet. Sed at nunc sed dui vitae semper enim Praesent mauris Nulla. At sollicitudin nibh velit vitae est Lorem dolor Aenean et egestas. Vestibulum Cum ligula lacus congue convallis tincidunt cursus orci Vivamus Curabitur. In nec suscipit metus eros mauris eu ipsum orci sagittis pede. Curabitur lorem.</p>', 1, 0, 0, 87, '2011-12-08 06:35:58', 42, '', '2011-12-13 09:21:04', 42, 0, '0000-00-00 00:00:00', '2011-12-08 06:35:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(114, 235, 'Matt Roberts\' MotoGP column ', 'matt-roberts-motogp-column', '', '<div><img src="images/stories/demo/sport/motorsport-2.jpg" border="0" alt="Matt Roberts\' MotoGP column " title="Matt Roberts\' MotoGP column " align="left" /></div>\r\n<p>Dignissim Nam Nam ligula amet Donec convallis urna pede tortor laoreet. Sed at nunc sed dui vitae semper enim Praesent mauris Nulla. At sollicitudin nibh velit vitae est Lorem dolor Aenean et egestas. Vestibulum Cum ligula lacus congue convallis tincidunt cursus orci Vivamus Curabitur.</p>\r\n', '\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor. Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut.</p>\r\n<p>Vivamus malesuada interdum eget Pellentesque ligula ante Aliquam Nulla tincidunt ullamcorper. Morbi laoreet ipsum Nullam Integer turpis platea mi Ut nec tincidunt. Nisl eget turpis morbi at dolor lacus Phasellus vitae pretium metus. Curabitur a nonummy Nulla auctor enim Vivamus consequat ac orci Vestibulum. Justo lobortis odio aliquam risus Sed Integer sagittis sed Sed risus. Et turpis id porttitor egestas.</p>\r\n<p>Semper Vestibulum consequat in euismod auctor volutpat semper Ut semper auctor. Eget wisi iaculis nisl sem cursus at porttitor volutpat Sed facilisi. Pede condimentum elit velit vitae risus ullamcorper Morbi Phasellus sapien sed. Et pretium cursus lacus vitae aliquet pharetra Vestibulum elit hac a. Nulla id libero nulla Cras sed tincidunt est semper laoreet Pellentesque. Tortor felis Curabitur sed vel in justo pulvinar lacus pellentesque Phasellus. Non sit.</p>\r\n<p>Ut nibh dui fames justo cursus augue Curabitur Curabitur dui consectetuer. Tortor Nulla quis suscipit hendrerit semper eget neque vel id leo. Quis dui In quam eu platea nec vitae sit et turpis. Pulvinar lacus pede nonummy tortor Phasellus Praesent tempus Ut sed Morbi. Tellus Mauris nibh Nam adipiscing cursus Vestibulum Maecenas pellentesque elit consectetuer. Wisi vel.</p>', 1, 0, 0, 87, '2011-12-08 06:37:00', 42, '', '2011-12-13 09:20:05', 42, 0, '0000-00-00 00:00:00', '2011-12-08 06:37:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(115, 236, 'In nec suscipit metus eros mauris eu ipsum', 'in-nec-suscipit-metus-eros-mauris-eu-ipsum', '', '<div><img src="images/stories/demo/sport/motorsport-8.jpg" border="0" alt="Matt Roberts\' MotoGP column " title="Matt Roberts\' MotoGP column " align="left" /></div>\r\n<p>Dignissim Nam Nam ligula amet Donec convallis urna pede tortor laoreet. Sed at nunc sed dui vitae semper enim Praesent mauris Nulla. At sollicitudin nibh velit vitae est Lorem dolor Aenean et egestas. Vestibulum Cum ligula lacus congue convallis tincidunt cursus.</p>\r\n', '\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor. Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut.</p>\r\n<p>Vivamus malesuada interdum eget Pellentesque ligula ante Aliquam Nulla tincidunt ullamcorper. Morbi laoreet ipsum Nullam Integer turpis platea mi Ut nec tincidunt. Nisl eget turpis morbi at dolor lacus Phasellus vitae pretium metus. Curabitur a nonummy Nulla auctor enim Vivamus consequat ac orci Vestibulum. Justo lobortis odio aliquam risus Sed Integer sagittis sed Sed risus. Et turpis id porttitor egestas.</p>\r\n<p>Semper Vestibulum consequat in euismod auctor volutpat semper Ut semper auctor. Eget wisi iaculis nisl sem cursus at porttitor volutpat Sed facilisi. Pede condimentum elit velit vitae risus ullamcorper Morbi Phasellus sapien sed. Et pretium cursus lacus vitae aliquet pharetra Vestibulum elit hac a. Nulla id libero nulla Cras sed tincidunt est semper laoreet Pellentesque. Tortor felis Curabitur sed vel in justo pulvinar lacus pellentesque Phasellus. Non sit.</p>\r\n<p>Ut nibh dui fames justo cursus augue Curabitur Curabitur dui consectetuer. Tortor Nulla quis suscipit hendrerit semper eget neque vel id leo. Quis dui In quam eu platea nec vitae sit et turpis. Pulvinar lacus pede nonummy tortor Phasellus Praesent tempus Ut sed Morbi. Tellus Mauris nibh Nam adipiscing cursus Vestibulum Maecenas pellentesque elit consectetuer. Wisi vel.</p>', 1, 0, 0, 87, '2011-12-08 06:37:40', 42, '', '2011-12-13 09:19:08', 42, 0, '0000-00-00 00:00:00', '2011-12-08 06:37:40', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 2, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(116, 237, 'India Closes Torch Relay to Spectators', 'india-closes-torch-relay-to-spectators', '', '<div><img src="images/stories/demo/sport/hr-3.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Semper Vestibulum consequat in euismod auctor volutpat semper Ut semper auctor. Eget wisi iaculis nisl sem cursus at porttitor volutpat Sed facilisi. Pede condimentum elit velit vitae risus ullamcorper Morbi Phasellus sapien sed.</p>\r\n', '\r\n<p>Et pretium cursus lacus vitae aliquet pharetra Vestibulum elit hac a. Nulla id libero nulla Cras sed tincidunt est semper laoreet Pellentesque. Tortor felis Curabitur sed vel in justo pulvinar lacus pellentesque Phasellus. Non sit. <a class="rss" href="#" title="Sample link">Nam neque libero eros Nunc dui</a> <a class="video" href="#" title="Sample link">Video</a></p>\r\n<p>Ut nibh dui fames justo cursus augue Curabitur Curabitur dui consectetuer. Tortor Nulla quis suscipit hendrerit semper eget neque vel id leo. Quis dui In quam eu platea nec vitae sit et turpis. Pulvinar lacus pede nonummy tortor Phasellus Praesent tempus Ut sed Morbi. Tellus Mauris nibh Nam adipiscing cursus Vestibulum Maecenas pellentesque elit consectetuer. Wisi vel.</p>\r\n<p>Vestibulum eu Nam neque libero eros Nunc dui In in tellus. Tellus id tincidunt Duis tristique id Curabitur ridiculus interdum ante ipsum. Nibh Nam condimentum mus eu consectetuer tellus consequat Vestibulum quis turpis. Faucibus vel risus Nullam mollis iaculis Pellentesque at pretium tincidunt pharetra. Et Vestibulum id nibh interdum a dis lacinia fringilla id tincidunt. Sem interdum Curabitur urna eu fringilla orci suscipit.</p>\r\n<p>Nibh Curabitur quis tincidunt Curabitur nunc nisl porttitor quis turpis sit. Consequat et sagittis id commodo urna Lorem ut dictumst Morbi Vestibulum. Condimentum cursus tincidunt dictumst Nulla Maecenas Phasellus nec cursus malesuada porta. Parturient massa Nulla adipiscing leo Suspendisse ac tincidunt penatibus mi Phasellus. Magna id condimentum nibh consectetuer non enim ac pulvinar leo quam. Id et pretium tincidunt.</p>\r\n<p>Lorem ac neque ac pretium tellus condimentum elit at molestie sapien. Montes hendrerit commodo nibh porttitor a habitant netus eget adipiscing felis. Pede non eget convallis laoreet diam ullamcorper nunc Nulla ipsum id. Justo orci tellus justo nibh tincidunt congue pellentesque felis nec vestibulum. Sed dui cursus velit pretium Curabitur elit semper Nulla nibh Nullam. A Donec cursus nibh aliquet nisl Cum.</p>', 1, 0, 0, 87, '2011-12-08 06:38:39', 42, '', '2011-12-13 09:19:43', 42, 0, '0000-00-00 00:00:00', '2011-12-08 06:38:39', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 1, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(117, 238, ' Morbi faucibus Sed Vivamus odio semper', 'morbi-faucibus-sed-vivamus-odio-semper', '', '<div><img src="images/stories/demo/sport/horse-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Sem tincidunt urna amet eros nec metus elit nibh sagittis et. Elit et mauris ut sollicitudin convallis interdum lacus sapien sed Curabitur. Interdum gravida massa quis ac nibh Integer eget eu non Sed.</p>\r\n', '\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus.</p>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit.</p>', 1, 0, 0, 87, '2011-12-08 06:39:20', 42, '', '2011-12-13 09:16:53', 42, 0, '0000-00-00 00:00:00', '2011-12-08 06:39:20', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 0, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(118, 239, 'Vestibulum nec Phasellus facilisi', 'vestibulum-nec-phasellus-facilisi', '', '<div><img src="images/stories/demo/entertaiment/e-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique.</p>\r\n', '\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 0, 0, 88, '2011-12-08 06:42:16', 42, '', '2011-12-13 09:16:25', 42, 0, '0000-00-00 00:00:00', '2011-12-08 06:42:16', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 5, 0, 7, '', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(119, 240, 'Scarlett Johansson to Play Sexy Alien', 'scarlett-johansson-to-play-sexy-alien-in-sci-fi-movie', '', '<div><img src="images/stories/demo/entertaiment/e-2.jpg" border="0" alt="Sample image" title="Sample image" /></div>\r\n<p>Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique.</p>\r\n', '\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 0, 0, 88, '2011-12-08 06:43:00', 42, '', '2011-12-13 09:14:15', 42, 0, '0000-00-00 00:00:00', '2011-12-08 06:43:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 7, 0, 6, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(120, 241, 'Harry Potter and the Deathly Hallows, Part 1', 'harry-potter-and-the-deathly-hallows-part-1', '', '<div><img src="images/stories/demo/entertaiment/tv-6.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer.</p>\r\n', '\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 0, 0, 88, '2011-12-08 06:43:40', 42, '', '2011-12-13 09:13:28', 42, 0, '0000-00-00 00:00:00', '2011-12-08 06:43:40', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 5, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(121, 242, 'Congue Cum tincidunt nunc wisi turpis', 'congue-cum-tincidunt-nunc-wisi-turpis', '', '<div><img src="images/stories/demo/entertaiment/tv-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique.</p>\r\n', '\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 0, 0, 88, '2011-12-08 06:42:16', 42, '', '2011-12-13 09:12:24', 42, 0, '0000-00-00 00:00:00', '2011-12-08 06:42:16', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(122, 243, 'Exclusive: A Day To Remember', 'exclusive-a-day-to-remember', '', '<div><img src="images/stories/demo/entertaiment/music-7.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Nunc adipiscing neque platea vitae Nulla molestie congue pretium Morbi Nam. Ut amet elit fringilla penatibus interdum porttitor ut id Aenean at.</p>\r\n', '\r\n<p>Lorem ipsum dolor sit amet consectetuer urna Aenean dictumst risus est. Quis eros nisl leo Duis pede In Nunc consectetuer nec vitae. A nibh Curabitur vitae Curabitur mauris Aenean convallis convallis Phasellus diam. Risus et quam Sed Suspendisse consequat id justo Vestibulum et eu. Morbi ut justo semper convallis nulla et cursus congue a Morbi.</p>\r\n<p>Malesuada Sed sit Quisque id wisi aliquam sollicitudin leo est justo. Pretium eleifend Vestibulum non tincidunt quam sed mollis porttitor adipiscing ante. Nunc adipiscing neque platea vitae Nulla molestie congue pretium Morbi Nam. Ut amet elit fringilla penatibus interdum porttitor ut id Aenean at. Velit sed et Nulla orci dolor faucibus eu laoreet urna Phasellus. Sed arcu ante Nam Curabitur amet Curabitur consectetuer turpis In ligula. Justo Sed.</p>\r\n<p>Nisl Ut neque id ligula pulvinar et cursus velit pharetra Nullam. Vitae tincidunt natoque dui aliquet id accumsan nunc Maecenas lacinia platea. Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum. Id congue vel aliquet sodales condimentum id ullamcorper hendrerit justo ut. Velit Fusce accumsan elit nibh Phasellus malesuada ornare semper eget odio. Vitae nibh Vestibulum In convallis porttitor ligula nunc ipsum ligula adipiscing. Enim et.</p>\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>', 1, 0, 0, 88, '2011-12-08 07:40:36', 42, '', '2011-12-13 09:12:54', 42, 0, '0000-00-00 00:00:00', '2011-12-08 07:40:36', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 4, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(123, 244, 'Tempor magnis tincidunt euismod', 'tempor-magnis-tincidunt-euismod', '', '<div><img src="images/stories/demo/entertaiment/music-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed.</p>\r\n', '\r\n<p>Lorem ipsum dolor sit amet consectetuer urna Aenean dictumst risus est. Quis eros nisl leo Duis pede In Nunc consectetuer nec vitae. A nibh Curabitur vitae Curabitur mauris Aenean convallis convallis Phasellus diam. Risus et quam Sed Suspendisse consequat id justo Vestibulum et eu. Morbi ut justo semper convallis nulla et cursus congue a Morbi.</p>\r\n<p>Malesuada Sed sit Quisque id wisi aliquam sollicitudin leo est justo. Pretium eleifend Vestibulum non tincidunt quam sed mollis porttitor adipiscing ante. Nunc adipiscing neque platea vitae Nulla molestie congue pretium Morbi Nam. Ut amet elit fringilla penatibus interdum porttitor ut id Aenean at. Velit sed et Nulla orci dolor faucibus eu laoreet urna Phasellus. Sed arcu ante Nam Curabitur amet Curabitur consectetuer turpis In ligula. Justo Sed.</p>\r\n<p>Nisl Ut neque id ligula pulvinar et cursus velit pharetra Nullam. Vitae tincidunt natoque dui aliquet id accumsan nunc Maecenas lacinia platea. Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum. Id congue vel aliquet sodales condimentum id ullamcorper hendrerit justo ut. Velit Fusce accumsan elit nibh Phasellus malesuada ornare semper eget odio. Vitae nibh Vestibulum In convallis porttitor ligula nunc ipsum ligula adipiscing. Enim et.</p>\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>', 1, 0, 0, 88, '2011-12-08 07:42:36', 42, '', '2011-12-13 09:14:58', 42, 0, '0000-00-00 00:00:00', '2011-12-08 07:42:36', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(124, 245, 'Vestibulum ac pede id Cum', 'vestibulum-ac-pede-id-cum', '', '<p><img src="images/stories/demo/entertaiment/e-16.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique.</p>\r\n', '\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>', 1, 0, 0, 88, '2011-12-08 07:43:45', 42, '', '2011-12-13 09:15:40', 42, 0, '0000-00-00 00:00:00', '2011-12-08 07:43:45', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 1, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(125, 246, 'Justo quam orci ipsum enim', 'justo-quam-orci-ipsum-enim', '', '<p><img src="images/stories/demo/entertaiment/e-15.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n', '\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>', 1, 0, 0, 88, '2011-12-08 07:44:01', 42, '', '2011-12-13 09:13:40', 42, 0, '0000-00-00 00:00:00', '2011-12-08 07:44:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 0, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(126, 247, 'Sony, Stung by Losses, Delays Thin TV', 'sony-stung-by-losses-delays-thin-tv', '', '<div><img src="images/stories/demo/business/tech-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et.</p>\r\n', '\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 0, 0, 86, '2011-12-08 07:47:42', 42, '', '2011-12-13 09:26:10', 42, 0, '0000-00-00 00:00:00', '2011-12-08 07:47:42', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(127, 248, 'Semper accumsan Integer', 'semper-accumsan-integer', '', '<div><img src="images/stories/demo/business/tech-10.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel.</p>\r\n', '\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 0, 0, 86, '2011-12-08 07:48:09', 42, '', '2011-12-13 09:24:34', 42, 0, '0000-00-00 00:00:00', '2011-12-08 07:48:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 6, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(128, 249, 'Nunc lacus quis dui adipiscing', 'nunc-lacus-quis-dui-adipiscing', '', '<div><img src="images/stories/demo/business/tech-14.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet.</p>\r\n', '\r\n<div><img src="images/stories/demo/business/tech-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 0, 0, 86, '2011-12-08 07:49:06', 42, '', '2011-12-13 09:23:28', 42, 0, '0000-00-00 00:00:00', '2011-12-08 07:49:06', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(129, 250, 'Nullam et nascetur vel', 'nullam-et-nascetur-vel', '', '<div><img src="images/stories/demo/business/tech-9.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n', '\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 0, 0, 86, '2011-12-08 07:49:42', 42, '', '2011-12-13 09:22:41', 42, 0, '0000-00-00 00:00:00', '2011-12-08 07:49:42', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 4, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(130, 251, 'Taking the ethical high road', 'taking-the-ethical-high-road', '', '<p><img src="images/stories/demo/business/traveltips-9.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum.</p>\r\n', '\r\n<p>Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat. Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>', 1, 0, 0, 86, '2011-12-08 07:51:34', 42, '', '2011-12-13 09:25:56', 42, 0, '0000-00-00 00:00:00', '2011-12-08 07:51:34', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 3, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(131, 252, 'From Vacant to Vibrant', 'from-vacant-to-vibrant', '', '<div><img src="images/stories/demo/business/traveltips-6.jpg" border="0" alt="9 essential travel strategies for 2009" title="Sample image" align="left" /></div>\r\n<p>Lorem ipsum dolor sit amet consectetuer eros nisl ut netus fermentum. Elit id lacus elit tellus id justo urna nec quis ridiculus. Hendrerit nunc pretium id lacinia Sed aliquam Phasellus velit ipsum Morbi.</p>\r\n', '\r\n<p>Auctor lorem neque interdum diam elit adipiscing lorem libero feugiat fringilla. Felis id sed tortor mattis elit libero Vivamus volutpat accumsan. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac. Nisl elit tincidunt congue in libero Maecenas nec habitasse lacinia eros. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Pellentesque tincidunt gravida dui nulla Morbi id at Nulla Quisque augue. Vestibulum orci Quisque hendrerit dolor Vestibulum enim pede vitae Maecenas Sed. In eu leo id In ligula cursus nisl Nulla habitant at. Ut pellentesque quis turpis dui tincidunt tempus pellentesque ridiculus pretium vel. Orci Curabitur ligula pellentesque Curabitur nec fames vitae Curabitur odio laoreet. Fringilla Aenean Curabitur vel neque malesuada augue.</p>\r\n<p>Tortor magna pretium magna vel interdum pretium velit amet mauris sit. Cursus laoreet id sollicitudin Quisque Suspendisse adipiscing Suspendisse tellus vitae Donec. Molestie orci nulla habitasse nunc tempus et facilisis Nulla porta lorem. Interdum orci gravida risus a metus fringilla condimentum tincidunt condimentum ut. Tortor nunc et justo volutpat rhoncus Nam lacus lacinia orci id. Augue Mauris leo pellentesque urna pretium Donec montes Aliquam ligula Maecenas. Curabitur Suspendisse et.</p>\r\n<p>Nullam odio et vestibulum laoreet ridiculus dui eu eu pellentesque amet. Tortor eu Morbi Sed nibh pellentesque lacinia interdum Maecenas Curabitur ligula. Felis tempus et enim laoreet nunc nulla id Fusce mollis egestas. Lacus ac ornare tellus Vestibulum eu pede faucibus Maecenas sed ut. Lobortis enim nunc leo tellus natoque.</p>\r\n<p>Neque tortor aliquam pretium fringilla pretium a dolor convallis leo tincidunt. Ut consectetuer laoreet aliquam sit sem Aenean et dignissim nulla leo. Pretium consectetuer eget pellentesque Sed nec tincidunt Vestibulum at Curabitur egestas. Pretium platea pellentesque convallis nisl nulla felis sociis nonummy ipsum ante. Condimentum lobortis sit et tellus id cursus Curabitur in convallis eget. Nonummy dui Nam ut cursus in auctor eros mauris justo eget. Ornare nec.</p>\r\n<p>Dolor dapibus Phasellus id Aenean rhoncus Maecenas Nunc pellentesque In convallis. Porttitor fringilla sed natoque Aliquam wisi Sed tempus pretium pretium Pellentesque. Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. Commodo mus nibh ac congue Aliquam orci Donec semper ipsum elit. Mattis lacus.</p>\r\n<p>Pellentesque pede tincidunt tellus lorem ultrices enim tristique tincidunt sem pretium. Mollis euismod lacinia et Curabitur orci pellentesque eget Vestibulum Duis penatibus. Vestibulum Donec id congue fames auctor interdum mauris auctor tellus cursus. Odio interdum Aenean interdum egestas vitae pellentesque dictum diam nec feugiat. Est risus dui consequat commodo nibh Donec at risus condimentum Quisque. Rutrum tincidunt tincidunt porttitor ridiculus Vestibulum et semper vitae Vestibulum urna.</p>\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id. Auctor congue pretium Aenean turpis dui eget Curabitur nulla cursus pellentesque. Et Duis id urna elit.</p>', 1, 0, 0, 86, '2011-12-08 07:52:00', 42, '', '2011-12-13 09:22:30', 42, 0, '0000-00-00 00:00:00', '2011-12-08 07:52:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(132, 253, 'Phones Get Game Power in the Cloud', 'phones-get-game-power-in-the-cloud', '', '<p><img src="images/stories/demo/business/traveltips-10.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum.</p>\r\n', '\r\n<p>Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat. Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 0, 0, 86, '2011-12-08 07:52:46', 42, '', '2011-12-26 04:35:44', 42, 0, '0000-00-00 00:00:00', '2011-12-08 07:52:46', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(133, 254, 'White House Pushes Vote on Consumer Agency Chief', 'white-house-pushes-vote-on-consumer-agency-chief', '', '<div><img src="images/stories/demo/business/traveltips-6.jpg" border="0" alt="9 essential travel strategies for 2009" title="Sample image" align="left" /></div>\r\n<p>Lorem ipsum dolor sit amet consectetuer eros nisl ut netus fermentum. Elit id lacus elit tellus id justo urna nec quis ridiculus. Hendrerit nunc pretium id lacinia Sed aliquam Phasellus velit ipsum Morbi.</p>\r\n', '\r\n<p>Auctor lorem neque interdum diam elit adipiscing lorem libero feugiat fringilla. Felis id sed tortor mattis elit libero Vivamus volutpat accumsan. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac. Nisl elit tincidunt congue in libero Maecenas nec habitasse lacinia eros. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Pellentesque tincidunt gravida dui nulla Morbi id at Nulla Quisque augue. Vestibulum orci Quisque hendrerit dolor Vestibulum enim pede vitae Maecenas Sed. In eu leo id In ligula cursus nisl Nulla habitant at. Ut pellentesque quis turpis dui tincidunt tempus pellentesque ridiculus pretium vel. Orci Curabitur ligula pellentesque Curabitur nec fames vitae Curabitur odio laoreet. Fringilla Aenean Curabitur vel neque malesuada augue.</p>\r\n<p>Tortor magna pretium magna vel interdum pretium velit amet mauris sit. Cursus laoreet id sollicitudin Quisque Suspendisse adipiscing Suspendisse tellus vitae Donec. Molestie orci nulla habitasse nunc tempus et facilisis Nulla porta lorem. Interdum orci gravida risus a metus fringilla condimentum tincidunt condimentum ut. Tortor nunc et justo volutpat rhoncus Nam lacus lacinia orci id. Augue Mauris leo pellentesque urna pretium Donec montes Aliquam ligula Maecenas. Curabitur Suspendisse et.</p>\r\n<p>Nullam odio et vestibulum laoreet ridiculus dui eu eu pellentesque amet. Tortor eu Morbi Sed nibh pellentesque lacinia interdum Maecenas Curabitur ligula. Felis tempus et enim laoreet nunc nulla id Fusce mollis egestas. Lacus ac ornare tellus Vestibulum eu pede faucibus Maecenas sed ut. Lobortis enim nunc leo tellus natoque.</p>\r\n<p>Neque tortor aliquam pretium fringilla pretium a dolor convallis leo tincidunt. Ut consectetuer laoreet aliquam sit sem Aenean et dignissim nulla leo. Pretium consectetuer eget pellentesque Sed nec tincidunt Vestibulum at Curabitur egestas. Pretium platea pellentesque convallis nisl nulla felis sociis nonummy ipsum ante. Condimentum lobortis sit et tellus id cursus Curabitur in convallis eget. Nonummy dui Nam ut cursus in auctor eros mauris justo eget. Ornare nec.</p>\r\n<p>Dolor dapibus Phasellus id Aenean rhoncus Maecenas Nunc pellentesque In convallis. Porttitor fringilla sed natoque Aliquam wisi Sed tempus pretium pretium Pellentesque. Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. Commodo mus nibh ac congue Aliquam orci Donec semper ipsum elit. Mattis lacus.</p>\r\n<p>Pellentesque pede tincidunt tellus lorem ultrices enim tristique tincidunt sem pretium. Mollis euismod lacinia et Curabitur orci pellentesque eget Vestibulum Duis penatibus. Vestibulum Donec id congue fames auctor interdum mauris auctor tellus cursus. Odio interdum Aenean interdum egestas vitae pellentesque dictum diam nec feugiat. Est risus dui consequat commodo nibh Donec at risus condimentum Quisque. Rutrum tincidunt tincidunt porttitor ridiculus Vestibulum et semper vitae Vestibulum urna.</p>\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id. Auctor congue pretium Aenean turpis dui eget Curabitur nulla cursus pellentesque. Et Duis id urna elit.</p>', 1, 0, 0, 86, '2011-12-08 07:53:48', 42, '', '2011-12-13 09:26:54', 42, 0, '0000-00-00 00:00:00', '2011-12-08 07:53:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 0, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(134, 255, 'First Latino White Sox Star Gets Another Shot', 'first-latino-white-sox-star-gets-another-shot', '', '<p><img src="images/stories/demo/world/us-9.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n', '\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 0, 0, 84, '2011-12-08 08:07:07', 42, '', '2011-12-13 09:36:38', 42, 0, '0000-00-00 00:00:00', '2011-12-08 08:07:07', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 7, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(135, 256, 'Democrats See a Two-Horse G.O.P', 'democrats-see-a-two-horse-gop-race-adding-a-whip', '', '<p><img src="images/stories/demo/world/us-10.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n', '\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 0, 0, 84, '2011-10-08 08:08:09', 42, '', '2011-12-19 07:08:52', 42, 0, '0000-00-00 00:00:00', '2011-10-08 08:08:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 5, 0, 6, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(136, 257, '2 Character Models for a Single ', '2-character-models-for-a-single-cinematic-point-winning-elections-at-any-cost', '', '<p><img src="images/stories/demo/world/us-11.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n', '\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 0, 0, 84, '2011-12-08 08:08:09', 42, '', '2011-12-13 09:34:19', 42, 0, '0000-00-00 00:00:00', '2011-12-08 08:08:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 5, 0, 5, '', '', 1, 7, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(137, 258, 'Plan to Widen Availability of Morning', 'plan-to-widen-availability-of-morning-after-pill-is-rejected', '', '<p><img src="images/stories/demo/world/us-8.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n', '\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 0, 0, 84, '2011-12-08 08:08:09', 42, '', '2011-12-22 04:39:42', 42, 42, '2011-12-22 04:39:42', '2011-12-08 08:08:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 5, 0, 4, '', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(138, 259, 'Blagojevich Sentenced to 14 Years in Prison', 'blagojevich-sentenced-to-14-years-in-prison', '', '<p><img src="images/stories/demo/world/us-13.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n', '\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 0, 0, 84, '2011-12-08 08:08:09', 42, '', '2011-12-13 09:34:30', 42, 0, '0000-00-00 00:00:00', '2011-12-08 08:08:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 3, '', '', 1, 13, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(139, 260, 'Florida Budget Adds to School Spending', 'blagojevich-sentenced-to-14-years-in-prison-2', '', '<p><img src="images/stories/demo/world/us-3.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n', '\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 0, 0, 84, '2011-12-08 08:08:09', 42, '', '2011-12-13 09:36:49', 42, 0, '0000-00-00 00:00:00', '2011-12-08 08:08:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 2, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(140, 261, 'â€˜Occupyâ€™ Groups Face Setbacks ', 'occupy-groups-face-setbacks-in-san-francisco-and-boston', '', '<p><img src="images/stories/demo/world/us-7.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n', '\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 0, 0, 84, '2011-12-08 08:08:09', 42, '', '2011-12-13 09:37:47', 42, 0, '0000-00-00 00:00:00', '2011-12-08 08:08:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 1, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(141, 262, 'Eyeing 2012, White House Presses Europe ', 'eyeing-2012-white-house-presses-europe-on-debt', '', '<p><img src="images/stories/demo/world/us-14.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n', '\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 0, 0, 84, '2011-10-08 08:08:09', 42, '', '2011-12-19 07:08:41', 42, 0, '0000-00-00 00:00:00', '2011-10-08 08:08:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 6, 0, 0, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(142, 264, 'Enim sollicitudin habitasse', 'enim-sollicitudin-habitasse', '', '<div><img src="images/stories/demo/style/fashion-7.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Lorem ipsum dolor sit amet consectetuer Aenean Nulla est nisl cursus. Eget enim eget et nunc urna libero augue convallis lacinia gravida. Et eros quis eget et vel turpis est nec ultrices Aliquam. Felis quam id vitae condimentum commodo Vivamus nascetur Suspendisse pellentesque Nunc. Nulla Mauris lacus at congue sem Nulla interdum sollicitudin dictumst nunc. Dolor ac Vestibulum.</p>\r\n', '\r\n<p>Sem tincidunt urna amet eros nec metus elit nibh sagittis et. Elit et mauris ut sollicitudin convallis interdum lacus sapien sed Curabitur. Interdum gravida massa quis ac nibh Integer eget eu non Sed. Felis Nullam scelerisque volutpat Morbi Curabitur enim Nam nunc fames Phasellus. Fringilla quis lorem Nam facilisi Phasellus Nam tempus diam morbi tellus. Habitant.</p>\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus.</p>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>', 1, 0, 0, 90, '2011-11-12 11:00:00', 42, '', '2011-12-19 07:08:11', 42, 0, '0000-00-00 00:00:00', '2011-11-12 11:00:25', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 7, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(143, 265, 'Ipsum sagittis venenatis', 'ipsum-sagittis-venenatis', '', '<div><img src="images/stories/demo/style/shop-8.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Lorem ipsum dolor sit amet consectetuer Aenean Nulla est nisl cursus. Eget enim eget et nunc urna libero augue convallis lacinia gravida. Et eros quis eget et vel turpis est nec ultrices Aliquam. Felis quam id vitae condimentum commodo Vivamus nascetur Suspendisse pellentesque Nunc. Nulla Mauris lacus at congue sem Nulla interdum sollicitudin dictumst nunc. Dolor ac Vestibulum.</p>\r\n', '\r\n<p>Sem tincidunt urna amet eros nec metus elit nibh sagittis et. Elit et mauris ut sollicitudin convallis interdum lacus sapien sed Curabitur. Interdum gravida massa quis ac nibh Integer eget eu non Sed. Felis Nullam scelerisque volutpat Morbi Curabitur enim Nam nunc fames Phasellus. Fringilla quis lorem Nam facilisi Phasellus Nam tempus diam morbi tellus. Habitant.</p>\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus.</p>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>', 1, 0, 0, 90, '2011-12-12 11:02:26', 42, '', '2011-12-13 09:06:50', 42, 0, '0000-00-00 00:00:00', '2011-12-12 11:02:26', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 6, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(144, 266, 'Karcher K2900M pressure washer', 'karcher-k2900m-pressure-washer', '', '<div><img src="images/stories/demo/style/shop-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum.</p>\r\n', '\r\n<p>Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat. Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 0, 0, 90, '2011-11-12 11:02:57', 42, '', '2011-12-19 07:08:19', 42, 0, '0000-00-00 00:00:00', '2011-11-12 11:02:57', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 5, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(145, 267, 'Morbi congue ac sapien sit', 'morbi-congue-ac-sapien-sit-euismod-tincidunt', '', '<div><img src="images/stories/demo/style/shop-7.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n', '\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit.</p>\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc.</p>\r\n<p>Sem lobortis id hendrerit pretium Suspendisse ut felis In aliquet mauris. Mauris Morbi augue Nunc mi cursus netus turpis malesuada sit ac. Id tristique a Nunc ligula morbi Pellentesque semper diam In enim. Nibh felis augue Donec cursus adipiscing id laoreet Duis lacus a. Suspendisse penatibus tempus sollicitudin at Cras congue ut.</p>', 1, 0, 0, 90, '2011-12-12 11:03:30', 42, '', '2011-12-16 07:51:23', 42, 0, '0000-00-00 00:00:00', '2011-12-12 11:03:30', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 4, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(146, 268, 'Multi-purpose oval roaster', 'multi-purpose-oval-roaster', '', '<div><img src="images/stories/demo/style/shop-3.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl.</p>\r\n', '\r\n<p>At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent. Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices.</p>\r\n<ul>\r\n<li><a href="#" title="Sample link">Pellentesque nec porta ipsum massa risus</a></li>\r\n<li><a href="#" title="Sample link">Curabitur Praesent Nam Donec Quisque</a></li>\r\n</ul>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 0, 0, 90, '2011-12-12 11:03:58', 42, '', '2011-12-13 09:09:11', 42, 0, '0000-00-00 00:00:00', '2011-12-12 11:03:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 3, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(147, 269, 'Ut Mauris elit ipsum Pellentesque nec', 'ut-mauris-elit-ipsum-pellentesque-nec', '', '<div><img src="images/stories/demo/style/shop-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl.</p>\r\n', '\r\n<p>At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent. Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 0, 0, 90, '2011-12-12 11:04:36', 42, '', '2011-12-13 09:10:49', 42, 0, '0000-00-00 00:00:00', '2011-12-12 11:04:36', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 2, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(148, 270, 'Rhoncus tellus eros enim netus', 'rhoncus-tellus-eros-enim-netus', '', '<div><img src="images/stories/demo/style/shop-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Sem tincidunt urna amet eros nec metus elit nibh sagittis et. Elit et mauris ut sollicitudin convallis interdum lacus sapien sed Curabitur. Interdum gravida massa quis ac nibh Integer eget eu non Sed. Felis Nullam scelerisque volutpat Morbi Curabitur enim Nam nunc fames Phasellus. Fringilla quis lorem Nam facilisi Phasellus Nam tempus diam morbi tellus. Habitant.</p>\r\n', '\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus.</p>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>', 1, 0, 0, 90, '2011-12-12 11:05:19', 42, '', '2011-12-13 09:08:56', 42, 0, '0000-00-00 00:00:00', '2011-12-12 11:05:19', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 1, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(149, 271, 'Vestibulum sem wisi', 'vestibulum-sem-wisi', '', '<div><img src="images/stories/demo/style/shop-6.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></div>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n', '\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit.</p>\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc.</p>', 1, 0, 0, 90, '2011-12-12 11:07:18', 42, '', '2011-12-13 09:11:01', 42, 0, '0000-00-00 00:00:00', '2011-12-12 11:07:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 0, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(150, 273, 'All positions layout', 'all-positions-layout', '', '<p>Nulla dapibus neque sit amet libero&nbsp; ser suscipit hendrerit. Donec rhoncus mollis suscipit. Mauris posuere turpis eu dui lobortis non iaculis odio tincidunt. Class aptent taciti sociosqu ad litora.</p>\r\n<p>Sodales ac feugiat elit Integer gravida risus eu habitasse ligula Lorem. Id senectus tincidunt metus porta amet sem senectus tellus Curabitur Fusce. Eget Curabitur rutrum Pellentesque Curabitur Nullam orci ut tristique Curabitur lacinia. Tortor consectetuer ac at montes id id neque est leo vel. Phasellus libero ut dui pede sagittis vel auctor dignissim Nunc ante. Nisl in Pellentesque mauris nibh et vel tincidunt auctor fringilla id. Neque elit augue.</p>\r\n<p>Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Suspendisse ut. Tortor consectetuer ac at montes id id neque est leo vel.</p>', '', 1, 0, 0, 9, '2011-12-15 04:40:18', 42, '', '2011-12-16 04:21:17', 42, 42, '2011-12-27 04:58:26', '2011-12-15 04:40:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 0, '', '', 1, 94, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(151, 274, 'Lorem ipsum dolor sit (2)', 'lorem-ipsum-dolor-sit-2', '', '<div><img src="images/stories/demo/world/af-6.jpg" border="0" alt="Aenean Donec gravida hendrerit" title="Sample image" align="left" /></div>\r\n<p>Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel.</p>\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 0, 0, 78, '2011-12-06 04:30:00', 42, '', '2011-12-15 06:52:20', 0, 0, '0000-00-00 00:00:00', '2011-12-06 04:30:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(152, 275, 'Lorem ipsum dolor sit (3)', 'lorem-ipsum-dolor-sit-3', '', '<div><img src="images/stories/demo/world/af-6.jpg" border="0" alt="Aenean Donec gravida hendrerit" title="Sample image" align="left" /></div>\r\n<p>Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel.</p>\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 0, 0, 78, '2011-12-06 04:30:00', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-12-06 04:30:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(153, 276, 'Lorem ipsum dolor sit (4)', 'lorem-ipsum-dolor-sit-4', '', '<div><img src="images/stories/demo/world/af-6.jpg" border="0" alt="Aenean Donec gravida hendrerit" title="Sample image" align="left" /></div>\r\n<p>Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel.</p>\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 0, 0, 78, '2011-12-06 04:30:00', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-12-06 04:30:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(154, 277, 'Full width', 'full-width', '', '<p><img src="images/stories/demo/category-5.jpg" border="0" style="border: 0; float: left; margin: 5px;" />Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', '', 1, 0, 0, 14, '2012-03-23 02:55:08', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-03-23 02:55:08', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 2, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(155, 278, '3 Columns', '3-columns', '', '<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', '', 1, 0, 0, 14, '2012-03-23 02:56:00', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-03-23 02:56:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 1, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(156, 279, 'Content + Right', 'content-right', '', '<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', '', 1, 0, 0, 14, '2012-03-23 02:56:45', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-03-23 02:56:45', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, 0, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');

DROP TABLE IF EXISTS `#__content_frontpage`;
CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM;

INSERT INTO `#__content_frontpage` (`content_id`, `ordering`) VALUES
(35, 11),
(102, 9),
(104, 8),
(87, 1),
(85, 3),
(91, 2),
(83, 10),
(81, 7),
(132, 6),
(129, 5),
(130, 4);

DROP TABLE IF EXISTS `#__content_rating`;
CREATE TABLE `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__core_log_searches`;
CREATE TABLE `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__extensions`;
CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=MyISAM ;

INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(1, 'com_mailto', 'component', 'com_mailto', '', 0, 1, 1, 1, '{"legacy":false,"name":"com_mailto","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MAILTO_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(2, 'com_wrapper', 'component', 'com_wrapper', '', 0, 1, 1, 1, '{"legacy":false,"name":"com_wrapper","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_WRAPPER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(3, 'com_admin', 'component', 'com_admin', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_admin","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_ADMIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(4, 'com_banners', 'component', 'com_banners', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_banners","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_BANNERS_XML_DESCRIPTION","group":""}', '{"purchase_type":"3","track_impressions":"0","track_clicks":"0","metakey_prefix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(5, 'com_cache', 'component', 'com_cache', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_cache","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CACHE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(6, 'com_categories', 'component', 'com_categories', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_categories","type":"component","creationDate":"December 2007","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CATEGORIES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(7, 'com_checkin', 'component', 'com_checkin', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_checkin","type":"component","creationDate":"Unknown","author":"Joomla! Project","copyright":"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CHECKIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(8, 'com_contact', 'component', 'com_contact', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_contact","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CONTACT_XML_DESCRIPTION","group":""}', '{"show_contact_category":"hide","show_contact_list":"0","presentation_style":"sliders","show_name":"1","show_position":"1","show_email":"0","show_street_address":"1","show_suburb":"1","show_state":"1","show_postcode":"1","show_country":"1","show_telephone":"1","show_mobile":"1","show_fax":"1","show_webpage":"1","show_misc":"1","show_image":"1","image":"","allow_vcard":"0","show_articles":"0","show_profile":"0","show_links":"0","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","contact_icons":"0","icon_address":"","icon_email":"","icon_telephone":"","icon_mobile":"","icon_fax":"","icon_misc":"","show_headings":"1","show_position_headings":"1","show_email_headings":"0","show_telephone_headings":"1","show_mobile_headings":"0","show_fax_headings":"0","allow_vcard_headings":"0","show_suburb_headings":"1","show_state_headings":"1","show_country_headings":"1","show_email_form":"1","show_email_copy":"1","banned_email":"","banned_subject":"","banned_text":"","validate_session":"1","custom_reply":"0","redirect":"","show_category_crumb":"0","metakey":"","metadesc":"","robots":"","author":"","rights":"","xreference":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(9, 'com_cpanel', 'component', 'com_cpanel', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_cpanel","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CPANEL_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10, 'com_installer', 'component', 'com_installer', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_installer","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_INSTALLER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(11, 'com_languages', 'component', 'com_languages', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_languages","type":"component","creationDate":"2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_LANGUAGES_XML_DESCRIPTION","group":""}', '{"administrator":"en-GB","site":"en-GB"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(12, 'com_login', 'component', 'com_login', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_login","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(13, 'com_media', 'component', 'com_media', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_media","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MEDIA_XML_DESCRIPTION","group":""}', '{"upload_extensions":"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS","upload_maxsize":"10","file_path":"images","image_path":"images","restrict_uploads":"1","allowed_media_usergroup":"3","check_mime":"1","image_extensions":"bmp,gif,jpg,png","ignore_extensions":"","upload_mime":"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip","upload_mime_illegal":"text\\/html","enable_flash":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(14, 'com_menus', 'component', 'com_menus', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_menus","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MENUS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(15, 'com_messages', 'component', 'com_messages', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_messages","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MESSAGES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(16, 'com_modules', 'component', 'com_modules', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_modules","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MODULES_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(17, 'com_newsfeeds', 'component', 'com_newsfeeds', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_newsfeeds","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{"show_feed_image":"1","show_feed_description":"1","show_item_description":"1","feed_word_count":"0","show_headings":"1","show_name":"1","show_articles":"0","show_link":"1","show_description":"1","show_description_image":"1","display_num":"","show_pagination_limit":"1","show_pagination":"1","show_pagination_results":"1","show_cat_items":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(18, 'com_plugins', 'component', 'com_plugins', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_plugins","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_PLUGINS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(19, 'com_search', 'component', 'com_search', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_search","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_SEARCH_XML_DESCRIPTION","group":""}', '{"enabled":"0","show_date":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(20, 'com_templates', 'component', 'com_templates', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_templates","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_TEMPLATES_XML_DESCRIPTION","group":""}', '{"template_positions_display":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(21, 'com_weblinks', 'component', 'com_weblinks', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_weblinks","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_WEBLINKS_XML_DESCRIPTION","group":""}', '{"show_comp_description":"1","comp_description":"","show_link_hits":"1","show_link_description":"1","show_other_cats":"0","show_headings":"0","show_numbers":"0","show_report":"1","count_clicks":"1","target":"0","link_icons":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(22, 'com_content', 'component', 'com_content', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_content","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CONTENT_XML_DESCRIPTION","group":""}', '{"article_layout":"_:default","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"1","show_item_navigation":"0","show_vote":"0","show_readmore":"1","show_readmore_title":"0","readmore_limit":"100","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","category_layout":"_:blog","show_category_title":"0","show_description":"0","show_description_image":"0","maxLevel":"1","show_empty_categories":"0","show_no_articles":"1","show_subcat_desc":"1","show_cat_num_articles":"0","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_num_articles_cat":"1","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"0","show_subcategory_content":"0","show_pagination_limit":"1","filter_field":"hide","show_headings":"1","list_show_date":"0","date_format":"","list_show_hits":"1","list_show_author":"1","orderby_pri":"order","orderby_sec":"rdate","order_date":"published","show_pagination":"2","show_pagination_results":"1","show_feed_link":"1","feed_summary":"0","filters":{"1":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"6":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"7":{"filter_type":"NONE","filter_tags":"","filter_attributes":""},"2":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"3":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"4":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"5":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"10":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"12":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"8":{"filter_type":"NONE","filter_tags":"","filter_attributes":""}}}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(23, 'com_config', 'component', 'com_config', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_config","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CONFIG_XML_DESCRIPTION","group":""}', '{"filters":{"1":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"6":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"7":{"filter_tags":"","filter_attributes":"","filter_type":"NONE"},"2":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"3":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"4":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"5":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"10":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"12":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"8":{"filter_tags":"","filter_attributes":"","filter_type":"NONE"}}}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(24, 'com_redirect', 'component', 'com_redirect', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_redirect","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_REDIRECT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(25, 'com_users', 'component', 'com_users', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_users","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_USERS_XML_DESCRIPTION","group":""}', '{"allowUserRegistration":"1","new_usertype":"2","useractivation":"1","frontend_userparams":"1","mailSubjectPrefix":"","mailBodySuffix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(100, 'PHPMailer', 'library', 'phpmailer', '', 0, 1, 1, 1, '{"legacy":false,"name":"PHPMailer","type":"library","creationDate":"2001","author":"PHPMailer","copyright":"(c) 2001-2003, Brent R. Matzelle, (c) 2004-2009, Andy Prevost. All Rights Reserved., (c) 2010-2011, Jim Jagielski. All Rights Reserved.","authorEmail":"jimjag@gmail.com","authorUrl":"https:\\/\\/code.google.com\\/a\\/apache-extras.org\\/p\\/phpmailer\\/","version":"5.2","description":"LIB_PHPMAILER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(101, 'SimplePie', 'library', 'simplepie', '', 0, 1, 1, 1, '{"legacy":false,"name":"SimplePie","type":"library","creationDate":"2004","author":"SimplePie","copyright":"Copyright (c) 2004-2009, Ryan Parman and Geoffrey Sneddon","authorEmail":"","authorUrl":"http:\\/\\/simplepie.org\\/","version":"1.2","description":"LIB_SIMPLEPIE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(102, 'phputf8', 'library', 'phputf8', '', 0, 1, 1, 1, '{"legacy":false,"name":"phputf8","type":"library","creationDate":"2006","author":"Harry Fuecks","copyright":"Copyright various authors","authorEmail":"hfuecks@gmail.com","authorUrl":"http:\\/\\/sourceforge.net\\/projects\\/phputf8","version":"0.5","description":"LIB_PHPUTF8_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(103, 'Joomla! Platform', 'library', 'joomla', '', 0, 1, 1, 1, '{"legacy":false,"name":"Joomla! Platform","type":"library","creationDate":"2008","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"http:\\/\\/www.joomla.org","version":"11.4","description":"LIB_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(200, 'mod_articles_archive', 'module', 'mod_articles_archive', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_archive","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters.\\n\\t\\tAll rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(201, 'mod_articles_latest', 'module', 'mod_articles_latest', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LATEST_NEWS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(202, 'mod_articles_popular', 'module', 'mod_articles_popular', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_articles_popular","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(203, 'mod_banners', 'module', 'mod_banners', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_banners","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_BANNERS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(204, 'mod_breadcrumbs', 'module', 'mod_breadcrumbs', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_breadcrumbs","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_BREADCRUMBS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(205, 'mod_custom', 'module', 'mod_custom', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(206, 'mod_feed', 'module', 'mod_feed', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_FEED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(207, 'mod_footer', 'module', 'mod_footer', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_footer","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_FOOTER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(208, 'mod_login', 'module', 'mod_login', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_login","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(209, 'mod_menu', 'module', 'mod_menu', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_menu","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_MENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(210, 'mod_articles_news', 'module', 'mod_articles_news', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_articles_news","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_ARTICLES_NEWS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(211, 'mod_random_image', 'module', 'mod_random_image', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_random_image","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_RANDOM_IMAGE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(212, 'mod_related_items', 'module', 'mod_related_items', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_related_items","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_RELATED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(213, 'mod_search', 'module', 'mod_search', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_search","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_SEARCH_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(214, 'mod_stats', 'module', 'mod_stats', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_stats","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_STATS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(215, 'mod_syndicate', 'module', 'mod_syndicate', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_syndicate","type":"module","creationDate":"May 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_SYNDICATE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(216, 'mod_users_latest', 'module', 'mod_users_latest', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_users_latest","type":"module","creationDate":"December 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_USERS_LATEST_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(217, 'mod_weblinks', 'module', 'mod_weblinks', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_weblinks","type":"module","creationDate":"July 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_WEBLINKS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(218, 'mod_whosonline', 'module', 'mod_whosonline', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_whosonline","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_WHOSONLINE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(219, 'mod_wrapper', 'module', 'mod_wrapper', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_wrapper","type":"module","creationDate":"October 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_WRAPPER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(220, 'mod_articles_category', 'module', 'mod_articles_category', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_category","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(221, 'mod_articles_categories', 'module', 'mod_articles_categories', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_categories","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(222, 'mod_languages', 'module', 'mod_languages', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_languages","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LANGUAGES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(300, 'mod_custom', 'module', 'mod_custom', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(301, 'mod_feed', 'module', 'mod_feed', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_FEED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(302, 'mod_latest', 'module', 'mod_latest', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LATEST_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(303, 'mod_logged', 'module', 'mod_logged', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_logged","type":"module","creationDate":"January 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LOGGED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(304, 'mod_login', 'module', 'mod_login', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_login","type":"module","creationDate":"March 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(305, 'mod_menu', 'module', 'mod_menu', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_menu","type":"module","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_MENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(307, 'mod_popular', 'module', 'mod_popular', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_popular","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(308, 'mod_quickicon', 'module', 'mod_quickicon', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_quickicon","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_QUICKICON_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(309, 'mod_status', 'module', 'mod_status', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_status","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_STATUS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(310, 'mod_submenu', 'module', 'mod_submenu', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_submenu","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_SUBMENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(311, 'mod_title', 'module', 'mod_title', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_title","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_TITLE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(312, 'mod_toolbar', 'module', 'mod_toolbar', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_toolbar","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_TOOLBAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(313, 'mod_multilangstatus', 'module', 'mod_multilangstatus', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_multilangstatus","type":"module","creationDate":"September 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_MULTILANGSTATUS_XML_DESCRIPTION","group":""}', '{"cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(400, 'plg_authentication_gmail', 'plugin', 'gmail', 'authentication', 0, 0, 1, 0, '{"legacy":false,"name":"plg_authentication_gmail","type":"plugin","creationDate":"February 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_GMAIL_XML_DESCRIPTION","group":""}', '{"applysuffix":"0","suffix":"","verifypeer":"1","user_blacklist":""}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(401, 'plg_authentication_joomla', 'plugin', 'joomla', 'authentication', 0, 1, 1, 1, '{"legacy":false,"name":"plg_authentication_joomla","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_AUTH_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(402, 'plg_authentication_ldap', 'plugin', 'ldap', 'authentication', 0, 0, 1, 0, '{"legacy":false,"name":"plg_authentication_ldap","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_LDAP_XML_DESCRIPTION","group":""}', '{"host":"","port":"389","use_ldapV3":"0","negotiate_tls":"0","no_referrals":"0","auth_method":"bind","base_dn":"","search_string":"","users_dn":"","username":"admin","password":"bobby7","ldap_fullname":"fullName","ldap_email":"mail","ldap_uid":"uid"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(404, 'plg_content_emailcloak', 'plugin', 'emailcloak', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"plg_content_emailcloak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION","group":""}', '{"mode":"1"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(405, 'plg_content_geshi', 'plugin', 'geshi', 'content', 0, 0, 1, 0, '{"legacy":false,"name":"plg_content_geshi","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"","authorUrl":"qbnz.com\\/highlighter","version":"2.5.0","description":"PLG_CONTENT_GESHI_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(406, 'plg_content_loadmodule', 'plugin', 'loadmodule', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"plg_content_loadmodule","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_LOADMODULE_XML_DESCRIPTION","group":""}', '{"style":"xhtml"}', '', '', 0, '2011-09-18 15:22:50', 0, 0),
(407, 'plg_content_pagebreak', 'plugin', 'pagebreak', 'content', 0, 1, 1, 1, '{"legacy":false,"name":"plg_content_pagebreak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION","group":""}', '{"title":"1","multipage_toc":"1","showall":"1"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(408, 'plg_content_pagenavigation', 'plugin', 'pagenavigation', 'content', 0, 1, 1, 1, '{"legacy":false,"name":"plg_content_pagenavigation","type":"plugin","creationDate":"January 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_PAGENAVIGATION_XML_DESCRIPTION","group":""}', '{"position":"1"}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(409, 'plg_content_vote', 'plugin', 'vote', 'content', 0, 1, 1, 1, '{"legacy":false,"name":"plg_content_vote","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_VOTE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(410, 'plg_editors_codemirror', 'plugin', 'codemirror', 'editors', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors_codemirror","type":"plugin","creationDate":"28 March 2011","author":"Marijn Haverbeke","copyright":"","authorEmail":"N\\/A","authorUrl":"","version":"1.0","description":"PLG_CODEMIRROR_XML_DESCRIPTION","group":""}', '{"linenumbers":"0","tabmode":"indent"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(411, 'plg_editors_none', 'plugin', 'none', 'editors', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors_none","type":"plugin","creationDate":"August 2004","author":"Unknown","copyright":"","authorEmail":"N\\/A","authorUrl":"","version":"2.5.0","description":"PLG_NONE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(412, 'plg_editors_tinymce', 'plugin', 'tinymce', 'editors', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors_tinymce","type":"plugin","creationDate":"2005-2013","author":"Moxiecode Systems AB","copyright":"Moxiecode Systems AB","authorEmail":"N\\/A","authorUrl":"tinymce.moxiecode.com\\/","version":"3.5.4.1","description":"PLG_TINY_XML_DESCRIPTION","group":""}', '{"mode":"1","skin":"0","compressed":"0","cleanup_startup":"0","cleanup_save":"2","entity_encoding":"raw","lang_mode":"0","lang_code":"en","text_direction":"ltr","content_css":"1","content_css_custom":"","relative_urls":"1","newlines":"0","invalid_elements":"script,applet,iframe","extended_elements":"","toolbar":"top","toolbar_align":"left","html_height":"550","html_width":"750","element_path":"1","fonts":"1","paste":"1","searchreplace":"1","insertdate":"1","format_date":"%Y-%m-%d","inserttime":"1","format_time":"%H:%M:%S","colors":"1","table":"1","smilies":"1","media":"1","hr":"1","directionality":"1","fullscreen":"1","style":"1","layer":"1","xhtmlxtras":"1","visualchars":"1","nonbreaking":"1","template":"1","blockquote":"1","wordcount":"1","advimage":"1","advlink":"1","autosave":"1","contextmenu":"1","inlinepopups":"1","safari":"0","custom_plugin":"","custom_button":""}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(413, 'plg_editors-xtd_article', 'plugin', 'article', 'editors-xtd', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors-xtd_article","type":"plugin","creationDate":"October 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_ARTICLE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(414, 'plg_editors-xtd_image', 'plugin', 'image', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"plg_editors-xtd_image","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_IMAGE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(415, 'plg_editors-xtd_pagebreak', 'plugin', 'pagebreak', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"plg_editors-xtd_pagebreak","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(416, 'plg_editors-xtd_readmore', 'plugin', 'readmore', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"plg_editors-xtd_readmore","type":"plugin","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_READMORE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(417, 'plg_search_categories', 'plugin', 'categories', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_categories","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(418, 'plg_search_contacts', 'plugin', 'contacts', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_contacts","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_CONTACTS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(419, 'plg_search_content', 'plugin', 'content', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_content","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_CONTENT_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(420, 'plg_search_newsfeeds', 'plugin', 'newsfeeds', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_newsfeeds","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(421, 'plg_search_weblinks', 'plugin', 'weblinks', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_weblinks","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(422, 'plg_system_languagefilter', 'plugin', 'languagefilter', 'system', 0, 0, 1, 1, '{"legacy":false,"name":"plg_system_languagefilter","type":"plugin","creationDate":"July 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(423, 'plg_system_p3p', 'plugin', 'p3p', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_p3p","type":"plugin","creationDate":"September 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_P3P_XML_DESCRIPTION","group":""}', '{"headers":"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(424, 'plg_system_cache', 'plugin', 'cache', 'system', 0, 0, 1, 1, '{"legacy":false,"name":"plg_system_cache","type":"plugin","creationDate":"February 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CACHE_XML_DESCRIPTION","group":""}', '{"browsercache":"0","cachetime":"15"}', '', '', 0, '0000-00-00 00:00:00', 9, 0),
(425, 'plg_system_debug', 'plugin', 'debug', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"plg_system_debug","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_DEBUG_XML_DESCRIPTION","group":""}', '{"profile":"1","queries":"1","memory":"1","language_files":"1","language_strings":"1","strip-first":"1","strip-prefix":"","strip-suffix":""}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(426, 'plg_system_log', 'plugin', 'log', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_log","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_LOG_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(427, 'plg_system_redirect', 'plugin', 'redirect', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_redirect","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_REDIRECT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(428, 'plg_system_remember', 'plugin', 'remember', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_remember","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_REMEMBER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(429, 'plg_system_sef', 'plugin', 'sef', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"plg_system_sef","type":"plugin","creationDate":"December 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEF_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 8, 0),
(430, 'plg_system_logout', 'plugin', 'logout', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_logout","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 3, 0);
INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(431, 'plg_user_contactcreator', 'plugin', 'contactcreator', 'user', 0, 0, 1, 1, '{"legacy":false,"name":"plg_user_contactcreator","type":"plugin","creationDate":"August 2009","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTACTCREATOR_XML_DESCRIPTION","group":""}', '{"autowebpage":"","category":"34","autopublish":"0"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(432, 'plg_user_joomla', 'plugin', 'joomla', 'user', 0, 1, 1, 0, '{"legacy":false,"name":"plg_user_joomla","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2009 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_USER_JOOMLA_XML_DESCRIPTION","group":""}', '{"autoregister":"1"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(433, 'plg_user_profile', 'plugin', 'profile', 'user', 0, 0, 1, 1, '{"legacy":false,"name":"plg_user_profile","type":"plugin","creationDate":"January 2008","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_USER_PROFILE_XML_DESCRIPTION","group":""}', '{"register-require_address1":"1","register-require_address2":"1","register-require_city":"1","register-require_region":"1","register-require_country":"1","register-require_postal_code":"1","register-require_phone":"1","register-require_website":"1","register-require_favoritebook":"1","register-require_aboutme":"1","register-require_tos":"1","register-require_dob":"1","profile-require_address1":"1","profile-require_address2":"1","profile-require_city":"1","profile-require_region":"1","profile-require_country":"1","profile-require_postal_code":"1","profile-require_phone":"1","profile-require_website":"1","profile-require_favoritebook":"1","profile-require_aboutme":"1","profile-require_tos":"1","profile-require_dob":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(434, 'plg_extension_joomla', 'plugin', 'joomla', 'extension', 0, 1, 1, 1, '{"legacy":false,"name":"plg_extension_joomla","type":"plugin","creationDate":"May 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(435, 'plg_content_joomla', 'plugin', 'joomla', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"plg_content_joomla","type":"plugin","creationDate":"November 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTENT_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(500, 'atomic', 'template', 'atomic', '', 0, 1, 1, 0, '{"legacy":false,"name":"atomic","type":"template","creationDate":"10\\/10\\/09","author":"Ron Severdia","copyright":"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.","authorEmail":"contact@kontentdesign.com","authorUrl":"http:\\/\\/www.kontentdesign.com","version":"2.5.0","description":"TPL_ATOMIC_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(502, 'bluestork', 'template', 'bluestork', '', 1, 1, 1, 0, '{"legacy":false,"name":"bluestork","type":"template","creationDate":"07\\/02\\/09","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"TPL_BLUESTORK_XML_DESCRIPTION","group":""}', '{"useRoundedCorners":"1","showSiteName":"0","textBig":"0","highContrast":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(503, 'beez_20', 'template', 'beez_20', '', 0, 1, 1, 0, '{"legacy":false,"name":"beez_20","type":"template","creationDate":"25 November 2009","author":"Angie Radtke","copyright":"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.","authorEmail":"a.radtke@derauftritt.de","authorUrl":"http:\\/\\/www.der-auftritt.de","version":"2.5.0","description":"TPL_BEEZ2_XML_DESCRIPTION","group":""}', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","templatecolor":"nature"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(504, 'hathor', 'template', 'hathor', '', 1, 1, 1, 0, '{"legacy":false,"name":"hathor","type":"template","creationDate":"May 2010","author":"Andrea Tarr","copyright":"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.","authorEmail":"hathor@tarrconsulting.com","authorUrl":"http:\\/\\/www.tarrconsulting.com","version":"2.5.0","description":"TPL_HATHOR_XML_DESCRIPTION","group":""}', '{"showSiteName":"0","colourChoice":"0","boldText":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(505, 'beez5', 'template', 'beez5', '', 0, 1, 1, 0, '{"legacy":false,"name":"beez5","type":"template","creationDate":"21 May 2010","author":"Angie Radtke","copyright":"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.","authorEmail":"a.radtke@derauftritt.de","authorUrl":"http:\\/\\/www.der-auftritt.de","version":"2.5.0","description":"TPL_BEEZ5_XML_DESCRIPTION","group":""}', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","html5":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(700, 'files_joomla', 'file', 'joomla', '', 0, 1, 1, 1, '{"legacy":false,"name":"files_joomla","type":"file","creationDate":"April 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.11","description":"FILES_JOOMLA_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(800, 'PKG_JOOMLA', 'package', 'pkg_joomla', '', 0, 1, 1, 1, '{"legacy":false,"name":"PKG_JOOMLA","type":"package","creationDate":"2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"http:\\/\\/www.joomla.org","version":"2.5.0","description":"PKG_JOOMLA_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10000, 'com_jaextmanager', 'component', 'com_jaextmanager', '', 1, 1, 0, 0, '{"legacy":false,"name":"com_jaextmanager","type":"component","creationDate":"May 2013","author":"JoomlArt","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"2.5.7","description":"JA Extension Manager Component","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10001, 'JA T3 Framework', 'plugin', 'jat3', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"JA T3 Framework","type":"plugin","creationDate":"28 June 2013","author":"www.JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"2.6.4","description":"\\n\\t\\n\\t\\t<h1>T3 Framework - JoomlArt Template Framework for Joomla 2.5 and Joomla 3.0<\\/h1>\\n\\t\\t<div style=\'font-weight: normal\'>\\n\\t\\t<p><span style=\'color: #ff6600;\'>\\n\\t\\t<strong>Features:<\\/strong><\\/span>\\n\\t\\tThis plugin is required for JA T3 Framework based templates to work.<\\/p>\\n\\t\\t\\n\\t\\t<strong><span style=\'color: #ff0000;\'>Usage Instruction:<\\/span><\\/strong><br \\/>\\n\\t\\t<ul>\\n\\t\\t<li>Enable the JA T3 plugin in Plugin manager<\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<strong><span style=\'color: #ff0000;\'>Upgrade Method:<\\/span><br \\/><\\/strong>\\n\\t\\t<ul>\\n\\t\\t  <li>You can install new version directly over this version. Uninstallation is not required. <\\/li>\\n\\t\\t  <li>Follow upgrade instructions and backup site \\/ plugin before upgrading<\\/li>\\n\\t\\t  <\\/ul>\\n\\t\\n\\t\\t<span style=\'color: #008000;\'><strong>Links:<\\/strong><\\/span><br \\/>\\n\\t\\t<ul>\\n\\t\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/wiki.joomlart.com\\/wiki\\/JA_T3_Framework_2\\/Overview\\">Wiki Userguide<\\/a><\\/li>\\n\\t\\t <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t\\t <li><a target=\'_blank\' href=\'http:\\/\\/www.joomlart.com\\/forums\\/forumdisplay.php?241\'>JA T3 Framework Forum<\\/a><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t\\t\\n\\t\\t","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1000, 0),
(10080, 'JA News Pro Module', 'module', 'mod_janewspro', '', 0, 1, 0, 0, '{"legacy":false,"name":"JA News Pro Module","type":"module","creationDate":"25 May 2013","author":"JoomlArt.com","copyright":"J.O.O.M Solutions Co., Ltd.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.7","description":"\\n\\t \\n\\t\\t<div style=\'text-align: left;\'>\\n\\t \\t<span style=\\"color: #008000;\\"><strong>JA News Pro Module for Joomla! 2.5<\\/strong><\\/span><br \\/>\\n\\t \\t<p><img alt=\\"JA News Pro Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec_newsfp_mod.png\\" \\/><\\/p>\\n\\t\\t<div style=\'font-weight:normal\'>\\n\\t \\tJA NEWS PRO Module comes with rich backend and advanced features for easy configuration. \\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Important Instructions:<\\/strong><\\/span><\\/p>\\n\\t \\t<ul>\\n\\t\\t\\t<li>Please refer to Template userguide or install the template Quickstart to view the optimum settings for this module.<\\/li>\\n\\t\\t\\t<li>The module display can be enhanced by CSS overrides in the demo templates. Thus, when you use this module in different templates, the results may vary and you may have to customize CSS to get your desired effects.<\\/li>\\n\\t\\t<\\/ul>\\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Usage Instruction:<\\/strong><\\/span><\\/p>\\n\\t \\t<ul>\\n\\t\\t\\t<li>JA News Pro module configure easily with K2 component and Joomla Content<\\/li>\\n\\t\\t\\t<li>JA News Pro module support 4 themes and allow user config content in the front end which is displayed in module (User Setting Tool).<\\/li>\\n\\t\\t\\t<li>JA News Pro module is best used with JA Teline IV template.<\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Methods:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ul>\\n\\t\\t\\t<li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li>\\n\\t\\t\\t<li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video..<\\/a><\\/strong><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t\\t<ul> <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li><li><a target=\'_blank\' href=\'http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51887\'>General Userguide<\\/a><\\/li><li>For more details on Thumbnail modes read this <a href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50325\\" title=\\"JA thumbanil modes\\" target=\\"_blank\\"><strong>tutorial<\\/strong><\\/a><\\/li><\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t\\t<\\/div>\\n\\t \\n\\t","group":""}', '{"moduleclass_sfx":"","settingcontent":"","source":"JANewsHelper","getChildren":"1","catsid":"","k2catsid":"","groupbysubcat":"0","maxSubCats":"-1","featured":"hide","ordering":"ordering","sort_order":"DESC","timerange":"","settingprofile":"","profile":"default","JPlugins":"1","K2Plugins":"1","colors":"","jacache":"1","jacache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10005, 'JA Content Slider', 'module', 'mod_jacontentslider', '', 0, 1, 0, 0, '{"legacy":false,"name":"JA Content Slider","type":"module","creationDate":"26 April 2013","author":"JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.6.4","description":"\\n\\t\\n\\t \\t<span style=\\"color: #008000;\\"><strong>JA Content Slider Module for Joomla! 2.5<\\/strong><\\/span><br \\/>\\n\\t \\t<p><img alt=\\"JA Content Slider Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/ja_contentslider.png\\" \\/><\\/p>\\n\\t\\t<div style=\'font-weight:normal\'>\\n\\t \\tSlide your articles from Joomla categories with cool effects, rich backend configs covering layout, animation control, auto thumbnail creation, images size, number of articles, sorting and much more\\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Important Instruction:<\\/strong><\\/span><\\/p>\\n\\t\\tCheck in configuration in your site if it does not have this line \\"var $absolute_path by \'your absolute path\';\\" you have to add its there to run.\\n\\t\\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Brief features:<\\/strong><\\/span><\\/p>\\n\\t \\t<ul>\\n\\t\\t\\t  <li>Slide your content with width and height properties.<\\/li>\\n\\t\\t\\t  <li>You can set the number of content to display in a tab.<\\/li>\\n\\t\\t\\t  <li>You can set categories contents to display.<\\/li>\\n\\t\\t\\t  <li>You can set display title, link title, introtext, readmore text links or not.<\\/li>\\n\\t\\t\\t  <li>You can set the slide to auto run or not. Default is YES.<\\/li>\\n\\t\\t\\t  <li>Set direction of slide. Default is left.<\\/li>\\n\\t\\t\\t  <li>Set time for rolling delay time and animation time.<\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ol><li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li><li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video..<\\/a><\\/strong><\\/li><\\/ol>\\n\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t\\t<ul><li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51825\\">JA Content Slider Userguide<\\/a><\\/li><li><a target=\\"_blank\\" href=\\"http:\\/\\/pm.joomlart.com\\/browse\\/JAECMODJACSLIDERJVI\\">Report Bug<\\/a><\\/li><li><a target=\\"_blank\\" href=\\"http:\\/\\/update.joomlart.com\\/\\">Updates &amp; Versions<\\/a><\\/li><\\/ul>\\n\\t\\t<p>Copyright 2004 - 2013 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t \\n\\t","group":""}', '{"moduleclass_sfx":"","settingcontent":"","source":"content","folder_images":"","catid":"","k2catsid":"","text_heading":"","showTab":"1","sort_order_field":"created","sort_order":"DESC","numElem":"3","maxitems":"10","link_titles":"1","showimages":"1","iwidth":"130","iheight":"90","showreadmore":"0","showintrotext":"1","numchar":"50","settingdisplay":"","xwidth":"140","xheight":"170","auto":"0","mode":"horizontal","direction":"left","delaytime":"5000","animationtime":"1000","showtitle":"1","showbutton":"1","scroll_when":"click","enable_cache":"1","cache_time":"300","source-articles-images-thumbnail_mode":"crop","source-articles-images-thumbnail_mode-resize-use_ratio":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10076, 'JA News Ticker', 'module', 'mod_janewsticker', '', 0, 1, 0, 0, '{"legacy":false,"name":"JA News Ticker","type":"module","creationDate":"May 2013","author":"Joomlart.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"2.5.5","description":"\\n\\t \\n\\t <div align=\\"left\\">\\n\\t \\t<span style=\\"color: #008000;\\"><strong>JA Newsticker Module for Joomla! 2.5<\\/strong><\\/span><br \\/>\\n\\t \\t<p><img alt=\\"JA Newsticker Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec_janews.png\\" \\/><\\/p>\\n\\t\\t<div style=\'font-weight:normal\'>\\n\\t \\tDisplay latest articles with cool animation effects as News Ticker, select categories to include, length of titles, sorting or even control buttons. Decent way to scroll out your latest information in limited space...\\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t \\t<ul>\\n\\t\\t\\t<li>The module supports a lot of animations display<\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t\\n\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Methods:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ul>\\n\\t\\t\\t<li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li>\\n\\t\\t\\t<li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video..<\\/a><\\/strong><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t\\t<ul>\\n\\t\\t<li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li><li><a target=\'_blank\' href=\'http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51825\'>General Userguide<\\/a><\\/li><li>For more details on Thumbnail modes read this <a href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50325\\" title=\\"JA thumbanil modes\\" target=\\"_blank\\"><strong>tutorial<\\/strong><\\/a><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t<\\/div>\\n\\t \\n\\t","group":""}', '{"moduleclass_sfx":"","settingcontent":"","using_mode":"","external_link":"","k2catsid":"","rss_link":"","category":"","sort_order_field":"created","sort_order":"DESC","max_items":"10","title_max_chars":"200","settingdisplay":"","animation_type":"horizontal","animation_speed":"500","animation_interval":"3000","animation_transition":"Fx.Transitions.linear","show_headtext":"1","headtext":"Headlines:","show_buttons_control":"0","enable_cache":"1","cache_time":"30"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10066, 'K2 Users', 'module', 'mod_k2_users', '', 0, 1, 0, 0, '{"legacy":false,"name":"K2 Users","type":"module","creationDate":"April 7th, 2013","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"K2_MOD_K2_USERS_DESCRTIPTION","group":""}', '{"moduleclass_sfx":"","getTemplate":"Default","source":"0","":"K2_DISPLAY_OPTIONS","filter":"1","K2UserGroup":"","ordering":"1","limit":"4","userIDs":"","userName":"1","userAvatar":"1","userAvatarWidthSelect":"custom","userAvatarWidth":"50","userDescription":"1","userDescriptionWordLimit":"","userURL":"1","userEmail":"0","userFeed":"1","userItemCount":"1","cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10067, 'K2 User', 'module', 'mod_k2_user', '', 0, 1, 0, 0, '{"legacy":false,"name":"K2 User","type":"module","creationDate":"April 7th, 2013","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"K2_MOD_K2_USER_DESCRIPTION","group":""}', '{"moduleclass_sfx":"","pretext":"","":"K2_LOGIN_LOGOUT_REDIRECTION","name":"1","userAvatar":"1","userAvatarWidthSelect":"custom","userAvatarWidth":"50","menu":"","login":"","logout":"","usesecure":"0","cache":"0","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10068, 'K2 Quick Icons (admin)', 'module', 'mod_k2_quickicons', '', 1, 1, 2, 0, '{"legacy":false,"name":"K2 Quick Icons (admin)","type":"module","creationDate":"April 7th, 2013","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"K2_QUICKICONS_FOR_USE_IN_THE_JOOMLA_CONTROL_PANEL_DASHBOARD_PAGE","group":""}', '{"modCSSStyling":"1","modLogo":"1","cache":"0","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10069, 'K2 Stats (admin)', 'module', 'mod_k2_stats', '', 1, 1, 2, 0, '{"legacy":false,"name":"K2 Stats (admin)","type":"module","creationDate":"April 7th, 2013","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"K2_STATS_FOR_USE_IN_THE_K2_DASHBOARD_PAGE","group":""}', '{"latestItems":"1","popularItems":"1","mostCommentedItems":"1","latestComments":"1","statistics":"1","cache":"0","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10099, 'JA Typo', 'plugin', 'jatypo', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"JA Typo","type":"plugin","creationDate":"May 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.5","description":"\\n\\t\\n\\t<div style=\'text-align: left;\'>\\n\\t<h1>JA Typo Plugin for Joomla! 2.5<\\/h1>\\n\\t<p><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t<img border=\\"0\\" alt=\\"JA Typography Plugin\\" src=\\"http:\\/\\/asset.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec_typo_plg.png\\" style=\\"float: left;\\">\\n\\tBonus Typography styles for your content. Choose styles right from your editor window. \\n\\tColorful buttons, tables, forms, tags, headings, lists, badges, icons, CSS3 buttons and more styles will come up...\\n\\t<p><strong><span style=\\"color: #ff0000;\\">Important Instruction:<\\/span><br \\/><\\/strong><\\/p>\\n\\t<ul><li>Install JA Typo Button Plugin for this to be seen in the Editor<\\/li>\\n\\t<li>You can use many types to load from a popup<\\/li>\\n\\t<\\/ul>\\n\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t<ol><li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading.<\\/li><\\/ol>\\n\\t<p><span style=\\"color: #008000;\\"><strong>Links :<\\/strong><\\/span><\\/p>\\n\\t<ul>\\n\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?49821\\">General Userguide<\\/a><\\/li>\\n\\t\\t <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t<\\/ul>\\n\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t<\\/div>\\n\\t\\n\\t","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10024, 'JA Accordion', 'module', 'mod_jaaccordion', '', 0, 1, 0, 0, '{"legacy":false,"name":"JA Accordion","type":"module","creationDate":"May 2013","author":"joomlart.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights\\n\\t\\tReserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.5","description":"\\n\\n\\t \\t<span style=\\"color: #008000;\\"><strong>JA Accordion Module for Joomla! 2.5<\\/strong><\\/span><br \\/>\\n\\t\\t<div style=\'font-weight:normal\'>\\n\\t \\tThis module displays selected contents with accordion effect. It supports Joomla! com_content articles \\/ categories and Modules.\\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t\\t <ul>\\n\\t\\t   \\t<li>Choose specific articles by ID or specific categories.<\\/li>\\n\\t\\t   \\t<li>Display multiple modules published to an specific module position.<\\/li>\\t\\n\\t\\t\\t<li>Easy to set number of items, transition effect, duration and width of module.<\\/li>\\n\\t\\t <\\/ul>\\t\\n\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Methods:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ol><li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li><li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video..<\\/a><\\/strong><\\/li><\\/ol>\\n\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t     <ul>\\n\\t\\t\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?65464\\">JA Accordion Userguide<\\/a><\\/li>\\n\\t\\t\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/pm.joomlart.com\\/browse\\/JAECMODEACCORDIONJ17\\">Report Bug<\\/a><\\/li>\\n\\t\\t\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/update.joomlart.com\\/\\">Updates &amp; Versions<\\/a><\\/li>\\n\\t\\t <\\/ul>\\n\\t\\t<p>Copyright 2004 - 2013 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t \\n\\t","group":""}', '{"settingcontent":"","type":"articlesIDs","modules-position":"","module-ids":"","artIDs":"1, 2, 3, 4","catids":"","show_featured":"","view":"introtext","ordering":"published","user_id":"0","@spacer":"","settingtype":"","Width":"","count":"5","mouseType":"click","duration":"1000","effect":"Fx.Transitions.Quad.easeInOut"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10062, 'K2 Comments', 'module', 'mod_k2_comments', '', 0, 1, 0, 0, '{"legacy":false,"name":"K2 Comments","type":"module","creationDate":"April 7th, 2013","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"MOD_K2_COMMENTS_DESCRIPTION","group":""}', '{"moduleclass_sfx":"","module_usage":"","":"K2_TOP_COMMENTERS","catfilter":"0","category_id":"","comments_limit":"5","comments_word_limit":"10","commenterName":"1","commentAvatar":"1","commentAvatarWidthSelect":"custom","commentAvatarWidth":"50","commentDate":"1","commentDateFormat":"absolute","commentLink":"1","itemTitle":"1","itemCategory":"1","feed":"1","commenters_limit":"5","commenterNameOrUsername":"1","commenterAvatar":"1","commenterAvatarWidthSelect":"custom","commenterAvatarWidth":"50","commenterLink":"1","commenterCommentsCounter":"1","commenterLatestComment":"1","cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10063, 'K2 Content', 'module', 'mod_k2_content', '', 0, 1, 0, 0, '{"legacy":false,"name":"K2 Content","type":"module","creationDate":"April 7th, 2013","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"K2_MOD_K2_CONTENT_DESCRIPTION","group":""}', '{"moduleclass_sfx":"","getTemplate":"Default","source":"filter","":"K2_OTHER_OPTIONS","catfilter":"0","category_id":"","getChildren":"0","itemCount":"5","itemsOrdering":"","FeaturedItems":"1","popularityRange":"","videosOnly":"0","item":"","items":"","itemTitle":"1","itemAuthor":"1","itemAuthorAvatar":"1","itemAuthorAvatarWidthSelect":"custom","itemAuthorAvatarWidth":"50","userDescription":"1","itemIntroText":"1","itemIntroTextWordLimit":"","itemImage":"1","itemImgSize":"Small","itemVideo":"1","itemVideoCaption":"1","itemVideoCredits":"1","itemAttachments":"1","itemTags":"1","itemCategory":"1","itemDateCreated":"1","itemHits":"1","itemReadMore":"1","itemExtraFields":"0","itemCommentsCounter":"1","feed":"1","itemPreText":"","itemCustomLink":"0","itemCustomLinkTitle":"","itemCustomLinkURL":"http:\\/\\/","itemCustomLinkMenuItem":"","K2Plugins":"1","JPlugins":"1","cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10065, 'K2 Tools', 'module', 'mod_k2_tools', '', 0, 1, 0, 0, '{"legacy":false,"name":"K2 Tools","type":"module","creationDate":"April 7th, 2013","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"K2_TOOLS","group":""}', '{"moduleclass_sfx":"","module_usage":"0","":"K2_CUSTOM_CODE_SETTINGS","archiveItemsCounter":"1","archiveCategory":"","authors_module_category":"","authorItemsCounter":"1","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"50","authorLatestItem":"1","calendarCategory":"","home":"","seperator":"","root_id":"","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"1","root_id2":"","catfilter":"0","category_id":"","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":"0","cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10070, 'Search - K2', 'plugin', 'k2', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"Search - K2","type":"plugin","creationDate":"April 7th, 2013","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"K2_THIS_PLUGIN_EXTENDS_THE_DEFAULT_JOOMLA_SEARCH_FUNCTIONALITY_TO_K2_CONTENT","group":""}', '{"search_limit":"50","search_tags":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10071, 'System - K2', 'plugin', 'k2', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - K2","type":"plugin","creationDate":"April 7th, 2013","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"K2_THE_K2_SYSTEM_PLUGIN_IS_USED_TO_ASSIST_THE_PROPER_FUNCTIONALITY_OF_THE_K2_COMPONENT_SITE_WIDE_MAKE_SURE_ITS_ALWAYS_PUBLISHED_WHEN_THE_K2_COMPONENT_IS_INSTALLED","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10072, 'User - K2', 'plugin', 'k2', 'user', 0, 1, 1, 0, '{"legacy":false,"name":"User - K2","type":"plugin","creationDate":"April 7th, 2013","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"K2_A_USER_SYNCHRONIZATION_PLUGIN_FOR_K2","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10073, 'COM_K2', 'component', 'com_k2', '', 1, 1, 0, 0, '{"legacy":false,"name":"COM_K2","type":"component","creationDate":"April 7th, 2013","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"Thank you for installing K2 by JoomlaWorks, the powerful content extension for Joomla!","group":""}', '{"enable_css":"1","jQueryHandling":"1.7remote","backendJQueryHandling":"remote","userName":"1","userImage":"1","userDescription":"1","userURL":"1","userEmail":"0","userFeedLink":"1","userFeedIcon":"1","userItemCount":"3","userItemTitle":"1","userItemTitleLinked":"1","userItemDateCreated":"1","userItemImage":"1","userItemIntroText":"1","userItemCategory":"1","userItemTags":"1","userItemCommentsAnchor":"1","userItemReadMore":"1","userItemK2Plugins":"1","defaultUsersItemid":"","tagItemCount":"3","tagItemTitle":"1","tagItemTitleLinked":"1","tagItemDateCreated":"1","tagItemImage":"1","tagItemIntroText":"1","tagItemCategory":"1","tagItemReadMore":"1","tagItemExtraFields":"0","tagOrdering":"","tagFeedLink":"0","tagFeedIcon":"0","defaultTagsItemid":"","genericItemCount":"10","genericItemTitle":"1","genericItemTitleLinked":"1","genericItemDateCreated":"1","genericItemImage":"1","genericItemIntroText":"1","genericItemCategory":"1","genericItemReadMore":"1","genericItemExtraFields":"0","genericFeedLink":"1","genericFeedIcon":"0","feedLimit":"10","feedItemImage":"1","feedImgSize":"S","feedItemIntroText":"1","feedTextWordLimit":"","feedItemFullText":"1","feedItemTags":"0","feedItemVideo":"0","feedItemGallery":"0","feedItemAttachments":"0","feedBogusEmail":"","introTextCleanup":"0","introTextCleanupExcludeTags":"","introTextCleanupTagAttr":"","fullTextCleanup":"0","fullTextCleanupExcludeTags":"","fullTextCleanupTagAttr":"","xssFiltering":"0","linkPopupWidth":"900","linkPopupHeight":"600","imagesQuality":"100","itemImageXS":"100","itemImageS":"200","itemImageM":"210","itemImageL":"738","itemImageXL":"738","itemImageGeneric":"738","catImageWidth":"210","catImageDefault":"1","userImageWidth":"100","userImageDefault":"1","commenterImgWidth":"60","onlineImageEditor":"splashup","imageTimestamp":"0","imageMemoryLimit":"","socialButtonCode":"","twitterUsername":"joomlart","facebookImage":"XSmall","comments":"1","commentsOrdering":"DESC","commentsLimit":"10","commentsFormPosition":"below","commentsPublishing":"1","commentsReporting":"2","commentsReportRecipient":"","inlineCommentsModeration":"0","gravatar":"1","recaptcha":"1","commentsFormNotes":"1","commentsFormNotesText":"","frontendEditing":"1","showImageTab":"1","showImageGalleryTab":"1","showVideoTab":"1","showExtraFieldsTab":"1","showAttachmentsTab":"1","showK2Plugins":"1","sideBarDisplayFrontend":"0","mergeEditors":"1","sideBarDisplay":"1","attachmentsFolder":"","hideImportButton":"0","taggingSystem":"1","lockTags":"0","showTagFilter":"0","googleSearch":"0","googleSearchContainer":"k2Container","K2UserProfile":"1","K2UserGroup":"1","redirect":"437","adminSearch":"simple","cookieDomain":"","recaptcha_public_key":"6Ld1n80SAAAAAKgeaqckP-aRgc3ANkGMUwGPx9HC","recaptcha_private_key":"[7:05:18 PM] Joom - PhuDT: Public Key: 6Ld1n80SAAAAAKgeaqckP-aRgc3ANkGMUwGPx9HC Private Key: 6Ld1n80SAAAAAJBcRryc-rQOPtvCKbidkq1BwQqM","recaptcha_theme":"clean","recaptchaOnRegistration":"0","stopForumSpam":"0","stopForumSpamApiKey":"","showItemsCounterAdmin":"1","showChildCatItems":"1","disableCompactOrdering":"0","metaDescLimit":"150","SEFReplacements":"\\u00c5\\u00a0|S, \\u00c5\\u2019|O, \\u00c5\\u00bd|Z, \\u00c5\\u00a1|s, \\u00c5\\u201c|oe, \\u00c5\\u00be|z, \\u00c5\\u00b8|Y, \\u00c2\\u00a5|Y, \\u00c2\\u00b5|u, \\u00c3\\u20ac|A, \\u00c3\\ufffd|A, \\u00c3\\u201a|A, \\u00c3\\u0192|A, \\u00c3\\u201e|A, \\u00c3\\u2026|A, \\u00c3\\u2020|A, \\u00c3\\u2021|C, \\u00c3\\u02c6|E, \\u00c3\\u2030|E, \\u00c3\\u0160|E, \\u00c3\\u2039|E, \\u00c3\\u0152|I, \\u00c3\\ufffd|I, \\u00c3\\u017d|I, \\u00c3\\ufffd|I, \\u00c3\\ufffd|D, \\u00c3\\u2018|N, \\u00c3\\u2019|O, \\u00c3\\u201c|O, \\u00c3\\u201d|O, \\u00c3\\u2022|O, \\u00c3\\u2013|O, \\u00c3\\u02dc|O, \\u00c3\\u2122|U, \\u00c3\\u0161|U, \\u00c3\\u203a|U, \\u00c3\\u0153|U, \\u00c3\\ufffd|Y, \\u00c3\\u0178|s, \\u00c3\\u00a0|a, \\u00c3\\u00a1|a, \\u00c3\\u00a2|a, \\u00c3\\u00a3|a, \\u00c3\\u00a4|a, \\u00c3\\u00a5|a, \\u00c3\\u00a6|a, \\u00c3\\u00a7|c, \\u00c3\\u00a8|e, \\u00c3\\u00a9|e, \\u00c3\\u00aa|e, \\u00c3\\u00ab|e, \\u00c3\\u00ac|i, \\u00c3\\u00ad|i, \\u00c3\\u00ae|i, \\u00c3\\u00af|i, \\u00c3\\u00b0|o, \\u00c3\\u00b1|n, \\u00c3\\u00b2|o, \\u00c3\\u00b3|o, \\u00c3\\u00b4|o, \\u00c3\\u00b5|o, \\u00c3\\u00b6|o, \\u00c3\\u00b8|o, \\u00c3\\u00b9|u, \\u00c3\\u00ba|u, \\u00c3\\u00bb|u, \\u00c3\\u00bc|u, \\u00c3\\u00bd|y, \\u00c3\\u00bf|y, \\u00c3\\u0178|ss","sh404SefLabelCat":"","sh404SefLabelUser":"blog","sh404SefLabelItem":"2","sh404SefTitleAlias":"alias","sh404SefModK2ContentFeedAlias":"feed","sh404SefInsertItemId":"0","sh404SefInsertUniqueItemId":"0","cbIntegration":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10081, 'JA News Featured', 'module', 'mod_janews_featured', '', 0, 1, 0, 0, '{"legacy":false,"name":"JA News Featured","type":"module","creationDate":"May 2013","author":"JoomlArt.com","copyright":"J.O.O.M Solutions Co., Ltd.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.5","description":"\\n\\t \\n\\t\\t<div style=\'text-align: left;\'>\\n\\t \\t<span style=\\"color: #008000;\\"><strong>JA News Featured Module for Joomla! 2.5<\\/strong><\\/span><br \\/>\\n\\t \\t<p><img alt=\\"JA News Featured Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec_newsfp_mod.png\\" \\/><\\/p>\\n\\t\\t<div style=\'font-weight:normal\'>\\n\\t \\tJA News Featured provides you a lightweight but powerful news headline style of your most recent contents. Please refer to the template userguide for optimum backend settings\\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Important Instruction:<\\/strong><\\/span><\\/p>\\n\\t \\t<ol><li>Please refer to Template userguide or install the template Quickstart to view the optimum settings for this module.<\\/li>\\n\\t\\t<li>The module display can be enhanced by CSS overrides in the demo templates. Thus when using this module in different templates, the results may vary and you may have to customize CSS again to get your desired effects.<\\/li>\\n\\t\\t<li>For Userguide, please visit <a href=\'http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?t=52039\' target=\'_blank\'>Here<\\/a><\\/li><\\/ol>\\n\\t \\t\\n\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ol><li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li><li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video..<\\/a><\\/strong><\\/li><\\/ol>\\n\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t\\t<ul> <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li><li><a target=\'_blank\' href=\'http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51825\'>General Userguide<\\/a><\\/li><li>For more details on Thumbnail modes read this <a href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50325\\" title=\\"JA thumbanil modes\\" target=\\"_blank\\"><strong>tutorial<\\/strong><\\/a><\\/li><\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t\\t<\\/div>\\n\\t \\n\\t","group":""}', '{"moduleclass_sfx":"","settingcontent":"","source":"JANewsHelper","catsid":"","k2catsid":"","getChildren":"1","featured":"hide","ordering":"ordering","sort_order":"DESC","settingprofile":"","profile":"default","JPlugins":"1","K2Plugins":"1","cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10082, 'System - JA Tabs', 'plugin', 'jatabs', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - JA Tabs","type":"plugin","creationDate":"04 May 2013","author":"JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights\\n\\t\\tReserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.6.0","description":"\\n\\t\\t\\n\\t\\t<div style=\\"text-align:left\\">\\n\\t\\t\\t<span style=\\"color: #008000;\\"><strong>JA Tabs Plugin for Joomla! 2.5<\\/strong><\\/span>\\n\\t\\t\\t<div style=\\"font-weight: normal\\">\\n\\t\\t\\t<p><strong><img src=\'..\\/plugins\\/system\\/jatabs\\/jatabs\\/tabs.png\' \\/>\\n\\t\\t\\t<span style=\'margin-top:10px;\'>JA Tabs plugin is a plugin which helps you to create tabs in any positions in Joomla contents<\\/span><\\/strong><\\/p>\\n\\t\\t\\t<p><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t<ol class=\\"checklist\\" style=\'clear:both\'>\\n\\t\\t\\t<li>Support multiple types of content: Module Position, Module name, HTML Content, Article IDs, Category ID<\\/li>\\n\\t\\t\\t<li>Configurable animations: Left\\/right, up\\/down, fading...<\\/li>\\n\\t\\t\\t<li>Multiple themes support<\\/li>\\n\\t\\t\\t<li>Extensive configuration options<\\/li>\\n\\t\\t\\t<\\/ol>\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Usage Instructions:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t\\t<p><span style=\\"color: #ff6600;\\"><strong>General Parameter Options:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t<h3 style=\\"color: blue\\">All available parameter options for JA Tabs Plugin.<\\/h3>\\n\\t\\t\\t<div  style=\\"font-weight: normal\\">\\n\\t\\t\\t<ol>\\n\\t\\t\\t<li><strong>type:<\\/strong> <br \\/> (modules, module, content, articles). JA Tabs type.<\\/li>\\n\\t\\t\\t<li><strong>position:<\\/strong> <br \\/> (top, left, right, bottom). Position of the tabs. Default value is top.<\\/li>\\n\\t\\t\\t<li><strong>style:<\\/strong><br \\/> JA Tabs styling (basic). The default setting is basic. <\\/li>\\n\\t\\t\\t<li><strong>width:<\\/strong><br \\/> Width of the tabs. It can be fixed or automatic. Example: empty or \'100%\' or \'600\'<\\/li>\\n\\t\\t\\t<li><strong>height:<\\/strong><br \\/> Height of the tabs. It can be fixed or automatic. Example: empty or \'auto\' or \'400\'.<\\/li>\\n\\t\\t\\t<li><strong>widthTabs:<\\/strong><br \\/> Width of the tabs. It should be \'empty\' for the \'Top\\/Bottom\' position of tabs title and fixed (such as \'150\') for the \'Left\\/Right\' position of tabs title.<\\/li>\\n\\t\\t\\t<li><strong>heightTabs:<\\/strong><br \\/> Height of the tabs. It should be \'empty\' for \'Left\\/Right\' position of tabs title and fixed (such as \'30\') for \'Top\\/Bottom\' position of tabs title.<\\/li>\\n\\t\\t\\t<li><strong>duration (ms):<\\/strong><br \\/> Time interval of effect transition (in milliseconds). The default setting is 1000. <\\/li>\\n\\t\\t\\t<li><strong>animType:<\\/strong><br \\/> (animFade, animMoveHor, animMoveVir, none). Define type of effect transition. The default setting is animMoveVir.<\\/li>\\n\\t\\t\\t<li><strong>mouseType:<\\/strong><br \\/> (click, mouseover, none). Action behavior of Control Panel. Default value is click. <\\/li>\\n\\t\\t\\t<li><strong>skipAnim:<\\/strong> <br \\/> (true, false). Skip animation. The default setting is false.<\\/li>\\n\\t\\t\\t<li><strong>ajax:<\\/strong> <br \\/> (true, false). Set to \\"True\\" if you want to use AJAX to load content in tabs (Does not apply for HTML Content type). The default setting is False.<\\/li>\\n\\t\\t\\t<li><strong>view:<\\/strong> <br \\/> (introtext, fulltext). Apply for Articles.<\\/li>\\n\\t\\t\\t<li><strong>jaclass:<\\/strong> <br \\/> Input the class for each tab in format: 1:class1,2:class2. The supported class depend on the tab style.<\\/li>\\n\\t\\t\\t<li><strong>module:<\\/strong> <br \\/> Apply for type=\\"modules\\". Input module position which will display in tabs. For example: articleslatestload<\\/li>\\n\\t\\t\\t<li><strong>modulename:<\\/strong> <br \\/> Apply for type=\\"module\\". Input one or more module names which are separated by commas. For example: mod_articles_news, mod_articles_latest<\\/li>\\n\\t\\t\\t<li><strong>ids:<\\/strong> <br \\/> Apply for type=\\"articles\\". Input one or more article IDs which are separated by commas. For example: 1, 2, 3, 4<\\/li>\\n\\t\\t\\t<li><strong>catid:<\\/strong> <br \\/> Apply for type=\\"articles\\". Input one catergory from which you want to display its articles in tabs. For example: 1<\\/li>\\n\\t\\t\\t<li><strong>maxitems:<\\/strong> <br \\/> Maximum number of articles to display<\\/li>\\n\\t\\t\\t<\\/div>\\t\\t\\t\\n\\t\\t\\t<p><span style=\\"color: #ff6600;\\"><strong>For Example tags:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t<div  style=\\"font-weight: normal\\">\\n\\t\\t\\t<b>1. Type = modules<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs type=\\"modules\\" module=\\"position-7\\" position=\\"top\\" \\n\\t\\t\\t\\tmouseType=\\"click\\" animType=\\"animFade\\"}\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\t\\n\\t\\t\\t<b>2. Type = module<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs type=\\"module\\" modulename=\\"mod_menu, mod_login\\" \\n\\t\\t\\tposition=\\"left\\" widthTabs=\\"150\\" animType=\\"animMoveVir\\"}\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\n\\t\\t\\t<b>3. Type = content<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs  type=\\"content\\" position=\\"top\\" height=\\"240\\" mouseType=\\"mouseover\\" \\n\\t\\t\\t\\tanimType=\\"animMoveHor\\"}\\n\\t\\t\\t  [tab title=\\"Entertainment\\"]\\n\\t\\t\\t    &lt;img src=\\"images\\/sampledata\\/fruitshop\\/apple.jpg\\" \\n\\t\\t\\t    alt=\\"Sample image\\" align=\\"left\\" class=\\"caption\\" \\/&gt;...\\n\\t\\t\\t  [\\/tab]\\n\\t\\t\\t  [tab title=\\"Travel\\"]\\n\\t\\t\\t    &lt;img src=\\"images\\/sampledata\\/fruitshop\\/bananas_2.jpg\\" \\/&gt;\\n\\t\\t\\t  [\\/tab]\\n\\t\\t\\t  [tab title=\\"Artist\\"]\\n\\t\\t\\t    &lt;img src=\\"images\\/sampledata\\/fruitshop\\/tamarind.jpg\\" \\/&gt;\\n\\t\\t\\t  [\\/tab]\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\t\\n\\t\\t\\t<b>4. Type = articles<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs type=\\"articles\\" ids=\\"25, 26, 27\\" ajax=true view=\\"introtext\\" position=\\"right\\" \\n\\t\\t\\t\\twidthTabs=150 width=530 animType=\\"animMoveVir\\"}\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\n\\t\\t\\t<b>5. Type = articles<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs type=\\"articles\\" catid=\\"55\\" view=\\"introtext\\" ajax=true position=\\"bottom\\"\\n\\t\\t\\t\\tanimType=\\"animMoveHor\\"}\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\t\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Methods:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t\\t<ol>\\n\\t\\t\\t\\t<li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading.<\\/li>\\t\\t\\n\\t\\t\\t<\\/ol>\\n\\t\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links :<\\/strong><\\/span><\\/p>\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t<ul><li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50267\\">General Userguide<\\/a><\\/li>\\n\\t\\t \\t<li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li><\\/ul>\\t\\t\\t\\n\\t\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p> \\n\\t\\t<\\/div>\\n\\t\\t\\n\\t","group":""}', '{"disable_tab":"0","style":"nex","position":"top","width":"100%","height":"auto","widthTabs":"100%","heightTabs":"39","view":"introtext","jaclass":"","duration":"1000","animType":"animMoveVir","skipAnim":"false","mouseType":"click"}', '', '', 0, '0000-00-00 00:00:00', 0, 0);
INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(10086, 'JA Side News', 'module', 'mod_jasidenews', '', 0, 1, 0, 0, '{"legacy":false,"name":"JA Side News","type":"module","creationDate":"26 April 2013","author":"Joomlart.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"2.6.1","description":"\\n\\t\\t\\n\\t\\t\\t<span style=\\"color: #008000;\\"><strong>JA Side News Module for Joomla 2.5<\\/strong><\\/span><br \\/>\\n\\t\\t\\t<p><img alt=\\"JA Side News Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/ja_sidenews.png\\" \\/><\\/p>\\n\\t\\t\\t<div style=\\"font-weight:normal\\">\\n\\t\\t\\tJA Side News module allows to display a list of articles with meta keyword \'\'Featured\'\' (this word is declared in the \'\'Keyword\'\' parameter inside the Metadata Information of each article).\\n\\t\\t\\t<p>Otherwise, it displays articles from one or many categories. The list can be sorted by Date, Order or Hits.<\\/p>\\n\\t\\t\\t\\n\\t\\t\\t<br \\/>\\n\\t\\t\\t<span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><br\\/>\\n\\t\\t\\t<ul>\\n\\t\\t\\t  <li>2 display layouts to choose from.<\\/li>\\n\\t\\t\\t  <li>Configure image sizes, dates and even read more button.<\\/li>\\n\\t\\t\\t  <li>Choose sidenews layout for text overlay effect.<\\/li>\\n\\t\\t\\t  <li>Easy to configure colors for overlay, text. Control animation with easy dimensions.<\\/li>\\n\\t\\t\\t<\\/ul>\\n\\t\\t\\t\\n\\t\\t\\t<br \\/>\\n\\t\\t\\t<strong><span style=\\"color: #ff0000;\\">Upgrade Methods:<\\/span><\\/strong><br \\/>\\n\\n\\t\\t\\t<ul>\\n\\t\\t\\t   <li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading OR<\\/li>\\n\\t\\t\\t  <li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video.<\\/a><\\/strong><\\/li>\\n\\t\\t\\t<\\/ul>\\n\\t\\t\\t<br\\/>\\n\\t\\t\\t<span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span>\\n\\t\\t\\t<ul>\\n\\t\\t\\t  <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li><li><a target=\'_blank\' href=\'http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?49940\'>General Userguide<\\/a><\\/li>\\n\\t\\t\\t  <li>For more details on Thumbnail modes read this <a href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50325\\" title=\\"JA thumbanil modes\\" target=\\"_blank\\"><strong>tutorial<\\/strong><\\/a><\\/li>\\n\\t\\t\\t<\\/ul>\\n\\t\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t\\t<\\/div>\\n\\n\\t\\t\\n\\t","group":""}', '{"moduleclass_sfx":"","settingcontent":"","display_model-modcats-category":"","show_featured":"1","sort_order_field":"created","sort_order":"DESC","max_items":"5","title_max_chars":"200","maxchars":"60","settingimg":"","thumbnail_mode":"crop","thumbnail_mode-resize-use_ratio":"1","iwidth":"152","iheight":"200","image_alignment":"left","settinglayout":"","layout":"default","layout-default-showdate":"1","layout-default-show_moredetail":"1","layout-default-showimage":"1","layout-sidenews-height":"200","layout-sidenews-textcolor":"FFFFFF","layout-sidenews-bgcolor":"4F4F4F","layout-sidenews-transparent":"80","layout-sidenews-element_apply_side":"content","layout-sidenews-play_mode":"caption","layout-sidenews-play_mode-caption-expandheight":"150","layout-sidenews-play_mode-caption-collapseheight":"30","layout-sidenews-animation_transition":"Fx.Transitions.Expo.easeOut","enable_cache":"1","cache_time":"30"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10088, 'JA Bulletin', 'module', 'mod_jabulletin', '', 0, 1, 0, 0, '{"legacy":false,"name":"JA Bulletin","type":"module","creationDate":"May 2013","author":"JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights\\n\\t\\tReserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.5","description":"\\n\\t\\n\\t\\t<div style=\'text-align: left;\'>\\n\\t   <span style=\\"color: #008000;\\">\\n\\t   \\t<strong>JA Bulletin Module<\\/strong>\\n\\t   <\\/span>\\n\\t   <br \\/>\\n\\t   <div style=\'font-weight: normal\'>\\n\\t   <p><img alt=\\"JA Bulletin Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/ja_bulletin.png\\" \\/><\\/p>\\n\\t   This module mimicks default Joomla most read and latest modules, with added support to show date and thumbnail images.\\n\\t   \\n\\t   <p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t   <ol><li>Show \\/ hide Images in the list<\\/li><li>Show or hide Date of the article.<\\/li><li>Easy thumbnail generation. For more details on Thumbnail mode read this <a href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50325\\" title=\\"JA thumbanil modes\\" target=\\"_blank\\"><strong>tutorial<\\/strong><\\/a>.<\\/li><\\/ol>\\n\\t   \\n\\t   <p><strong><span style=\\"color: #ff0000;\\">Important Instruction:<\\/span><\\/strong><\\/p>\\n\\t   <ol><li><strong>The module display can be enhanced by CSS overrides in the demo templates (used in over 20+ JA templates). Thus, when you used Bulletin in different templates, the results may vary and you may have to customize CSS to get desired effects.<\\/strong><\\/li><\\/ol>\\n\\t   <p><strong><span style=\\"color: #ff0000;\\">Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t   <ol>\\n\\t   <li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li>\\n\\t   \\t<li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video.<\\/a><\\/strong><\\/li>\\n\\t   <\\/ol>\\n\\t   <p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t   <ul><li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?49878\\">JA Bulletin - General User guide<\\/a><\\/li><li><a target=\\"_blank\\" href=\\"http:\\/\\/pm.joomlart.com\\/browse\\/JAECMODBULLETINJIVI\\">Report Bug<\\/a><\\/li><li><a target=\\"_blank\\" href=\\"http:\\/\\/update.joomlart.com\\/#products.list\\/\\/JA%20Bulletin%20Module%20for%20Joomla%202.5\\/\\">Updates &amp; Versions<\\/a><\\/li><\\/ul>\\n\\t   <p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t   <\\/div>\\n\\t   <\\/div>\\n\\t\\n\\t","group":""}', '{"moduleclass_sfx":"","content_setting":"","type":"latest","ordering":"published","using_mode":"catids","category":"","k2catsid":"","count":"5","show_featured":"1","show_date":"1","show_author":"0","show_readmore":"0","show_hits":"0","use_custom_text":"1","custom_text":"Hits:","image_setting":"","show_image":"1","thumbnail_mode":"crop","use_ratio":"1","width":"40","height":"40","cache":"1","cache_time":"30"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10089, 'Content - JA Thumbnail', 'plugin', 'plg_jathumbnail', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"Content - JA Thumbnail","type":"plugin","creationDate":"March 2013","author":"JoomlArt.com","copyright":"J.O.O.M Solutions Co., Ltd.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.5","description":"\\n\\t\\n\\t<h1>JA Thumbnail Plugin for Joomla! 2.5<\\/h1>\\n\\tThis plugin helps to generate thumbnails automatically in Joomla Articles. This must be properly configured to get the best usage. Below are some important notes.\\n\\t<p><span style=\'color: #ff6600;\'><strong>Details:<\\/strong><\\/span><\\/p>\\n\\t<img border=\'0\' alt=\'JA Thumbnail Plugin\' src=\'http:\\/\\/asset.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec_highslide.png?javer=1109130907\' style=\'float: left\'>\\n\\tThe Manual mode is recommended for sites with only a few images, the Auto mode is for sites with a massive volume of images\\n\\t<p><strong><span style=\'color: #ff0000;\'>Important Instructions :<\\/span><\\/strong><\\/p>\\n\\tNote: Add the following to disable the slideshow feature in the selected images in an article <code>{jathumbnail off images=\\"images\\/stories\\/demo\\/world\\/rs-3.jpg,images\\/stories\\/demo\\/world\\/rs-2.jpg\\"}<\\/code>\\n\\t<p><strong><span style=\'color: #ff0000;\'>Usage Instruction:<\\/span><br \\/><\\/strong><\\/p>\\n\\tIn the <strong>\\"Integration Mode\\"<\\/strong>  on the parameter list on the right: <br \\/>\\n\\t\\t<ul>\\n\\t\\t\\t<li>\\"<strong>Auto<\\/strong>\\" mode: JA Thumbnail Plugin is enabled automatically in all Joomla articles. To turn off this feature for specific articles, use the <font color=\\"red\\"><strong><em>{jathumbnail off}<\\/em><\\/strong><\\/font>tag in that article.<\\/li>   \\n\\t\\t\\t<li>\\"<strong>Manual<\\/strong>\\" mode: To enable JA thumbnail plugin for an article, you must place {jathumbnail} somewhere in your articles content.<\\/li>   \\n\\t\\t\\t<li> \\"<strong>Disable<\\/strong>\\" mode: Disable the Thumbnail generation (DO NOT use the Disable feature of Joomla if you have used the tag <em><strong>{jathumbnail}<\\/strong><\\/em> or <em><strong>{jathumbnail off}<\\/strong><\\/em> already. It will be parsed as normal text.<\\/li> \\n\\t\\t<\\/ul>\\n\\t<p><strong><span style=\'color: #ff0000;\'>Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ol><li>You can install the new version directly over this version. Uninstallation is not required. <\\/li>\\n\\t\\t<li>Backup any customized files before upgrading.<\\/li><\\/ol>\\n\\t<p><span style=\'color: #008000;\'><strong>Links :<\\/strong><\\/span><\\/p>\\n\\t<ul>\\n\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50783\\">General Userguide<\\/a><\\/li>\\n\\t\\t <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t\\n\\t\\t<\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\n\\t","group":""}', '{"content_mode":"auto","content_mode-auto-content_position":"1","content_mode-auto-manual-content_width":"210","content_mode-auto-manual-content_height":"120","content_mode-auto-manual-crop_image":"1","content_mode-auto-manual-content_align":"left","view_on_page":"all","blog_mode-1-apply_catetories":["90","88","87","86","85","84","83","82","81"],"blog_mode-1-blog_leading_width":"210","blog_mode-1-blog_leading_height":"120","blog_mode-1-blog_intro_width":"210","blog_mode-1-blog_intro_height":"120","blog_mode-1-crop_image":"1"}', '', '', 42, '2012-07-09 08:10:55', 0, 0),
(10092, 'ja_nex', 'template', 'ja_nex', '', 0, 1, 1, 0, '{"legacy":false,"name":"ja_nex","type":"template","creationDate":"March 2013","author":"JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"2.5.8","description":" <p>JA Nex is now updated and available for use with Joomla 2.5<\\/p>\\n<p>Joomlart\'s latest addition to its powerful stable of News Themes, <strong>JA NEX<\\/strong> comes built the newly updated JAT3 2 Framework and K2 for Joomla! 2.5<\\/p>\\n<p>JA Nex is the latest of the news templates from JoomlArt, drawing inspiration from the Teline series of news templates<\\/p>\\n\\n<p>This template does not come with native RTL language support in terms of css styles.<\\/p>\\n<p>This template does not support RTL CSS style<\\/p>\\n\\n<p><strong>Resources :<\\/strong><\\/p>\\n<p>|\\n<a href=\'http:\\/\\/www.joomlart.com\\/joomla\\/templates\\/ja-nex\' title=\'Home\' target=\'_blank\' > Template Home Page<\\/a> |\\n<a href=\'http:\\/\\/www.joomlart.com\\/demo\\/#joomla25-templates.joomlart.com\\/ja_nex\' title=\'Demo\' target=\'_blank\' > Demo<\\/a> |\\n<a href=\'http:\\/\\/www.joomlart.com\\/forums\\/forumdisplay.php?332\' title=\'forum\' target=\'_blank\' >Forum<\\/a> |<\\/p>\\n<p>\\n|<a href=\'http:\\/\\/wiki.joomlart.com\\/wiki\\/JA_T3_Framework_2\\/Overview\' title=\'T3 wiki\' target=\'_blank\' >T3 Framework Wiki<\\/a> |\\n<a href=\'http:\\/\\/update.joomlart.com\' title=\'Updates\' target=\'_blank\' >Updates<\\/a> |\\n<a href=\'http:\\/\\/pm.joomlart.com\\/browse\\/JATCNEXJ17\' title=\'Changelog\' target=\'_blank\' >JIRA<\\/a> |\\n<a href=\'http:\\/\\/www.joomlart.com\\/forums\\/downloads.php?do=cat&id=431\' title=\'Downloads\' target=\'_blank\' >Downloads<\\/a> |\\n<\\/p> ","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10095, 'System - JA Popup', 'plugin', 'japopup', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - JA Popup","type":"plugin","creationDate":"Jul 2013","author":"JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights\\n\\t\\tReserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.6.0","description":"\\n\\t\\t\\n\\t\\t<div style=\\"text-align:left;\\">\\n\\t\\t\\t<h1>JA Popup Plugin for Joomla! 2.5<\\/h1>\\n\\t\\t\\t<span style=\\"color: #008000;\\"><strong>JA Popup plugin supports many types of content to display using Framework like AJAX, iFrame, Youtube video, image, slideshow, Inline.<\\/strong><\\/span>\\n\\t\\t\\t<p><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t\\t<img border=\\"0\\" alt=\\"JA Popup plugin\\" src=\\"http:\\/\\/asset.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec-popup_plg.png\\">Depending on each type of Popup that you select, you declare JA Popup tab in your content (i.e. module, article) to <code>{japopup type=\\"<span style=\\"color:#FF0000\\">iframe<\\/span>\\" content=\\"http:\\/\\/www.bing.com\\/\\" width=\\"500\\" height=\\"400\\" }Load a sample iFrame{\\/japopup}<\\/code>\\n\\t\\t\\t\\n\\t\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Usage Instructions:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t\\t<ol>   \\n\\t\\t\\t\\t<li>\\n\\t\\t\\t\\t\\t<strong>ajax<\\/strong>: <em>loading external page or HTML content via AJAX method <\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"ajax\\" content=\\"http:\\/\\/www.bing.com\\/\\" width=\\"500\\" height=\\"400\\"}Load an Url using AJAX{\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li> \\n\\t\\t\\t\\t\\n\\t\\t\\t\\t<li> \\n\\t\\t\\t\\t\\t<strong>iFrame<\\/strong>: <em>loading external page or HTML content via iFrame method  <\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"iframe\\" content=\\"http:\\/\\/www.bing.com\\/\\" width=\\"500\\" height=\\"400\\"}Load a sample iFrame{\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li>   \\n\\t\\t\\t\\t<li> \\n\\t\\t\\t\\t\\t<strong>youtube<\\/strong>: <em>loading Youtube video. Note: use embeded link <\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"youtube\\" content=\\"http:\\/\\/www.youtube.com\\/v\\/cdphzxz64BY?hl=en&fs=1\\" width=\\"640\\" height=\\"380\\" title=\\"Political Roast: Obama Emanuel 2005\\"}Political Roast: Obama Emanuel 2005{\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li>   \\n\\t\\t\\t\\t<li> \\n\\t\\t\\t\\t\\t<strong>image<\\/strong>:<em> loading a specified image <\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"image\\" content=\\"images\\/sampledata\\/fruitshop\\/apple.jpg\\" width=\\"400\\" height=\\"300\\" title=\\"Sample image\\"}Sample image{\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li>   \\n\\t\\t\\t\\t<li>\\n\\t\\t\\t\\t\\t<strong>slideshow<\\/strong>:<em> loading a group of images via a slideshow<\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"slideshow\\" content=\\"images\\/sampledata\\/fruitshop\\/apple.jpg,images\\/sampledata\\/fruitshop\\/bananas_2.jpg\\" width=\\"400\\" height=\\"300\\" title=\\"Sample image\\"} Sample image {\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li>  \\n\\t\\t\\t\\t<li>\\n\\t\\t\\t\\t\\t<strong>Inline<\\/strong>:<em> To display full HTML content in the expander<\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/>\\n\\t\\t\\t\\t\\t\\t<code>\\n\\t\\t\\t\\t\\t\\t\\t{japopup type=\\"inline\\" content=\\"inline1\\" width=\\"500\\" height=\\"400\\" }Inline{\\/japopup}\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t<\\/code>\\n\\t\\t\\t\\t\\t<br \\/>\\n\\t\\t\\t\\t\\t<strong>inline1<\\/strong>:<em> The ID of block content<\\/em><br>\\t\\n\\t\\t\\t\\t<\\/li> \\n\\t\\t\\t<\\/ol> \\n\\t\\t\\t<p>The best showcase of JA Popup is used in JA Teline III.<\\/p> \\n\\t\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t\\t\\t<ol>\\n\\t\\t\\t\\t\\t<li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading.<\\/li>\\t\\t\\n\\t\\t\\t\\t<\\/ol>\\n\\t\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t\\t<ul>\\t\\t\\n\\t\\t\\t\\t\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51150\\">General Userguide<\\/a><\\/li>\\n\\t\\t\\t\\t\\t<li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t\\t\\t\\t<\\/ul>\\n\\t\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p> \\n\\t\\t<\\/div>\\n\\t\\t\\n\\t","group":""}', '{"group1":"thickbox","group1-fancybox-centerOnScroll":"1","group1-fancybox-image_scale":"1","group1-fancybox-speed_in":"500","group1-fancybox-speed_out":"500","group1-greybox-behavior":"","group1-highslide-outline":"drop-shadow","group1-highslide-speed_in":"250","group1-highslide-speed_out":"250","group1-shadowbox-animateFade":"1","group1-shadowbox-animate":"1","group1-shadowbox-animSequence":"wh","group1-shadowbox-overlayColor":"FFFFFF","group1-shadowbox-viewportPadding":"20","group1-multibox-contentColor":"FFFFFF","group1-multibox-showControls":"1","width":"600","height":"400","overlay":"1","overlay_opacity":"0.7","add_title":"1","add_desc":"1","image_slideshow":"one"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10100, 'com_finder', 'component', 'com_finder', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_finder","type":"component","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_FINDER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10101, 'mod_finder', 'module', 'mod_finder', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_finder","type":"module","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_FINDER_XML_DESCRIPTION","group":""}', '{"searchfilter":"","show_autosuggest":"1","show_advanced":"0","moduleclass_sfx":"","field_size":"25","show_label":"1","label_pos":"top","show_button":"0","button_pos":"right","opensearch":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10106, 'plg_captcha_recaptcha', 'plugin', 'recaptcha', 'captcha', 0, 1, 1, 0, '{"legacy":false,"name":"plg_captcha_recaptcha","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION","group":""}', '{"public_key":"","private_key":"","theme":"clean"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10110, 'plg_content_finder', 'plugin', 'finder', 'content', 0, 0, 1, 0, '{"legacy":false,"name":"plg_content_finder","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTENT_FINDER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10112, 'plg_finder_categories', 'plugin', 'categories', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_categories","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_CATEGORIES_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10113, 'plg_finder_contacts', 'plugin', 'contacts', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_contacts","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_CONTACTS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10114, 'plg_finder_content', 'plugin', 'content', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_content","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_CONTENT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10115, 'plg_finder_newsfeeds', 'plugin', 'newsfeeds', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_newsfeeds","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10116, 'plg_finder_weblinks', 'plugin', 'weblinks', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_weblinks","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_FINDER_WEBLINKS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10117, 'plg_quickicon_extensionupdate', 'plugin', 'extensionupdate', 'quickicon', 0, 1, 1, 0, '{"legacy":false,"name":"plg_quickicon_extensionupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION","group":""}', '{"context":"mod_quickicon"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10118, 'plg_quickicon_joomlaupdate', 'plugin', 'joomlaupdate', 'quickicon', 0, 1, 1, 0, '{"legacy":false,"name":"plg_quickicon_joomlaupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION","group":""}', '{"context":"mod_quickicon"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10119, 'plg_system_highlight', 'plugin', 'highlight', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"plg_system_highlight","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10120, 'plg_system_languagecode', 'plugin', 'languagecode', 'system', 0, 0, 1, 0, '{"legacy":false,"name":"plg_system_languagecode","type":"plugin","creationDate":"November 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10121, 'mod_version', 'module', 'mod_version', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_version","type":"module","creationDate":"January 2012","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_VERSION_XML_DESCRIPTION","group":""}', '{"format":"short","product":"1","cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10122, 'Editor Button - JA Typo Button', 'plugin', 'jatypobutton', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"Editor Button - JA Typo Button","type":"plugin","creationDate":"May 2013","author":"JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.7","description":"\\n\\t\\n\\t\\t<div style=\'text-align: left;\'>\\n\\t\\t\\t<h1>JA Typo Button Plugin for Joomla! 2.5<\\/h1>\\n\\t\\t\\t<div style=\'font-weight: normal\'>\\n\\t\\t\\t<p><span style=\'color: #ff6600;\'><strong>Features:<\\/strong><\\/span>\\n\\t\\t\\tPlease install plugin JA Typo.<\\/p>\\n\\t\\t\\t\\n\\t\\t\\t<strong><span style=\'color: #ff0000;\'>Usage Instruction:<\\/span><\\/strong><br \\/>\\n\\t\\t\\t<ul>\\n\\t\\t\\t<li>Upon installation of this plugin, JA Typo button can be accessed in the editor.<\\/li><\\/ul>\\n\\t\\t\\t<strong><span style=\'color: #ff0000;\'>Upgrade Method:<\\/span><br \\/><\\/strong>\\n\\t\\t\\t<ul>\\n\\t\\t\\t  <li>You can install new version directly over this version. Uninstallation is not required. <\\/li>\\n\\t\\t\\t  <li>Backup any customized files before upgrading.<\\/li>\\n\\t\\t\\t<\\/ul>\\n\\t\\t\\t<span style=\'color: #008000;\'><strong>Links:<\\/strong><\\/span><br \\/>\\n\\t\\t\\t<ul>\\n\\t\\t\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?49821\\">General Userguide<\\/a><\\/li>\\n\\t\\t\\t <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t\\t\\n\\t\\t\\t<\\/ul>\\n\\t\\t\\t<p>Copyright 2004 - 2012 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t\\t<\\/div>\\n\\t\\t<\\/div>\\n\\t\\n\\t","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10124, 'plg_finder_k2', 'plugin', 'k2', 'finder', 0, 1, 1, 0, '{"legacy":false,"name":"plg_finder_k2","type":"plugin","creationDate":"April 7th, 2013","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"PLG_FINDER_K2_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10131, 'com_joomlaupdate', 'component', 'com_joomlaupdate', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_joomlaupdate","type":"component","creationDate":"February 2012","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_JOOMLAUPDATE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10140, 'com_kunena', 'component', 'com_kunena', '', 1, 1, 0, 0, '{"legacy":false,"name":"com_kunena","type":"component","creationDate":"2012-09-02","author":"Kunena Team","copyright":"(C) 2008 - 2012 Kunena Team. All rights reserved.","authorEmail":"kunena@kunena.org","authorUrl":"http:\\/\\/www.kunena.org","version":"2.0.2","description":"COM_KUNENA_XML_DESCRIPTION","group":""}', '{"liveupdate":"stuck=0\\nlastcheck=1350644190\\nupdatedata=\\"\\"{\\\\\\"supported\\\\\\":true,\\\\\\"stuck\\\\\\":false,\\\\\\"version\\\\\\":\\\\\\"2.0.2\\\\\\",\\\\\\"date\\\\\\":\\\\\\"2012-09-02\\\\\\",\\\\\\"stability\\\\\\":\\\\\\"stable\\\\\\",\\\\\\"downloadURL\\\\\\":\\\\\\"http:\\\\\\\\\\\\\\/\\\\\\\\\\\\\\/joomlacode.org\\\\\\\\\\\\\\/gf\\\\\\\\\\\\\\/download\\\\\\\\\\\\\\/frsrelease\\\\\\\\\\\\\\/17387\\\\\\\\\\\\\\/75810\\\\\\\\\\\\\\/com_kunena_v2.0.2_2012-09-02.zip\\\\\\",\\\\\\"infoURL\\\\\\":\\\\\\"http:\\\\\\\\\\\\\\/\\\\\\\\\\\\\\/www.kunena.org\\\\\\\\\\\\\\/component\\\\\\\\\\\\\\/ars\\\\\\\\\\\\\\/repository\\\\\\\\\\\\\\/kunena\\\\\\\\\\\\\\/202\\\\\\",\\\\\\"releasenotes\\\\\\":\\\\\\" Please read Kunena 2.0.1 Read Me.\\\\\\"}\\"\\""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10141, 'plg_system_kunena', 'plugin', 'kunena', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"plg_system_kunena","type":"plugin","creationDate":"2012-09-02","author":"Kunena Team","copyright":"www.kunena.org","authorEmail":"Kunena@kunena.org","authorUrl":"http:\\/\\/www.kunena.org","version":"2.0.2","description":"PLG_SYSTEM_KUNENA_DESC","group":""}', '{"jcontentevents":"0","jcontentevent_target":"body"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10142, 'plg_quickicon_kunena', 'plugin', 'kunena', 'quickicon', 0, 1, 1, 0, 'false', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10143, 'plg_kunena_alphauserpoints', 'plugin', 'alphauserpoints', 'kunena', 0, 0, 1, 0, '{"legacy":false,"name":"plg_kunena_alphauserpoints","type":"plugin","creationDate":"2012-09-02","author":"Kunena Team","copyright":"www.kunena.org","authorEmail":"Kunena@kunena.org","authorUrl":"http:\\/\\/www.kunena.org","version":"2.0.2","description":"PLG_KUNENA_ALPHAUSERPOINTS_DESCRIPTION","group":""}', '{"activity":"1","avatar":"1","profile":"1","activity_points_limit":"0"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(10144, 'plg_kunena_community', 'plugin', 'community', 'kunena', 0, 0, 1, 0, '{"legacy":false,"name":"plg_kunena_community","type":"plugin","creationDate":"2012-09-02","author":"Kunena Team","copyright":"www.kunena.org","authorEmail":"Kunena@kunena.org","authorUrl":"http:\\/\\/www.kunena.org","version":"2.0.2","description":"PLG_KUNENA_COMMUNITY_DESCRIPTION","group":""}', '{"access":"1","login":"1","activity":"1","avatar":"1","profile":"1","private":"1","activity_points_limit":"0","activity_stream_limit":"0"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(10145, 'plg_kunena_comprofiler', 'plugin', 'comprofiler', 'kunena', 0, 0, 1, 0, '{"legacy":false,"name":"plg_kunena_comprofiler","type":"plugin","creationDate":"2012-09-02","author":"Kunena Team","copyright":"www.kunena.org","authorEmail":"Kunena@kunena.org","authorUrl":"http:\\/\\/www.kunena.org","version":"2.0.2","description":"PLG_KUNENA_COMPROFILER_DESCRIPTION","group":""}', '{"access":"1","login":"1","activity":"1","avatar":"1","profile":"1","private":"1"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(10146, 'plg_kunena_gravatar', 'plugin', 'gravatar', 'kunena', 0, 0, 1, 0, '{"legacy":false,"name":"plg_kunena_gravatar","type":"plugin","creationDate":"2012-09-02","author":"Kunena Team","copyright":"www.kunena.org","authorEmail":"Kunena@kunena.org","authorUrl":"http:\\/\\/www.kunena.org","version":"2.0.2","description":"PLG_KUNENA_GRAVATAR_DESCRIPTION","group":""}', '{"avatar":"1"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(10147, 'plg_kunena_uddeim', 'plugin', 'uddeim', 'kunena', 0, 0, 1, 0, '{"legacy":false,"name":"plg_kunena_uddeim","type":"plugin","creationDate":"2012-09-02","author":"Kunena Team","copyright":"www.kunena.org","authorEmail":"Kunena@kunena.org","authorUrl":"http:\\/\\/www.kunena.org","version":"2.0.2","description":"PLG_KUNENA_UDDEIM_DESCRIPTION","group":""}', '{"private":"1"}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(10148, 'plg_kunena_kunena', 'plugin', 'kunena', 'kunena', 0, 1, 1, 0, '{"legacy":false,"name":"plg_kunena_kunena","type":"plugin","creationDate":"2012-09-02","author":"Kunena Team","copyright":"www.kunena.org","authorEmail":"Kunena@kunena.org","authorUrl":"http:\\/\\/www.kunena.org","version":"2.0.2","description":"PLG_KUNENA_KUNENA_DESCRIPTION","group":""}', '{"avatar":"1","profile":"1"}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(10149, 'plg_kunena_joomla', 'plugin', 'joomla', 'kunena', 0, 1, 1, 0, '{"legacy":false,"name":"plg_kunena_joomla","type":"plugin","creationDate":"2012-09-02","author":"Kunena Team","copyright":"www.kunena.org","authorEmail":"Kunena@kunena.org","authorUrl":"http:\\/\\/www.kunena.org","version":"2.0.2","description":"PLG_KUNENA_JOOMLA_17_DESCRIPTION","group":""}', '{"access":"1","login":"1"}', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(10193, 'Josetta - K2 Items', 'plugin', 'k2item', 'josetta_ext', 0, 1, 1, 0, '{"legacy":false,"name":"Josetta - K2 Items","type":"plugin","creationDate":"June 7th, 2012","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10190, 'Josetta - K2 Categories', 'plugin', 'k2category', 'josetta_ext', 0, 1, 1, 0, '{"legacy":false,"name":"Josetta - K2 Categories","type":"plugin","creationDate":"April 7th, 2013","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.6","description":"","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10183, 'English (United Kingdom)', 'language', 'en-GB', '', 0, 1, 1, 0, '{"legacy":false,"name":"English (United Kingdom)","type":"language","creationDate":"2008-03-15","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.10","description":"en-GB site language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10184, 'English (United Kingdom)', 'language', 'en-GB', '', 1, 1, 1, 0, '{"legacy":false,"name":"English (United Kingdom)","type":"language","creationDate":"2008-03-15","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.10","description":"en-GB administrator language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10185, 'Kunena Groups', 'plugin', 'kunenagroups', 'community', 0, 0, 1, 0, '{"legacy":true,"name":"Kunena Groups","type":"plugin","creationDate":"2012-09-02","author":"Kunena Team","copyright":"(C) 2008 - 2012 Kunena Team. All rights reserved.","authorEmail":"admin@kunena.org","authorUrl":"http:\\/\\/www.kunena.org","version":"2.0.2","description":"PLG_COMMUNITY_KUNENAGROUPS_DESCRIPTION","group":""}', '{"coreapp":"1","category_mapping":"","default_category":"0","allow_categories":"","deny_categories":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10186, 'My Forum Menu', 'plugin', 'kunenamenu', 'community', 0, 0, 1, 0, '{"legacy":true,"name":"My Forum Menu","type":"plugin","creationDate":"2012-09-02","author":"Kunena Team","copyright":"(C) 2008 - 2012 Kunena Team. All rights reserved.","authorEmail":"admin@kunena.org","authorUrl":"http:\\/\\/www.kunena.org","version":"2.0.2","description":"PLG_COMMUNITY_KUNENAMENU_DESCRIPTION","group":""}', '{"coreapp":"0","sh_editprofile":"1","sh_myprofile":"1","sh_myposts":"1","sh_mysubscriptions":"1","sh_myfavorites":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10187, 'My Forum Posts', 'plugin', 'mykunena', 'community', 0, 0, 1, 0, '{"legacy":true,"name":"My Forum Posts","type":"plugin","creationDate":"2012-09-02","author":"Kunena Team","copyright":"(C) 2008 - 2012 Kunena Team. All rights reserved.","authorEmail":"admin@kunena.org","authorUrl":"http:\\/\\/www.kunena.org","version":"2.0.2","description":"PLG_COMMUNITY_MYKUNENA_DESCRIPTION","group":""}', '{"count":"5","coreapp":"0","cache":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0);

DROP TABLE IF EXISTS `#__finder_filters`;
CREATE TABLE `#__finder_filters` (
  `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `map_count` int(10) unsigned NOT NULL DEFAULT '0',
  `data` text NOT NULL,
  `params` mediumtext,
  PRIMARY KEY (`filter_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links`;
CREATE TABLE `#__finder_links` (
  `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `route` varchar(255) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `indexdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `md5sum` varchar(32) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `state` int(5) DEFAULT '1',
  `access` int(5) DEFAULT '0',
  `language` varchar(8) NOT NULL,
  `publish_start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `list_price` double unsigned NOT NULL DEFAULT '0',
  `sale_price` double unsigned NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL,
  `object` mediumblob NOT NULL,
  PRIMARY KEY (`link_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_title` (`title`),
  KEY `idx_md5` (`md5sum`),
  KEY `idx_url` (`url`(75)),
  KEY `idx_published_list` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`list_price`),
  KEY `idx_published_sale` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`sale_price`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms0`;
CREATE TABLE `#__finder_links_terms0` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms1`;
CREATE TABLE `#__finder_links_terms1` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms2`;
CREATE TABLE `#__finder_links_terms2` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms3`;
CREATE TABLE `#__finder_links_terms3` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms4`;
CREATE TABLE `#__finder_links_terms4` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms5`;
CREATE TABLE `#__finder_links_terms5` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms6`;
CREATE TABLE `#__finder_links_terms6` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms7`;
CREATE TABLE `#__finder_links_terms7` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms8`;
CREATE TABLE `#__finder_links_terms8` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms9`;
CREATE TABLE `#__finder_links_terms9` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsa`;
CREATE TABLE `#__finder_links_termsa` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsb`;
CREATE TABLE `#__finder_links_termsb` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsc`;
CREATE TABLE `#__finder_links_termsc` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsd`;
CREATE TABLE `#__finder_links_termsd` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termse`;
CREATE TABLE `#__finder_links_termse` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsf`;
CREATE TABLE `#__finder_links_termsf` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_taxonomy`;
CREATE TABLE `#__finder_taxonomy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `state` (`state`),
  KEY `ordering` (`ordering`),
  KEY `access` (`access`),
  KEY `idx_parent_published` (`parent_id`,`state`,`access`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `#__finder_taxonomy_map`;
CREATE TABLE `#__finder_taxonomy_map` (
  `link_id` int(10) unsigned NOT NULL,
  `node_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`node_id`),
  KEY `link_id` (`link_id`),
  KEY `node_id` (`node_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_terms`;
CREATE TABLE `#__finder_terms` (
  `term_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '0',
  `soundex` varchar(75) NOT NULL,
  `links` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `idx_term` (`term`),
  KEY `idx_term_phrase` (`term`,`phrase`),
  KEY `idx_stem_phrase` (`stem`,`phrase`),
  KEY `idx_soundex_phrase` (`soundex`,`phrase`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_terms_common`;
CREATE TABLE `#__finder_terms_common` (
  `term` varchar(75) NOT NULL,
  `language` varchar(3) NOT NULL,
  KEY `idx_word_lang` (`term`,`language`),
  KEY `idx_lang` (`language`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_tokens`;
CREATE TABLE `#__finder_tokens` (
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '1',
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  KEY `idx_word` (`term`),
  KEY `idx_context` (`context`)
) ENGINE=MEMORY;

DROP TABLE IF EXISTS `#__finder_tokens_aggregate`;
CREATE TABLE `#__finder_tokens_aggregate` (
  `term_id` int(10) unsigned NOT NULL,
  `map_suffix` char(1) NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `term_weight` float unsigned NOT NULL,
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `context_weight` float unsigned NOT NULL,
  `total_weight` float unsigned NOT NULL,
  KEY `token` (`term`),
  KEY `keyword_id` (`term_id`)
) ENGINE=MEMORY;

DROP TABLE IF EXISTS `#__finder_types`;
CREATE TABLE `#__finder_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `mime` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `title` (`title`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__jaem_log`;
CREATE TABLE `#__jaem_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ext_id` varchar(50) DEFAULT NULL,
  `service_id` int(11) DEFAULT NULL,
  `check_date` datetime DEFAULT NULL,
  `check_info` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `ext_id` (`ext_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__jaem_services`;
CREATE TABLE `#__jaem_services` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ws_name` varchar(255) NOT NULL,
  `ws_mode` varchar(50) NOT NULL DEFAULT 'local',
  `ws_uri` varchar(255) NOT NULL,
  `ws_user` varchar(100) NOT NULL,
  `ws_pass` varchar(100) NOT NULL,
  `ws_default` tinyint(1) NOT NULL DEFAULT '0',
  `ws_core` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM ;

INSERT INTO `#__jaem_services` (`id`, `ws_name`, `ws_mode`, `ws_uri`, `ws_user`, `ws_pass`, `ws_default`, `ws_core`) VALUES
(1, 'Local Service', 'local', '', '', '', 1, 1),
(2, 'JoomlArt Updates', 'remote', 'http://update.joomlart.com/service/', '', '', 0, 1);

DROP TABLE IF EXISTS `#__jarpx_mapid`;
CREATE TABLE `#__jarpx_mapid` (
  `user_id` int(11) NOT NULL,
  `rpxid` varchar(50) NOT NULL
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__k2_attachments`;
CREATE TABLE `#__k2_attachments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `filename` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `titleAttribute` text NOT NULL,
  `hits` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__k2_categories`;
CREATE TABLE `#__k2_categories` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `extraFieldsGroup` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `image` varchar(255) NOT NULL,
  `params` text NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category` (`published`,`access`,`trash`),
  KEY `parent` (`parent`),
  KEY `ordering` (`ordering`),
  KEY `published` (`published`),
  KEY `access` (`access`),
  KEY `trash` (`trash`),
  KEY `language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__k2_categories` (`id`, `name`, `alias`, `description`, `parent`, `extraFieldsGroup`, `published`, `access`, `ordering`, `image`, `params`, `trash`, `plugins`, `language`) VALUES
(1, 'All Categories', 'all-categories', '', 0, 0, 1, 1, 1, '', '{"inheritFrom":"0","theme":"nex","num_leading_items":"0","num_leading_columns":"0","leadingImgSize":"Large","num_primary_items":"0","num_primary_columns":"0","primaryImgSize":"Medium","num_secondary_items":"0","num_secondary_columns":"0","secondaryImgSize":"Medium","num_links":"0","num_links_columns":"0","linksImgSize":"XSmall","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"0","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"1","catFeedIcon":"0","subCategories":"1","subCatColumns":"3","subCatOrdering":"","subCatTitle":"1","subCatTitleItemCounter":"1","subCatDescription":"1","subCatImage":"1","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"1","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"1","catItemTags":"1","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"1","catItemCommentsAnchor":"1","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"1","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"1","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"1","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"1","itemAuthorLatestLimit":"5","itemRelated":"1","itemRelatedLimit":"5","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(2, 'Sample Category 1', 'sample-category-1', '<p>Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, 1, 1, 1, '2.jpg', '{"inheritFrom":"0","theme":"nex","num_leading_items":"1","num_leading_columns":"1","leadingImgSize":"XLarge","num_primary_items":"3","num_primary_columns":"3","primaryImgSize":"Medium","num_secondary_items":"6","num_secondary_columns":"3","secondaryImgSize":"Medium","num_links":"0","num_links_columns":"1","linksImgSize":"Medium","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"0","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"1","catFeedIcon":"0","subCategories":"0","subCatColumns":"1","subCatOrdering":"","subCatTitle":"0","subCatTitleItemCounter":"0","subCatDescription":"0","subCatImage":"0","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"0","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"0","catItemTags":"1","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"1","catItemCommentsAnchor":"1","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"1","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"1","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"0","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"1","itemAuthorLatestLimit":"5","itemRelated":"1","itemRelatedLimit":"5","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(6, 'Sample Category 3', 'sample-category-3', '<p>Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, 1, 1, 4, '6.jpg', '{"inheritFrom":"0","theme":"nex","num_leading_items":"1","num_leading_columns":"1","leadingImgSize":"XLarge","num_primary_items":"3","num_primary_columns":"3","primaryImgSize":"Medium","num_secondary_items":"3","num_secondary_columns":"3","secondaryImgSize":"Medium","num_links":"0","num_links_columns":"1","linksImgSize":"Medium","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"0","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"1","catFeedIcon":"0","subCategories":"0","subCatColumns":"1","subCatOrdering":"","subCatTitle":"0","subCatTitleItemCounter":"0","subCatDescription":"0","subCatImage":"0","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"0","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"0","catItemTags":"1","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"1","catItemCommentsAnchor":"1","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"1","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"1","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"0","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"1","itemAuthorLatestLimit":"5","itemRelated":"1","itemRelatedLimit":"5","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(7, 'Sample Category 4', 'sample-category-4', '<p>Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, 1, 1, 6, '7.jpg', '{"inheritFrom":"0","theme":"nex","num_leading_items":"1","num_leading_columns":"1","leadingImgSize":"XLarge","num_primary_items":"3","num_primary_columns":"3","primaryImgSize":"Medium","num_secondary_items":"3","num_secondary_columns":"3","secondaryImgSize":"Medium","num_links":"0","num_links_columns":"1","linksImgSize":"Medium","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"0","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"1","catFeedIcon":"0","subCategories":"0","subCatColumns":"1","subCatOrdering":"","subCatTitle":"0","subCatTitleItemCounter":"0","subCatDescription":"0","subCatImage":"0","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"0","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"0","catItemTags":"1","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"1","catItemCommentsAnchor":"1","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"1","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"1","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"0","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"1","itemAuthorLatestLimit":"5","itemRelated":"1","itemRelatedLimit":"5","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(8, 'Sample Category 2', 'sample-category-2', '<p>Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, 1, 1, 8, '8.jpg', '{"inheritFrom":"0","theme":"nex","num_leading_items":"1","num_leading_columns":"1","leadingImgSize":"XLarge","num_primary_items":"3","num_primary_columns":"3","primaryImgSize":"Medium","num_secondary_items":"3","num_secondary_columns":"3","secondaryImgSize":"Medium","num_links":"0","num_links_columns":"1","linksImgSize":"Medium","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"0","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"1","catFeedIcon":"0","subCategories":"0","subCatColumns":"1","subCatOrdering":"","subCatTitle":"0","subCatTitleItemCounter":"0","subCatDescription":"0","subCatImage":"0","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"0","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"0","catItemTags":"1","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"1","catItemCommentsAnchor":"1","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"1","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"1","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"0","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"1","itemAuthorLatestLimit":"5","itemRelated":"1","itemRelatedLimit":"5","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(9, 'NEX Blog', 'nex-blog', '', 0, 0, 1, 1, 2, '', '{"inheritFrom":"0","theme":"nex_blog","num_leading_items":"1","num_leading_columns":"1","leadingImgSize":"XLarge","num_primary_items":"1","num_primary_columns":"1","primaryImgSize":"XLarge","num_secondary_items":"1","num_secondary_columns":"1","secondaryImgSize":"XLarge","num_links":"0","num_links_columns":"1","linksImgSize":"Medium","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"0","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"1","catFeedIcon":"0","subCategories":"0","subCatColumns":"1","subCatOrdering":"","subCatTitle":"1","subCatTitleItemCounter":"1","subCatDescription":"1","subCatImage":"1","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"1","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"1","catItemTags":"1","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"1","catItemCommentsAnchor":"1","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"1","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"1","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"0","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"1","itemAuthorLatestLimit":"5","itemRelated":"1","itemRelatedLimit":"5","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(10, 'Sample Category 6', 'sample-category-6', '<p>Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, 1, 1, 3, '10.jpg', '{"inheritFrom":"0","theme":"nex","num_leading_items":"1","num_leading_columns":"1","leadingImgSize":"XLarge","num_primary_items":"3","num_primary_columns":"3","primaryImgSize":"Medium","num_secondary_items":"3","num_secondary_columns":"3","secondaryImgSize":"Medium","num_links":"0","num_links_columns":"1","linksImgSize":"Medium","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"0","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"1","catFeedIcon":"0","subCategories":"0","subCatColumns":"1","subCatOrdering":"","subCatTitle":"0","subCatTitleItemCounter":"0","subCatDescription":"0","subCatImage":"0","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"0","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"0","catItemTags":"1","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"1","catItemCommentsAnchor":"1","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"1","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"1","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"0","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"1","itemAuthorLatestLimit":"5","itemRelated":"1","itemRelatedLimit":"5","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(11, 'Sample Category 7', 'sample-category-7', '<p>Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, 1, 1, 5, '11.jpg', '{"inheritFrom":"0","theme":"nex","num_leading_items":"1","num_leading_columns":"1","leadingImgSize":"XLarge","num_primary_items":"3","num_primary_columns":"3","primaryImgSize":"Medium","num_secondary_items":"3","num_secondary_columns":"3","secondaryImgSize":"Medium","num_links":"0","num_links_columns":"1","linksImgSize":"Medium","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"0","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"1","catFeedIcon":"0","subCategories":"0","subCatColumns":"1","subCatOrdering":"","subCatTitle":"0","subCatTitleItemCounter":"0","subCatDescription":"0","subCatImage":"0","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"0","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"0","catItemTags":"1","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"1","catItemCommentsAnchor":"1","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"1","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"1","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"0","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"1","itemAuthorLatestLimit":"5","itemRelated":"1","itemRelatedLimit":"5","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(12, 'Sample Category 8', 'sample-category-8', '<p>Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, 1, 1, 7, '12.jpg', '{"inheritFrom":"0","theme":"nex","num_leading_items":"1","num_leading_columns":"1","leadingImgSize":"XLarge","num_primary_items":"3","num_primary_columns":"3","primaryImgSize":"Medium","num_secondary_items":"3","num_secondary_columns":"3","secondaryImgSize":"Medium","num_links":"0","num_links_columns":"1","linksImgSize":"Medium","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"0","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"1","catFeedIcon":"0","subCategories":"0","subCatColumns":"1","subCatOrdering":"","subCatTitle":"0","subCatTitleItemCounter":"0","subCatDescription":"0","subCatImage":"0","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"0","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"0","catItemTags":"1","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"1","catItemCommentsAnchor":"1","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"1","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"1","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"0","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"1","itemAuthorLatestLimit":"5","itemRelated":"1","itemRelatedLimit":"5","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(13, 'Sample Category 5', 'sample-category-5', '<p>Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, 1, 1, 9, '13.jpg', '{"inheritFrom":"0","theme":"nex","num_leading_items":"1","num_leading_columns":"1","leadingImgSize":"XLarge","num_primary_items":"3","num_primary_columns":"3","primaryImgSize":"Medium","num_secondary_items":"3","num_secondary_columns":"3","secondaryImgSize":"Medium","num_links":"0","num_links_columns":"1","linksImgSize":"Medium","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"0","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"1","catFeedIcon":"0","subCategories":"0","subCatColumns":"1","subCatOrdering":"","subCatTitle":"0","subCatTitleItemCounter":"0","subCatDescription":"0","subCatImage":"0","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"0","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"0","catItemTags":"1","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"1","catItemCommentsAnchor":"1","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"1","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"1","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"0","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"1","itemAuthorLatestLimit":"5","itemRelated":"1","itemRelatedLimit":"5","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(14, 'Sample Category 9', 'sample-category-9', '<p>Mauris Lorem Donec risus consectetuer quis justo In iaculis wisi vitae. Congue nec a interdum.</p>', 1, 0, 1, 1, 2, '14.jpg', '{"inheritFrom":"0","theme":"nex","num_leading_items":"1","num_leading_columns":"1","leadingImgSize":"XLarge","num_primary_items":"3","num_primary_columns":"3","primaryImgSize":"Medium","num_secondary_items":"3","num_secondary_columns":"3","secondaryImgSize":"Medium","num_links":"0","num_links_columns":"1","linksImgSize":"Medium","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"0","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"1","catFeedIcon":"0","subCategories":"0","subCatColumns":"1","subCatOrdering":"","subCatTitle":"0","subCatTitleItemCounter":"0","subCatDescription":"0","subCatImage":"0","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"0","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"0","catItemTags":"1","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"1","catItemCommentsAnchor":"1","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"1","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"1","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"0","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"1","itemAuthorLatestLimit":"5","itemRelated":"1","itemRelatedLimit":"5","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*');

DROP TABLE IF EXISTS `#__k2_comments`;
CREATE TABLE `#__k2_comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) NOT NULL,
  `commentDate` datetime NOT NULL,
  `commentText` text NOT NULL,
  `commentEmail` varchar(255) NOT NULL,
  `commentURL` varchar(255) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`),
  KEY `userID` (`userID`),
  KEY `published` (`published`),
  KEY `latestComments` (`published`,`commentDate`)
) ENGINE=MyISAM ;

INSERT INTO `#__k2_comments` (`id`, `itemID`, `userID`, `userName`, `commentDate`, `commentText`, `commentEmail`, `commentURL`, `published`) VALUES
(2, 5, 42, 'Super User', '2011-12-06 09:07:02', 'Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.', 'support@joom.com', '', 1),
(3, 5, 42, 'Super User', '2011-12-06 09:07:51', 'Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing.', 'support@joom.com', '', 1),
(4, 5, 42, 'Super User', '2011-12-06 09:08:21', 'Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum.\r\n\r\nOrci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.', 'support@joom.com', '', 1);

DROP TABLE IF EXISTS `#__k2_extra_fields`;
CREATE TABLE `#__k2_extra_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `type` varchar(255) NOT NULL,
  `group` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `group` (`group`),
  KEY `published` (`published`),
  KEY `ordering` (`ordering`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__k2_extra_fields_groups`;
CREATE TABLE `#__k2_extra_fields_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__k2_items`;
CREATE TABLE `#__k2_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) DEFAULT NULL,
  `catid` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `video` text,
  `gallery` varchar(255) DEFAULT NULL,
  `extra_fields` text,
  `extra_fields_search` text NOT NULL,
  `created` datetime NOT NULL,
  `created_by` int(11) NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL,
  `checked_out` int(10) unsigned NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `modified` datetime NOT NULL,
  `modified_by` int(11) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL,
  `publish_down` datetime NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `featured` smallint(6) NOT NULL DEFAULT '0',
  `featured_ordering` int(11) NOT NULL DEFAULT '0',
  `image_caption` text NOT NULL,
  `image_credits` varchar(255) NOT NULL,
  `video_caption` text NOT NULL,
  `video_credits` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL,
  `params` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `metakey` text NOT NULL,
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `item` (`published`,`publish_up`,`publish_down`,`trash`,`access`),
  KEY `catid` (`catid`),
  KEY `created_by` (`created_by`),
  KEY `ordering` (`ordering`),
  KEY `featured` (`featured`),
  KEY `featured_ordering` (`featured_ordering`),
  KEY `hits` (`hits`),
  KEY `created` (`created`),
  KEY `language` (`language`),
  FULLTEXT KEY `search` (`title`,`introtext`,`fulltext`,`extra_fields_search`,`image_caption`,`image_credits`,`video_caption`,`video_credits`,`metadesc`,`metakey`),
  FULLTEXT KEY `title` (`title`)
) ENGINE=MyISAM ;

INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES
(1, 'Fringilla Nam faucibus', 'et-ligula-id-mauris-fringilla-nam-faucibus', 2, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 06:48:22', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 05:04:02', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 1, 0, 0, '', '', '', '', 4, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(2, 'Dictumst dui Phasellus', 'eget-urna-cursus-dictumst-dui-phasellus', 2, 1, '<p>Onvallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:28:09', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 05:03:37', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 5, 0, 0, '', '', '', '', 9, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(3, 'Volutpat lacinia dui quis', 'volutpat-lacinia-dui-quis-curabitur-pellentesque-ipsum-eu', 2, 1, '<p>Convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:30:16', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 05:03:47', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 9, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(4, 'Curabitur nec platea lorem Nunc facilisis', 'curabitur-nec-platea-lorem-nunc-facilisis', 2, 1, '<p>Bibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:30:16', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 05:03:52', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 3, 0, 0, '', '', '', '', 4, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(5, 'Enim adipiscing pretium eros id', 'nibh-convallis-curabitur-enim-adipiscing-pretium-eros-id', 2, 1, '<p>Iibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:31:56', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 05:03:05', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 7, 0, 0, '', '', '', '', 12, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(6, 'Id porttitor augue magna ac Donec risus', 'id-porttitor-augue-magna-ac-donec-risus', 8, 1, '<p>Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:45:11', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:51:58', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 7, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(7, 'Ut ante amet tincidunt nibh odio sit Phasellus Donec', 'ut-ante-amet-tincidunt-nibh-odio-sit-phasellus-donec', 8, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:45:12', 42, '', 0, '0000-00-00 00:00:00', '2011-12-14 04:16:10', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 2, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(8, 'Vivamus sapien lacus porttitor Vestibulum', 'vivamus-sapien-lacus-porttitor-vestibulum', 8, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:45:12', 42, '', 0, '0000-00-00 00:00:00', '2011-12-14 04:16:00', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 3, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(9, 'Vestibulum adipiscing rutrum id condimentum', 'vestibulum-adipiscing-rutrum-id-condimentum', 8, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:45:12', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:52:08', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 4, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(10, 'Hasellus urna Sed enim nonummy lobortis', 'phasellus-urna-sed-enim-nonummy-lobortis', 8, 1, '<p>Vallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:45:12', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 08:26:40', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 1, 0, 1, '', '', '', '', 2, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*');
INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES
(11, 'Dolor congue vitae nibh ac lacinia mi metus quis fames et', 'dolor-congue-vitae-nibh-ac-lacinia-mi-metus-quis-fames-et', 6, 1, '<p><span class="dropcap">N</span>ibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:48:39', 42, '', 0, '0000-00-00 00:00:00', '2011-12-06 08:06:03', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 1, 1, 1, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(12, 'Venenatis convallis condimentum Mauris Curabitu', 'venenatis-convallis-condimentum-mauris-curabitu', 6, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:48:39', 42, '', 0, '0000-00-00 00:00:00', '2011-12-06 08:06:59', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 1, 1, 2, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(13, 'Velit pretium nibh tincidunt eget urna tincidunt faucibus', 'velit-pretium-nibh-tincidunt-eget-urna-tincidunt-faucibus', 6, 1, '<p><span class="dropcap">N</span>allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:48:40', 42, '', 0, '0000-00-00 00:00:00', '2011-12-06 08:06:47', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 1, 1, 3, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(14, 'Et ligula id mauris fringilla Nam faucibus', 'et-ligula-id-mauris-fringilla-nam-faucibus', 6, 1, '<p><span class="dropcap">C</span>onvallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:48:40', 42, '', 0, '0000-00-00 00:00:00', '2011-12-06 08:06:30', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 1, 1, 4, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(15, 'Vivamus sapien lacus porttitor Vestibulum Donec congue', 'vivamus-sapien-lacus-porttitor-vestibulum-donec-congue', 6, 1, '<p><span class="dropcap">I</span>bh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:48:40', 42, '', 0, '0000-00-00 00:00:00', '2011-12-06 08:06:18', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 1, 1, 5, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(16, 'Vamus sapien lacus porttitor Vestibulum Donec congue', 'vamus-sapien-lacus-porttitor-vestibulum-donec-congue', 7, 1, '<p><span class="dropcap">N</span>ibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:54:35', 42, '', 0, '0000-00-00 00:00:00', '2011-12-06 08:08:15', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 1, 1, 1, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(17, 'Ligula id mauris fringilla Nam faucibus', 'ligula-id-mauris-fringilla-nam-faucibus', 7, 1, '<p><span class="dropcap">A</span>bitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:54:35', 42, '', 0, '0000-00-00 00:00:00', '2011-12-06 08:09:13', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 1, 1, 2, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(18, 'Elit pretium nibh tincidunt eget urna tincidunt faucibus', 'elit-pretium-nibh-tincidunt-eget-urna-tincidunt-faucibus', 7, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:54:35', 42, '', 0, '0000-00-00 00:00:00', '2011-12-06 08:08:57', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 1, 1, 3, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(19, 'Nenatis convallis condimentum Mauris Curabitu', 'nenatis-convallis-condimentum-mauris-curabitu', 7, 1, '<p><span class="dropcap">U</span>rabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:54:35', 42, '', 0, '0000-00-00 00:00:00', '2011-12-06 08:08:45', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 1, 1, 4, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(20, 'Olor congue vitae nibh ac lacinia mi metus quis fames et', 'dolor-congue-vitae-nibh-ac-lacinia-mi-metus-quis-fames-et', 7, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 07:54:35', 42, '', 0, '0000-00-00 00:00:00', '2011-12-06 08:08:31', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 1, 1, 5, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*');
INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES
(21, 'Dolor congue vitae nibh ac lacinia mi metus quis fames et', 'dolor-congue-vitae-nibh-ac-lacinia-mi-metus-quis-fames-et', 9, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 08:12:10', 42, '', 0, '0000-00-00 00:00:00', '2011-12-13 08:44:12', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 1, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(22, 'Enatis convallis condimentum Mauris Curabitu', 'enatis-convallis-condimentum-mauris-curabitu', 9, 1, '<p>Urabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 08:12:10', 42, '', 0, '0000-00-00 00:00:00', '2011-12-15 07:53:23', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 3, 0, 0, '', '', '', '', 5, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(23, 'Pretium nibh tincidunt eget urna tincidunt faucibus', 'pretium-nibh-tincidunt-eget-urna-tincidunt-faucibus', 9, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 08:12:10', 42, '', 0, '0000-00-00 00:00:00', '2011-12-13 08:45:10', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 5, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(24, 'Igula id mauris fringilla Nam faucibus', 'igula-id-mauris-fringilla-nam-faucibus', 9, 1, '<p>Abitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 08:12:11', 42, '', 0, '0000-00-00 00:00:00', '2011-12-15 07:53:01', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 6, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(25, 'Amus sapien lacus porttitor Vestibulum Donec congue', 'amus-sapien-lacus-porttitor-vestibulum-donec-congue', 9, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-06 08:12:11', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 09:24:38', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 7, 0, 0, '', '', '', '', 2, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(26, 'Nam dictum mauris vitae auctor', 'metus-sit-ac-nam-dictum-mauris-vitae-auctor', 2, 1, '<p>Iibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-09 10:21:24', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 05:02:55', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 8, 0, 0, '', '', '', '', 2, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(27, 'Ligula ligula mollis pede leo turpis', 'pretium-vivamus-ligula-ligula-mollis-pede-leo-turpis', 2, 1, '<p>Bibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-09 10:21:24', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 05:02:46', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 4, 0, 0, '', '', '', '', 7, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(28, 'Id porttitor augue magna ac', 'id-porttitor-augue-magna-ac', 2, 1, '<p>Convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-09 10:21:25', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 05:02:27', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 10, 0, 0, '', '', '', '', 3, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(29, 'Phasellus Donec semper quam', 'phasellus-donec-semper-quam', 2, 1, '<p>Onvallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-09 10:21:25', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 05:02:00', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 6, 0, 0, '', '', '', '', 16, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(30, 'Et ligula id mauris fringilla', 'et-ligula-id-mauris-fringilla', 2, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-09 10:21:25', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 05:02:33', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 2, 1, 1, '', '', '', '', 52, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*');
INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES
(31, 'Rutrum id condimentum', 'rutrum-id-condimentum', 8, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-05 00:00:00', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:52:03', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 6, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(32, 'Lacus porttitor Vestibulum', 'lacus-porttitor-vestibulum', 8, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-05 00:00:00', 42, '', 0, '0000-00-00 00:00:00', '2011-12-14 04:15:09', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 5, 1, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(33, 'Acus porttitor Vestibulumm', 'acus-porttitor-vestibulumm', 6, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:12:04', 42, '', 0, '0000-00-00 00:00:00', '2011-12-14 04:18:50', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 1, 0, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(34, 'Utrum id condimentum', 'utrum-id-condimentum', 6, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:12:04', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:49:07', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 2, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(35, 'Asellus urna Sed enim nonummy lobortis', 'asellus-urna-sed-enim-nonummy-lobortis', 6, 1, '<p>Vallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:12:05', 42, '', 0, '0000-00-00 00:00:00', '2011-12-14 04:18:20', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 3, 0, 1, '', '', '', '', 3, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(36, 'Estibulum adipiscing rutrum id condimentum', 'estibulum-adipiscing-rutrum-id-condimentum', 6, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:12:05', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:49:17', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 4, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(37, 'Ivamus sapien lacus porttitor Vestibulum', 'ivamus-sapien-lacus-porttitor-vestibulum', 6, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:12:05', 42, '', 0, '0000-00-00 00:00:00', '2011-12-14 04:17:50', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 5, 0, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(38, 'Ante amet tincidunt nibh odio sit Phasellus Donec', 'ante-amet-tincidunt-nibh-odio-sit-phasellus-donec', 6, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:12:06', 42, '', 0, '0000-00-00 00:00:00', '2011-12-14 04:17:45', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 6, 0, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(39, 'Orttitor augue magna ac Donec risus', 'orttitor-augue-magna-ac-donec-risus', 6, 1, '<p>Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:12:06', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 08:20:50', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 7, 1, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(40, 'Ugue magna ac Donec risus', 'ugue-magna-ac-donec-risus', 7, 1, '<p>Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:32:29', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:44:52', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 1, 0, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*');
INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES
(41, 'Nte amet tincidunt nibh odio sit Phasellus Donec', 'nte-amet-tincidunt-nibh-odio-sit-phasellus-donec', 7, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:32:29', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:44:42', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 2, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(42, 'Mus sapien lacus porttitor Vestibulum', 'mus-sapien-lacus-porttitor-vestibulum', 7, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:32:29', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:44:37', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 3, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(43, 'Stibulum adipiscing rutrum id condimentum', 'stibulum-adipiscing-rutrum-id-condimentum', 7, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:32:29', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:44:27', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 4, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(44, 'Sellus urna Sed enim nonummy lobortis', 'sellus-urna-sed-enim-nonummy-lobortis', 7, 1, '<p>Vallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:32:30', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:44:22', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 5, 0, 1, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(45, 'Of Utrum id condimentum', 'utrum-id-condimentum', 7, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:32:30', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:44:11', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 6, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(46, 'Cus porttitor Vestibulumm', 'cus-porttitor-vestibulumm', 7, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:32:30', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:43:59', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 7, 1, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(47, 'Odio sit Phasellus Donec semper quam', 'odio-sit-phasellus-donec-semper-quam', 13, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:43:54', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:40:15', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 1, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(48, 'Lobortis turpis sollicitudin', 'lobortis-turpis-sollicitudin', 13, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:43:54', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:40:57', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 2, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(49, 'Rna Sed enim nonummy lobortis', 'rna-sed-enim-nonummy-lobortis', 13, 1, '<p>Vallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:43:54', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:40:47', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 3, 0, 1, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(50, 'Trum id condimentum', 'trum-id-condimentum', 13, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:43:54', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:40:42', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 4, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*');
INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES
(51, 'Us sapien lacus porttitor Vestibulum', 'us-sapien-lacus-porttitor-vestibulum', 13, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:43:55', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:40:32', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 5, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(52, 'Met tincidunt nibh odio sit Phasellus Donec', 'met-tincidunt-nibh-odio-sit-phasellus-donec', 13, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:43:55', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:40:22', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 6, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(53, 'Donec lacinia pretium dui', 'donec-lacinia-pretium-dui', 13, 1, '<p>Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:43:55', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:40:07', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 7, 1, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(54, 'Onec lacinia pretium dui', 'onec-lacinia-pretium-dui', 10, 1, '<p>Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:52:14', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:31:35', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 1, 0, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(55, 'Tincidunt nibh odio sit Phasellus Donec', 'tincidunt-nibh-odio-sit-phasellus-donec', 10, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:52:14', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:32:12', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 2, 0, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(56, 'Semper nulla', 'semper-nulla', 10, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:52:14', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:32:07', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 3, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(57, 'Trum id condimentumt', 'trum-id-condimentumt', 10, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:52:15', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:31:57', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 4, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(58, 'Na Sed enim nonummy lobortis', 'na-sed-enim-nonummy-lobortis', 10, 1, '<p>Vallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:52:15', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:31:52', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 5, 0, 1, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(59, 'Bortis turpis sollicitudin', 'bortis-turpis-sollicitudin', 10, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:52:15', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:31:42', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 6, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(60, 'Hasellus Donec semper quam', 'hasellus-donec-semper-quam', 10, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:52:15', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:31:28', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 7, 1, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*');
INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES
(61, 'Curabitur enim adipiscing', 'hasellus-donec-semper-quam', 11, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:57:17', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:29:00', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 1, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(62, 'Condimentum montes ac', 'condimentum-montes-ac', 11, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:57:17', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:28:28', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 2, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(63, 'Nam dictum mauris', 'nam-dictum-mauris', 11, 1, '<p>Vallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:57:17', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:28:23', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 3, 0, 1, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(64, 'Tempus wisi facilisi ut', 'tempus-wisi-facilisi-ut', 11, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:57:18', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:28:08', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 4, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(65, 'Consectetuer at lobortis', 'consectetuer-at-lobortis', 11, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:57:18', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:27:58', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 5, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(66, 'Curabitur tincidunt fermentum', 'curabitur-tincidunt-fermentum', 11, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 07:57:18', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:27:50', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 6, 0, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(67, 'Tempor tellus Ut velit amet', 'tempor-tellus-ut-velit-amet', 11, 1, '<p>Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-10-13 07:57:18', 42, '', 0, '0000-00-00 00:00:00', '2011-12-19 04:34:31', 42, '2011-10-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 7, 1, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(68, 'Quis pretium vel vitae', 'quis-pretium-vel-vitae', 12, 1, '<p>Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 08:03:43', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:24:26', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 1, 0, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(69, 'Dictum mauris vitae', 'dictum-mauris-vitae', 12, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 08:03:43', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:23:36', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 2, 0, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(70, 'Lorem adipiscing', 'lorem-adipiscing', 12, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 08:03:44', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:23:42', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 3, 0, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*');
INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES
(71, 'Eget urna tincidunt faucibus', 'eget-urna-tincidunt-faucibus', 12, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 08:03:44', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:23:49', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 4, 0, 0, '', '', '', '', 5, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(72, 'Nam convallis felis', 'nam-convallis-felis', 12, 1, '<p>Vallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 08:03:44', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:24:00', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 5, 0, 1, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(73, 'Velit pretium nibh tincidunt', 'velit-pretium-nibh-tincidunt', 12, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 08:03:44', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:24:10', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 6, 0, 0, '', '', '', '', 3, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(74, 'Nam dictum maurism', 'nam-dictum-maurism', 12, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 08:03:45', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:24:15', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 7, 1, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(75, 'Nam dictum maurismt', 'nam-dictum-maurismt', 14, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 08:14:17', 42, '', 42, '2011-12-16 07:17:44', '2011-12-14 04:38:26', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 1, 0, 0, '', '', '', '', 0, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(76, 'Elit pretium nibh tinci', 'elit-pretium-nibh-tinci', 14, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 08:14:18', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 07:18:25', 42, '2011-12-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 2, 0, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(77, 'Nam convallis feli', 'nam-convallis-feli', 14, 1, '<p>Vallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-10-13 08:14:18', 42, '', 0, '0000-00-00 00:00:00', '2011-12-19 04:34:16', 42, '2011-10-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 3, 0, 1, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(78, 'Eget urna tincidunt fauci', 'eget-urna-tincidunt-fauci', 14, 1, '<p>Allis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-11-13 08:14:18', 42, '', 0, '0000-00-00 00:00:00', '2011-12-19 04:33:20', 42, '2011-11-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 4, 0, 0, '', '', '', '', 2, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(79, 'Lorem adipiscing dictumst', 'lorem-adipiscing-dictumst', 14, 1, '<p>Llis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 08:14:18', 42, '', 0, '0000-00-00 00:00:00', '2011-12-16 08:09:16', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 5, 0, 0, '', '', '', '', 3, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(80, 'Dictum mauris vitae ee', 'dictum-mauris-vitae', 14, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-11-13 08:14:18', 42, '', 0, '0000-00-00 00:00:00', '2011-12-19 04:33:47', 42, '2011-11-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 6, 0, 0, '', '', '', '', 3, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*');
INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES
(81, 'Uis pretium vel vitae', 'uis-pretium-vel-vitae', 14, 1, '<p>Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 08:14:19', 42, '', 42, '2011-12-16 07:18:51', '2011-12-14 04:37:18', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 7, 1, 0, '', '', '', '', 13, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(82, 'Natis convallis condimentum Mauris Curabitu', 'enatis-convallis-condimentum-mauris-curabitu', 9, 1, '<p>Urabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 08:44:35', 42, '', 0, '0000-00-00 00:00:00', '2011-12-15 07:52:35', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 4, 0, 0, '', '', '', '', 5, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(83, 'Congue vitae nibh ac lacinia mi metus quis fames et', 'congue-vitae-nibh-ac-lacinia-mi-metus-quis-fames-et', 9, 1, '<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n', '\r\n<p>Dolor congue vitae nibh ac lacinia mi metus quis fames et. Id porttitor augue magna ac Donec risus ligula quis morbi Cum. Nullam nec et convallis facilisis pulvinar enim rutrum lorem eros porta. Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor ac pulvinar. Condimentum facilisi Phasellus tempus wisi facilisi ut.</p>\r\n<p>Orci augue faucibus gravida nisl penatibus Nulla volutpat libero eros tortor. Vivamus sapien lacus porttitor Vestibulum Donec congue et sed quis ridiculus. Dictum id Quisque hac tellus mi Curabitur nec platea cursus lobortis. Donec lacinia pretium dui Aenean molestie condimentum odio montes tellus est. Orci quis Nam sagittis Lorem vitae tortor Aenean tellus gravida suscipit. Tempor tellus Ut velit amet.</p>\r\n<p>Eget urna cursus dictumst dui Phasellus urna Sed enim nonummy lobortis. Et ligula id mauris fringilla Nam faucibus quam pede auctor consequat. Magnis orci pellentesque auctor non metus a justo elit Lorem adipiscing. Metus sit ac Nam dictum mauris vitae auctor id non Vestibulum. Orci Sed Ut augue ut Curabitur aliquam Donec elit nec ipsum. Venenatis convallis condimentum Mauris Curabitur tincidunt fermentum aliquam at laoreet.</p>\r\n<p>Nibh convallis Curabitur enim adipiscing pretium eros id nibh dictumst Praesent. Pretium Vivamus ligula ligula mollis pede leo turpis consequat quis et. Semper nulla Ut sed venenatis a tempor Aenean id et vitae. Ut ante amet tincidunt nibh odio sit Phasellus Donec semper quam. Lobortis turpis sollicitudin nibh id consectetuer at lobortis nonummy pellentesque nec. Pede.</p>\r\n<p>Vestibulum adipiscing rutrum id condimentum montes ac metus tincidunt neque pellentesque. Volutpat lacinia dui quis Curabitur Pellentesque ipsum eu In Curabitur consectetuer. Aliquam Vivamus tortor habitasse vel id id Maecenas sed interdum massa. Quis pretium vel vitae vitae fringilla et risus eget parturient a. Iaculis ac ut laoreet id at a semper.</p>\r\n<p>Et tristique felis hac Nam convallis felis vel pretium Nullam feugiat. Elit Curabitur nec platea lorem Nunc facilisis condimentum justo sagittis parturient. Tempor Nunc egestas Nunc dictum cursus ac nulla auctor ante malesuada. Velit pretium nibh tincidunt eget urna tincidunt faucibus dignissim rhoncus sed. Aliquam lacus condimentum tristique mattis adipiscing dapibus rhoncus et gravida.</p>', NULL, NULL, '[]', '', '2011-12-13 08:44:35', 42, '', 0, '0000-00-00 00:00:00', '2011-12-13 09:08:30', 42, '2011-12-06 06:48:22', '0000-00-00 00:00:00', 0, 1, 2, 1, 0, '', '', '', '', 24, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*');

DROP TABLE IF EXISTS `#__k2_rating`;
CREATE TABLE `#__k2_rating` (
  `itemID` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(11) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(11) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`itemID`)
) ENGINE=MyISAM;

INSERT INTO `#__k2_rating` (`itemID`, `rating_sum`, `rating_count`, `lastip`) VALUES
(30, 4, 1, '127.0.0.1'),
(29, 5, 1, '127.0.0.1'),
(5, 4, 1, '127.0.0.1'),
(83, 4, 1, '10.0.0.102');

DROP TABLE IF EXISTS `#__k2_tags`;
CREATE TABLE `#__k2_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `published` (`published`),
  FULLTEXT KEY `name` (`name`)
) ENGINE=MyISAM ;

INSERT INTO `#__k2_tags` (`id`, `name`, `published`) VALUES
(1, 'joomla', 1),
(2, 'business', 1),
(3, 'blog', 1);

DROP TABLE IF EXISTS `#__k2_tags_xref`;
CREATE TABLE `#__k2_tags_xref` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tagID` int(11) NOT NULL,
  `itemID` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `tagID` (`tagID`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM ;

INSERT INTO `#__k2_tags_xref` (`id`, `tagID`, `itemID`) VALUES
(433, 3, 1),
(432, 2, 1),
(431, 1, 1),
(428, 2, 5),
(427, 1, 5),
(430, 3, 4),
(429, 1, 4),
(470, 2, 6),
(469, 1, 6),
(366, 3, 7),
(365, 1, 7),
(475, 3, 10),
(474, 2, 10),
(473, 1, 10),
(66, 3, 11),
(65, 2, 11),
(64, 1, 11),
(70, 3, 14),
(69, 1, 14),
(68, 2, 15),
(67, 1, 15),
(72, 2, 16),
(71, 1, 16),
(77, 3, 17),
(76, 1, 17),
(75, 3, 20),
(74, 2, 20),
(73, 1, 20),
(306, 3, 21),
(305, 2, 21),
(304, 1, 21),
(419, 3, 24),
(418, 1, 24),
(477, 2, 25),
(476, 1, 25),
(426, 2, 26),
(425, 1, 26),
(424, 3, 27),
(423, 1, 27),
(422, 3, 30),
(421, 2, 30),
(420, 1, 30),
(371, 3, 35),
(370, 2, 35),
(369, 1, 35),
(368, 3, 38),
(367, 1, 38),
(472, 2, 39),
(471, 1, 39),
(468, 2, 40),
(467, 1, 40),
(466, 3, 41),
(465, 1, 41),
(464, 3, 44),
(463, 2, 44),
(462, 1, 44),
(461, 3, 49),
(460, 2, 49),
(459, 1, 49),
(458, 3, 52),
(457, 1, 52),
(456, 2, 53),
(455, 1, 53),
(449, 2, 54),
(448, 1, 54),
(454, 3, 55),
(453, 1, 55),
(452, 3, 58),
(451, 2, 58),
(450, 1, 58),
(447, 3, 63),
(446, 2, 63),
(445, 1, 63),
(444, 3, 66),
(443, 1, 66),
(487, 2, 67),
(486, 1, 67),
(440, 2, 68),
(439, 1, 68),
(435, 3, 69),
(434, 1, 69),
(438, 3, 72),
(437, 2, 72),
(436, 1, 72),
(485, 3, 77),
(484, 2, 77),
(483, 1, 77),
(482, 3, 80),
(481, 1, 80),
(410, 2, 81),
(409, 1, 81),
(320, 3, 83),
(319, 2, 83),
(318, 1, 83);

DROP TABLE IF EXISTS `#__k2_user_groups`;
CREATE TABLE `#__k2_user_groups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `permissions` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM ;

INSERT INTO `#__k2_user_groups` (`id`, `name`, `permissions`) VALUES
(1, 'Registered', '{"comment":"1","frontEdit":"0","add":"0","editOwn":"0","editAll":"0","publish":"0","inheritance":0,"categories":"all"}'),
(2, 'Site Owner', '{"comment":"1","frontEdit":"1","add":"1","editOwn":"1","editAll":"1","publish":"1","inheritance":1,"categories":"all"}');

DROP TABLE IF EXISTS `#__k2_users`;
CREATE TABLE `#__k2_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) DEFAULT NULL,
  `gender` enum('m','f') NOT NULL DEFAULT 'm',
  `description` text NOT NULL,
  `image` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `group` int(11) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  `ip` varchar(15) NOT NULL,
  `hostname` varchar(255) NOT NULL,
  `notes` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `userID` (`userID`),
  KEY `group` (`group`)
) ENGINE=MyISAM ;

INSERT INTO `#__k2_users` (`id`, `userID`, `userName`, `gender`, `description`, `image`, `url`, `group`, `plugins`, `ip`, `hostname`, `notes`) VALUES
(1, 42, 'Super User', 'f', '<p>Libero tellus sit ipsum ante eu Curabitur nibh Sed Pellentesque nisl. Nibh quis laoreet mauris mi est quis nibh porttitor.</p>', '1.jpg', 'http://www.joomlart.com', 0, '', '10.0.0.240', '10.0.0.240', '');

DROP TABLE IF EXISTS `#__kunena_aliases`;
CREATE TABLE `#__kunena_aliases` (
  `alias` varchar(255) NOT NULL,
  `type` varchar(10) NOT NULL,
  `item` varchar(32) NOT NULL,
  `state` tinyint(4) NOT NULL DEFAULT '0',
  UNIQUE KEY `alias` (`alias`),
  KEY `state` (`state`),
  KEY `item` (`item`),
  KEY `type` (`type`)
) ENGINE=MyISAM;

INSERT INTO `#__kunena_aliases` (`alias`, `type`, `item`, `state`) VALUES
('announcement', 'view', 'announcement', 1),
('category', 'view', 'category', 1),
('common', 'view', 'common', 1),
('credits', 'view', 'credits', 1),
('home', 'view', 'home', 1),
('misc', 'view', 'misc', 1),
('search', 'view', 'search', 1),
('statistics', 'view', 'statistics', 1),
('topic', 'view', 'topic', 1),
('topics', 'view', 'topics', 1),
('user', 'view', 'user', 1),
('category/create', 'layout', 'category.create', 1),
('create', 'layout', 'category.create', 0),
('category/default', 'layout', 'category.default', 1),
('default', 'layout', 'category.default', 0),
('category/edit', 'layout', 'category.edit', 1),
('edit', 'layout', 'category.edit', 0),
('category/manage', 'layout', 'category.manage', 1),
('manage', 'layout', 'category.manage', 0),
('category/moderate', 'layout', 'category.moderate', 1),
('moderate', 'layout', 'category.moderate', 0),
('category/user', 'layout', 'category.user', 1),
('main-forum', 'catid', '1', 1),
('welcome-mat', 'catid', '2', 1),
('suggestion-box', 'catid', '3', 1),
('africa-zone', 'catid', '4', 0),
('protests-as-sudan', 'catid', '5', 0),
('avoiding-problems', 'catid', '6', 0),
('lacinia-sed-convallis', 'catid', '7', 0),
('employment-taxes', 'catid', '8', 0),
('financial-discussion', 'catid', '9', 0),
('general-finance', 'catid', '10', 0),
('insurance', 'catid', '11', 0),
('investments', 'catid', '12', 0),
('semper-accumsan', 'catid', '13', 0);

DROP TABLE IF EXISTS `#__kunena_announcement`;
CREATE TABLE `#__kunena_announcement` (
  `id` int(3) NOT NULL AUTO_INCREMENT,
  `title` tinytext NOT NULL,
  `created_by` int(11) NOT NULL DEFAULT '0',
  `sdescription` text NOT NULL,
  `description` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `ordering` tinyint(4) NOT NULL DEFAULT '0',
  `showdate` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__kunena_attachments`;
CREATE TABLE `#__kunena_attachments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mesid` int(11) NOT NULL DEFAULT '0',
  `userid` int(11) NOT NULL DEFAULT '0',
  `hash` char(32) DEFAULT NULL,
  `size` int(11) DEFAULT NULL,
  `folder` varchar(255) NOT NULL,
  `filetype` varchar(20) NOT NULL,
  `filename` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `mesid` (`mesid`),
  KEY `userid` (`userid`),
  KEY `hash` (`hash`),
  KEY `filename` (`filename`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__kunena_categories`;
CREATE TABLE `#__kunena_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) DEFAULT '0',
  `name` tinytext,
  `alias` varchar(255) NOT NULL,
  `icon_id` tinyint(4) NOT NULL DEFAULT '0',
  `locked` tinyint(4) NOT NULL DEFAULT '0',
  `accesstype` varchar(20) NOT NULL DEFAULT 'joomla.level',
  `access` int(11) NOT NULL DEFAULT '0',
  `pub_access` int(11) NOT NULL DEFAULT '1',
  `pub_recurse` tinyint(4) DEFAULT '1',
  `admin_access` int(11) NOT NULL DEFAULT '0',
  `admin_recurse` tinyint(4) DEFAULT '1',
  `ordering` smallint(6) NOT NULL DEFAULT '0',
  `published` tinyint(4) NOT NULL DEFAULT '0',
  `channels` text,
  `checked_out` tinyint(4) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review` tinyint(4) NOT NULL DEFAULT '0',
  `allow_anonymous` tinyint(4) NOT NULL DEFAULT '0',
  `post_anonymous` tinyint(4) NOT NULL DEFAULT '0',
  `hits` int(11) NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `headerdesc` text NOT NULL,
  `class_sfx` varchar(20) NOT NULL,
  `allow_polls` tinyint(4) NOT NULL DEFAULT '0',
  `topic_ordering` varchar(16) NOT NULL DEFAULT 'lastpost',
  `numTopics` mediumint(8) NOT NULL DEFAULT '0',
  `numPosts` mediumint(8) NOT NULL DEFAULT '0',
  `last_topic_id` int(11) NOT NULL DEFAULT '0',
  `last_post_id` int(11) NOT NULL DEFAULT '0',
  `last_post_time` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `category_access` (`accesstype`,`access`),
  KEY `published_pubaccess_id` (`published`,`pub_access`,`id`)
) ENGINE=MyISAM ;

INSERT INTO `#__kunena_categories` (`id`, `parent_id`, `name`, `alias`, `icon_id`, `locked`, `accesstype`, `access`, `pub_access`, `pub_recurse`, `admin_access`, `admin_recurse`, `ordering`, `published`, `channels`, `checked_out`, `checked_out_time`, `review`, `allow_anonymous`, `post_anonymous`, `hits`, `description`, `headerdesc`, `class_sfx`, `allow_polls`, `topic_ordering`, `numTopics`, `numPosts`, `last_topic_id`, `last_post_id`, `last_post_time`, `params`) VALUES
(1, 0, 'Main Forum', 'main-forum', 0, 0, 'joomla.group', 0, 1, 1, 0, 1, 1, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'This is the main forum section. It serves as a container for categories for your topics.', 'The section header is used to display additional information about the categories of topics that it contains.', '', 0, 'lastpost', 0, 0, 0, 0, 0, ''),
(2, 1, 'Welcome Mat', 'welcome-mat', 0, 0, 'joomla.group', 0, 1, 1, 0, 1, 1, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'We encourage new members to introduce themselves here. Get to know one another and share your interests.', '[b]Welcome to the Kunena forum![/b] \n\n Tell us and our members who you are, what you like and why you became a member of this site. \n We welcome all new members and hope to see you around a lot!', '', 0, 'lastpost', 1, 1, 1, 1, 1350459317, ''),
(3, 1, 'Suggestion Box', 'suggestion-box', 0, 0, 'joomla.group', 0, 1, 1, 0, 1, 2, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'Have some feedback and input to share? \n Don\'t be shy and drop us a note. We want to hear from you and strive to make our site better and more user friendly for our guests and members a like.', 'This is the optional category header for the Suggestion Box.', '', 1, 'lastpost', 0, 0, 0, 0, 0, ''),
(4, 0, 'Africa Zone', 'africa-zone', 0, 0, 'joomla.level', 1, 1, 1, 8, 1, 2, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'Sed ut perspiciatis unde omnis iste natus error sit.', 'Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugi', '', 0, 'lastpost', 0, 0, 0, 0, 0, '{}'),
(5, 4, 'Protests as Sudan', 'protests-as-sudan', 0, 0, 'joomla.level', 1, 1, 1, 8, 1, 1, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'Protests as Sudan \'tight pants\' trial delayed', 'Sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. ', '', 0, 'lastpost', 0, 0, 0, 0, 0, '{}'),
(6, 4, 'Avoiding Problems', 'avoiding-problems', 0, 0, 'joomla.level', 1, 1, 1, 8, 1, 2, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'You can avoid many problems by keeping accurate records.', 'Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur.', '', 0, 'lastpost', 0, 0, 0, 0, 0, '{}'),
(7, 4, 'Lacinia Sed convallis', 'lacinia-sed-convallis', 0, 0, 'joomla.level', 1, 1, 1, 8, 1, 3, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'This section is packed with the information you need.', 'This section is packed with the information you need to operate your business. Learn about operating a business with employees, business deductions and tax credits, filing and paying taxes, recordkeeping, and choosing an accounting method. \r\n', '', 0, 'lastpost', 0, 0, 0, 0, 0, '{}'),
(8, 4, 'Employment Taxes', 'employment-taxes', 0, 0, 'joomla.level', 1, 1, 1, 8, 1, 4, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'The subject of employment taxes is not as formidable.\r\n', 'The subject of employment taxes is not as formidable when you consult our comprehensive resources.', '', 0, 'lastpost', 0, 0, 0, 0, 0, '{}'),
(9, 0, 'Financial Discussion', 'financial-discussion', 0, 0, 'joomla.level', 1, 1, 1, 8, 1, 3, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'Talk about internet banking, home loans, credit cards, discuss personal.', 'Talk about internet banking, home loans, credit cards, discuss personal and business finance, find financial discussions, banking forums, banks, mortgage, loans, ...', '', 0, 'lastpost', 0, 0, 0, 0, 0, '{}'),
(10, 9, 'General Finance', 'general-finance', 0, 0, 'joomla.level', 1, 1, 1, 8, 1, 1, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'Discuss general personal finance issues and home accounting', 'Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel.', '', 0, 'lastpost', 0, 0, 0, 0, 0, '{}'),
(11, 9, 'Insurance', 'insurance', 0, 0, 'joomla.level', 1, 1, 1, 8, 1, 2, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'Life assurance, car insurance, holiday insurances', 'Life assurance, car insurance, holiday insurances, etc - discuss insurance and ask questions about insurance and insurance companies here.\r\n', '', 0, 'lastpost', 0, 0, 0, 0, 0, '{}'),
(12, 9, 'Investments', 'investments', 0, 0, 'joomla.level', 1, 1, 1, 8, 1, 4, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'Discussions and questions about stock market investments.\r\n', 'Discussions and questions about stock market investments, tax free savings, and high interest savings accounts.\r\n', '', 0, 'lastpost', 0, 0, 0, 0, 0, '{}'),
(13, 9, 'Semper accumsan', 'semper-accumsan', 0, 0, 'joomla.level', 1, 1, 1, 8, 1, 3, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'Discussions about business finance, such as accounts and accounting.', 'Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum', '', 0, 'lastpost', 0, 0, 0, 0, 0, '{}');

DROP TABLE IF EXISTS `#__kunena_configuration`;
CREATE TABLE `#__kunena_configuration` (
  `id` int(11) NOT NULL DEFAULT '0',
  `params` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;

INSERT INTO `#__kunena_configuration` (`id`, `params`) VALUES
(1, '{"board_title":"Kunena","email":"","board_offline":0,"offline_message":"<h2>The Forum is currently offline for maintenance.<\\/h2>\\n<div>Check back soon!<\\/div>","enablerss":1,"threads_per_page":20,"messages_per_page":6,"messages_per_page_search":15,"showhistory":1,"historylimit":6,"shownew":1,"disemoticons":0,"template":"ja_nex","showannouncement":1,"avataroncat":0,"catimagepath":"category_images","showchildcaticon":1,"rtewidth":450,"rteheight":300,"enableforumjump":1,"reportmsg":1,"username":1,"askemail":0,"showemail":0,"showuserstats":1,"showkarma":1,"useredit":1,"useredittime":0,"useredittimegrace":600,"editmarkup":1,"allowsubscriptions":1,"subscriptionschecked":1,"allowfavorites":1,"maxsubject":50,"maxsig":300,"regonly":0,"pubwrite":0,"floodprotection":0,"mailmod":0,"mailadmin":0,"captcha":0,"mailfull":1,"allowavatarupload":1,"allowavatargallery":1,"avatarquality":75,"avatarsize":2048,"imageheight":800,"imagewidth":800,"imagesize":150,"filetypes":"txt,rtf,pdf,zip,tar.gz,tgz,tar.bz2","filesize":120,"showranking":1,"rankimages":1,"userlist_rows":30,"userlist_online":1,"userlist_avatar":1,"userlist_name":1,"userlist_posts":1,"userlist_karma":1,"userlist_email":0,"userlist_usertype":0,"userlist_joindate":1,"userlist_lastvisitdate":1,"userlist_userhits":1,"latestcategory":"","showstats":1,"showwhoisonline":1,"showgenstats":1,"showpopuserstats":1,"popusercount":5,"showpopsubjectstats":1,"popsubjectcount":5,"usernamechange":0,"showspoilertag":1,"showvideotag":1,"showebaytag":1,"trimlongurls":1,"trimlongurlsfront":40,"trimlongurlsback":20,"autoembedyoutube":1,"autoembedebay":1,"ebaylanguagecode":"en-us","sessiontimeout":1800,"highlightcode":0,"rss_type":"topic","rss_timelimit":"month","rss_limit":100,"rss_included_categories":"","rss_excluded_categories":"","rss_specification":"rss2.0","rss_allow_html":1,"rss_author_format":"name","rss_author_in_title":1,"rss_word_count":"0","rss_old_titles":1,"rss_cache":900,"defaultpage":"recent","default_sort":"asc","sef":1,"sefutf8":0,"showimgforguest":1,"showfileforguest":1,"pollnboptions":4,"pollallowvoteone":1,"pollenabled":1,"poppollscount":5,"showpoppollstats":1,"polltimebtvotes":"00:15:00","pollnbvotesbyuser":100,"pollresultsuserslist":1,"maxpersotext":50,"ordering_system":"mesid","post_dateformat":"ago","post_dateformat_hover":"datetime","hide_ip":1,"imagetypes":"jpg,jpeg,gif,png","checkmimetypes":1,"imagemimetypes":"image\\/jpeg,image\\/jpg,image\\/gif,image\\/png","imagequality":50,"thumbheight":32,"thumbwidth":32,"hideuserprofileinfo":"put_empty","boxghostmessage":0,"userdeletetmessage":0,"latestcategory_in":1,"topicicons":1,"debug":0,"catsautosubscribed":0,"showbannedreason":0,"version_check":1,"showthankyou":1,"showpopthankyoustats":1,"popthankscount":5,"mod_see_deleted":0,"bbcode_img_secure":"text","listcat_show_moderators":1,"lightbox":1,"show_list_time":720,"show_session_type":0,"show_session_starttime":0,"userlist_allowed":0,"userlist_count_users":1,"enable_threaded_layouts":0,"category_subscriptions":"post","topic_subscriptions":"every","pubprofile":1,"thankyou_max":10,"email_recipient_count":0,"email_recipient_privacy":"bcc","email_visible_address":"","captcha_post_limit":0,"recaptcha_publickey":"","recaptcha_privatekey":"","recaptcha_theme":"white","keywords":1,"userkeywords":0,"image_upload":"registered","file_upload":"registered","topic_layout":"flat","time_to_create_page":1,"show_imgfiles_manage_profile":1,"hold_newusers_posts":0,"hold_guest_posts":0,"attachment_limit":8,"pickup_category":0,"article_display":"intro","send_emails":1,"stopforumspam_key":"","fallback_english":1,"cache":1,"cache_time":60,"ebay_affiliate_id":5337089937,"iptracking":1,"plugins":{"plg_system_kunena":{}}}');

DROP TABLE IF EXISTS `#__kunena_keywords`;
CREATE TABLE `#__kunena_keywords` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(40) NOT NULL,
  `public_count` int(11) NOT NULL,
  `total_count` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `public_count` (`public_count`),
  KEY `total_count` (`total_count`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__kunena_keywords_map`;
CREATE TABLE `#__kunena_keywords_map` (
  `keyword_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `topic_id` int(11) NOT NULL,
  UNIQUE KEY `keyword_user_topic` (`keyword_id`,`user_id`,`topic_id`),
  KEY `user_id` (`user_id`),
  KEY `topic_user` (`topic_id`,`user_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__kunena_messages`;
CREATE TABLE `#__kunena_messages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent` int(11) DEFAULT '0',
  `thread` int(11) DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `name` tinytext,
  `userid` int(11) NOT NULL DEFAULT '0',
  `email` tinytext,
  `subject` tinytext,
  `time` int(11) NOT NULL DEFAULT '0',
  `ip` varchar(128) DEFAULT NULL,
  `topic_emoticon` int(11) NOT NULL DEFAULT '0',
  `locked` tinyint(4) NOT NULL DEFAULT '0',
  `hold` tinyint(4) NOT NULL DEFAULT '0',
  `ordering` int(11) DEFAULT '0',
  `hits` int(11) DEFAULT '0',
  `moved` tinyint(4) DEFAULT '0',
  `modified_by` int(7) DEFAULT NULL,
  `modified_time` int(11) DEFAULT NULL,
  `modified_reason` tinytext,
  PRIMARY KEY (`id`),
  KEY `thread` (`thread`),
  KEY `ip` (`ip`),
  KEY `userid` (`userid`),
  KEY `time` (`time`),
  KEY `locked` (`locked`),
  KEY `hold_time` (`hold`,`time`),
  KEY `parent_hits` (`parent`,`hits`),
  KEY `catid_parent` (`catid`,`parent`)
) ENGINE=MyISAM ;

INSERT INTO `#__kunena_messages` (`id`, `parent`, `thread`, `catid`, `name`, `userid`, `email`, `subject`, `time`, `ip`, `topic_emoticon`, `locked`, `hold`, `ordering`, `hits`, `moved`, `modified_by`, `modified_time`, `modified_reason`) VALUES
(1, 0, 1, 2, 'Kunena', 42, NULL, 'Welcome to Kunena!', 1350459317, '127.0.0.1', 0, 0, 0, 0, 0, 0, NULL, NULL, NULL);

DROP TABLE IF EXISTS `#__kunena_messages_text`;
CREATE TABLE `#__kunena_messages_text` (
  `mesid` int(11) NOT NULL DEFAULT '0',
  `message` text NOT NULL,
  PRIMARY KEY (`mesid`)
) ENGINE=MyISAM;

INSERT INTO `#__kunena_messages_text` (`mesid`, `message`) VALUES
(1, '[size=4][b]Welcome to Kunena![/b][/size] \n\n Thank you for choosing Kunena for your community forum needs in Joomla. \n\n Kunena, translated from Swahili meaning “to speak”, is built by a team of open source professionals with the goal of providing a top quality, tightly unified forum solution for Joomla. \n\n\n [size=4][b]Additional Kunena Resources[/b][/size] \n\n [b]Kunena Documentation:[/b] [url]http://www.kunena.org/docs[/url] \n\n [b]Kunena Support Forum[/b]: [url]http://www.kunena.org/forum[/url] \n\n [b]Kunena Downloads:[/b] [url]http://www.kunena.org/download[/url] \n\n [b]Kunena Blog:[/b] [url]http://www.kunena.org/blog[/url] \n\n [b]Follow Kunena on Twitter:[/b] [url]http://www.kunena.org/twitter[/url]');

DROP TABLE IF EXISTS `#__kunena_polls`;
CREATE TABLE `#__kunena_polls` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `threadid` int(11) NOT NULL,
  `polltimetolive` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `threadid` (`threadid`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__kunena_polls_options`;
CREATE TABLE `#__kunena_polls_options` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `pollid` int(11) DEFAULT NULL,
  `text` varchar(100) DEFAULT NULL,
  `votes` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `pollid` (`pollid`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__kunena_polls_users`;
CREATE TABLE `#__kunena_polls_users` (
  `pollid` int(11) DEFAULT NULL,
  `userid` int(11) DEFAULT NULL,
  `votes` int(11) DEFAULT NULL,
  `lasttime` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvote` int(11) DEFAULT NULL,
  UNIQUE KEY `pollid` (`pollid`,`userid`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__kunena_ranks`;
CREATE TABLE `#__kunena_ranks` (
  `rank_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `rank_title` varchar(255) NOT NULL DEFAULT '',
  `rank_min` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `rank_special` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `rank_image` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`rank_id`)
) ENGINE=MyISAM ;

INSERT INTO `#__kunena_ranks` (`rank_id`, `rank_title`, `rank_min`, `rank_special`, `rank_image`) VALUES
(1, 'Fresh Boarder', 0, 0, 'rank1.gif'),
(2, 'Junior Boarder', 20, 0, 'rank2.gif'),
(3, 'Senior Boarder', 40, 0, 'rank3.gif'),
(4, 'Expert Boarder', 80, 0, 'rank4.gif'),
(5, 'Gold Boarder', 160, 0, 'rank5.gif'),
(6, 'Platinum Boarder', 320, 0, 'rank6.gif'),
(7, 'Administrator', 0, 1, 'rankadmin.gif'),
(8, 'Moderator', 0, 1, 'rankmod.gif'),
(9, 'Spammer', 0, 1, 'rankspammer.gif'),
(10, 'Banned', 0, 1, 'rankbanned.gif');

DROP TABLE IF EXISTS `#__kunena_sessions`;
CREATE TABLE `#__kunena_sessions` (
  `userid` int(11) NOT NULL DEFAULT '0',
  `allowed` text,
  `lasttime` int(11) NOT NULL DEFAULT '0',
  `readtopics` text,
  `currvisit` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`userid`),
  KEY `currvisit` (`currvisit`)
) ENGINE=MyISAM;

INSERT INTO `#__kunena_sessions` (`userid`, `allowed`, `lasttime`, `readtopics`, `currvisit`) VALUES
(42, 'na', 1352707691, '0', 1353917291);

DROP TABLE IF EXISTS `#__kunena_smileys`;
CREATE TABLE `#__kunena_smileys` (
  `id` int(4) NOT NULL AUTO_INCREMENT,
  `code` varchar(12) NOT NULL DEFAULT '',
  `location` varchar(50) NOT NULL DEFAULT '',
  `greylocation` varchar(60) NOT NULL DEFAULT '',
  `emoticonbar` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM ;

INSERT INTO `#__kunena_smileys` (`id`, `code`, `location`, `greylocation`, `emoticonbar`) VALUES
(1, 'B)', 'cool.png', 'cool-grey.png', 1),
(2, '8)', 'cool.png', 'cool-grey.png', 0),
(3, '8-)', 'cool.png', 'cool-grey.png', 0),
(4, ':-(', 'sad.png', 'sad-grey.png', 0),
(5, ':(', 'sad.png', 'sad-grey.png', 1),
(6, ':sad:', 'sad.png', 'sad-grey.png', 0),
(7, ':cry:', 'sad.png', 'sad-grey.png', 0),
(8, ':)', 'smile.png', 'smile-grey.png', 1),
(9, ':-)', 'smile.png', 'smile-grey.png', 0),
(10, ':cheer:', 'cheerful.png', 'cheerful-grey.png', 1),
(11, ';)', 'wink.png', 'wink-grey.png', 1),
(12, ';-)', 'wink.png', 'wink-grey.png', 0),
(13, ':wink:', 'wink.png', 'wink-grey.png', 0),
(14, ';-)', 'wink.png', 'wink-grey.png', 0),
(15, ':P', 'tongue.png', 'tongue-grey.png', 1),
(16, ':p', 'tongue.png', 'tongue-grey.png', 0),
(17, ':-p', 'tongue.png', 'tongue-grey.png', 0),
(18, ':-P', 'tongue.png', 'tongue-grey.png', 0),
(19, ':razz:', 'tongue.png', 'tongue-grey.png', 0),
(20, ':angry:', 'angry.png', 'angry-grey.png', 1),
(21, ':mad:', 'angry.png', 'angry-grey.png', 0),
(22, ':unsure:', 'unsure.png', 'unsure-grey.png', 1),
(23, ':o', 'shocked.png', 'shocked-grey.png', 0),
(24, ':-o', 'shocked.png', 'shocked-grey.png', 0),
(25, ':O', 'shocked.png', 'shocked-grey.png', 0),
(26, ':-O', 'shocked.png', 'shocked-grey.png', 0),
(27, ':eek:', 'shocked.png', 'shocked-grey.png', 0),
(28, ':ohmy:', 'shocked.png', 'shocked-grey.png', 1),
(29, ':huh:', 'wassat.png', 'wassat-grey.png', 1),
(30, ':?', 'confused.png', 'confused-grey.png', 0),
(31, ':-?', 'confused.png', 'confused-grey.png', 0),
(32, ':???', 'confused.png', 'confused-grey.png', 0),
(33, ':dry:', 'ermm.png', 'ermm-grey.png', 1),
(34, ':ermm:', 'ermm.png', 'ermm-grey.png', 0),
(35, ':lol:', 'grin.png', 'grin-grey.png', 1),
(36, ':X', 'sick.png', 'sick-grey.png', 0),
(37, ':x', 'sick.png', 'sick-grey.png', 0),
(38, ':sick:', 'sick.png', 'sick-grey.png', 1),
(39, ':silly:', 'silly.png', 'silly-grey.png', 1),
(40, ':y32b4:', 'silly.png', 'silly-grey.png', 0),
(41, ':blink:', 'blink.png', 'blink-grey.png', 1),
(42, ':blush:', 'blush.png', 'blush-grey.png', 1),
(43, ':oops:', 'blush.png', 'blush-grey.png', 1),
(44, ':kiss:', 'kissing.png', 'kissing-grey.png', 1),
(45, ':rolleyes:', 'blink.png', 'blink-grey.png', 0),
(46, ':roll:', 'blink.png', 'blink-grey.png', 0),
(47, ':woohoo:', 'w00t.png', 'w00t-grey.png', 1),
(48, ':side:', 'sideways.png', 'sideways-grey.png', 1),
(49, ':S', 'dizzy.png', 'dizzy-grey.png', 1),
(50, ':s', 'dizzy.png', 'dizzy-grey.png', 0),
(51, ':evil:', 'devil.png', 'devil-grey.png', 1),
(52, ':twisted:', 'devil.png', 'devil-grey.png', 0),
(53, ':whistle:', 'whistling.png', 'whistling-grey.png', 1),
(54, ':pinch:', 'pinch.png', 'pinch-grey.png', 1),
(55, ':D', 'laughing.png', 'laughing-grey.png', 0),
(56, ':-D', 'laughing.png', 'laughing-grey.png', 0),
(57, ':grin:', 'laughing.png', 'laughing-grey.png', 0),
(58, ':laugh:', 'laughing.png', 'laughing-grey.png', 0),
(59, ':|', 'neutral.png', 'neutral-grey.png', 0),
(60, ':-|', 'neutral.png', 'neutral-grey.png', 0),
(61, ':neutral:', 'neutral.png', 'neutral-grey.png', 0),
(62, ':mrgreen:', 'mrgreen.png', 'mrgreen-grey.png', 0),
(63, ':?:', 'question.png', 'question-grey.png', 0),
(64, ':!:', 'exclamation.png', 'exclamation-grey.png', 0),
(65, ':arrow:', 'arrow.png', 'arrow-grey.png', 0),
(66, ':idea:', 'idea.png', 'idea-grey.png', 0);

DROP TABLE IF EXISTS `#__kunena_thankyou`;
CREATE TABLE `#__kunena_thankyou` (
  `postid` int(11) NOT NULL,
  `userid` int(11) NOT NULL,
  `targetuserid` int(11) NOT NULL,
  `time` datetime NOT NULL,
  UNIQUE KEY `postid` (`postid`,`userid`),
  KEY `userid` (`userid`),
  KEY `targetuserid` (`targetuserid`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__kunena_topics`;
CREATE TABLE `#__kunena_topics` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `category_id` int(11) NOT NULL DEFAULT '0',
  `subject` tinytext,
  `icon_id` int(11) NOT NULL DEFAULT '0',
  `locked` tinyint(4) NOT NULL DEFAULT '0',
  `hold` tinyint(4) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `posts` int(11) NOT NULL DEFAULT '0',
  `hits` int(11) NOT NULL DEFAULT '0',
  `attachments` int(11) NOT NULL DEFAULT '0',
  `poll_id` int(11) NOT NULL DEFAULT '0',
  `moved_id` int(11) NOT NULL DEFAULT '0',
  `first_post_id` int(11) NOT NULL DEFAULT '0',
  `first_post_time` int(11) NOT NULL DEFAULT '0',
  `first_post_userid` int(11) NOT NULL DEFAULT '0',
  `first_post_message` text,
  `first_post_guest_name` tinytext,
  `last_post_id` int(11) NOT NULL DEFAULT '0',
  `last_post_time` int(11) NOT NULL DEFAULT '0',
  `last_post_userid` int(11) NOT NULL DEFAULT '0',
  `last_post_message` text,
  `last_post_guest_name` tinytext,
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category_id` (`category_id`),
  KEY `locked` (`locked`),
  KEY `hold` (`hold`),
  KEY `posts` (`posts`),
  KEY `hits` (`hits`),
  KEY `first_post_userid` (`first_post_userid`),
  KEY `last_post_userid` (`last_post_userid`),
  KEY `first_post_time` (`first_post_time`),
  KEY `last_post_time` (`last_post_time`)
) ENGINE=MyISAM ;

INSERT INTO `#__kunena_topics` (`id`, `category_id`, `subject`, `icon_id`, `locked`, `hold`, `ordering`, `posts`, `hits`, `attachments`, `poll_id`, `moved_id`, `first_post_id`, `first_post_time`, `first_post_userid`, `first_post_message`, `first_post_guest_name`, `last_post_id`, `last_post_time`, `last_post_userid`, `last_post_message`, `last_post_guest_name`, `params`) VALUES
(1, 2, 'Welcome to Kunena!', 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1350459317, 42, '[size=4][b]Welcome to Kunena![/b][/size] \n\n Thank you for choosing Kunena for your community forum needs in Joomla. \n\n Kunena, translated from Swahili meaning “to speak”, is built by a team of open source professionals with the goal of providing a top quality, tightly unified forum solution for Joomla. \n\n\n [size=4][b]Additional Kunena Resources[/b][/size] \n\n [b]Kunena Documentation:[/b] [url]http://www.kunena.org/docs[/url] \n\n [b]Kunena Support Forum[/b]: [url]http://www.kunena.org/forum[/url] \n\n [b]Kunena Downloads:[/b] [url]http://www.kunena.org/download[/url] \n\n [b]Kunena Blog:[/b] [url]http://www.kunena.org/blog[/url] \n\n [b]Follow Kunena on Twitter:[/b] [url]http://www.kunena.org/twitter[/url]', 'Kunena', 1, 1350459317, 42, '[size=4][b]Welcome to Kunena![/b][/size] \n\n Thank you for choosing Kunena for your community forum needs in Joomla. \n\n Kunena, translated from Swahili meaning “to speak”, is built by a team of open source professionals with the goal of providing a top quality, tightly unified forum solution for Joomla. \n\n\n [size=4][b]Additional Kunena Resources[/b][/size] \n\n [b]Kunena Documentation:[/b] [url]http://www.kunena.org/docs[/url] \n\n [b]Kunena Support Forum[/b]: [url]http://www.kunena.org/forum[/url] \n\n [b]Kunena Downloads:[/b] [url]http://www.kunena.org/download[/url] \n\n [b]Kunena Blog:[/b] [url]http://www.kunena.org/blog[/url] \n\n [b]Follow Kunena on Twitter:[/b] [url]http://www.kunena.org/twitter[/url]', 'Kunena', '');

DROP TABLE IF EXISTS `#__kunena_user_categories`;
CREATE TABLE `#__kunena_user_categories` (
  `user_id` int(11) NOT NULL,
  `category_id` int(11) NOT NULL,
  `role` tinyint(4) NOT NULL DEFAULT '0',
  `allreadtime` datetime DEFAULT NULL,
  `subscribed` tinyint(4) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  PRIMARY KEY (`user_id`,`category_id`),
  KEY `category_subscribed` (`category_id`,`subscribed`),
  KEY `role` (`role`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__kunena_user_read`;
CREATE TABLE `#__kunena_user_read` (
  `user_id` int(11) NOT NULL,
  `topic_id` int(11) NOT NULL,
  `category_id` int(11) NOT NULL,
  `message_id` int(11) NOT NULL,
  `time` int(11) NOT NULL,
  UNIQUE KEY `user_topic_id` (`user_id`,`topic_id`),
  KEY `category_user_id` (`category_id`,`user_id`),
  KEY `time` (`time`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__kunena_user_topics`;
CREATE TABLE `#__kunena_user_topics` (
  `user_id` int(11) NOT NULL DEFAULT '0',
  `topic_id` int(11) NOT NULL DEFAULT '0',
  `category_id` int(11) NOT NULL,
  `posts` mediumint(8) NOT NULL DEFAULT '0',
  `last_post_id` int(11) NOT NULL DEFAULT '0',
  `owner` tinyint(4) NOT NULL DEFAULT '0',
  `favorite` tinyint(4) NOT NULL DEFAULT '0',
  `subscribed` tinyint(4) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  UNIQUE KEY `user_topic_id` (`user_id`,`topic_id`),
  KEY `topic_id` (`topic_id`),
  KEY `posts` (`posts`),
  KEY `owner` (`owner`),
  KEY `favorite` (`favorite`),
  KEY `subscribed` (`subscribed`)
) ENGINE=MyISAM;

INSERT INTO `#__kunena_user_topics` (`user_id`, `topic_id`, `category_id`, `posts`, `last_post_id`, `owner`, `favorite`, `subscribed`, `params`) VALUES
(42, 1, 2, 1, 1, 1, 0, 0, '');

DROP TABLE IF EXISTS `#__kunena_users`;
CREATE TABLE `#__kunena_users` (
  `userid` int(11) NOT NULL DEFAULT '0',
  `view` varchar(8) NOT NULL DEFAULT 'flat',
  `signature` text,
  `moderator` int(11) DEFAULT '0',
  `banned` datetime DEFAULT NULL,
  `ordering` int(11) DEFAULT '0',
  `posts` int(11) DEFAULT '0',
  `avatar` varchar(255) DEFAULT NULL,
  `karma` int(11) DEFAULT '0',
  `karma_time` int(11) DEFAULT '0',
  `group_id` int(4) DEFAULT '1',
  `uhits` int(11) DEFAULT '0',
  `personalText` tinytext,
  `gender` tinyint(4) NOT NULL DEFAULT '0',
  `birthdate` date NOT NULL DEFAULT '0001-01-01',
  `location` varchar(50) DEFAULT NULL,
  `icq` varchar(50) DEFAULT NULL,
  `aim` varchar(50) DEFAULT NULL,
  `yim` varchar(50) DEFAULT NULL,
  `msn` varchar(50) DEFAULT NULL,
  `skype` varchar(50) DEFAULT NULL,
  `twitter` varchar(50) DEFAULT NULL,
  `facebook` varchar(50) DEFAULT NULL,
  `gtalk` varchar(50) DEFAULT NULL,
  `myspace` varchar(50) DEFAULT NULL,
  `linkedin` varchar(50) DEFAULT NULL,
  `delicious` varchar(50) DEFAULT NULL,
  `friendfeed` varchar(50) DEFAULT NULL,
  `digg` varchar(50) DEFAULT NULL,
  `blogspot` varchar(50) DEFAULT NULL,
  `flickr` varchar(50) DEFAULT NULL,
  `bebo` varchar(50) DEFAULT NULL,
  `websitename` varchar(50) DEFAULT NULL,
  `websiteurl` varchar(50) DEFAULT NULL,
  `rank` tinyint(4) NOT NULL DEFAULT '0',
  `hideEmail` tinyint(1) NOT NULL DEFAULT '1',
  `showOnline` tinyint(1) NOT NULL DEFAULT '1',
  `thankyou` int(11) DEFAULT '0',
  PRIMARY KEY (`userid`),
  KEY `group_id` (`group_id`),
  KEY `posts` (`posts`),
  KEY `uhits` (`uhits`),
  KEY `banned` (`banned`),
  KEY `moderator` (`moderator`)
) ENGINE=MyISAM;

INSERT INTO `#__kunena_users` (`userid`, `view`, `signature`, `moderator`, `banned`, `ordering`, `posts`, `avatar`, `karma`, `karma_time`, `group_id`, `uhits`, `personalText`, `gender`, `birthdate`, `location`, `icq`, `aim`, `yim`, `msn`, `skype`, `twitter`, `facebook`, `gtalk`, `myspace`, `linkedin`, `delicious`, `friendfeed`, `digg`, `blogspot`, `flickr`, `bebo`, `websitename`, `websiteurl`, `rank`, `hideEmail`, `showOnline`, `thankyou`) VALUES
(42, 'flat', NULL, 0, NULL, 0, 1, NULL, 0, 0, 1, 0, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, 0);

DROP TABLE IF EXISTS `#__kunena_users_banned`;
CREATE TABLE `#__kunena_users_banned` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) DEFAULT NULL,
  `ip` varchar(128) DEFAULT NULL,
  `blocked` tinyint(4) NOT NULL DEFAULT '0',
  `expiration` datetime DEFAULT NULL,
  `created_by` int(11) NOT NULL,
  `created_time` datetime NOT NULL,
  `reason_private` text,
  `reason_public` text,
  `modified_by` int(11) DEFAULT NULL,
  `modified_time` datetime DEFAULT NULL,
  `comments` text,
  `params` text,
  PRIMARY KEY (`id`),
  KEY `userid` (`userid`),
  KEY `ip` (`ip`),
  KEY `expiration` (`expiration`),
  KEY `created_time` (`created_time`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__kunena_version`;
CREATE TABLE `#__kunena_version` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `version` varchar(20) NOT NULL,
  `versiondate` date NOT NULL,
  `installdate` date NOT NULL,
  `build` varchar(20) NOT NULL,
  `versionname` varchar(40) DEFAULT NULL,
  `state` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM ;

INSERT INTO `#__kunena_version` (`id`, `version`, `versiondate`, `installdate`, `build`, `versionname`, `state`) VALUES
(1, '2.0.2', '2012-09-02', '2012-10-17', '', 'Botschafter', '');

DROP TABLE IF EXISTS `#__languages`;
CREATE TABLE `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_image` (`image`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_ordering` (`ordering`)
) ENGINE=MyISAM ;

INSERT INTO `#__languages` (`lang_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `sitename`, `published`, `access`, `ordering`) VALUES
(1, 'en-GB', 'English (UK)', 'English (UK)', 'en', 'en', '', '', '', '', 1, 0, 1);

DROP TABLE IF EXISTS `#__menu`;
CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to j40f79_menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) binary NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to j40f79_extensions.id',
  `ordering` int(11) NOT NULL DEFAULT '0' COMMENT 'The relative ordering of the menu item in the tree.',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to j40f79_users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(333)),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(1, '', 'Menu_Item_Root', 'root', '', '', '', '', 1, 0, 0, 0, 0, 0, '0000-00-00 00:00:00', 0, 0, '', 0, '', 0, 461, 0, '*', 0),
(2, 'menu', 'com_banners', 'Banners', '', 'Banners', 'index.php?option=com_banners', 'component', 0, 1, 1, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 31, 40, 0, '*', 1),
(3, 'menu', 'com_banners', 'Banners', '', 'Banners/Banners', 'index.php?option=com_banners', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 32, 33, 0, '*', 1),
(4, 'menu', 'com_banners_categories', 'Categories', '', 'Banners/Categories', 'index.php?option=com_categories&extension=com_banners', 'component', 0, 2, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-cat', 0, '', 34, 35, 0, '*', 1),
(5, 'menu', 'com_banners_clients', 'Clients', '', 'Banners/Clients', 'index.php?option=com_banners&view=clients', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-clients', 0, '', 36, 37, 0, '*', 1),
(6, 'menu', 'com_banners_tracks', 'Tracks', '', 'Banners/Tracks', 'index.php?option=com_banners&view=tracks', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-tracks', 0, '', 38, 39, 0, '*', 1),
(7, 'menu', 'com_contact', 'Contacts', '', 'Contacts', 'index.php?option=com_contact', 'component', 0, 1, 1, 8, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 41, 46, 0, '*', 1),
(8, 'menu', 'com_contact', 'Contacts', '', 'Contacts/Contacts', 'index.php?option=com_contact', 'component', 0, 7, 2, 8, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 42, 43, 0, '*', 1),
(9, 'menu', 'com_contact_categories', 'Categories', '', 'Contacts/Categories', 'index.php?option=com_categories&extension=com_contact', 'component', 0, 7, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact-cat', 0, '', 44, 45, 0, '*', 1),
(10, 'menu', 'com_messages', 'Messaging', '', 'Messaging', 'index.php?option=com_messages', 'component', 0, 1, 1, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages', 0, '', 49, 54, 0, '*', 1),
(11, 'menu', 'com_messages_add', 'New Private Message', '', 'Messaging/New Private Message', 'index.php?option=com_messages&task=message.add', 'component', 0, 10, 2, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-add', 0, '', 50, 51, 0, '*', 1),
(12, 'menu', 'com_messages_read', 'Read Private Message', '', 'Messaging/Read Private Message', 'index.php?option=com_messages', 'component', 0, 10, 2, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-read', 0, '', 52, 53, 0, '*', 1),
(13, 'menu', 'com_newsfeeds', 'News Feeds', '', 'News Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 1, 1, 17, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 55, 60, 0, '*', 1),
(14, 'menu', 'com_newsfeeds_feeds', 'Feeds', '', 'News Feeds/Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 13, 2, 17, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 56, 57, 0, '*', 1),
(15, 'menu', 'com_newsfeeds_categories', 'Categories', '', 'News Feeds/Categories', 'index.php?option=com_categories&extension=com_newsfeeds', 'component', 0, 13, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds-cat', 0, '', 58, 59, 0, '*', 1),
(16, 'menu', 'com_redirect', 'Redirect', '', 'Redirect', 'index.php?option=com_redirect', 'component', 0, 1, 1, 24, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:redirect', 0, '', 71, 72, 0, '*', 1),
(17, 'menu', 'com_search', 'Search', '', 'Search', 'index.php?option=com_search', 'component', 0, 1, 1, 19, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:search', 0, '', 61, 62, 0, '*', 1),
(18, 'menu', 'com_weblinks', 'Weblinks', '', 'Weblinks', 'index.php?option=com_weblinks', 'component', 0, 1, 1, 21, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 65, 70, 0, '*', 1),
(19, 'menu', 'com_weblinks_links', 'Links', '', 'Weblinks/Links', 'index.php?option=com_weblinks', 'component', 0, 18, 2, 21, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 66, 67, 0, '*', 1),
(20, 'menu', 'com_weblinks_categories', 'Categories', '', 'Weblinks/Categories', 'index.php?option=com_categories&extension=com_weblinks', 'component', 0, 18, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks-cat', 0, '', 68, 69, 0, '*', 1),
(464, 'top', 'Our Gallery', 'home', '', 'home', '#', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 241, 242, 0, '*', 0),
(227, 'aboutjoomla', 'Weblinks Categories', 'weblinks-categories', '', 'using-joomla/extensions/components/weblinks-component/weblinks-categories', 'index.php?option=com_weblinks&view=categories&id=18', 'component', 1, 265, 5, 21, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevelcat":"-1","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_num_links_cat":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"-1","show_empty_categories":"","show_subcat_desc":"","show_cat_num_links":"","show_pagination_limit":"","show_headings":"","show_link_description":"","show_link_hits":"","show_pagination":"","show_pagination_results":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 107, 108, 0, '*', 0),
(611, 'mainmenu', 'Asia', 'asia', '', 'all-category/asia', 'index.php?option=com_content&view=category&layout=blog&id=82', 'component', 1, 602, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 318, 319, 0, '*', 0),
(229, 'aboutjoomla', 'Single Contact', 'single-contact', '', 'using-joomla/extensions/components/contact-component/single-contact', 'index.php?option=com_contact&view=contact&id=1', 'component', 1, 270, 5, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_crumb":"","presentation_style":"","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 97, 98, 0, '*', 0),
(201, 'usermenu', 'Your Profile', 'your-profile', '', 'your-profile', 'index.php?option=com_users&view=profile', 'component', 1, 1, 1, 25, 0, 0, '0000-00-00 00:00:00', 0, 2, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 251, 252, 0, '*', 0),
(296, 'parks', 'Park Links', 'park-links', '', 'park-links', 'index.php?option=com_weblinks&view=category&id=31', 'component', 1, 1, 1, 21, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"-1","show_empty_categories":"","show_description":"1","show_description_image":"1","show_cat_num_articles":"","display_num":"","show_headings":"0","orderby_pri":"","show_pagination":"","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 265, 266, 0, 'en-GB', 0),
(234, 'parks', 'Park Blog', 'park-blog', '', 'park-blog', 'index.php?option=com_content&view=category&layout=blog&id=27', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"1","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"1","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 255, 256, 0, 'en-GB', 0),
(207, 'top', 'About Joomla! 2.5', 'about-joomla-25', '', 'about-joomla-25', 'index.php?option=com_content&view=article&id=24', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 249, 250, 0, '*', 0),
(242, 'parks', 'Write a Blog Post', 'write-a-blog-post', '', 'write-a-blog-post', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 3, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 257, 258, 0, 'en-GB', 0),
(243, 'parks', 'Parks Home', 'parks-home', '', 'parks-home', 'index.php?option=com_content&view=article&id=6', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"0","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"","show_print_icon":"0","show_email_icon":"0","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 253, 254, 0, 'en-GB', 0),
(244, 'parks', 'Image Gallery', 'image-gallery', '', 'image-gallery', 'index.php?option=com_content&view=categories&id=28', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"1","categories_description":"","maxLevelcat":"","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_num_articles_cat":"","drill_down_layout":"1","show_category_title":"","show_description":"1","show_description_image":"1","maxLevel":"-1","show_empty_categories":"","show_subcat_desc":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 259, 264, 0, 'en-GB', 0),
(270, 'aboutjoomla', 'Contact Component', 'contact-component', '', 'using-joomla/extensions/components/contact-component', 'index.php?option=com_content&view=article&id=9', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 92, 101, 0, '*', 0),
(279, 'aboutjoomla', 'The Joomla! Community', 'the-joomla-community', '', 'the-joomla-community', 'index.php?option=com_content&view=article&id=47', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"0","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 245, 246, 0, '*', 0),
(249, 'aboutjoomla', 'Submit a Weblink', 'submit-a-weblink', '', 'using-joomla/extensions/components/weblinks-component/submit-a-weblink', 'index.php?option=com_weblinks&view=form&layout=edit', 'component', 1, 265, 5, 21, 0, 0, '0000-00-00 00:00:00', 0, 3, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 103, 104, 0, '*', 0),
(251, 'aboutjoomla', 'Contact Categories', 'contact-categories', '', 'using-joomla/extensions/components/contact-component/contact-categories', 'index.php?option=com_contact&view=categories&id=16', 'component', 1, 270, 5, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","filter_field":"","show_pagination":"","show_noauth":"","presentation_style":"sliders","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 93, 94, 0, '*', 0),
(252, 'aboutjoomla', 'News Feed Categories', 'new-feed-categories', '', 'using-joomla/extensions/components/news-feeds-component/new-feed-categories', 'index.php?option=com_newsfeeds&view=categories&id=0', 'component', 1, 267, 5, 17, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"1","categories_description":"Because this links to the root category the \\"uncategorised\\" category is displayed. ","maxLevel":"-1","show_empty_categories":"1","show_description":"1","show_description_image":"1","show_cat_num_articles":"1","display_num":"","show_headings":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 111, 112, 0, '*', 0),
(253, 'aboutjoomla', 'News Feed Category', 'news-feed-category', '', 'using-joomla/extensions/components/news-feeds-component/news-feed-category', 'index.php?option=com_newsfeeds&view=category&id=17', 'component', 1, 267, 5, 17, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 115, 116, 0, '*', 0),
(254, 'aboutjoomla', 'Single News Feed', 'single-news-feed', '', 'using-joomla/extensions/components/news-feeds-component/single-news-feed', 'index.php?option=com_newsfeeds&view=newsfeed&id=4', 'component', 1, 267, 5, 17, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 113, 114, 0, '*', 0),
(255, 'aboutjoomla', 'Search', 'search', '', 'using-joomla/extensions/components/search-component/search', 'index.php?option=com_search&view=search', 'component', 1, 276, 5, 19, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"search_areas":"1","show_date":"1","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 133, 134, 0, '*', 0),
(256, 'aboutjoomla', 'Archived Articles', 'archived-articles', '', 'using-joomla/extensions/components/content-component/archived-articles', 'index.php?option=com_content&view=archive', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"orderby_sec":"","order_date":"","display_num":"","filter_field":"","show_category":"1","link_category":"1","show_title":"1","link_titles":"1","show_intro":"1","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_hits":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 87, 88, 0, '*', 0),
(257, 'aboutjoomla', 'Single Article', 'single-article', '', 'using-joomla/extensions/components/content-component/single-article', 'index.php?option=com_content&view=article&id=6', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 77, 78, 0, '*', 0),
(278, 'aboutjoomla', 'The Joomla! Project', 'the-joomla-project', '', 'the-joomla-project', 'index.php?option=com_content&view=article&id=48', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"1","link_titles":"","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"1","show_print_icon":"","show_email_icon":"","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 243, 244, 0, '*', 0),
(259, 'aboutjoomla', 'Article Category Blog', 'article-category-blog', '', 'using-joomla/extensions/components/content-component/article-category-blog', 'index.php?option=com_content&view=category&layout=blog&id=27', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"0","show_description_image":"0","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 81, 82, 0, '*', 0),
(260, 'aboutjoomla', 'Article Category List', 'article-category-list', '', 'using-joomla/extensions/components/content-component/article-category-list', 'index.php?option=com_content&view=category&id=19', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","orderby_pri":"","orderby_sec":"alpha","order_date":"","show_pagination":"","show_pagination_results":"","display_num":"10","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 83, 84, 0, '*', 0),
(262, 'aboutjoomla', 'Featured Articles', 'featured-articles', '', 'using-joomla/extensions/components/content-component/featured-articles', 'index.php?option=com_content&view=featured', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 85, 86, 0, '*', 0),
(263, 'aboutjoomla', 'Submit Article', 'submit-article', '', 'using-joomla/extensions/components/content-component/submit-article', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 3, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 89, 90, 0, '*', 0),
(265, 'aboutjoomla', 'Weblinks Component', 'weblinks-component', '', 'using-joomla/extensions/components/weblinks-component', 'index.php?option=com_content&view=article&id=54', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 102, 109, 0, '*', 0),
(266, 'aboutjoomla', 'Content Component', 'content-component', '', 'using-joomla/extensions/components/content-component', 'index.php?option=com_content&view=article&id=10', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"article-allow_ratings":"","article-allow_comments":"","show_category":"","link_category":"","show_title":"","link_titles":"","show_intro":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 76, 91, 0, '*', 0),
(267, 'aboutjoomla', 'News Feeds Component', 'news-feeds-component', '', 'using-joomla/extensions/components/news-feeds-component', 'index.php?option=com_content&view=article&id=60', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"Newsfeeds Categories View ","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 110, 117, 0, '*', 0),
(268, 'aboutjoomla', 'Components', 'components', '', 'using-joomla/extensions/components', 'index.php?option=com_content&view=category&layout=blog&id=21', 'component', 1, 277, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"1","show_description_image":"","maxLevel":"","show_empty_categories":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"7","num_columns":"1","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"0","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_readmore":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 75, 138, 0, '*', 0),
(277, 'aboutjoomla', 'Using Extensions', 'extensions', '', 'using-joomla/extensions', 'index.php?option=com_content&view=categories&id=20', 'component', 1, 280, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"1","categories_description":"","maxLevelcat":"1","show_empty_categories_cat":"1","show_subcat_desc_cat":"1","show_cat_num_articles_cat":"0","drill_down_layout":"0","show_category_title":"","show_description":"1","show_description_image":"1","maxLevel":"1","show_empty_categories":"1","show_subcat_desc":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 74, 235, 0, '*', 0),
(271, 'aboutjoomla', 'Users Component', 'users-component', '', 'using-joomla/extensions/components/users-component', 'index.php?option=com_content&view=article&id=52', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 118, 131, 0, '*', 0),
(272, 'aboutjoomla', 'Article Categories', 'article-categories', '', 'using-joomla/extensions/components/content-component/article-categories', 'index.php?option=com_content&view=categories&id=14', 'component', 1, 266, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","category_layout":"","show_headings":"","show_date":"","date_format":"","filter_field":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 79, 80, 0, '*', 0),
(273, 'aboutjoomla', 'Administrator Components', 'administrator-components', '', 'using-joomla/extensions/components/administrator-components', 'index.php?option=com_content&view=article&id=1', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 136, 137, 0, '*', 0),
(274, 'aboutjoomla', 'Weblinks Single Category', 'weblinks-single-category', '', 'using-joomla/extensions/components/weblinks-component/weblinks-single-category', 'index.php?option=com_weblinks&view=category&id=32', 'component', 1, 265, 5, 21, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","orderby_pri":"","show_pagination":"","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 105, 106, 0, '*', 0),
(275, 'aboutjoomla', 'Contact Single Category', 'contact-single-category', '', 'using-joomla/extensions/components/contact-component/contact-single-category', 'index.php?option=com_contact&view=category&catid=26&id=36', 'component', 1, 270, 5, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"20","show_headings":"","filter_field":"","show_pagination":"","show_noauth":"","presentation_style":"sliders","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 95, 96, 0, '*', 0),
(276, 'aboutjoomla', 'Search Component', 'search-component', '', 'using-joomla/extensions/components/search-component', 'index.php?option=com_content&view=article&id=39', 'component', 1, 268, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 132, 135, 0, '*', 0),
(280, 'aboutjoomla', 'Using Joomla!', 'using-joomla', '', 'using-joomla', 'index.php?option=com_content&view=article&id=53', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"1","link_titles":"0","show_intro":"1","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"0","show_noauth":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 73, 240, 0, '*', 0),
(281, 'aboutjoomla', 'Modules', 'modules', '', 'using-joomla/extensions/modules', 'index.php?option=com_content&view=category&id=22', 'component', 1, 277, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"1","show_description_image":"1","maxLevel":"1","show_empty_categories":"1","show_no_articles":"0","show_subcat_desc":"1","show_cat_num_articles":"","page_subheading":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","show_pagination":"","show_pagination_results":"","show_title":"1","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"","show_readmore":"0","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 139, 196, 0, '*', 0),
(282, 'aboutjoomla', 'Templates', 'templates', '', 'using-joomla/extensions/templates', 'index.php?option=com_content&view=category&id=23', 'component', 1, 277, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"1","show_description_image":"","maxLevel":"2","show_empty_categories":"1","show_no_articles":"0","show_subcat_desc":"1","show_cat_num_articles":"","page_subheading":"","show_pagination_limit":"0","filter_field":"hide","show_headings":"0","list_show_date":"0","date_format":"","list_show_hits":"0","list_show_author":"0","show_pagination":"0","show_pagination_results":"","show_title":"1","link_titles":"1","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"Templates","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 197, 216, 0, '*', 0),
(283, 'aboutjoomla', 'Languages', 'languages', '', 'using-joomla/extensions/languages', 'index.php?option=com_content&view=category&layout=blog&id=24', 'component', 1, 277, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"1","show_category_title":"1","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 217, 218, 0, '*', 0),
(284, 'aboutjoomla', 'Plugins', 'plugins', '', 'using-joomla/extensions/plugins', 'index.php?option=com_content&view=category&layout=blog&id=25', 'component', 1, 277, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"1","show_cat_num_articles":"","num_leading_articles":"0","num_intro_articles":"7","num_columns":"1","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"","show_readmore":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 219, 234, 0, '*', 0),
(285, 'aboutjoomla', 'Typography Atomic', 'typography-atomic', '', 'using-joomla/extensions/templates/atomic/typography-atomic', 'index.php?option=com_content&view=article&id=49', 'component', 1, 422, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 211, 212, 0, '*', 0),
(290, 'mainmenu', 'What\'s new in 2.5', 'whats-new-in-25', '', 'joomlart/whats-new-in-25', 'index.php?option=com_content&view=article&id=53', 'component', 1, 294, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"1","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 4, 13, 0, '*', 0),
(561, 'mainmenu', 'K2 component', 'k2-component', '', 'k2-component', 'index.php?option=com_content&view=article&id=76', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 335, 364, 0, '*', 0),
(712, 'main', 'K2_MEDIA_MANAGER', 'k2-media-manager', '', 'com-k2/k2-media-manager', 'index.php?option=com_k2&view=media', 'component', 0, 703, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 456, 457, 0, '', 1),
(294, 'mainmenu', 'Joomlart', 'joomlart', '', 'joomlart', 'index.php?option=com_content&view=article&id=24', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"3","mega_group":"0","mega_width":"600","mega_colw":"180","mega_colxw":"colw3=220\\r\\n","mega_class":"","mega_subcontent":"0"}', 3, 30, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(300, 'aboutjoomla', 'Latest Users', 'latest-users', '', 'using-joomla/extensions/modules/user-modules/latest-users', 'index.php?option=com_content&view=article&id=66', 'component', 1, 412, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 163, 164, 0, '*', 0),
(301, 'aboutjoomla', 'Who\'s Online', 'whos-online', '', 'using-joomla/extensions/modules/user-modules/whos-online', 'index.php?option=com_content&view=article&id=56', 'component', 1, 412, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 165, 166, 0, '*', 0),
(302, 'aboutjoomla', 'Most Read', 'most-read', '', 'using-joomla/extensions/modules/content-modules/most-read', 'index.php?option=com_content&view=article&id=30', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 147, 148, 0, '*', 0),
(303, 'aboutjoomla', 'Menu', 'menu', '', 'using-joomla/extensions/modules/navigation-modules/menu', 'index.php?option=com_content&view=article&id=29', 'component', 1, 415, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 141, 142, 0, '*', 0),
(304, 'aboutjoomla', 'Statistics', 'statistics', '', 'using-joomla/extensions/modules/utility-modules/statistics', 'index.php?option=com_content&view=article&id=44', 'component', 1, 414, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 187, 188, 0, '*', 0),
(305, 'aboutjoomla', 'Banner', 'banner', '', 'using-joomla/extensions/modules/display-modules/banner', 'index.php?option=com_content&view=article&id=7', 'component', 1, 413, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 173, 174, 0, '*', 0),
(306, 'aboutjoomla', 'Search', 'search', '', 'using-joomla/extensions/modules/utility-modules/search', 'index.php?option=com_content&view=article&id=40', 'component', 1, 414, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 189, 190, 0, '*', 0),
(307, 'aboutjoomla', 'Random Image', 'random-image', '', 'using-joomla/extensions/modules/display-modules/random-image', 'index.php?option=com_content&view=article&id=36', 'component', 1, 413, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 171, 172, 0, '*', 0),
(309, 'aboutjoomla', 'News Flash', 'news-flash', '', 'using-joomla/extensions/modules/content-modules/news-flash', 'index.php?option=com_content&view=article&id=31', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 149, 150, 0, '*', 0),
(310, 'aboutjoomla', 'Latest Articles', 'latest-articles', '', 'using-joomla/extensions/modules/content-modules/latest-articles', 'index.php?option=com_content&view=article&id=27', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 151, 152, 0, '*', 0),
(311, 'aboutjoomla', 'Syndicate', 'syndicate', '', 'using-joomla/extensions/modules/utility-modules/syndicate', 'index.php?option=com_content&view=article&id=45', 'component', 1, 414, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 185, 186, 0, '*', 0),
(312, 'aboutjoomla', 'Login', 'login', '', 'using-joomla/extensions/modules/user-modules/login', 'index.php?option=com_content&view=article&id=28', 'component', 1, 412, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 167, 168, 0, '*', 0),
(313, 'aboutjoomla', 'Wrapper', 'wrapper', '', 'using-joomla/extensions/modules/utility-modules/wrapper', 'index.php?option=com_content&view=article&id=59', 'component', 1, 414, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 193, 194, 0, '*', 0),
(316, 'aboutjoomla', 'Home Page Atomic', 'home-page-atomic', '', 'using-joomla/extensions/templates/atomic/home-page-atomic', 'index.php?option=com_content&view=featured', 'component', 1, 422, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 213, 214, 0, '*', 0),
(317, 'aboutjoomla', 'System', 'system', '', 'using-joomla/extensions/plugins/system', 'index.php?option=com_content&view=article&id=46', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 232, 233, 0, '*', 0),
(318, 'aboutjoomla', 'Authentication', 'authentication', '', 'using-joomla/extensions/plugins/authentication', 'index.php?option=com_content&view=article&id=5', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 220, 221, 0, '*', 0),
(319, 'aboutjoomla', 'Content', 'content', '', 'using-joomla/extensions/plugins/content', 'index.php?option=com_content&view=article&id=62', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 222, 223, 0, '*', 0),
(320, 'aboutjoomla', 'Editors', 'editors', '', 'using-joomla/extensions/plugins/editors', 'index.php?option=com_content&view=article&id=14', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 224, 225, 0, '*', 0),
(321, 'aboutjoomla', 'Editors Extended', 'editors-extended', '', 'using-joomla/extensions/plugins/editors-extended', 'index.php?option=com_content&view=article&id=15', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 226, 227, 0, '*', 0),
(322, 'aboutjoomla', 'Search', 'search', '', 'using-joomla/extensions/plugins/search', 'index.php?option=com_content&view=article&id=41', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 228, 229, 0, '*', 0),
(323, 'aboutjoomla', 'User', 'user', '', 'using-joomla/extensions/plugins/user', 'index.php?option=com_content&view=article&id=51', 'component', 1, 284, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 230, 231, 0, '*', 0),
(324, 'aboutjoomla', 'Footer', 'footer', '', 'using-joomla/extensions/modules/display-modules/footer', 'index.php?option=com_content&view=article&id=19', 'component', 1, 413, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 177, 178, 0, '*', 0),
(325, 'aboutjoomla', 'Archive', 'archive', '', 'using-joomla/extensions/modules/content-modules/archive', 'index.php?option=com_content&view=article&id=2', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 153, 154, 0, '*', 0),
(326, 'aboutjoomla', 'Related Items', 'related-items', '', 'using-joomla/extensions/modules/content-modules/related-items', 'index.php?option=com_content&view=article&id=37', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 155, 156, 0, '*', 0),
(399, 'parks', 'Animals', 'animals', '', 'image-gallery/animals', 'index.php?option=com_content&view=category&layout=blog&id=72', 'component', 1, 244, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"0","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"0","num_intro_articles":"6","num_columns":"2","num_links":"4","multi_column_order":"1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"0","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"1","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 260, 261, 0, 'en-GB', 0),
(400, 'parks', 'Scenery', 'scenery', '', 'image-gallery/scenery', 'index.php?option=com_content&view=category&layout=blog&id=73', 'component', 1, 244, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"0","show_description_image":"0","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"0","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"0","show_category":"1","link_category":"","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"1","show_readmore":"1","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 262, 263, 0, 'en-GB', 0),
(402, 'aboutjoomla', 'Login Form', 'login-form', '', 'using-joomla/extensions/components/users-component/login-form', 'index.php?option=com_users&view=login', 'component', 1, 271, 5, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"login_redirect_url":"","logindescription_show":"1","login_description":"","login_image":"","logout_redirect_url":"","logoutdescription_show":"1","logout_description":"","logout_image":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Login Form","pageclass_sfx":" ","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 119, 120, 0, '*', 0),
(403, 'aboutjoomla', 'User Profile', 'user-profile', '', 'using-joomla/extensions/components/users-component/user-profile', 'index.php?option=com_users&view=profile', 'component', 1, 271, 5, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"User Profile","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 121, 122, 0, '*', 0),
(404, 'aboutjoomla', 'Edit User Profile', 'edit-user-profile', '', 'using-joomla/extensions/components/users-component/edit-user-profile', 'index.php?option=com_users&view=profile&layout=edit', 'component', 1, 271, 5, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Edit User Profile","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 123, 124, 0, '*', 0),
(405, 'aboutjoomla', 'Registration Form', 'registration-form', '', 'using-joomla/extensions/components/users-component/registration-form', 'index.php?option=com_users&view=registration', 'component', 1, 271, 5, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Registration Form","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 125, 126, 0, '*', 0),
(406, 'aboutjoomla', 'Username Reminder Request', 'username-reminder', '', 'using-joomla/extensions/components/users-component/username-reminder', 'index.php?option=com_users&view=remind', 'component', 1, 271, 5, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Username Reminder Request","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 127, 128, 0, '*', 0),
(409, 'aboutjoomla', 'Password Reset', 'password-reset', '', 'using-joomla/extensions/components/users-component/password-reset', 'index.php?option=com_users&view=reset', 'component', 1, 271, 5, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Password Reset","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 129, 130, 0, '*', 0),
(410, 'aboutjoomla', 'Feed Display', 'feed-display', '', 'using-joomla/extensions/modules/display-modules/feed-display', 'index.php?option=com_content&view=article&id=16', 'component', 1, 413, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 175, 176, 0, '*', 0),
(411, 'aboutjoomla', 'Content Modules', 'content-modules', '', 'using-joomla/extensions/modules/content-modules', 'index.php?option=com_content&view=category&id=64', 'component', 1, 281, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"1","show_description":"1","show_description_image":"","show_cat_num_articles":"","display_num":"0","show_headings":"0","list_show_title":"1","list_show_date":"0","date_format":"","list_show_hits":"0","list_show_author":"0","filter_field":"hide","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_pagination_limit":"0","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 146, 161, 0, '*', 0),
(412, 'aboutjoomla', 'User Modules', 'user-modules', '', 'using-joomla/extensions/modules/user-modules', 'index.php?option=com_content&view=category&id=65', 'component', 1, 281, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_cat_num_articles":"","display_num":"0","show_headings":"0","list_show_title":"1","list_show_date":"","date_format":"","list_show_hits":"0","list_show_author":"0","filter_field":"hide","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_pagination_limit":"0","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 162, 169, 0, '*', 0),
(413, 'aboutjoomla', 'Display Modules', 'display-modules', '', 'using-joomla/extensions/modules/display-modules', 'index.php?option=com_content&view=category&id=66', 'component', 1, 281, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"","show_description":"1","show_description_image":"1","show_cat_num_articles":"","display_num":"0","show_headings":"0","list_show_title":"1","list_show_date":"","date_format":"","list_show_hits":"0","list_show_author":"0","filter_field":"hide","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_pagination_limit":"0","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 170, 183, 0, '*', 0),
(414, 'aboutjoomla', 'Utility Modules', 'utility-modules', '', 'using-joomla/extensions/modules/utility-modules', 'index.php?option=com_content&view=category&id=67', 'component', 1, 281, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"","show_description":"1","show_description_image":"1","show_cat_num_articles":"","display_num":"0","show_headings":"0","list_show_title":"0","list_show_date":"0","date_format":"","list_show_hits":"0","list_show_author":"0","filter_field":"","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_pagination_limit":"0","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 184, 195, 0, '*', 0),
(415, 'aboutjoomla', 'Navigation Modules', 'navigation-modules', '', 'using-joomla/extensions/modules/navigation-modules', 'index.php?option=com_content&view=category&id=75', 'component', 1, 281, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_category_title":"","page_subheading":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","list_show_title":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","filter_field":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_limit":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 140, 145, 0, '*', 0),
(416, 'aboutjoomla', 'Breadcrumbs', 'breadcrumbs', '', 'using-joomla/extensions/modules/navigation-modules/breadcrumbs', 'index.php?option=com_content&view=article&id=61', 'component', 1, 415, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 143, 144, 0, '*', 0),
(417, 'aboutjoomla', 'Weblinks', 'weblinks', '', 'using-joomla/extensions/modules/display-modules/weblinks', 'index.php?option=com_content&view=article&id=55', 'component', 1, 413, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 179, 180, 0, '*', 0),
(418, 'aboutjoomla', 'Custom HTML', 'custom-html', '', 'using-joomla/extensions/modules/display-modules/custom-html', 'index.php?option=com_content&view=article&id=12', 'component', 1, 413, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 181, 182, 0, '*', 0),
(419, 'aboutjoomla', 'Beez 2', 'beez-2', '', 'using-joomla/extensions/templates/beez-2', 'index.php?option=com_content&view=category&layout=blog&id=69', 'component', 1, 282, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 198, 203, 0, '*', 0),
(422, 'aboutjoomla', 'Atomic', 'atomic', '', 'using-joomla/extensions/templates/atomic', 'index.php?option=com_content&view=category&layout=blog&id=68', 'component', 1, 282, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"2","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 210, 215, 0, '*', 0),
(423, 'aboutjoomla', 'Typography Beez 2', 'typography-beez-2', '', 'using-joomla/extensions/templates/beez-2/typography-beez-2', 'index.php?option=com_content&view=article&id=49', 'component', 1, 419, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 199, 200, 0, '*', 0),
(424, 'aboutjoomla', 'Home Page Beez 2', 'home-page-beez-2', '', 'using-joomla/extensions/templates/beez-2/home-page-beez-2', 'index.php?option=com_content&view=featured', 'component', 1, 419, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 201, 202, 0, '*', 0),
(430, 'fruitshop', 'Contact Us', 'contact-us', '', 'contact-us', 'index.php?option=com_contact&view=category&catid=47&id=36', 'component', 1, 1, 1, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"20","show_headings":"0","filter_field":"hide","show_pagination":"","show_noauth":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 273, 274, 0, '*', 0),
(427, 'fruitshop', 'Fruit Encyclopedia', 'fruit-encyclopedia', '', 'fruit-encyclopedia', 'index.php?option=com_contact&view=categories&id=37', 'component', 1, 1, 1, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"1","categories_description":"","maxLevelcat":"","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_items_cat":"","show_category_title":"","show_description":"1","show_description_image":"1","maxLevel":"-1","show_empty_categories":"1","show_subcat_desc":"","show_cat_items":"","show_pagination_limit":"","show_headings":"0","show_position_headings":"","show_email_headings":"0","show_telephone_headings":"0","show_mobile_headings":"0","show_fax_headings":"0","show_suburb_headings":"0","show_state_headings":"","show_country_headings":"","show_pagination":"","show_pagination_results":"","presentation_style":"","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":" categories-listalphabet","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 269, 270, 0, '*', 0),
(429, 'fruitshop', 'Welcome', 'welcome', 'Fruit store front page', 'welcome', 'index.php?option=com_content&view=article&id=20', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"0","link_titles":"0","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 267, 268, 0, '*', 0),
(431, 'fruitshop', 'Growers', 'growers', '', 'growers', 'index.php?option=com_content&view=category&layout=blog&id=30', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"0","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"1","show_cat_num_articles":"","num_leading_articles":"5","num_intro_articles":"0","num_columns":"1","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"alpha","order_date":"","show_pagination":"","show_noauth":"","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 271, 272, 0, '*', 0),
(432, 'fruitshop', 'Login ', 'shop-login', '', 'shop-login', 'index.php?option=com_users&view=login', 'component', 1, 1, 1, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"login_redirect_url":"","logindescription_show":"1","login_description":"","login_image":"","logout_redirect_url":"","logoutdescription_show":"1","logout_description":"","logout_image":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 275, 276, 0, '*', 0),
(433, 'fruitshop', 'Directions', 'directions', '', 'directions', 'index.php?option=com_content&view=article&id=13', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 277, 278, 0, '*', 0),
(435, 'mainmenu', 'Home', 'joomla-2-5-nex-for-news-site', '', 'joomla-2-5-nex-for-news-site', 'index.php?option=com_content&view=featured', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 117, '{"featured_categories":[""],"layout_type":"blog","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_pagination_results":"","show_title":"1","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"","show_readmore":"1","show_readmore_title":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"Newspaper template joomla 2.5","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"News site with Joomla 2.5 template for latest news. ","menu-meta_keywords":"news Joomla 2.5 template, Joomla 2.5 news site template, readers, newspaper, magazine, broadcast","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 1, 2, 1, '*', 0),
(444, 'top', 'Our Photos', 'sample-sites-2', '', 'sample-sites-2', '#', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 247, 248, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(436, 'aboutjoomla', 'Getting Help', 'getting-help', '', 'using-joomla/getting-help', 'index.php?option=com_content&view=article&id=21', 'component', 1, 280, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 238, 239, 0, '*', 0),
(437, 'aboutjoomla', 'Getting Started', 'getting-started', '', 'getting-started', 'index.php?option=com_content&view=article&id=22', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"1","link_titles":"0","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"0","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 63, 64, 0, '*', 0),
(455, 'mainmenu', 'Explore', 'explore', '', 'explore', 'index.php?option=com_content&view=article&id=1', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"3","mega_group":"0","mega_width":"540","mega_colw":"170","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 285, 308, 0, '*', 0),
(438, 'mainmenu', 'Weblinks', 'weblinks', '', 'joomlart/whats-new-in-25/weblinks', 'index.php?option=com_weblinks&view=categories&id=0', 'component', 1, 290, 3, 21, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevelcat":"-1","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_num_links_cat":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"-1","show_empty_categories":"","show_subcat_desc":"","show_cat_num_links":"","show_pagination_limit":"","show_headings":"","show_link_description":"","show_link_hits":"","show_pagination":"","show_pagination_results":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Weblinks Page","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 5, 6, 0, '*', 0),
(439, 'mainmenu', 'Contacts', 'contacts', '', 'joomlart/whats-new-in-25/contacts', 'index.php?option=com_contact&view=contact&id=1', 'component', 1, 290, 3, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"presentation_style":"","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 7, 8, 0, '*', 0),
(480, 'mainmenu', 'Newsfeeds', 'newsfeeds', '', 'joomlart/whats-new-in-25/newsfeeds', 'index.php?option=com_newsfeeds&view=category&id=17', 'component', 1, 290, 3, 17, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_subcat_desc":"","show_cat_items":"","show_pagination_limit":"","show_headings":"","show_articles":"","show_link":"","show_pagination":"","show_pagination_results":"","show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 11, 12, 0, '*', 0),
(443, 'aboutjoomla', 'Article Categories', 'article-categories-view', '', 'using-joomla/extensions/modules/content-modules/article-categories-view', 'index.php?option=com_content&view=article&id=3', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 157, 158, 0, '*', 0),
(447, 'aboutjoomla', 'Language Switcher', 'language-switcher', '', 'using-joomla/extensions/modules/utility-modules/language-switcher', 'index.php?option=com_content&view=article&id=26', 'component', 1, 414, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 191, 192, 0, '*', 0),
(449, 'usermenu', 'Submit an Article', 'submit-an-article', '', 'submit-an-article', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 3, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 281, 282, 0, '*', 0),
(450, 'usermenu', 'Submit a Web Link', 'submit-a-web-link', '', 'submit-a-web-link', 'index.php?option=com_weblinks&view=form&layout=edit', 'component', 1, 1, 1, 21, 0, 0, '0000-00-00 00:00:00', 0, 3, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 283, 284, 0, '*', 0),
(452, 'aboutjoomla', 'Featured Contacts', 'featured-contacts', '', 'using-joomla/extensions/components/contact-component/featured-contacts', 'index.php?option=com_contact&view=featured&id=16', 'component', 1, 270, 5, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","filter_field":"","show_pagination":"","show_noauth":"","presentation_style":"sliders","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 99, 100, 0, '*', 0),
(453, 'aboutjoomla', 'Parameters', 'parameters', '', 'using-joomla/parameters', 'index.php?option=com_content&view=article&id=32', 'component', 1, 280, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"1","link_parent_category":"1","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"1","show_publish_date":"1","show_item_navigation":"1","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 236, 237, 0, '*', 0),
(456, 'aboutjoomla', 'Beez5', 'beez5', '', 'using-joomla/extensions/templates/beez5', 'index.php?option=com_content&view=category&layout=blog&id=70', 'component', 1, 282, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 204, 209, 0, '*', 0),
(457, 'aboutjoomla', 'Typography Beez5', 'typography-beez-5', '', 'using-joomla/extensions/templates/beez5/typography-beez-5', 'index.php?option=com_content&view=article&id=49', 'component', 1, 456, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 205, 206, 0, '*', 0),
(458, 'aboutjoomla', 'Home Page Beez5', 'home-page-beez5', '', 'using-joomla/extensions/templates/beez5/home-page-beez5', 'index.php?option=com_content&view=featured', 'component', 1, 456, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 207, 208, 0, '*', 0),
(459, 'aboutjoomla', 'Article Category', 'article-category', '', 'using-joomla/extensions/modules/content-modules/article-category', 'index.php?option=com_content&view=article&id=4', 'component', 1, 411, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 159, 160, 0, '*', 0),
(462, 'fruitshop', 'Add a recipe', 'add-a-recipe', '', 'add-a-recipe', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 4, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 309, 310, 0, '*', 0),
(463, 'fruitshop', 'Recipes', 'recipes', '', 'recipes', 'index.php?option=com_content&view=category&id=76', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"0","show_description":"1","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","list_show_title":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","filter_field":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_limit":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 311, 312, 0, '*', 0),
(465, 'main', 'com_jaextmanager', 'ja-ext-manager', '', 'ja-ext-manager', 'index.php?option=com_jaextmanager', 'component', 0, 1, 1, 10000, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_jaextmanager/assets/images/jauc.png', 0, '', 313, 314, 0, '', 1),
(466, 'mainmenu', 'Typography', 'typography', '', 'typography', 'index.php?option=com_content&view=article&id=68', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 279, 280, 0, '*', 0),
(711, 'main', 'K2_EXTRA_FIELD_GROUPS', 'k2-extra-field-groups', '', 'com-k2/k2-extra-field-groups', 'index.php?option=com_k2&view=extrafieldsgroups', 'component', 0, 703, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 454, 455, 0, '', 1),
(710, 'main', 'K2_EXTRA_FIELDS', 'k2-extra-fields', '', 'com-k2/k2-extra-fields', 'index.php?option=com_k2&view=extrafields', 'component', 0, 703, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 452, 453, 0, '', 1),
(709, 'main', 'K2_USER_GROUPS', 'k2-user-groups', '', 'com-k2/k2-user-groups', 'index.php?option=com_k2&view=usergroups', 'component', 0, 703, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 450, 451, 0, '', 1),
(708, 'main', 'K2_USERS', 'k2-users', '', 'com-k2/k2-users', 'index.php?option=com_k2&view=users', 'component', 0, 703, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 448, 449, 0, '', 1),
(479, 'mainmenu', 'Blog Page', 'blog-page', '', 'joomlart/whats-new-in-25/blog-page', 'index.php?option=com_content&view=category&layout=blog&id=78', 'component', 0, 290, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"3","num_columns":"1","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"1","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 9, 10, 0, '*', 0),
(481, 'mainmenu', 'Sample Module ', '2011-12-05-04-27-53', '', 'explore/2011-12-05-04-27-53', '#', 'url', 1, 455, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"1","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"mod","mega_subcontent_mod_modules":["48"],"mega_subcontent_pos_positions":["megamenu"]}', 306, 307, 0, '*', 0),
(482, 'mainmenu', 'I\'m Module ', '2011-12-05-04-32-06', '', 'joomlart/2011-12-05-04-32-06', '#', 'url', 1, 294, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"1","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"mod","mega_subcontent_mod_modules":["92"]}', 28, 29, 0, '*', 0),
(483, 'mainmenu', 'Navigations', 'navigations', '', 'explore/navigations', 'index.php?option=com_content&view=article&id=136', 'component', 1, 455, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"1","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 286, 295, 0, '*', 0),
(484, 'mainmenu', 'More Info', '2011-12-05-04-39-05', '', 'explore/2011-12-05-04-39-05', '#', 'url', 1, 455, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"1","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 296, 305, 0, '*', 0),
(485, 'mainmenu', 'All positions layout', 'all-positions-layout', '', 'explore/2011-12-05-04-39-05/all-positions-layout', 'index.php?option=com_content&view=article&id=150', 'component', 1, 484, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"1","show_vote":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 297, 298, 0, '*', 0),
(486, 'mainmenu', 'Module Positions', '2011-12-05-04-43-33', '', 'explore/2011-12-05-04-39-05/2011-12-05-04-43-33', '?tp=1', 'url', 1, 484, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 299, 300, 0, '*', 0),
(487, 'mainmenu', 'Mega Menu ', 'mega-menu', '', 'explore/navigations/mega-menu', 'index.php?option=com_content&view=article&id=136', 'component', 1, 483, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 117, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 287, 288, 0, '*', 0),
(488, 'mainmenu', 'Dropline Menu ', 'drop-line', '', 'explore/navigations/drop-line', 'index.php?option=com_content&view=article&id=72', 'component', 1, 483, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 117, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 291, 292, 0, '*', 0),
(489, 'mainmenu', 'Template Info', '2011-12-05-04-45-06', '', 'explore/2011-12-05-04-39-05/2011-12-05-04-45-06', '#', 'url', 1, 484, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 301, 302, 0, '*', 0),
(490, 'mainmenu', 'Split Menu ', 'split-menu', '', 'explore/navigations/split-menu', 'index.php?option=com_content&view=article&id=136', 'component', 1, 483, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 117, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 293, 294, 0, '*', 0),
(491, 'mainmenu', 'Extensions', '2011-12-05-04-45-7', '', 'explore/2011-12-05-04-39-05/2011-12-05-04-45-7', '#', 'url', 1, 484, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 303, 304, 0, '*', 0),
(492, 'mainmenu', 'Css Menu', 'css-menu', '', 'explore/navigations/css-menu', 'index.php?option=com_content&view=article&id=136', 'component', 1, 483, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 117, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 289, 290, 0, '*', 0),
(707, 'main', 'K2_COMMENTS', 'k2-comments', '', 'com-k2/k2-comments', 'index.php?option=com_k2&view=comments', 'component', 0, 703, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 446, 447, 0, '', 1),
(493, 'mainmenu', 'Color Themes', 'colors', '', 'joomlart/colors', 'index.php?option=com_content&view=featured', 'component', 1, 294, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"featured_categories":[""],"layout_type":"blog","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"1","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 14, 27, 0, '*', 0),
(494, 'mainmenu', 'Default', 'default', '', 'joomlart/colors/default', 'index.php?option=com_content&view=featured', 'component', 1, 493, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 117, '{"featured_categories":[""],"layout_type":"blog","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 15, 16, 0, '*', 0),
(706, 'main', 'K2_TAGS', 'k2-tags', '', 'com-k2/k2-tags', 'index.php?option=com_k2&view=tags', 'component', 0, 703, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 444, 445, 0, '', 1),
(705, 'main', 'K2_CATEGORIES', 'k2-categories', '', 'com-k2/k2-categories', 'index.php?option=com_k2&view=categories', 'component', 0, 703, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 442, 443, 0, '', 1),
(562, 'mainmenu', 'All Categories', 'all-categories', '', 'k2-component/all-categories', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=1', 'component', 1, 561, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["1"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 336, 355, 0, '*', 0),
(563, 'mainmenu', 'Sample Category 1', 'sample-category-1', '', 'k2-component/all-categories/sample-category-1', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=2', 'component', 1, 562, 3, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["2"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 337, 338, 0, '*', 0),
(564, 'mainmenu', 'Sample Category 2', 'sample-category-2', '', 'k2-component/all-categories/sample-category-2', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=8', 'component', 1, 562, 3, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["8"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 339, 340, 0, '*', 0),
(565, 'mainmenu', 'Sample Category 3', 'sample-category-3', '', 'k2-component/all-categories/sample-category-3', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=6', 'component', 1, 562, 3, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["6"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 341, 342, 0, '*', 0),
(566, 'mainmenu', 'Sample Category 4', 'sample-category-4', '', 'k2-component/all-categories/sample-category-4', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=7', 'component', 1, 562, 3, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["7"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 343, 344, 0, '*', 0),
(567, 'mainmenu', 'User Page', 'user-page', '', 'k2-component/user-page', 'index.php?option=com_k2&view=itemlist&layout=user&id=42&task=user', 'component', 1, 561, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"theme":"nex","userCategoriesFilter":["1","2","14","10","6","11","7","12","8","13"],"userOrdering":"","userFeedLink":"1","userFeedIcon":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 356, 357, 0, '*', 0),
(568, 'mainmenu', 'Item Page', 'item-page', '', 'k2-component/item-page', 'index.php?option=com_k2&view=item&layout=item&id=30', 'component', 1, 561, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 358, 359, 0, '*', 0),
(569, 'mainmenu', 'Tag Page', 'tag-page', '', 'k2-component/tag-page', 'index.php?option=com_k2&view=itemlist&layout=tag&tag=joomla&task=tag', 'component', 1, 561, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"theme":"nex","categoriesFilter":["1","2","14","10","6","11","7","12","8","13"],"tagOrdering":"","tagFeedLink":"1","tagFeedIcon":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 360, 361, 0, '*', 0),
(570, 'mainmenu', 'Nex Blog', 'nex-blog', '', 'k2-component/nex-blog', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=9', 'component', 1, 561, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["9"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 362, 363, 0, '*', 0),
(588, 'mainmenu', 'Kunena Forum', 'kunena-forum', '', 'kunena-forum', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"682","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 365, 366, 0, '*', 0),
(596, 'mainmenu', 'Sample Category 5', 'sample-category-5', '', 'k2-component/all-categories/sample-category-5', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=13', 'component', 1, 562, 3, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["13"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 345, 346, 0, '*', 0),
(597, 'mainmenu', 'Sample Category 6', 'sample-category-6', '', 'k2-component/all-categories/sample-category-6', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=10', 'component', 1, 562, 3, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["10"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 347, 348, 0, '*', 0),
(598, 'mainmenu', 'Sample Category 7', 'sample-category-7', '', 'k2-component/all-categories/sample-category-7', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=11', 'component', 1, 562, 3, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["11"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 349, 350, 0, '*', 0),
(599, 'mainmenu', 'Sample Category 8', 'sample-category-8', '', 'k2-component/all-categories/sample-category-8', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=12', 'component', 1, 562, 3, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["12"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 351, 352, 0, '*', 0),
(600, 'mainmenu', 'Sample Category 9', 'sample-category-9', '', 'k2-component/all-categories/sample-category-9', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=14', 'component', 1, 562, 3, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["14"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 353, 354, 0, '*', 0),
(601, 'mainmenu', 'Africa', 'africa', '', 'all-category/africa', 'index.php?option=com_content&view=category&layout=blog&id=81', 'component', 1, 602, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 316, 317, 0, '*', 0),
(602, 'mainmenu', 'All Category', 'all-category', '', 'all-category', 'index.php?option=com_content&view=categories&id=91', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevelcat":"","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_num_articles_cat":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","display_num":"10","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":" allpage","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 315, 334, 0, '*', 0),
(618, 'mainmenu', 'Fashion', 'fashion', '', 'all-category/fashion', 'index.php?option=com_content&view=category&layout=blog&id=90', 'component', 1, 602, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"6","num_columns":"3","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 332, 333, 0, '*', 0),
(617, 'mainmenu', 'Entertaiment', 'entertaiment', '', 'all-category/entertaiment', 'index.php?option=com_content&view=category&layout=blog&id=88', 'component', 1, 602, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 330, 331, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(616, 'mainmenu', 'World Sport', 'world-sport', '', 'all-category/world-sport', 'index.php?option=com_content&view=category&layout=blog&id=87', 'component', 1, 602, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 328, 329, 0, '*', 0),
(615, 'mainmenu', 'Business', 'business', '', 'all-category/business', 'index.php?option=com_content&view=category&layout=blog&id=86', 'component', 1, 602, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 326, 327, 0, '*', 0),
(614, 'mainmenu', 'Middle East', 'middle-east', '', 'all-category/middle-east', 'index.php?option=com_content&view=category&layout=blog&id=85', 'component', 1, 602, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 324, 325, 0, '*', 0),
(613, 'mainmenu', 'Latin America', 'latin-america', '', 'all-category/latin-america', 'index.php?option=com_content&view=category&layout=blog&id=84', 'component', 1, 602, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 322, 323, 0, '*', 0),
(612, 'mainmenu', 'Europe', 'europe', '', 'all-category/europe', 'index.php?option=com_content&view=category&layout=blog&id=83', 'component', 1, 602, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 320, 321, 0, '*', 0),
(620, 'footer-menu', 'Home', 'home-page', '', 'home-page', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"435","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 367, 368, 0, '*', 0),
(621, 'footer-menu', 'Fashion', 'fashion-page', '', 'fashion-page', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"618","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 369, 370, 0, '*', 0),
(622, 'footer-menu', 'Asia', 'asia-page', '', 'asia-page', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"611","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 371, 372, 0, '*', 0),
(623, 'footer-menu', 'Europe', 'europe-page', '', 'europe-page', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"612","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 373, 374, 0, '*', 0),
(624, 'footer-menu', 'Latin America', 'latin-america-page', '', 'latin-america-page', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"613","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 375, 376, 0, '*', 0),
(625, 'footer-menu', 'Middle East', 'middle-east-page', '', 'middle-east-page', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"614","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 377, 378, 0, '*', 0),
(626, 'footer-menu', 'Business', 'business-page', '', 'business-page', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"615","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 379, 380, 0, '*', 0),
(627, 'footer-menu', 'World Sport', 'world-sport-page', '', 'world-sport-page', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"616","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 381, 382, 0, '*', 0),
(628, 'footer-menu', 'Entertaiment', 'entertaiment-page', '', 'entertaiment-page', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"617","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 383, 384, 0, '*', 0),
(629, 'footer-menu', 'Africa', 'africa-page', '', 'africa-page', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"601","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 385, 386, 0, '*', 0),
(630, 'mainmenu', 'Black ', 'black-color', '', 'joomlart/colors/black-color', 'index.php?option=com_content&view=featured', 'component', 1, 493, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 117, '{"featured_categories":[""],"layout_type":"blog","num_leading_articles":"0","num_intro_articles":"0","num_columns":"0","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 17, 18, 0, '*', 0),
(631, 'mainmenu', 'Blue', 'blue-color', '', 'joomlart/colors/blue-color', 'index.php?option=com_content&view=featured', 'component', 1, 493, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 117, '{"featured_categories":[""],"layout_type":"blog","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 19, 20, 0, '*', 0),
(632, 'mainmenu', 'Green ', 'green-color', '', 'joomlart/colors/green-color', 'index.php?option=com_content&view=featured', 'component', 1, 493, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 117, '{"featured_categories":[""],"layout_type":"blog","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 21, 22, 0, '*', 0),
(633, 'mainmenu', 'Orange', 'orange-color', '', 'joomlart/colors/orange-color', 'index.php?option=com_content&view=featured', 'component', 1, 493, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 117, '{"featured_categories":[""],"layout_type":"blog","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 23, 24, 0, '*', 0),
(634, 'mainmenu', 'Pink ', 'pink-color', '', 'joomlart/colors/pink-color', 'index.php?option=com_content&view=featured', 'component', 1, 493, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 117, '{"featured_categories":[""],"layout_type":"blog","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 25, 26, 0, '*', 0),
(704, 'main', 'K2_ITEMS', 'k2-items', '', 'com-k2/k2-items', 'index.php?option=com_k2&view=items', 'component', 0, 703, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 440, 441, 0, '', 1),
(657, 'main', 'COM_FINDER', 'com-finder', '', 'com-finder', 'index.php?option=com_finder', 'component', 0, 1, 1, 10100, 0, 0, '0000-00-00 00:00:00', 0, 1, 'class:finder', 0, '', 387, 388, 0, '', 1),
(658, 'menu', 'com_finder', 'Smart Search', '', 'Smart Search', 'index.php?option=com_finder', 'component', 0, 1, 1, 27, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:finder', 0, '', 47, 48, 0, '*', 1),
(659, 'mainmenu', 'Layout', '2012-03-23-03-02-16', '', '2012-03-23-03-02-16', '#', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 389, 396, 0, '*', 0),
(660, 'mainmenu', 'Full width', 'full-width', '', '2012-03-23-03-02-16/full-width', 'index.php?option=com_content&view=article&id=154', 'component', 1, 659, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 390, 391, 0, '*', 0),
(661, 'mainmenu', '3 Columns', '3-columns', '', '2012-03-23-03-02-16/3-columns', 'index.php?option=com_content&view=article&id=155', 'component', -2, 659, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 392, 393, 0, '*', 0),
(662, 'mainmenu', 'Content + Right laylout', 'content-right-laylout', '', '2012-03-23-03-02-16/content-right-laylout', 'index.php?option=com_content&view=article&id=156', 'component', 1, 659, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 394, 395, 0, '*', 0),
(663, 'main', 'com_joomlaupdate', 'com-joomlaupdate', '', 'com-joomlaupdate', 'index.php?option=com_joomlaupdate', 'component', 0, 1, 1, 10131, 0, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 397, 398, 0, '', 1),
(673, 'main', 'COM_KUNENA', 'com-kunena', '', 'com-kunena', 'index.php?option=com_kunena', 'component', 0, 1, 1, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-logo-white.png', 0, '', 401, 416, 0, '', 1),
(666, 'main', 'COM_KUNENA_CONFIGURATION', 'com-kunena-configuration', '', 'com-kunena/com-kunena-configuration', 'index.php?option=com_kunena&view=config', 'component', 0, 665, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-config.png', 0, '', 404, 405, 0, '', 1),
(667, 'main', 'COM_KUNENA_CATEGORY_MANAGER', 'com-kunena-category-manager', '', 'com-kunena/com-kunena-category-manager', 'index.php?option=com_kunena&view=categories', 'component', 0, 665, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-categories.png', 0, '', 406, 407, 0, '', 1),
(668, 'main', 'COM_KUNENA_USER_MANAGER', 'com-kunena-user-manager', '', 'com-kunena/com-kunena-user-manager', 'index.php?option=com_kunena&view=users', 'component', 0, 665, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-users.png', 0, '', 408, 409, 0, '', 1),
(669, 'main', 'COM_KUNENA_TEMPLATE_MANAGER', 'com-kunena-template-manager', '', 'com-kunena/com-kunena-template-manager', 'index.php?option=com_kunena&view=templates', 'component', 0, 665, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-templates.png', 0, '', 410, 411, 0, '', 1),
(670, 'main', 'COM_KUNENA_EMOTICON_MANAGER', 'com-kunena-emoticon-manager', '', 'com-kunena/com-kunena-emoticon-manager', 'index.php?option=com_kunena&view=smilies', 'component', 0, 665, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-smileys.png', 0, '', 412, 413, 0, '', 1),
(671, 'main', 'COM_KUNENA_RANK_MANAGER', 'com-kunena-rank-manager', '', 'com-kunena/com-kunena-rank-manager', 'index.php?option=com_kunena&view=ranks', 'component', 0, 665, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-ranks.png', 0, '', 414, 415, 0, '', 1),
(672, 'main', 'COM_KUNENA_TRASH_MANAGER', 'com-kunena-trash-manager', '', 'com-kunena/com-kunena-trash-manager', 'index.php?option=com_kunena&view=trash', 'component', 0, 665, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-trash.png', 0, '', 416, 417, 0, '', 1),
(674, 'main', 'COM_KUNENA_CONFIGURATION', 'com-kunena-configuration', '', 'com-kunena/com-kunena-configuration', 'index.php?option=com_kunena&view=config', 'component', 0, 673, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-config.png', 0, '', 402, 403, 0, '', 1),
(675, 'main', 'COM_KUNENA_CATEGORY_MANAGER', 'com-kunena-category-manager', '', 'com-kunena/com-kunena-category-manager', 'index.php?option=com_kunena&view=categories', 'component', 0, 673, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-categories.png', 0, '', 404, 405, 0, '', 1),
(676, 'main', 'COM_KUNENA_USER_MANAGER', 'com-kunena-user-manager', '', 'com-kunena/com-kunena-user-manager', 'index.php?option=com_kunena&view=users', 'component', 0, 673, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-users.png', 0, '', 406, 407, 0, '', 1),
(677, 'main', 'COM_KUNENA_TEMPLATE_MANAGER', 'com-kunena-template-manager', '', 'com-kunena/com-kunena-template-manager', 'index.php?option=com_kunena&view=templates', 'component', 0, 673, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-templates.png', 0, '', 408, 409, 0, '', 1),
(678, 'main', 'COM_KUNENA_EMOTICON_MANAGER', 'com-kunena-emoticon-manager', '', 'com-kunena/com-kunena-emoticon-manager', 'index.php?option=com_kunena&view=smilies', 'component', 0, 673, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-smileys.png', 0, '', 410, 411, 0, '', 1),
(679, 'main', 'COM_KUNENA_RANK_MANAGER', 'com-kunena-rank-manager', '', 'com-kunena/com-kunena-rank-manager', 'index.php?option=com_kunena&view=ranks', 'component', 0, 673, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-ranks.png', 0, '', 412, 413, 0, '', 1),
(680, 'main', 'COM_KUNENA_TRASH_MANAGER', 'com-kunena-trash-manager', '', 'com-kunena/com-kunena-trash-manager', 'index.php?option=com_kunena&view=trash', 'component', 0, 673, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-trash.png', 0, '', 414, 415, 0, '', 1),
(681, 'kunenamenu', 'Forum', 'forum', '', 'forum', 'index.php?option=com_kunena&view=home&defaultmenu=683', 'component', 1, 1, 1, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"catids":0}', 417, 436, 0, '*', 0),
(682, 'kunenamenu', 'Index', 'index', '', 'forum/index', 'index.php?option=com_kunena&view=category&layout=list', 'component', 1, 681, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 418, 419, 0, '*', 0),
(683, 'kunenamenu', 'Recent Topics', 'recent', '', 'forum/recent', 'index.php?option=com_kunena&view=topics&mode=replies', 'component', 1, 681, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"topics_catselection":1,"topics_categories":0,"topics_time":720}', 420, 421, 0, '*', 0),
(684, 'kunenamenu', 'New Topic', 'newtopic', '', 'forum/newtopic', 'index.php?option=com_kunena&view=topic&layout=create', 'component', 1, 681, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 2, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 422, 423, 0, '*', 0),
(685, 'kunenamenu', 'No Replies', 'noreplies', '', 'forum/noreplies', 'index.php?option=com_kunena&view=topics&mode=noreplies', 'component', 1, 681, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 2, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"topics_catselection":1,"topics_categories":0,"topics_time":-1}', 424, 425, 0, '*', 0),
(686, 'kunenamenu', 'My Topics', 'mylatest', '', 'forum/mylatest', 'index.php?option=com_kunena&view=topics&layout=user&mode=default', 'component', 1, 681, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 2, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"topics_catselection":1,"topics_categories":0,"topics_time":-1}', 426, 427, 0, '*', 0),
(687, 'kunenamenu', 'Profile', 'profile', '', 'forum/profile', 'index.php?option=com_kunena&view=user', 'component', 1, 681, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 2, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"integration":1}', 428, 429, 0, '*', 0),
(688, 'kunenamenu', 'Help', 'help', '', 'forum/help', 'index.php?option=com_kunena&view=misc', 'component', 1, 681, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"body":"This help page is a menu item inside [b]Kunena Menu[\\/b], which allows easy navigation in your forum. \\r\\n\\r\\n You can use Joomla Menu Manager to edit items in this menu. Please go to [b]Administration[\\/b] >> [b]Menus[\\/b] >> [b]Kunena Menu[\\/b] >> [b]Help[\\/b] to edit or remove this menu item. \\r\\n\\r\\n In this menu item you can use Plain Text, BBCode or HTML. If you want to bind article into this page, you may use article BBCode (with article id): [code][article=full]123[\\/article][\\/code] \\r\\n\\r\\n If you want to create your own menu for Kunena, please start by creating [b]Home Page[\\/b] first. In that page you can select default menu item, which is shown when you enter to Kunena.","body_format":"bbcode","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 432, 433, 0, '*', 0),
(689, 'kunenamenu', 'Search', 'search', '', 'forum/search', 'index.php?option=com_kunena&view=search', 'component', 1, 681, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 434, 435, 0, '*', 0),
(690, 'mainmenu', 'Forum', 'kunena-2012-10-17', '', 'kunena-2012-10-17', 'index.php?Itemid=681', 'alias', 0, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"681","menu-anchor_title":"","menu-anchor_css":"","menu_image":""}', 437, 438, 0, '*', 0),
(691, 'kunenamenu', 'Rules', 'rules', '', 'forum/rules', 'index.php?option=com_kunena&view=misc', 'component', 1, 681, 2, 10140, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"body":"[article=full]1[\\/article]","body_format":"bbcode","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 430, 431, 0, '*', 0),
(703, 'main', 'COM_K2', 'com-k2', '', 'com-k2', 'index.php?option=com_k2', 'component', 0, 1, 1, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, '../media/k2/assets/images/system/k2_16x16.png', 0, '', 439, 460, 0, '', 1),
(713, 'main', 'K2_INFORMATION', 'k2-information', '', 'com-k2/k2-information', 'index.php?option=com_k2&view=info', 'component', 0, 703, 2, 10073, 0, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 458, 459, 0, '', 1);

DROP TABLE IF EXISTS `#__menu_types`;
CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=MyISAM ;

INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`) VALUES
(2, 'usermenu', 'User Menu', 'A Menu for logged in Users'),
(3, 'top', 'Top', 'Links for major types of users'),
(4, 'aboutjoomla', 'About Joomla', 'All about Joomla!'),
(5, 'parks', 'Australian Parks', 'Main menu for a site about Australian  parks'),
(6, 'mainmenu', 'Main Menu', 'Simple Home Menu'),
(7, 'fruitshop', 'Fruit Shop', 'Menu for the sample shop site.'),
(9, 'footer-menu', 'Footer Menu ', ''),
(10, 'kunenamenu', 'Kunena Menu', 'This is the default Kunena menu. It is used as the top navigation for Kunena. It can be publish in any module position. Simply unpublish items that are not required.');

DROP TABLE IF EXISTS `#__messages`;
CREATE TABLE `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__messages_cfg`;
CREATE TABLE `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__modules`;
CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(1, 'Main Menu', '', '', 1, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"mainmenu","startLevel":"1","endLevel":"2","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"_menu","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(2, 'Login', '', '', 1, 'login', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '', 1, '*'),
(3, 'Popular Articles', '', '', 3, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_popular', 3, 1, '{"count":"5","catid":"","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(4, 'Recently Added Articles', '', '', 4, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_latest', 3, 1, '{"count":"5","ordering":"c_dsc","catid":"","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(8, 'Toolbar', '', '', 1, 'toolbar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_toolbar', 3, 1, '', 1, '*'),
(9, 'Quick Icons', '', '', 1, 'icon', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_quickicon', 3, 1, '', 1, '*'),
(10, 'Logged-in Users', '', '', 2, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_logged', 3, 1, '{"count":"5","name":"1","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(12, 'Admin Menu', '', '', 1, 'menu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 3, 1, '{"layout":"","moduleclass_sfx":"","shownew":"1","showhelp":"1","cache":"0"}', 1, '*'),
(13, 'Admin Submenu', '', '', 1, 'submenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_submenu', 3, 1, '', 1, '*'),
(14, 'User Status', '', '', 2, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_status', 3, 1, '', 1, '*'),
(15, 'Title', '', '', 1, 'title', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_title', 3, 1, '', 1, '*'),
(16, 'Login Form', '', '', 15, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(17, 'Breadcrumbs', '', '', 1, 'position-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_breadcrumbs', 1, 1, '{"showHere":"1","showHome":"1","homeText":"Home","showLast":"1","separator":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(79, 'Multilanguage status', '', '', 1, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_multilangstatus', 3, 1, '{"layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(18, 'Book Store', '', '', 1, 'position-10', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_banners', 1, 0, '{"target":"1","count":"1","cid":"3","catid":[""],"tag_search":"0","ordering":"0","header_text":"","footer_text":"Books!","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(19, 'User Menu', '', '', 23, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 2, 1, '{"menutype":"usermenu","startLevel":"1","endLevel":"1","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"_menu","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(20, 'Top', '', '', 1, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"top","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","maxdepth":"10","window_open":"","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(22, 'Australian Parks ', '', '', 2, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"parks","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, 'en-GB'),
(23, 'About Joomla', '', '', 25, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"aboutjoomla","startLevel":"1","endLevel":"1","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"_menu ","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(68, 'Partner', '', '<div class="clearfix">\r\n<div class="list-item first_item">\r\n<h3>Hubs</h3>\r\n<ul>\r\n<li><a href="#">News</a></li>\r\n<li><a href="#">Business</a></li>\r\n<li><a href="#">Culture</a></li>\r\n<li><a href="#">Design</a></li>\r\n<li><a href="#">Lifestyle</a></li>\r\n<li><a href="#">Technology</a></li>\r\n</ul>\r\n</div>\r\n<div class="list-item ">\r\n<h3>Features</h3>\r\n<ul>\r\n<li><a href="#">Infographics</a></li>\r\n<li><a href="#">Videos</a></li>\r\n<li><a href="#">Slideshow</a></li>\r\n<li><a href="#">Project</a></li>\r\n<li><a href="#">Current issue</a></li>\r\n<li><a href="#">Online Store</a></li>\r\n</ul>\r\n</div>\r\n<div class="list-item">\r\n<h3>Company</h3>\r\n<ul>\r\n<li><a href="#">About</a></li>\r\n<li><a href="#">Contact</a></li>\r\n<li><a href="#">Support</a></li>\r\n<li><a href="#">Jobs</a></li>\r\n<li><a href="#">Privacy</a></li>\r\n<li><a href="#">Terms</a></li>\r\n</ul>\r\n</div>\r\n</div>', 2, 'foot-left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" partner no-padding","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(93, 'Accordion title', '', '', 16, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jaaccordion', 1, 0, '{"moduleclass_sfx":" redbg no-bg","type":"modules","modules-position":"accordion","module-ids":["131","144","145"],"artIDs":"1, 2, 3, 4","catids":[""],"show_featured":"","view":"introtext","ordering":"c_dsc","user_id":"0","Width":"","count":"3","mouseType":"click","duration":"1000","effect":"Fx.Transitions.Quad.easeInOut"}', 0, '*'),
(67, 'Extensions', '', '', 2, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_menu', 1, 1, '{"menutype":"aboutjoomla","startLevel":"1","endLevel":"6","showAllChildren":"0","tag_id":"","class_sfx":"-menu","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(25, 'Site Map', '', '', 1, 'sitemapload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 0, '{"menutype":"mainmenu","startLevel":"2","endLevel":"3","showAllChildren":"1","tag_id":"","class_sfx":"sitemap","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(26, 'This Site', '', '', 5, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"mainmenu","startLevel":"1","endLevel":"1","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"_menu","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(27, 'Archived Articles', '', '', 5, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_articles_archive', 1, 1, '{"count":"10","layout":"_:default","moduleclass_sfx":"_menu","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(28, 'Latest News', '', '', 12, '', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_latest', 1, 1, '{"catid":["19"],"count":"5","show_featured":"","ordering":"c_dsc","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(29, 'Articles Most Read', '', '', 13, '', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_popular', 1, 1, '{"catid":["26","29"],"count":"5","show_front":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(30, 'Feed Display', '', '', 14, '', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_feed', 1, 1, '{"rssurl":"http:\\/\\/community.joomla.org\\/blogs\\/community.feed?type=rss","rssrtl":"0","rsstitle":"1","rssdesc":"1","rssimage":"1","rssitems":"3","rssitemdesc":"1","word_count":"0","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(31, 'News Flash', '', '', 15, '', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news', 1, 1, '{"catid":["19"],"image":"0","item_title":"0","link_titles":"","item_heading":"h4","showLastSeparator":"1","readmore":"1","count":"1","ordering":"a.publish_up","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(33, 'Random Image', '', '', 16, '', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_random_image', 1, 1, '{"type":"jpg","folder":"images\\/sampledata\\/parks\\/animals","link":"","width":"180","height":"","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(34, 'Articles Related Items', '', '', 17, '', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_related_items', 1, 1, '{"showDate":"0","layout":"_:default","moduleclass_sfx":"","owncache":"1"}', 0, '*'),
(35, 'Search', '', '', 1, 'search', 42, '2011-12-15 10:46:25', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_search', 1, 1, '{"label":"","width":"20","text":"","button":"1","button_pos":"right","imagebutton":"1","button_text":"","opensearch":"1","opensearch_title":"","set_itemid":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(36, 'Statistics', '', '', 18, '', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_stats', 1, 1, '{"serverinfo":"1","siteinfo":"1","counter":"1","increase":"0","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(37, 'Syndicate Feeds', '', '', 1, 'syndicateload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_syndicate', 1, 1, '{"text":"Feed Entries","format":"rss","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(38, 'Users Latest', '', '', 11, '', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_users_latest', 1, 1, '{"shownumber":"5","linknames":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"static"}', 0, '*'),
(39, 'Who\'s Online', '', '', 19, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_whosonline', 1, 1, '{"showmode":"2","linknames":"0","layout":"_:default","moduleclass_sfx":" badge-top","cache":"0"}', 0, '*'),
(40, 'Wrapper', '', '', 9, '', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_wrapper', 1, 1, '{"url":"http:\\/\\/www.youtube.com\\/embed\\/vb2eObvmvdI","add":"1","scrolling":"auto","width":"640","height":"390","height_auto":"1","target":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(41, 'Footer', '', '', 1, 'footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_footer', 1, 1, '{"layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(44, 'Login', '', '', 1, 'login ', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 0, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(45, 'Top Menu ', '', '', 1, 'topmenu-right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 0, '{"menutype":"top","startLevel":"1","endLevel":"1","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(47, 'Latest Park Blogs', '', '', 6, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_latest', 1, 1, '{"count":"5","ordering":"c_dsc","user_id":"0","show_front":"1","catid":"35","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, 'en-GB'),
(48, 'Vimeo ', '', '<p style="padding-bottom: 5px;"><object data="http://vimeo.com/moogaloop.swf?clip_id=7421222&amp;server=vimeo.com&amp;color=333333&amp;fullscreen=1" type="application/x-shockwave-flash" width="153" height="86"><param name="quality" value="high" /><param name="src" value="http://vimeo.com/moogaloop.swf?clip_id=7421222&amp;server=vimeo.com&amp;color=333333&amp;fullscreen=1" /><param name="pluginspage" value="http://vimeo.com/moogaloop.swf?clip_id=7421222&amp;server=vimeo.com&amp;color=33bbbb&amp;fullscreen=1" /><param name="scale" value="noborder" /></object></p>', 1, 'megamenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" no-background","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(49, 'Weblinks', '', '', 6, '', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_weblinks', 1, 1, '{"catid":"32","count":"5","ordering":"title","direction":"asc","target":"3","description":"0","hits":"0","count_clicks":"0","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(52, 'Breadcrumbs', '', '', 1, 'breadcrumbs', 42, '2011-12-15 04:01:19', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_breadcrumbs', 1, 1, '{"showHere":"1","showHome":"1","homeText":"Home","showLast":"1","separator":"","layout":"_:default","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(61, 'Articles Categories', '', '', 4, '', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_categories', 1, 1, '{"parent":"29","show_description":"0","show_children":"0","count":"0","maxlevel":"0","layout":"_:default","item_heading":"4","moduleclass_sfx":"","owncache":"1","cache_time":"900"}', 0, '*'),
(56, 'Banners', '', '', 3, '', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_banners', 1, 1, '{"target":"1","count":"1","cid":"1","catid":["15"],"tag_search":"0","ordering":"random","header_text":"","footer_text":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(57, 'Fruit Shop', '', '', 3, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"fruitshop","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(58, 'Image Temp', '', '<div><img src="images/stories/demo/img-footer.gif" border="0" alt="left" title="Sample photo" width="122" />Lorem ipsum dolor sit amet, <a href="#" title="sample link">consectetur</a> adipisicing elit, sed do eiusmod tempor incididunt ut <a href="#" title="sample link">labore et</a> dolore.</div>', 1, 'foot-left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" imgtemp no-padding","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(62, 'Language Switcher', '', '', 3, 'position-4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_languages', 1, 1, '{"header_text":"","footer_text":"","image":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(63, 'Search', '', '', 1, 'position-0', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_search', 1, 1, '{"width":"20","text":"","button":"","button_pos":"right","imagebutton":"1","button_text":"","set_itemid":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(64, 'Language Switcher', '', '', 1, 'languageswitcherload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_languages', 1, 1, '{"header_text":"","footer_text":"","image":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(65, 'Follow me', '', '<div class="social"><a class="ico-social ico-facebooks" href="#" title="Facebook"><span>Facebook</span></a><a class="ico-social ico-twitters" href="#" title="Twitter"><span>Twitter</span></a><a class="ico-social ico-rss" href="#" title="RSS"><span>RSS</span></a></div>', 1, 'social', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(69, 'Articles Category', '', '', 2, '', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_category', 1, 1, '{"mode":"normal","show_on_article_page":"1","show_front":"show","count":"0","category_filtering_type":"1","catid":["72"],"show_child_category_articles":"0","levels":"1","author_filtering_type":"1","created_by":[""],"author_alias_filtering_type":"1","created_by_alias":[""],"excluded_articles":"","date_filtering":"off","date_field":"a.created","start_date_range":"","end_date_range":"","relative_date":"30","article_ordering":"a.title","article_ordering_direction":"ASC","article_grouping":"none","article_grouping_direction":"ksort","month_year_format":"F Y","item_heading":"4","link_titles":"1","show_date":"0","show_date_field":"created","show_date_format":"Y-m-d H:i:s","show_category":"0","show_hits":"0","show_author":"0","show_introtext":"0","introtext_limit":"100","show_readmore":"0","show_readmore_title":"1","readmore_limit":"15","layout":"_:default","moduleclass_sfx":"","owncache":"1","cache_time":"900"}', 0, '*'),
(70, 'Search', '', '', 2, 'menu-footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_search', 1, 0, '{"label":"","width":"20","text":"","button":"1","button_pos":"right","imagebutton":"1","button_text":"","opensearch":"1","opensearch_title":"","set_itemid":"","layout":"_:default","moduleclass_sfx":"_search ","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(71, 'Top Menu (Atomic Template)', '', '', 1, 'atomic-topmenu', 42, '2011-12-08 08:59:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 0, '{"menutype":"aboutjoomla","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(72, 'Newsletter', '', '<form action="index.php" method="post"><label>Lorem Ipsum is simply dummy text of the printing and typesetting industry</label>\r\n<div><input class="form-text" type="text" name="Your email" size="14" maxlength="60" /><a class="links">Submit</a></div>\r\n</form>', 2, 'foot-right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" ","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(73, 'Today video ', '', '<p><object data="http://vimeo.com/moogaloop.swf?clip_id=7421222&amp;server=vimeo.com&amp;color=333333&amp;fullscreen=1" type="application/x-shockwave-flash" width="210" height="120"><param name="quality" value="high" /><param name="src" value="http://vimeo.com/moogaloop.swf?clip_id=7421222&amp;server=vimeo.com&amp;color=333333&amp;fullscreen=1" /><param name="pluginspage" value="http://vimeo.com/moogaloop.swf?clip_id=7421222&amp;server=vimeo.com&amp;color=33bbbb&amp;fullscreen=1" /><param name="scale" value="noborder" /><param name="wmode" value="transparent" /></object></p>', 11, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blackbg","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(74, 'Adv Banner', '', '<div class="images-adv"><img src="images/stories/demo/adv1.jpg" border="0" alt="Sample photo" title="Sample photo" /></div>', 1, 'content-mass-bottom', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" whitebg adv","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(75, 'Photostream ', '', '<div class="img-photo clearfix">\r\n	<span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide1.jpg" width="594" height="386"} \r\n		<img src="images/stories/highslide/thumb-1.jpg" border="0" alt="Sample Image" /> {/japopup} </span> \r\n	<span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide2.jpg" width="594" height="386"} \r\n		<img src="images/stories/highslide/thumb-2.jpg" border="0" alt="Sample Images" /> {/japopup} </span> \r\n	<span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide3.jpg" width="594" height="386"} \r\n		<img src="images/stories/highslide/thumb-3.jpg" border="0" alt="Sample Images" /> {/japopup} </span> \r\n	<span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide4.jpg" width="594" height="386"} \r\n		<img src="images/stories/highslide/thumb-4.jpg" border="0" alt="Sample Images" /> {/japopup} </span> \r\n	<span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide5.jpg" width="594" height="386"} \r\n		<img src="images/stories/highslide/thumb-5.jpg" border="0" alt="Sample Images" /> {/japopup} </span> \r\n	<span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide6.jpg" width="594" height="386"} \r\n		<img src="images/stories/highslide/thumb-6.jpg" border="0" alt="Sample Images" /> {/japopup} </span>\r\n	<span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide7.jpg" width="594" height="386"} \r\n		<img src="images/stories/highslide/thumb-7.jpg" border="0" alt="Sample Images" /> {/japopup} </span>\r\n	<span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide8.jpg" width="594" height="386"} \r\n		<img src="images/stories/highslide/thumb-8.jpg" border="0" alt="Sample Images" /> {/japopup} </span>\r\n	<span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide9.jpg" width="594" height="386"} \r\n		<img src="images/stories/highslide/thumb-9.jpg" border="0" alt="Sample Images" /> {/japopup} </span>\r\n</div>', 12, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(76, 'Login (Atomic Template)', '', '', 2, 'atomic-sidebar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 0, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(77, 'Shop', '', '', 1, 'position-11', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_banners', 1, 0, '{"target":"1","count":"1","cid":"2","catid":["15"],"tag_search":"0","ordering":"0","header_text":"","footer_text":"Shop!","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(78, 'Contribute', '', '', 1, 'position-9', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_banners', 1, 0, '{"target":"1","count":"1","cid":"1","catid":["15"],"tag_search":"0","ordering":"0","header_text":"","footer_text":"Contribute! ","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(82, 'Editor\'s Picks', '', '', 1, 'slider', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jacontentslider', 1, 1, '{"moduleclass_sfx":" no-padding","source":"content","folder_images":"images\\/stories\\/demo\\/slideshow","catid":["90","88","87"],"k2catsid":["0"],"text_heading":"","showTab":"0","sort_order_field":"created","sort_order":"DESC","numElem":5,"maxitems":8,"link_titles":"1","showimages":"0","iwidth":148,"iheight":40,"showreadmore":"0","showintrotext":"0","numchar":0,"xwidth":189,"xheight":82,"auto":"0","mode":"horizontal","direction":"left","delaytime":5000,"animationtime":1000,"showtitle":"1","showbutton":"1","scroll_when":"click","source-articles-images-thumbnail_mode":"crop","source-articles-images-thumbnail_mode-resize-use_ratio":"0","enable_cache":"1","cache_time":300}', 0, '*'),
(118, 'K2 Comments', '', '', 9, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_comments', 1, 1, '{"moduleclass_sfx":"","module_usage":"0","catfilter":"0","comments_limit":"2","comments_word_limit":"10","commenterName":"1","commentAvatar":"1","commentAvatarWidthSelect":"custom","commentAvatarWidth":"60","commentDate":"1","commentDateFormat":"absolute","commentLink":"1","itemTitle":"0","itemCategory":"0","feed":"0","commenters_limit":"2","commenterNameOrUsername":"1","commenterAvatar":"1","commenterAvatarWidthSelect":"custom","commenterAvatarWidth":"60","commenterLink":"1","commenterCommentsCounter":"1","commenterLatestComment":"1","cache":"1","cache_time":"900"}', 0, '*'),
(119, 'K2 Content', '', '', 10, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_content', 1, 1, '{"moduleclass_sfx":"","getTemplate":"Default","source":"filter","catfilter":"0","getChildren":"0","itemCount":"2","itemsOrdering":"","FeaturedItems":"1","popularityRange":"","videosOnly":"0","item":"0","itemTitle":"1","itemAuthor":"1","itemAuthorAvatar":"1","itemAuthorAvatarWidthSelect":"custom","itemAuthorAvatarWidth":"60","userDescription":"0","itemIntroText":"1","itemIntroTextWordLimit":"15","itemImage":"1","itemImgSize":"XSmall","itemVideo":"0","itemVideoCaption":"0","itemVideoCredits":"0","itemAttachments":"0","itemTags":"0","itemCategory":"0","itemDateCreated":"1","itemHits":"0","itemReadMore":"1","itemExtraFields":"0","itemCommentsCounter":"0","feed":"0","itemPreText":"","itemCustomLink":"0","itemCustomLinkTitle":"","itemCustomLinkURL":"http:\\/\\/","itemCustomLinkMenuItem":"","K2Plugins":"1","JPlugins":"1","cache":"1","cache_time":"900"}', 0, '*'),
(92, 'I am Module ', '', '<p><img src="images/stories/demo/demo-3.jpg" border="0" alt="Sample photo" title="Sample photo" align="left" style="margin-bottom: 10px;" /> Lorem ipsum dolor sit amet, consectetur elit. <br /><a class="readmore" href="#">Read more</a></p>', 1, 'megamenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" no-padding no-background","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(121, 'K2 Categories', '', '', 8, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_tools', 1, 1, '{"moduleclass_sfx":"_menu","module_usage":"4","archiveItemsCounter":"1","archiveCategory":"0","authors_module_category":"1","authorItemsCounter":"1","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"48","authorLatestItem":"1","calendarCategory":"0","home":"","seperator":"","root_id":"1","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"1","root_id2":"0","catfilter":"0","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":["1"],"cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900"}', 0, '*'),
(122, 'K2 Users', '', '', 20, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_users', 1, 1, '{"moduleclass_sfx":"","getTemplate":"Default","source":"filter","filter":"1","ordering":"alpha","limit":"4","userName":"1","userAvatar":"1","userAvatarWidthSelect":"custom","userAvatarWidth":"60","userDescription":"1","userDescriptionWordLimit":"","userURL":"1","userEmail":"0","userFeed":"1","userItemCount":"1","cache":"1","cache_time":"900"}', 0, '*'),
(123, 'K2 User', '', '', 24, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_user', 1, 1, '{"moduleclass_sfx":"","pretext":"","posttext":"","userGreetingText":"","name":"1","userAvatar":"1","userAvatarWidthSelect":"custom","userAvatarWidth":"60","menu":"","login":"","logout":"","usesecure":"0","cache":"0","cache_time":"900"}', 0, '*'),
(124, 'K2 Quick Icons (admin)', '', '', 99, 'icon', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_quickicons', 3, 1, '', 1, '*'),
(125, 'K2 Stats (admin)', '', '', 0, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_stats', 3, 1, '', 1, '*'),
(126, 'Newsticker', '', '', 1, 'topbar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_janewsticker', 1, 0, '{"moduleclass_sfx":"","using_mode":"categories_selected","external_link":"","k2catsid":["0"],"rss_link":"","category":[""],"sort_order_field":"created","sort_order":"DESC","max_items":10,"title_max_chars":50,"animation_type":"horizontal","animation_speed":500,"animation_interval":3000,"animation_transition":"Fx.Transitions.Circ.easeIn","show_headtext":"1","headtext":"Hot","show_buttons_control":"0","enable_cache":"1","cache_time":30}', 0, '*'),
(128, 'JA News Pro! Module', '', '', 1, 'content-mass-top', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_janewspro', 1, 0, '{"moduleclass_sfx":" no-bg absolute-title","source":"JANewsHelper","getChildren":"1","catsid":["90","88","87","86","85","84","83","82","81"],"k2catsid":["2"],"groupbysubcat":"0","maxSubCats":"-1","featured":"show","ordering":"ordering","sort_order":"DESC","timerange":"","profile":"nex","JPlugins":"0","K2Plugins":"0","colors":"","jacache":"0","jacache_time":900}', 0, '*'),
(129, 'Featured', '', '', 1, 'sl1-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_janews_featured', 1, 1, '{"moduleclass_sfx":" no-padding absolute-title simple-title","source":"JANewsHelper","catsid":["90","88","87","86","85","84","83","82","81"],"k2catsid":["0"],"getChildren":"1","featured":"only","ordering":"ordering","sort_order":"DESC","profile":"nex","JPlugins":"1","K2Plugins":"1","cache":"0","cache_time":"900"}', 0, '*'),
(130, 'JA Side News', '', '', 1, 'sl1-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_jasidenews', 1, 1, '{"moduleclass_sfx":"","display_model-modcats-category":["","14","19","20","21","22","64","65","66","67","75","23","69","70","68","24","25","26","27","28","72","73","29","30","76","9","77","78","81","82","83","84","85","86","87","88"],"show_featured":"1","sort_order_field":"created","sort_order":"DESC","max_items":5,"title_max_chars":200,"maxchars":60,"thumbnail_mode":"crop","thumbnail_mode-resize-use_ratio":"1","iwidth":152,"iheight":200,"image_alignment":"auto","layout":"default","layout-default-showdate":"1","layout-default-show_moredetail":"1","layout-default-showimage":"1","layout-sidenews-height":"200","layout-sidenews-textcolor":"FFFFFF","layout-sidenews-bgcolor":"4F4F4F","layout-sidenews-transparent":"80","layout-sidenews-element_apply_side":"content","layout-sidenews-play_mode":"caption","layout-sidenews-play_mode-caption-expandheight":"150","layout-sidenews-play_mode-caption-collapseheight":"30","layout-sidenews-animation_transition":"Fx.Transitions.Expo.easeOut","enable_cache":"1","cache_time":30}', 0, '*'),
(131, 'Upcoming Releases', '', '', 2, 'accordion', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jabulletin', 1, 1, '{"moduleclass_sfx":"","type":"latest","ordering":"c_dsc","using_mode":"catids","category":["81","82","83","84","85","86","87","88"],"k2catsid":["0"],"count":3,"show_featured":"1","show_date":"1","show_author":"0","show_readmore":"0","show_hits":"0","use_custom_text":"1","custom_text":"Hits:","show_image":"1","thumbnail_mode":"crop","use_ratio":"1","width":58,"height":58,"cache":"1","cache_time":"30"}', 0, '*'),
(134, 'Quick guide', '', '<p><img src="images/stories/demo/demo-1.jpg" border="0" alt="Sample photo" title="Sample photo" align="left" />Sed ipsum enim, mollis eu pellentesque a, ullamcorper at sem. Mauris eugiat, dui vel cursus elementum, nulla metus bibendum neque, in tincidunt tellus lorem vitae metus in tincidunt tellus lorem vitae metus.</p>\r\n<p><a class="readmore" href="#">Read more</a></p>', 3, 'ja-tabs', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(135, 'About T3 Framework', '', '<p><img src="images/stories/demo/demo-2.jpg" border="0" alt="Sample photo" title="Sample photo" align="left" />Sed ipsum enim, mollis eu pellentesque a, ullamcorper at sem. Mauris eugiat, dui vel cursus elementum, nulla metus bibendum neque, in tincidunt tellus lorem vitae metus ipsum enim, mollis eu pellentesque a, ullamcorper at sem.</p>\r\n<p><a class="readmore" href="#">Read more</a></p>', 2, 'ja-tabs', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(136, 'Template Features', '', '', 1, 'ja-tabs', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jasidenews', 1, 1, '{"moduleclass_sfx":"","display_model-modcats-category":["88","87","86","85","84","83","82","81"],"show_featured":"1","sort_order_field":"created","sort_order":"DESC","max_items":3,"title_max_chars":20,"maxchars":48,"thumbnail_mode":"crop","thumbnail_mode-resize-use_ratio":"1","iwidth":60,"iheight":60,"image_alignment":"left","layout":"default","layout-default-showdate":"0","layout-default-show_moredetail":"1","layout-default-showimage":"1","layout-sidenews-height":"200","layout-sidenews-textcolor":"FFFFFF","layout-sidenews-bgcolor":"4F4F4F","layout-sidenews-transparent":"80","layout-sidenews-element_apply_side":"content","layout-sidenews-play_mode":"caption","layout-sidenews-play_mode-caption-expandheight":"150","layout-sidenews-play_mode-caption-collapseheight":"30","layout-sidenews-animation_transition":"Fx.Transitions.Expo.easeOut","enable_cache":"0","cache_time":30}', 0, '*'),
(137, 'Why Pick Us', '', '<div>{jatabs type="modules" module="ja-tabs" position="top" mouseType="click" animType="animMoveHor" } {/jatabs}</div>', 1, 'content-mass-bottom', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" no-padding","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(138, 'Demo notice', '', '<div>Quisque sed dui enim. Mauris ultricies, tellus ac semper consequat.</div>', 22, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blackbg bgcolor","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(139, 'Color Module', '', '<p>Nunc rutrum scelerisque ipsum ut aliquet. Duis et augue nunc, gravida fermentum mi.</p>', 21, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" redbg badge-top","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(140, 'Template Features', '', '<div class="list-useful">\r\n<p class="blocknumber blocknumber-1"><span class="bignumber">01</span> <span class="title-bignumber">Fluid Grid</span> Lorem ipsum dolor sit amet consectetuer rutrum dignissim et neque id.</p>\r\n<p class="blocknumber blocknumber-1"><span class="bignumber">02</span> <span class="title-bignumber">Simple and Clean Design</span> Interdum pharetra in a metus congue In Sed Pellente gravida pellentesque.</p>\r\n<p class="blocknumber blocknumber-1 last"><span class="bignumber">03</span> <span class="title-bignumber">Mega Menu</span> In Sed Pellentesque tincidunt pharetra a metus congue tincidunt pharetra.</p>\r\n</div>', 18, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" badge-vote","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(141, 'Module Adv', '', '<div class="adv"><img src="images/stories/demo/adv2.jpg" border="0" alt="Sample photo" title="Sample photo" align="middle" /></div>', 13, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" adv ","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(142, 'Newsletter', '', '<form action="index.php" method="post"><label>Lorem Ipsum is simply dummy text of the printing and typesetting industry</label>\r\n<div><input class="form-text" type="text" name="Your email" size="14" maxlength="60" /> <a class="links">Submit</a></div>\r\n</form>', 1, 'sl1-3', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" letter badge-letter","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(143, 'Connect ', '', '<div class="social"><a class="ico-social ico-facebooks" href="#" title="Facebook"><span>Facebook</span></a><a class="ico-social ico-twitters" href="#" title="Twitter"><span>Twitter</span></a><a class="ico-social ico-rss" href="#" title="RSS"><span>RSS</span></a><a class="ico-social ico-flick" href="#" title="Flick"><span>Flick</span></a></div>', 1, 'foot-right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" connect ","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(144, 'Accordion Module', '', '', 1, 'accordion', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jasidenews', 1, 1, '{"moduleclass_sfx":"","display_model-modcats-category":["88","87","86","85","84","83","82","81"],"show_featured":"1","sort_order_field":"created","sort_order":"DESC","max_items":1,"title_max_chars":10,"maxchars":80,"thumbnail_mode":"crop","thumbnail_mode-resize-use_ratio":"1","iwidth":58,"iheight":58,"image_alignment":"left","layout":"default","layout-default-showdate":"0","layout-default-show_moredetail":"0","layout-default-showimage":"1","layout-sidenews-height":"200","layout-sidenews-textcolor":"FFFFFF","layout-sidenews-bgcolor":"4F4F4F","layout-sidenews-transparent":"80","layout-sidenews-element_apply_side":"content","layout-sidenews-play_mode":"caption","layout-sidenews-play_mode-caption-expandheight":"150","layout-sidenews-play_mode-caption-collapseheight":"30","layout-sidenews-animation_transition":"Fx.Transitions.Expo.easeOut","enable_cache":"0","cache_time":30}', 0, '*'),
(145, 'Most Popular', '', '', 3, 'accordion', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jabulletin', 1, 1, '{"moduleclass_sfx":"","type":"mostread","ordering":"c_dsc","using_mode":"catids","category":["81","82","83","84","85","86","87","88"],"k2catsid":["0"],"count":3,"show_featured":"1","show_date":"1","show_author":"0","show_readmore":"0","show_hits":"0","use_custom_text":"1","custom_text":"Hits:","show_image":"1","thumbnail_mode":"crop","use_ratio":"1","width":58,"height":58,"cache":"1","cache_time":"30"}', 0, '*'),
(146, 'Music News', '', '', 1, 'sl1-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_janewspro', 1, 1, '{"moduleclass_sfx":" no-bg absolute-title hightlight-title","source":"JANewsHelper","getChildren":"1","catsid":["81"],"k2catsid":["0"],"groupbysubcat":"0","maxSubCats":"-1","featured":"hide","ordering":"ordering","sort_order":"DESC","timerange":"","profile":"nex_sidebar","JPlugins":"0","K2Plugins":"0","colors":"","jacache":"0","jacache_time":900}', 0, '*'),
(147, 'Adv Banner Top', '', '<div class="adv"><img src="images/stories/demo/adv3.jpg" border="0" alt="Sample photo" title="Sample photo" /></div>', 1, 'sl1-3', 42, '2012-07-09 10:17:55', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" adv","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(148, 'Sl1-1', '', '<img src="images/stories/demo/demo-4.jpg" border="0" alt="Sample Image" />\r\n<div style="padding: 20px 15px;">Nulla dapibus neque sit amet libero  ser suscipit hendrerit. Donec rhoncus mollis. <br /><strong>Module Class Suffix</strong>: no-padding absolute-title simple-title</div>', 1, 'sl1-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" no-padding absolute-title simple-title","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(149, 'Sl1-2 ', '', '<div style="background: #fff;">\r\n<img alt="" src="images/stories/demo/demo-5.jpg" />\r\n<div style="padding: 20px 15px;">\r\n<strong>Module Class Suffix</strong>: no-bg absolute-title hightlight-title\r\n</div>\r\n</div>', 1, 'sl1-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" no-bg absolute-title hightlight-title","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(150, 'Sl1-3', '', '<strong>Module Class Suffix</strong>: letter badge-letter\r\n<br /> \r\nSodales ac feugiat elit Integer gravida risus eu habitasse ligula Lorem. Id senectus tincidunt metus porta amet sem senectus tellus Curabitur Fusce. Eget Curabitur rutrum Pellentesque Curabitur Nullam orci ut tristique Curabitur lacinia. Tortor consectetuer ac at montes id id neque est leo vel. Phasellus libero ut dui pede sagittis vel auctor dignissim Nunc ante. Nisl in Pellentesque mauris nibh et vel tincidunt auctor fringilla id. Neque elit augue.', 1, 'sl1-3', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" letter badge-letter","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(151, 'Footer Menu ', '', '', 1, 'menu-footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 0, '{"menutype":"footer-menu","startLevel":"1","endLevel":"1","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"_menu","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(152, 'Right Position', '', '<p><span><strong>Module Class Suffix</strong>: badge-vote</span></p>', 6, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" badge-vote","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(153, 'Right Position', '', '<span><strong>Module Class Suffix</strong>: blackbg</span>', 4, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blackbg","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(154, 'Right Position', '', '<span><strong>Module Class Suffix</strong>: redbg badge-top</span>', 3, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" redbg badge-top","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(155, 'Right Position', '', '<span><strong>Module Class Suffix</strong>: blackbg bgcolor</span>', 2, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" blackbg bgcolor","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(156, 'Content Mass Bottom', '', 'Nulla dapibus neque sit amet libero  ser suscipit hendrerit. Donec rhoncus mollis suscipit. Mauris posuere turpis eu dui lobortis non iaculis odio tincidunt. Class aptent taciti sociosqu ad litora.', 1, 'content-mass-bottom', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(157, 'Foot Left', '', '<div><img src="images/stories/demo/img-footer.gif" border="0" alt="left" title="Sample photo" width="122" />Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</div>', 1, 'foot-left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" imgtemp no-padding","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(158, 'Foot Left', '', '<div class="clearfix">\r\n<div class="list-item first_item">\r\n<h3>Hubs</h3>\r\n<ul>\r\n<li><a href="#">News</a></li>\r\n<li><a href="#">Business</a></li>\r\n<li><a href="#">Culture</a></li>\r\n<li><a href="#">Design</a></li>\r\n<li><a href="#">Lifestyle</a></li>\r\n<li><a href="#">Technology</a></li>\r\n</ul>\r\n</div>\r\n<div class="list-item ">\r\n<h3>Features</h3>\r\n<ul>\r\n<li><a href="#">Infographics</a></li>\r\n<li><a href="#">Videos</a></li>\r\n<li><a href="#">Slideshow</a></li>\r\n<li><a href="#">Project</a></li>\r\n<li><a href="#">Current issue</a></li>\r\n<li><a href="#">Online Store</a></li>\r\n</ul>\r\n</div>\r\n<div class="list-item">\r\n<h3>Company</h3>\r\n<ul>\r\n<li><a href="#">About</a></li>\r\n<li><a href="#">Contact</a></li>\r\n<li><a href="#">Support</a></li>\r\n<li><a href="#">Jobs</a></li>\r\n<li><a href="#">Privacy</a></li>\r\n<li><a href="#">Terms</a></li>\r\n</ul>\r\n</div>\r\n</div>', 2, 'foot-left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":" partner no-padding","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(159, 'K2 Archive', '', '', 7, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_tools', 1, 1, '{"moduleclass_sfx":"_menu","module_usage":"0","archiveItemsCounter":"1","archiveCategory":"0","authors_module_category":"1","authorItemsCounter":"1","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"48","authorLatestItem":"1","calendarCategory":"0","home":"","seperator":"","root_id":"1","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"1","root_id2":"0","catfilter":"0","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":["1"],"cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900"}', 0, '*');
INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(160, 'Photo Images', '', '<div class="img-photo clearfix"><span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide1.jpg" width="594" height="386"} <img src="images/stories/highslide/thumb-1.jpg" border="0" alt="Sample Image" /> {/japopup} </span> <span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide2.jpg" width="594" height="386"} <img src="images/stories/highslide/thumb-2.jpg" border="0" alt="Sample Images" /> {/japopup} </span> <span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide3.jpg" width="594" height="386"} <img src="images/stories/highslide/thumb-3.jpg" border="0" alt="Sample Images" /> {/japopup} </span> <span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide4.jpg" width="594" height="386"} <img src="images/stories/highslide/thumb-4.jpg" border="0" alt="Sample Images" /> {/japopup} </span> <span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide5.jpg" width="594" height="386"} <img src="images/stories/highslide/thumb-5.jpg" border="0" alt="Sample Images" /> {/japopup} </span> <span class="highslide-img">{japopup type="image" title="Sample Images" content="images/stories/highslide/slide6.jpg" width="594" height="386"} <img src="images/stories/highslide/thumb-6.jpg" border="0" alt="Sample Images" /> {/japopup} </span></div>', 17, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(161, 'JA Newspro Mobile', '', '', 1, 'ja-news-mobile', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_janewspro', 1, 0, '{"moduleclass_sfx":"","source":"JANewsHelper","getChildren":"1","catsid":["90","88","87","86","85","84","83","82","81"],"k2catsid":["0"],"groupbysubcat":"0","maxSubCats":"-1","featured":"hide","ordering":"ordering","sort_order":"DESC","timerange":"","profile":"mobile","JPlugins":"1","K2Plugins":"1","colors":"","jacache":"1","jacache_time":900}', 0, '*'),
(162, 'Joomla Version', '', '', 1, 'footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_version', 3, 1, '{"format":"short","product":"1","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*');

DROP TABLE IF EXISTS `#__modules_menu`;
CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=MyISAM;

INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES
(1, 201),
(1, 207),
(1, 227),
(1, 229),
(1, 234),
(1, 242),
(1, 243),
(1, 244),
(1, 249),
(1, 251),
(1, 252),
(1, 253),
(1, 254),
(1, 255),
(1, 256),
(1, 257),
(1, 259),
(1, 260),
(1, 262),
(1, 263),
(1, 265),
(1, 266),
(1, 267),
(1, 268),
(1, 270),
(1, 271),
(1, 272),
(1, 273),
(1, 274),
(1, 275),
(1, 276),
(1, 277),
(1, 278),
(1, 279),
(1, 280),
(1, 281),
(1, 282),
(1, 283),
(1, 284),
(1, 285),
(1, 290),
(1, 294),
(1, 296),
(1, 300),
(1, 301),
(1, 302),
(1, 303),
(1, 304),
(1, 305),
(1, 306),
(1, 307),
(1, 309),
(1, 310),
(1, 311),
(1, 312),
(1, 313),
(1, 316),
(1, 317),
(1, 318),
(1, 319),
(1, 320),
(1, 321),
(1, 322),
(1, 323),
(1, 324),
(1, 325),
(1, 326),
(1, 399),
(1, 400),
(1, 402),
(1, 403),
(1, 404),
(1, 405),
(1, 406),
(1, 409),
(1, 410),
(1, 411),
(1, 412),
(1, 413),
(1, 414),
(1, 415),
(1, 416),
(1, 417),
(1, 418),
(1, 419),
(1, 422),
(1, 423),
(1, 424),
(1, 427),
(1, 429),
(1, 430),
(1, 431),
(1, 432),
(1, 433),
(1, 436),
(1, 437),
(1, 438),
(1, 439),
(1, 443),
(1, 444),
(1, 447),
(1, 449),
(1, 450),
(1, 452),
(1, 453),
(1, 455),
(1, 456),
(1, 457),
(1, 458),
(1, 459),
(1, 462),
(1, 463),
(1, 464),
(1, 479),
(1, 480),
(1, 483),
(1, 601),
(1, 611),
(1, 612),
(1, 613),
(1, 614),
(1, 615),
(1, 616),
(1, 617),
(1, 618),
(1, 661),
(1, 662),
(2, 0),
(3, 0),
(4, 0),
(6, 0),
(7, 0),
(8, 0),
(9, 0),
(10, 0),
(12, 0),
(13, 0),
(14, 0),
(15, 0),
(16, 290),
(16, 482),
(16, 494),
(16, 601),
(16, 602),
(16, 611),
(16, 612),
(16, 613),
(16, 614),
(16, 615),
(16, 616),
(16, 617),
(16, 618),
(16, 630),
(16, 631),
(16, 632),
(16, 633),
(16, 634),
(17, 201),
(17, 207),
(17, 227),
(17, 229),
(17, 234),
(17, 242),
(17, 243),
(17, 244),
(17, 249),
(17, 251),
(17, 252),
(17, 253),
(17, 254),
(17, 255),
(17, 256),
(17, 257),
(17, 259),
(17, 260),
(17, 262),
(17, 263),
(17, 265),
(17, 266),
(17, 267),
(17, 268),
(17, 270),
(17, 271),
(17, 272),
(17, 273),
(17, 274),
(17, 275),
(17, 276),
(17, 277),
(17, 278),
(17, 279),
(17, 280),
(17, 281),
(17, 282),
(17, 283),
(17, 284),
(17, 285),
(17, 290),
(17, 294),
(17, 296),
(17, 300),
(17, 301),
(17, 302),
(17, 303),
(17, 304),
(17, 305),
(17, 306),
(17, 307),
(17, 309),
(17, 310),
(17, 311),
(17, 312),
(17, 313),
(17, 316),
(17, 317),
(17, 318),
(17, 319),
(17, 320),
(17, 321),
(17, 322),
(17, 323),
(17, 324),
(17, 325),
(17, 326),
(17, 399),
(17, 400),
(17, 402),
(17, 403),
(17, 404),
(17, 405),
(17, 406),
(17, 409),
(17, 410),
(17, 411),
(17, 412),
(17, 413),
(17, 414),
(17, 415),
(17, 416),
(17, 417),
(17, 418),
(17, 419),
(17, 422),
(17, 423),
(17, 424),
(17, 427),
(17, 429),
(17, 430),
(17, 431),
(17, 432),
(17, 433),
(17, 436),
(17, 437),
(17, 438),
(17, 439),
(17, 443),
(17, 444),
(17, 447),
(17, 449),
(17, 450),
(17, 452),
(17, 453),
(17, 455),
(17, 456),
(17, 457),
(17, 458),
(17, 459),
(17, 462),
(17, 463),
(17, 464),
(17, 466),
(17, 479),
(17, 480),
(17, 481),
(17, 482),
(17, 483),
(17, 484),
(17, 485),
(17, 486),
(17, 487),
(17, 488),
(17, 489),
(17, 490),
(17, 491),
(17, 492),
(17, 493),
(17, 494),
(17, 561),
(17, 562),
(17, 563),
(17, 564),
(17, 565),
(17, 566),
(17, 567),
(17, 568),
(17, 569),
(17, 570),
(17, 578),
(17, 579),
(17, 580),
(17, 581),
(17, 582),
(17, 583),
(17, 584),
(17, 585),
(17, 586),
(17, 587),
(17, 588),
(17, 596),
(17, 597),
(17, 598),
(17, 599),
(17, 600),
(17, 601),
(17, 602),
(17, 611),
(17, 612),
(17, 613),
(17, 614),
(17, 615),
(17, 616),
(17, 617),
(17, 618),
(18, 0),
(19, 290),
(19, 601),
(19, 602),
(19, 611),
(19, 612),
(19, 613),
(19, 614),
(19, 615),
(19, 616),
(19, 617),
(19, 618),
(20, 0),
(22, 231),
(22, 234),
(22, 238),
(22, 242),
(22, 243),
(22, 244),
(22, 296),
(22, 399),
(22, 400),
(23, 435),
(25, 294),
(26, -463),
(26, -462),
(26, -433),
(26, -432),
(26, -431),
(26, -430),
(26, -429),
(26, -427),
(26, -400),
(26, -399),
(26, -296),
(26, -244),
(26, -243),
(26, -242),
(26, -238),
(26, -234),
(27, 601),
(27, 611),
(27, 612),
(27, 613),
(27, 614),
(27, 615),
(27, 616),
(27, 617),
(27, 618),
(28, 310),
(29, 302),
(30, 410),
(31, 309),
(32, 309),
(33, 307),
(34, 326),
(35, 0),
(36, 304),
(37, 311),
(38, 300),
(39, 435),
(39, 561),
(40, 313),
(41, 0),
(44, 0),
(45, 0),
(47, 231),
(47, 234),
(47, 242),
(47, 243),
(47, 244),
(47, 296),
(47, 399),
(47, 400),
(48, 0),
(49, 417),
(52, 201),
(52, 207),
(52, 227),
(52, 229),
(52, 234),
(52, 242),
(52, 243),
(52, 244),
(52, 249),
(52, 251),
(52, 252),
(52, 253),
(52, 254),
(52, 255),
(52, 256),
(52, 257),
(52, 259),
(52, 260),
(52, 262),
(52, 263),
(52, 265),
(52, 266),
(52, 267),
(52, 268),
(52, 270),
(52, 271),
(52, 272),
(52, 273),
(52, 274),
(52, 275),
(52, 276),
(52, 277),
(52, 278),
(52, 279),
(52, 280),
(52, 281),
(52, 282),
(52, 283),
(52, 284),
(52, 285),
(52, 290),
(52, 294),
(52, 296),
(52, 300),
(52, 301),
(52, 302),
(52, 303),
(52, 304),
(52, 305),
(52, 306),
(52, 307),
(52, 309),
(52, 310),
(52, 311),
(52, 312),
(52, 313),
(52, 316),
(52, 317),
(52, 318),
(52, 319),
(52, 320),
(52, 321),
(52, 322),
(52, 323),
(52, 324),
(52, 325),
(52, 326),
(52, 399),
(52, 400),
(52, 402),
(52, 403),
(52, 404),
(52, 405),
(52, 406),
(52, 409),
(52, 410),
(52, 411),
(52, 412),
(52, 413),
(52, 414),
(52, 415),
(52, 416),
(52, 417),
(52, 418),
(52, 419),
(52, 422),
(52, 423),
(52, 424),
(52, 427),
(52, 429),
(52, 430),
(52, 431),
(52, 432),
(52, 433),
(52, 436),
(52, 437),
(52, 438),
(52, 439),
(52, 443),
(52, 444),
(52, 447),
(52, 449),
(52, 450),
(52, 452),
(52, 453),
(52, 455),
(52, 456),
(52, 457),
(52, 458),
(52, 459),
(52, 462),
(52, 463),
(52, 464),
(52, 466),
(52, 479),
(52, 480),
(52, 481),
(52, 482),
(52, 483),
(52, 484),
(52, 485),
(52, 486),
(52, 487),
(52, 488),
(52, 489),
(52, 490),
(52, 491),
(52, 492),
(52, 493),
(52, 494),
(52, 561),
(52, 562),
(52, 563),
(52, 564),
(52, 565),
(52, 566),
(52, 567),
(52, 568),
(52, 569),
(52, 570),
(52, 596),
(52, 597),
(52, 598),
(52, 599),
(52, 600),
(52, 601),
(52, 602),
(52, 611),
(52, 612),
(52, 613),
(52, 614),
(52, 615),
(52, 616),
(52, 617),
(52, 618),
(56, 305),
(57, 238),
(57, 427),
(57, 429),
(57, 430),
(57, 431),
(57, 432),
(57, 433),
(57, 462),
(57, 463),
(58, 0),
(61, 443),
(62, 231),
(62, 234),
(62, 242),
(62, 243),
(62, 244),
(62, 296),
(62, 399),
(62, 400),
(63, 0),
(64, 447),
(65, 0),
(68, 0),
(69, 459),
(70, 0),
(71, 285),
(71, 316),
(72, 0),
(73, 435),
(73, 494),
(73, 630),
(73, 631),
(73, 632),
(73, 633),
(73, 634),
(74, 435),
(74, 493),
(74, 494),
(74, 630),
(74, 631),
(74, 632),
(74, 633),
(74, 634),
(75, 435),
(76, 285),
(76, 316),
(77, 0),
(78, 0),
(79, 0),
(82, 435),
(83, 290),
(83, 601),
(83, 602),
(83, 611),
(83, 612),
(83, 613),
(83, 614),
(83, 615),
(83, 616),
(83, 617),
(83, 618),
(92, 0),
(93, 201),
(93, 207),
(93, 227),
(93, 229),
(93, 234),
(93, 242),
(93, 243),
(93, 244),
(93, 249),
(93, 251),
(93, 252),
(93, 253),
(93, 254),
(93, 255),
(93, 256),
(93, 257),
(93, 259),
(93, 260),
(93, 262),
(93, 263),
(93, 265),
(93, 266),
(93, 267),
(93, 268),
(93, 270),
(93, 271),
(93, 272),
(93, 273),
(93, 274),
(93, 275),
(93, 276),
(93, 277),
(93, 278),
(93, 279),
(93, 280),
(93, 281),
(93, 282),
(93, 283),
(93, 284),
(93, 285),
(93, 290),
(93, 294),
(93, 296),
(93, 300),
(93, 301),
(93, 302),
(93, 303),
(93, 304),
(93, 305),
(93, 306),
(93, 307),
(93, 309),
(93, 310),
(93, 311),
(93, 312),
(93, 313),
(93, 316),
(93, 317),
(93, 318),
(93, 319),
(93, 320),
(93, 321),
(93, 322),
(93, 323),
(93, 324),
(93, 325),
(93, 326),
(93, 399),
(93, 400),
(93, 402),
(93, 403),
(93, 404),
(93, 405),
(93, 406),
(93, 409),
(93, 410),
(93, 411),
(93, 412),
(93, 413),
(93, 414),
(93, 415),
(93, 416),
(93, 417),
(93, 418),
(93, 419),
(93, 422),
(93, 423),
(93, 424),
(93, 427),
(93, 429),
(93, 430),
(93, 431),
(93, 432),
(93, 433),
(93, 435),
(93, 436),
(93, 437),
(93, 438),
(93, 439),
(93, 443),
(93, 444),
(93, 447),
(93, 449),
(93, 450),
(93, 452),
(93, 453),
(93, 455),
(93, 456),
(93, 457),
(93, 458),
(93, 459),
(93, 462),
(93, 463),
(93, 464),
(93, 479),
(93, 480),
(93, 481),
(93, 482),
(93, 483),
(93, 487),
(93, 493),
(93, 494),
(93, 630),
(93, 631),
(93, 632),
(93, 633),
(93, 634),
(118, 562),
(118, 563),
(118, 564),
(118, 565),
(118, 566),
(118, 567),
(118, 568),
(118, 569),
(118, 570),
(118, 596),
(118, 597),
(118, 598),
(118, 599),
(118, 600),
(119, 563),
(119, 564),
(119, 565),
(119, 566),
(119, 567),
(119, 568),
(119, 569),
(119, 570),
(120, 563),
(120, 564),
(120, 565),
(120, 566),
(120, 567),
(120, 568),
(120, 569),
(120, 570),
(121, 563),
(121, 564),
(121, 565),
(121, 566),
(121, 567),
(121, 568),
(121, 569),
(121, 570),
(121, 596),
(121, 597),
(121, 598),
(121, 599),
(121, 600),
(122, 563),
(122, 564),
(122, 565),
(122, 566),
(122, 567),
(122, 568),
(122, 569),
(122, 570),
(123, 562),
(123, 563),
(123, 564),
(123, 565),
(123, 566),
(123, 567),
(123, 568),
(123, 569),
(123, 570),
(123, 596),
(123, 597),
(123, 598),
(123, 599),
(123, 600),
(124, 0),
(125, 0),
(126, 0),
(127, 0),
(128, 435),
(128, 493),
(128, 494),
(128, 630),
(128, 631),
(128, 632),
(128, 633),
(128, 634),
(129, 435),
(129, 493),
(129, 494),
(129, 630),
(129, 631),
(129, 632),
(129, 633),
(129, 634),
(130, 435),
(131, 201),
(131, 207),
(131, 227),
(131, 229),
(131, 234),
(131, 242),
(131, 243),
(131, 244),
(131, 249),
(131, 251),
(131, 252),
(131, 253),
(131, 254),
(131, 255),
(131, 256),
(131, 257),
(131, 259),
(131, 260),
(131, 262),
(131, 263),
(131, 265),
(131, 266),
(131, 267),
(131, 268),
(131, 270),
(131, 271),
(131, 272),
(131, 273),
(131, 274),
(131, 275),
(131, 276),
(131, 277),
(131, 278),
(131, 279),
(131, 280),
(131, 281),
(131, 282),
(131, 283),
(131, 284),
(131, 285),
(131, 290),
(131, 294),
(131, 296),
(131, 300),
(131, 301),
(131, 302),
(131, 303),
(131, 304),
(131, 305),
(131, 306),
(131, 307),
(131, 309),
(131, 310),
(131, 311),
(131, 312),
(131, 313),
(131, 316),
(131, 317),
(131, 318),
(131, 319),
(131, 320),
(131, 321),
(131, 322),
(131, 323),
(131, 324),
(131, 325),
(131, 326),
(131, 399),
(131, 400),
(131, 402),
(131, 403),
(131, 404),
(131, 405),
(131, 406),
(131, 409),
(131, 410),
(131, 411),
(131, 412),
(131, 413),
(131, 414),
(131, 415),
(131, 416),
(131, 417),
(131, 418),
(131, 419),
(131, 422),
(131, 423),
(131, 424),
(131, 427),
(131, 429),
(131, 430),
(131, 431),
(131, 432),
(131, 433),
(131, 435),
(131, 436),
(131, 437),
(131, 438),
(131, 439),
(131, 443),
(131, 444),
(131, 447),
(131, 449),
(131, 450),
(131, 452),
(131, 453),
(131, 455),
(131, 456),
(131, 457),
(131, 458),
(131, 459),
(131, 462),
(131, 463),
(131, 464),
(131, 466),
(131, 479),
(131, 480),
(131, 481),
(131, 482),
(131, 483),
(131, 484),
(131, 485),
(131, 486),
(131, 487),
(131, 488),
(131, 489),
(131, 490),
(131, 491),
(131, 492),
(131, 493),
(131, 494),
(131, 562),
(131, 563),
(131, 564),
(131, 565),
(131, 566),
(131, 567),
(131, 568),
(131, 569),
(131, 570),
(131, 578),
(131, 579),
(131, 580),
(131, 581),
(131, 582),
(131, 583),
(131, 584),
(131, 585),
(131, 586),
(131, 587),
(131, 596),
(131, 597),
(131, 598),
(131, 599),
(131, 600),
(134, 0),
(135, 201),
(135, 207),
(135, 227),
(135, 229),
(135, 234),
(135, 242),
(135, 243),
(135, 244),
(135, 249),
(135, 251),
(135, 252),
(135, 253),
(135, 254),
(135, 255),
(135, 256),
(135, 257),
(135, 259),
(135, 260),
(135, 262),
(135, 263),
(135, 265),
(135, 266),
(135, 267),
(135, 268),
(135, 270),
(135, 271),
(135, 272),
(135, 273),
(135, 274),
(135, 275),
(135, 276),
(135, 277),
(135, 278),
(135, 279),
(135, 280),
(135, 281),
(135, 282),
(135, 283),
(135, 284),
(135, 285),
(135, 290),
(135, 294),
(135, 296),
(135, 300),
(135, 301),
(135, 302),
(135, 303),
(135, 304),
(135, 305),
(135, 306),
(135, 307),
(135, 309),
(135, 310),
(135, 311),
(135, 312),
(135, 313),
(135, 316),
(135, 317),
(135, 318),
(135, 319),
(135, 320),
(135, 321),
(135, 322),
(135, 323),
(135, 324),
(135, 325),
(135, 326),
(135, 399),
(135, 400),
(135, 402),
(135, 403),
(135, 404),
(135, 405),
(135, 406),
(135, 409),
(135, 410),
(135, 411),
(135, 412),
(135, 413),
(135, 414),
(135, 415),
(135, 416),
(135, 417),
(135, 418),
(135, 419),
(135, 422),
(135, 423),
(135, 424),
(135, 427),
(135, 429),
(135, 430),
(135, 431),
(135, 432),
(135, 433),
(135, 435),
(135, 436),
(135, 437),
(135, 438),
(135, 439),
(135, 443),
(135, 444),
(135, 447),
(135, 449),
(135, 450),
(135, 452),
(135, 453),
(135, 455),
(135, 456),
(135, 457),
(135, 458),
(135, 459),
(135, 462),
(135, 463),
(135, 464),
(135, 466),
(135, 479),
(135, 480),
(135, 481),
(135, 482),
(135, 483),
(135, 484),
(135, 486),
(135, 487),
(135, 488),
(135, 489),
(135, 490),
(135, 491),
(135, 492),
(135, 493),
(135, 494),
(135, 561),
(135, 562),
(135, 563),
(135, 564),
(135, 565),
(135, 566),
(135, 567),
(135, 568),
(135, 569),
(135, 570),
(135, 578),
(135, 579),
(135, 580),
(135, 581),
(135, 582),
(135, 583),
(135, 584),
(135, 585),
(135, 586),
(135, 587),
(135, 596),
(135, 597),
(135, 598),
(135, 599),
(135, 600),
(135, 601),
(136, 0),
(137, 201),
(137, 207),
(137, 227),
(137, 229),
(137, 234),
(137, 242),
(137, 243),
(137, 244),
(137, 249),
(137, 251),
(137, 252),
(137, 253),
(137, 254),
(137, 255),
(137, 256),
(137, 257),
(137, 259),
(137, 260),
(137, 262),
(137, 263),
(137, 265),
(137, 266),
(137, 267),
(137, 268),
(137, 270),
(137, 271),
(137, 272),
(137, 273),
(137, 274),
(137, 275),
(137, 276),
(137, 277),
(137, 278),
(137, 279),
(137, 280),
(137, 281),
(137, 282),
(137, 283),
(137, 284),
(137, 285),
(137, 290),
(137, 294),
(137, 296),
(137, 300),
(137, 301),
(137, 302),
(137, 303),
(137, 304),
(137, 305),
(137, 306),
(137, 307),
(137, 309),
(137, 310),
(137, 311),
(137, 312),
(137, 313),
(137, 316),
(137, 317),
(137, 318),
(137, 319),
(137, 320),
(137, 321),
(137, 322),
(137, 323),
(137, 324),
(137, 325),
(137, 326),
(137, 399),
(137, 400),
(137, 402),
(137, 403),
(137, 404),
(137, 405),
(137, 406),
(137, 409),
(137, 410),
(137, 411),
(137, 412),
(137, 413),
(137, 414),
(137, 415),
(137, 416),
(137, 417),
(137, 418),
(137, 419),
(137, 422),
(137, 423),
(137, 424),
(137, 427),
(137, 429),
(137, 430),
(137, 431),
(137, 432),
(137, 433),
(137, 435),
(137, 436),
(137, 437),
(137, 438),
(137, 439),
(137, 443),
(137, 444),
(137, 447),
(137, 449),
(137, 450),
(137, 452),
(137, 453),
(137, 455),
(137, 456),
(137, 457),
(137, 458),
(137, 459),
(137, 462),
(137, 463),
(137, 464),
(137, 466),
(137, 479),
(137, 480),
(137, 481),
(137, 482),
(137, 483),
(137, 484),
(137, 486),
(137, 487),
(137, 488),
(137, 489),
(137, 490),
(137, 491),
(137, 492),
(137, 493),
(137, 494),
(137, 561),
(137, 562),
(137, 563),
(137, 564),
(137, 565),
(137, 566),
(137, 567),
(137, 568),
(137, 569),
(137, 570),
(137, 588),
(137, 596),
(137, 597),
(137, 598),
(137, 599),
(137, 600),
(137, 601),
(137, 630),
(137, 631),
(137, 632),
(137, 633),
(137, 634),
(138, 435),
(139, 435),
(139, 561),
(140, 435),
(140, 493),
(140, 494),
(140, 561),
(140, 562),
(140, 570),
(140, 630),
(140, 631),
(140, 632),
(140, 633),
(140, 634),
(141, 435),
(141, 493),
(141, 494),
(141, 602),
(141, 630),
(141, 631),
(141, 632),
(141, 633),
(141, 634),
(142, 435),
(142, 493),
(142, 494),
(142, 630),
(142, 631),
(142, 632),
(142, 633),
(142, 634),
(143, 0),
(144, 201),
(144, 207),
(144, 227),
(144, 229),
(144, 234),
(144, 242),
(144, 243),
(144, 244),
(144, 249),
(144, 251),
(144, 252),
(144, 253),
(144, 254),
(144, 255),
(144, 256),
(144, 257),
(144, 259),
(144, 260),
(144, 262),
(144, 263),
(144, 265),
(144, 266),
(144, 267),
(144, 268),
(144, 270),
(144, 271),
(144, 272),
(144, 273),
(144, 274),
(144, 275),
(144, 276),
(144, 277),
(144, 278),
(144, 279),
(144, 280),
(144, 281),
(144, 282),
(144, 283),
(144, 284),
(144, 285),
(144, 290),
(144, 294),
(144, 296),
(144, 300),
(144, 301),
(144, 302),
(144, 303),
(144, 304),
(144, 305),
(144, 306),
(144, 307),
(144, 309),
(144, 310),
(144, 311),
(144, 312),
(144, 313),
(144, 316),
(144, 317),
(144, 318),
(144, 319),
(144, 320),
(144, 321),
(144, 322),
(144, 323),
(144, 324),
(144, 325),
(144, 326),
(144, 399),
(144, 400),
(144, 402),
(144, 403),
(144, 404),
(144, 405),
(144, 406),
(144, 409),
(144, 410),
(144, 411),
(144, 412),
(144, 413),
(144, 414),
(144, 415),
(144, 416),
(144, 417),
(144, 418),
(144, 419),
(144, 422),
(144, 423),
(144, 424),
(144, 427),
(144, 429),
(144, 430),
(144, 431),
(144, 432),
(144, 433),
(144, 435),
(144, 436),
(144, 437),
(144, 438),
(144, 439),
(144, 443),
(144, 444),
(144, 447),
(144, 449),
(144, 450),
(144, 452),
(144, 453),
(144, 455),
(144, 456),
(144, 457),
(144, 458),
(144, 459),
(144, 462),
(144, 463),
(144, 464),
(144, 479),
(144, 480),
(144, 481),
(144, 482),
(144, 483),
(144, 484),
(144, 485),
(144, 486),
(144, 487),
(144, 488),
(144, 489),
(144, 490),
(144, 491),
(144, 492),
(144, 493),
(144, 494),
(144, 561),
(144, 562),
(144, 563),
(144, 564),
(144, 565),
(144, 566),
(144, 567),
(144, 568),
(144, 569),
(144, 570),
(144, 588),
(144, 596),
(144, 597),
(144, 598),
(144, 599),
(144, 600),
(144, 601),
(144, 602),
(144, 611),
(144, 612),
(144, 613),
(144, 614),
(144, 615),
(144, 616),
(144, 617),
(144, 618),
(145, 201),
(145, 207),
(145, 227),
(145, 229),
(145, 234),
(145, 242),
(145, 243),
(145, 244),
(145, 249),
(145, 251),
(145, 252),
(145, 253),
(145, 254),
(145, 255),
(145, 256),
(145, 257),
(145, 259),
(145, 260),
(145, 262),
(145, 263),
(145, 265),
(145, 266),
(145, 267),
(145, 268),
(145, 270),
(145, 271),
(145, 272),
(145, 273),
(145, 274),
(145, 275),
(145, 276),
(145, 277),
(145, 278),
(145, 279),
(145, 280),
(145, 281),
(145, 282),
(145, 283),
(145, 284),
(145, 285),
(145, 290),
(145, 294),
(145, 296),
(145, 300),
(145, 301),
(145, 302),
(145, 303),
(145, 304),
(145, 305),
(145, 306),
(145, 307),
(145, 309),
(145, 310),
(145, 311),
(145, 312),
(145, 313),
(145, 316),
(145, 317),
(145, 318),
(145, 319),
(145, 320),
(145, 321),
(145, 322),
(145, 323),
(145, 324),
(145, 325),
(145, 326),
(145, 399),
(145, 400),
(145, 402),
(145, 403),
(145, 404),
(145, 405),
(145, 406),
(145, 409),
(145, 410),
(145, 411),
(145, 412),
(145, 413),
(145, 414),
(145, 415),
(145, 416),
(145, 417),
(145, 418),
(145, 419),
(145, 422),
(145, 423),
(145, 424),
(145, 427),
(145, 429),
(145, 430),
(145, 431),
(145, 432),
(145, 433),
(145, 435),
(145, 436),
(145, 437),
(145, 438),
(145, 439),
(145, 443),
(145, 444),
(145, 447),
(145, 449),
(145, 450),
(145, 452),
(145, 453),
(145, 455),
(145, 456),
(145, 457),
(145, 458),
(145, 459),
(145, 462),
(145, 463),
(145, 464),
(145, 466),
(145, 479),
(145, 480),
(145, 481),
(145, 482),
(145, 483),
(145, 484),
(145, 485),
(145, 486),
(145, 487),
(145, 488),
(145, 489),
(145, 490),
(145, 491),
(145, 492),
(145, 493),
(145, 494),
(145, 562),
(145, 563),
(145, 564),
(145, 565),
(145, 566),
(145, 567),
(145, 568),
(145, 569),
(145, 570),
(145, 578),
(145, 579),
(145, 580),
(145, 581),
(145, 582),
(145, 583),
(145, 584),
(145, 585),
(145, 586),
(145, 587),
(145, 596),
(145, 597),
(145, 598),
(145, 599),
(145, 600),
(146, 435),
(146, 493),
(146, 494),
(146, 630),
(146, 631),
(146, 632),
(146, 633),
(146, 634),
(147, 435),
(147, 493),
(147, 494),
(147, 630),
(147, 631),
(147, 632),
(147, 633),
(147, 634),
(148, 485),
(149, 485),
(150, 485),
(151, 0),
(152, 485),
(152, 661),
(152, 662),
(153, 485),
(154, 485),
(155, 485),
(156, 485),
(157, 485),
(158, 485),
(159, 563),
(159, 564),
(159, 565),
(159, 566),
(159, 567),
(159, 568),
(159, 569),
(159, 570),
(159, 596),
(159, 597),
(159, 598),
(159, 599),
(159, 600),
(160, 290),
(160, 493),
(160, 494),
(160, 602),
(160, 630),
(160, 631),
(160, 632),
(160, 633),
(160, 634),
(161, 435),
(162, 0),
(163, 290),
(163, 601),
(163, 602),
(163, 611),
(163, 612),
(163, 613),
(163, 614),
(163, 615),
(163, 616),
(163, 617),
(163, 618);

DROP TABLE IF EXISTS `#__newsfeeds`;
CREATE TABLE `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `filename` varchar(200) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

INSERT INTO `#__newsfeeds` (`catid`, `id`, `name`, `alias`, `link`, `filename`, `published`, `numarticles`, `cache_time`, `checked_out`, `checked_out_time`, `ordering`, `rtl`, `access`, `language`, `params`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `xreference`, `publish_up`, `publish_down`) VALUES
(17, 1, 'Joomla! Announcements', 'joomla-announcements', 'http://www.joomla.org/announcements.feed?type=rss', NULL, 1, 5, 3600, 0, '0000-00-00 00:00:00', 1, 0, 1, 'en-GB', '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0"}', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","author":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(17, 2, 'New Joomla! Extensions', 'new-joomla-extensions', 'http://feeds.joomla.org/JoomlaExtensions', NULL, 1, 5, 3600, 0, '0000-00-00 00:00:00', 4, 0, 1, 'en-GB', '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0"}', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","author":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(17, 3, 'Joomla! Security News', 'joomla-security-news', 'http://feeds.joomla.org/JoomlaSecurityNews', NULL, 1, 5, 3600, 0, '0000-00-00 00:00:00', 2, 0, 1, 'en-GB', '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0"}', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","author":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(17, 4, 'Joomla! Connect', 'joomla-connect', 'http://feeds.joomla.org/JoomlaConnect', NULL, 1, 5, 3600, 0, '0000-00-00 00:00:00', 3, 0, 1, 'en-GB', '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0"}', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","author":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');

DROP TABLE IF EXISTS `#__overrider`;
CREATE TABLE `#__overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` text NOT NULL,
  `file` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__redirect_links`;
CREATE TABLE `#__redirect_links` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `old_url` varchar(255) NOT NULL,
  `new_url` varchar(255) NOT NULL,
  `referer` varchar(150) NOT NULL,
  `comment` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(4) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_link_old` (`old_url`),
  KEY `idx_link_modifed` (`modified_date`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__schemas`;
CREATE TABLE `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) ENGINE=MyISAM;

INSERT INTO `#__schemas` (`extension_id`, `version_id`) VALUES
(700, '2.5.11');

DROP TABLE IF EXISTS `#__session`;
CREATE TABLE `#__session` (
  `session_id` varchar(200) NOT NULL DEFAULT '',
  `client_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `guest` tinyint(4) unsigned DEFAULT '1',
  `time` varchar(14) DEFAULT '',
  `data` mediumtext,
  `userid` int(11) DEFAULT '0',
  `username` varchar(150) DEFAULT '',
  `usertype` varchar(50) DEFAULT '',
  PRIMARY KEY (`session_id`),
  KEY `whosonline` (`guest`,`usertype`),
  KEY `userid` (`userid`),
  KEY `time` (`time`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__template_styles`;
CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=MyISAM ;

INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES
(2, 'bluestork', 1, '1', 'Bluestork - Default', '{"useRoundedCorners":"1","showSiteName":"0"}'),
(3, 'atomic', 0, '0', 'Atomic - Default', '{}'),
(4, 'beez_20', 0, '0', 'Beez2 - Default', '{"wrapperSmall":53,"wrapperLarge":72,"logo":"images\\/joomla_black.gif","sitetitle":"Joomla!","sitedescription":"Open Source Content Management","navposition":"left","templatecolor":"personal"}'),
(5, 'hathor', 1, '0', 'Hathor - Default', '{"showSiteName":"0","colourChoice":"","boldText":"0"}'),
(6, 'beez5', 0, '0', 'Beez5 - Default', '{"wrapperSmall":53,"wrapperLarge":72,"logo":"images\\/sampledata\\/fruitshop\\/fruits.gif","sitetitle":"Joomla!","sitedescription":"Open Source Content Management","navposition":"left","html5":0}'),
(114, 'beez_20', 0, '0', 'Beez2 - Parks Site', '{"wrapperSmall":53,"wrapperLarge":72,"logo":"","sitetitle":"Australian Parks","sitedescription":"Parks Sample Site","navposition":"center","templatecolor":"nature"}'),
(115, 'ja_vintase', 0, '0', 'ja_vintase - Default', '{}'),
(117, 'ja_nex', 0, '1', 'JA_Nex - Default', '{}');

DROP TABLE IF EXISTS `#__update_categories`;
CREATE TABLE `#__update_categories` (
  `categoryid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) DEFAULT '',
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `updatesite` int(11) DEFAULT '0',
  PRIMARY KEY (`categoryid`)
) ENGINE=MyISAM COMMENT='Update Categories';


DROP TABLE IF EXISTS `#__update_sites`;
CREATE TABLE `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
) ENGINE=MyISAM  COMMENT='Update Sites';

INSERT INTO `#__update_sites` (`update_site_id`, `name`, `type`, `location`, `enabled`, `last_check_timestamp`) VALUES
(1, 'Joomla Core', 'collection', 'http://update.joomla.org/core/list.xml', 1, 1372994660),
(2, 'Joomla Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', 1, 1372994660),
(3, '', 'collection', 'http://update.joomlart.com/service/tracking/list.xml', 1, 1372994660),
(6, 'Kunena 2.0 Update Site', 'collection', 'http://update.kunena.org/2.0', 1, 1372994660),
(7, 'K2 Updates', 'extension', 'http://getk2.org/update.xml', 1, 1372994660);
INSERT IGNORE INTO `#__update_sites` VALUES
(1, 'Joomla Core', 'collection', 'http://update.joomla.org/core/list.xml', 1, 0),
(2, 'Joomla Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', 1, 0),
(3,'Accredited Joomla! Translations','collection','http://update.joomla.org/language/translationlist.xml', 1 ,0);
DROP TABLE IF EXISTS `#__update_sites_extensions`;
CREATE TABLE `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) ENGINE=MyISAM COMMENT='Links extensions to update sites';
INSERT IGNORE INTO `#__update_sites_extensions` VALUES
(1, 700),
(2, 700),
(3, 600);

DROP TABLE IF EXISTS `#__updates`;
CREATE TABLE `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `categoryid` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  `infourl` text NOT NULL,
  PRIMARY KEY (`update_id`)
) ENGINE=MyISAM  COMMENT='Available Updates';

DROP TABLE IF EXISTS `#__user_notes`;
CREATE TABLE `#__user_notes` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(100) NOT NULL DEFAULT '',
  `body` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL,
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_category_id` (`catid`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__user_profiles`;
CREATE TABLE `#__user_profiles` (
  `user_id` int(11) NOT NULL,
  `profile_key` varchar(100) NOT NULL,
  `profile_value` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `idx_user_id_profile_key` (`user_id`,`profile_key`)
) ENGINE=MyISAM COMMENT='Simple user profile storage table';


DROP TABLE IF EXISTS `#__user_usergroup_map`;
CREATE TABLE `#__user_usergroup_map` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to j40f79_users.id',
  `group_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to j40f79_usergroups.id',
  PRIMARY KEY (`user_id`,`group_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__usergroups`;
CREATE TABLE `#__usergroups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`),
  KEY `idx_usergroup_title_lookup` (`title`),
  KEY `idx_usergroup_adjacency_lookup` (`parent_id`),
  KEY `idx_usergroup_nested_set_lookup` (`lft`,`rgt`)
) ENGINE=MyISAM ;

INSERT INTO `#__usergroups` (`id`, `parent_id`, `lft`, `rgt`, `title`) VALUES
(1, 0, 1, 20, 'Public'),
(2, 1, 6, 17, 'Registered'),
(3, 2, 7, 14, 'Author'),
(4, 3, 8, 11, 'Editor'),
(5, 4, 9, 10, 'Publisher'),
(6, 1, 2, 5, 'Manager'),
(7, 6, 3, 4, 'Administrator'),
(8, 1, 18, 19, 'Super Users'),
(12, 2, 15, 16, 'Customer Group (Example)'),
(10, 3, 12, 13, 'Shop Suppliers (Example)');

DROP TABLE IF EXISTS `#__users`;
CREATE TABLE `#__users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `username` varchar(150) NOT NULL DEFAULT '',
  `email` varchar(100) NOT NULL DEFAULT '',
  `password` varchar(100) NOT NULL DEFAULT '',
  `usertype` varchar(25) NOT NULL DEFAULT '',
  `block` tinyint(4) NOT NULL DEFAULT '0',
  `sendEmail` tinyint(4) DEFAULT '0',
  `registerDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvisitDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activation` varchar(100) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `lastResetTime` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Date of last password reset',
  `resetCount` int(11) NOT NULL DEFAULT '0' COMMENT 'Count of password resets since lastResetTime',
  PRIMARY KEY (`id`),
  KEY `usertype` (`usertype`),
  KEY `idx_name` (`name`),
  KEY `idx_block` (`block`),
  KEY `username` (`username`),
  KEY `email` (`email`)
) ENGINE=MyISAM ;


DROP TABLE IF EXISTS `#__viewlevels`;
CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=MyISAM ;

INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`) VALUES
(1, 'Public', 0, '[1]'),
(2, 'Registered', 1, '[6,2,8]'),
(3, 'Special', 2, '[6,3,8]'),
(4, 'Customer Access Level (Example)', 3, '[6,3,12]');

DROP TABLE IF EXISTS `#__weblinks`;
CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

INSERT INTO `#__weblinks` (`id`, `catid`, `sid`, `title`, `alias`, `url`, `description`, `date`, `hits`, `state`, `checked_out`, `checked_out_time`, `ordering`, `archived`, `approved`, `access`, `params`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES
(1, 32, 0, 'Joomla!', 'joomla', 'http://www.joomla.org', '<p>Home of Joomla!</p>', '0000-00-00 00:00:00', 3, 1, 0, '0000-00-00 00:00:00', 1, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(2, 33, 0, 'php.net', 'php', 'http://www.php.net', '<p>The language that Joomla! is developed in</p>', '0000-00-00 00:00:00', 6, 1, 0, '0000-00-00 00:00:00', 1, 0, 1, 1, '{"target":"","count_clicks":""}', 'en-GB', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(3, 33, 0, 'MySQL', 'mysql', 'http://www.mysql.com', '<p>The database that Joomla! uses</p>', '0000-00-00 00:00:00', 1, 1, 0, '0000-00-00 00:00:00', 2, 0, 1, 1, '{"target":"","count_clicks":""}', 'en-GB', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(4, 32, 0, 'OpenSourceMatters', 'opensourcematters', 'http://www.opensourcematters.org', '<p>Home of OSM</p>', '0000-00-00 00:00:00', 11, 1, 0, '0000-00-00 00:00:00', 3, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(5, 32, 0, 'Joomla! - Forums', 'joomla-forums', 'http://forum.joomla.org', '<p>Joomla! Forums</p>', '0000-00-00 00:00:00', 4, 1, 0, '0000-00-00 00:00:00', 2, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(6, 33, 0, 'Ohloh Tracking of Joomla!', 'ohloh-tracking-of-joomla', 'http://www.ohloh.net/projects/20', '<p>Objective reports from Ohloh about Joomla\'s development activity. Joomla! has some star developers with serious kudos.</p>', '0000-00-00 00:00:00', 1, 1, 0, '0000-00-00 00:00:00', 3, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(7, 31, 0, 'Baw Baw National Park', 'baw-baw-national-park', 'http://www.parkweb.vic.gov.au/1park_display.cfm?park=44', '<p>Park of the Austalian Alps National Parks system, Baw BawÂ  features sub alpine vegetation, beautiful views, and opportunities for hiking, skiing and other outdoor activities.</p>', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 1, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(8, 31, 0, 'Kakadu', 'kakadu', 'http://www.environment.gov.au/parks/kakadu/index.html', '<p>Kakadu is known for both its cultural heritage and its natural features. It is one of a small number of places listed as World Heritage Places for both reasons. Extensive rock art is found there.</p>', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 2, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(9, 31, 0, 'Pulu Keeling', 'pulu-keeling', 'http://www.environment.gov.au/parks/cocos/index.html', '<p>Located on an atoll 2000 kilometers north of Perth, Pulu Keeling is Australia\'s smallest national park.</p>', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 3, 0, 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2011-01-01 00:00:01', 42, '', '2011-01-01 00:00:01', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '2010-07-10 23:44:03', '0000-00-00 00:00:00');

